
type __ = Obj.t

type empty_set = |

val implb : bool -> bool -> bool

val negb : bool -> bool

type nat =
| O
| S of nat

val option_map : ('a1 -> 'a2) -> 'a1 option -> 'a2 option

type ('a, 'b) sum =
| Inl of 'a
| Inr of 'b

val fst : ('a1 * 'a2) -> 'a1

val snd : ('a1 * 'a2) -> 'a2

val length : 'a1 list -> nat

val app : 'a1 list -> 'a1 list -> 'a1 list

type comparison =
| Eq
| Lt
| Gt

val compOpp : comparison -> comparison

type compareSpecT =
| CompEqT
| CompLtT
| CompGtT

val compareSpec2Type : comparison -> compareSpecT

type 'a compSpecT = compareSpecT

val compSpec2Type : 'a1 -> 'a1 -> comparison -> 'a1 compSpecT

val id : __ -> __

type 'a sig0 = 'a
  (* singleton inductive, whose constructor was exist *)

type ('a, 'p) sigT =
| ExistT of 'a * 'p

val projT1 : ('a1, 'a2) sigT -> 'a1

val projT2 : ('a1, 'a2) sigT -> 'a2



type uint =
| Nil
| D0 of uint
| D1 of uint
| D2 of uint
| D3 of uint
| D4 of uint
| D5 of uint
| D6 of uint
| D7 of uint
| D8 of uint
| D9 of uint

type signed_int =
| Pos of uint
| Neg of uint

val nzhead : uint -> uint

val unorm : uint -> uint

val norm : signed_int -> signed_int

val revapp : uint -> uint -> uint

val rev : uint -> uint

module Little :
 sig
  val double : uint -> uint

  val succ_double : uint -> uint
 end

type uint0 =
| Nil0
| D10 of uint0
| D11 of uint0
| D12 of uint0
| D13 of uint0
| D14 of uint0
| D15 of uint0
| D16 of uint0
| D17 of uint0
| D18 of uint0
| D19 of uint0
| Da of uint0
| Db of uint0
| Dc of uint0
| Dd of uint0
| De of uint0
| Df of uint0

type signed_int0 =
| Pos0 of uint0
| Neg0 of uint0

val nzhead0 : uint0 -> uint0

val unorm0 : uint0 -> uint0

val norm0 : signed_int0 -> signed_int0

val revapp0 : uint0 -> uint0 -> uint0

val rev0 : uint0 -> uint0

module Coq_Little :
 sig
  val double : uint0 -> uint0

  val succ_double : uint0 -> uint0
 end

type uint1 =
| UIntDecimal of uint
| UIntHexadecimal of uint0

type signed_int1 =
| IntDecimal of signed_int
| IntHexadecimal of signed_int0

val pred : nat -> nat

val add : nat -> nat -> nat

val mul : nat -> nat -> nat

val sub : nat -> nat -> nat

val max : nat -> nat -> nat

val min : nat -> nat -> nat

val eqb : bool -> bool -> bool

type reflect =
| ReflectT
| ReflectF

val iff_reflect : bool -> reflect

val eqb_spec : bool -> bool -> reflect

module type DecidableType =
 sig
  type t

  val eq_dec : t -> t -> bool
 end

module type EqLtLe =
 sig
  type t
 end

module type OrderedType =
 sig
  type t

  val compare : t -> t -> comparison

  val eq_dec : t -> t -> bool
 end

module type OrderedType' =
 sig
  type t

  val compare : t -> t -> comparison

  val eq_dec : t -> t -> bool
 end

module OT_to_Full :
 functor (O:OrderedType') ->
 sig
  type t = O.t

  val compare : t -> t -> comparison

  val eq_dec : t -> t -> bool
 end

module type TotalLeBool' =
 sig
  type t

  val leb : t -> t -> bool
 end

module MakeOrderTac :
 functor (O:EqLtLe) ->
 functor (P:sig
 end) ->
 sig
 end

module OT_to_OrderTac :
 functor (OT:OrderedType) ->
 sig
  module OTF :
   sig
    type t = OT.t

    val compare : t -> t -> comparison

    val eq_dec : t -> t -> bool
   end

  module TO :
   sig
    type t = OTF.t

    val compare : t -> t -> comparison

    val eq_dec : t -> t -> bool
   end
 end

module OrderedTypeFacts :
 functor (O:OrderedType') ->
 sig
  module OrderTac :
   sig
    module OTF :
     sig
      type t = O.t

      val compare : t -> t -> comparison

      val eq_dec : t -> t -> bool
     end

    module TO :
     sig
      type t = OTF.t

      val compare : t -> t -> comparison

      val eq_dec : t -> t -> bool
     end
   end

  val eq_dec : O.t -> O.t -> bool

  val lt_dec : O.t -> O.t -> bool

  val eqb : O.t -> O.t -> bool
 end

module Nat :
 sig
  val succ : nat -> nat

  val pred : nat -> nat

  val add : nat -> nat -> nat

  val mul : nat -> nat -> nat

  val sub : nat -> nat -> nat

  val eqb : nat -> nat -> bool

  val leb : nat -> nat -> bool

  val ltb : nat -> nat -> bool

  val max : nat -> nat -> nat

  val min : nat -> nat -> nat

  val eqb_spec : nat -> nat -> reflect
 end

val hd : 'a1 -> 'a1 list -> 'a1

val tl : 'a1 list -> 'a1 list

val nth : nat -> 'a1 list -> 'a1 -> 'a1

val nth_error : 'a1 list -> nat -> 'a1 option

val nth_default : 'a1 -> 'a1 list -> nat -> 'a1

val last : 'a1 list -> 'a1 -> 'a1

val removelast : 'a1 list -> 'a1 list

val count_occ : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 -> nat

val rev1 : 'a1 list -> 'a1 list

val rev_append : 'a1 list -> 'a1 list -> 'a1 list

val rev' : 'a1 list -> 'a1 list

val concat : 'a1 list list -> 'a1 list

val map : ('a1 -> 'a2) -> 'a1 list -> 'a2 list

val flat_map : ('a1 -> 'a2 list) -> 'a1 list -> 'a2 list

val fold_left : ('a1 -> 'a2 -> 'a1) -> 'a2 list -> 'a1 -> 'a1

val fold_right : ('a2 -> 'a1 -> 'a1) -> 'a1 -> 'a2 list -> 'a1

val existsb : ('a1 -> bool) -> 'a1 list -> bool

val forallb : ('a1 -> bool) -> 'a1 list -> bool

val filter : ('a1 -> bool) -> 'a1 list -> 'a1 list

val find : ('a1 -> bool) -> 'a1 list -> 'a1 option

val partition : ('a1 -> bool) -> 'a1 list -> 'a1 list * 'a1 list

val combine : 'a1 list -> 'a2 list -> ('a1 * 'a2) list

val firstn : nat -> 'a1 list -> 'a1 list

val skipn : nat -> 'a1 list -> 'a1 list

val seq : nat -> nat -> nat list

val repeat : 'a1 -> nat -> 'a1 list

type positive =
| XI of positive
| XO of positive
| XH

type n =
| N0
| Npos of positive

type z =
| Z0
| Zpos of positive
| Zneg of positive

module Pos :
 sig
  type mask =
  | IsNul
  | IsPos of positive
  | IsNeg
 end

module Coq_Pos :
 sig
  val succ : positive -> positive

  val add : positive -> positive -> positive

  val add_carry : positive -> positive -> positive

  val pred_double : positive -> positive

  val pred_N : positive -> n

  type mask = Pos.mask =
  | IsNul
  | IsPos of positive
  | IsNeg

  val succ_double_mask : mask -> mask

  val double_mask : mask -> mask

  val double_pred_mask : positive -> mask

  val sub_mask : positive -> positive -> mask

  val sub_mask_carry : positive -> positive -> mask

  val sub : positive -> positive -> positive

  val mul : positive -> positive -> positive

  val iter : ('a1 -> 'a1) -> 'a1 -> positive -> 'a1

  val pow : positive -> positive -> positive

  val square : positive -> positive

  val div2 : positive -> positive

  val div2_up : positive -> positive

  val size_nat : positive -> nat

  val size : positive -> positive

  val compare_cont : comparison -> positive -> positive -> comparison

  val compare : positive -> positive -> comparison

  val eqb : positive -> positive -> bool

  val leb : positive -> positive -> bool

  val sqrtrem_step :
    (positive -> positive) -> (positive -> positive) -> (positive * mask) ->
    positive * mask

  val sqrtrem : positive -> positive * mask

  val sqrt : positive -> positive

  val gcdn : nat -> positive -> positive -> positive

  val gcd : positive -> positive -> positive

  val ggcdn : nat -> positive -> positive -> positive * (positive * positive)

  val ggcd : positive -> positive -> positive * (positive * positive)

  val coq_Nsucc_double : n -> n

  val coq_Ndouble : n -> n

  val coq_lor : positive -> positive -> positive

  val coq_land : positive -> positive -> n

  val ldiff : positive -> positive -> n

  val coq_lxor : positive -> positive -> n

  val shiftl : positive -> n -> positive

  val testbit_nat : positive -> nat -> bool

  val testbit : positive -> n -> bool

  val iter_op : ('a1 -> 'a1 -> 'a1) -> positive -> 'a1 -> 'a1

  val to_nat : positive -> nat

  val of_succ_nat : nat -> positive

  val of_uint_acc : uint -> positive -> positive

  val of_uint : uint -> n

  val of_hex_uint_acc : uint0 -> positive -> positive

  val of_hex_uint : uint0 -> n

  val to_little_uint : positive -> uint

  val to_uint : positive -> uint

  val to_little_hex_uint : positive -> uint0

  val to_hex_uint : positive -> uint0

  val eq_dec : positive -> positive -> bool

  val peano_rect : 'a1 -> (positive -> 'a1 -> 'a1) -> positive -> 'a1
 end

module N :
 sig
  val double : n -> n

  val add : n -> n -> n

  val mul : n -> n -> n

  val compare : n -> n -> comparison

  val ltb : n -> n -> bool

  val to_uint : n -> uint
 end

module Coq_N :
 sig
  type t = n

  val zero : n

  val one : n

  val two : n

  val succ_double : n -> n

  val double : n -> n

  val succ : n -> n

  val pred : n -> n

  val succ_pos : n -> positive

  val add : n -> n -> n

  val sub : n -> n -> n

  val mul : n -> n -> n

  val compare : n -> n -> comparison

  val eqb : n -> n -> bool

  val leb : n -> n -> bool

  val ltb : n -> n -> bool

  val min : n -> n -> n

  val max : n -> n -> n

  val div2 : n -> n

  val even : n -> bool

  val odd : n -> bool

  val pow : n -> n -> n

  val square : n -> n

  val log2 : n -> n

  val size : n -> n

  val size_nat : n -> nat

  val pos_div_eucl : positive -> n -> n * n

  val div_eucl : n -> n -> n * n

  val div : n -> n -> n

  val modulo : n -> n -> n

  val gcd : n -> n -> n

  val ggcd : n -> n -> n * (n * n)

  val sqrtrem : n -> n * n

  val sqrt : n -> n

  val coq_lor : n -> n -> n

  val coq_land : n -> n -> n

  val ldiff : n -> n -> n

  val coq_lxor : n -> n -> n

  val shiftl_nat : n -> nat -> n

  val shiftr_nat : n -> nat -> n

  val shiftl : n -> n -> n

  val shiftr : n -> n -> n

  val testbit_nat : n -> nat -> bool

  val testbit : n -> n -> bool

  val to_nat : n -> nat

  val of_nat : nat -> n

  val iter : n -> ('a1 -> 'a1) -> 'a1 -> 'a1

  val of_uint : uint -> n

  val of_hex_uint : uint0 -> n

  val of_num_uint : uint1 -> n

  val of_int : signed_int -> n option

  val of_hex_int : signed_int0 -> n option

  val of_num_int : signed_int1 -> n option

  val to_uint : n -> uint

  val to_hex_uint : n -> uint0

  val to_num_uint : n -> uint1

  val to_num_hex_uint : n -> uint1

  val to_int : n -> signed_int

  val to_hex_int : n -> signed_int0

  val to_num_int : n -> signed_int1

  val to_num_hex_int : n -> signed_int1

  val eq_dec : n -> n -> bool

  val discr : n -> positive option

  val binary_rect : 'a1 -> (n -> 'a1 -> 'a1) -> (n -> 'a1 -> 'a1) -> n -> 'a1

  val binary_rec : 'a1 -> (n -> 'a1 -> 'a1) -> (n -> 'a1 -> 'a1) -> n -> 'a1

  val peano_rect : 'a1 -> (n -> 'a1 -> 'a1) -> n -> 'a1

  val peano_rec : 'a1 -> (n -> 'a1 -> 'a1) -> n -> 'a1

  val recursion : 'a1 -> (n -> 'a1 -> 'a1) -> n -> 'a1

  val leb_spec0 : n -> n -> reflect

  val ltb_spec0 : n -> n -> reflect

  module Private_OrderTac :
   sig
    module IsTotal :
     sig
     end

    module Tac :
     sig
     end
   end

  val measure_right_induction :
    ('a1 -> n) -> n -> ('a1 -> __ -> ('a1 -> __ -> 'a2) -> 'a2) -> 'a1 -> 'a2

  val measure_left_induction :
    ('a1 -> n) -> n -> ('a1 -> __ -> ('a1 -> __ -> 'a2) -> 'a2) -> 'a1 -> 'a2

  val measure_induction :
    ('a1 -> n) -> ('a1 -> ('a1 -> __ -> 'a2) -> 'a2) -> 'a1 -> 'a2

  module Private_Tac :
   sig
   end

  module Private_Dec :
   sig
    val max_case_strong :
      n -> n -> (n -> n -> __ -> 'a1 -> 'a1) -> (__ -> 'a1) -> (__ -> 'a1) ->
      'a1

    val max_case : n -> n -> (n -> n -> __ -> 'a1 -> 'a1) -> 'a1 -> 'a1 -> 'a1

    val max_dec : n -> n -> bool

    val min_case_strong :
      n -> n -> (n -> n -> __ -> 'a1 -> 'a1) -> (__ -> 'a1) -> (__ -> 'a1) ->
      'a1

    val min_case : n -> n -> (n -> n -> __ -> 'a1 -> 'a1) -> 'a1 -> 'a1 -> 'a1

    val min_dec : n -> n -> bool
   end

  val max_case_strong : n -> n -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1

  val max_case : n -> n -> 'a1 -> 'a1 -> 'a1

  val max_dec : n -> n -> bool

  val min_case_strong : n -> n -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1

  val min_case : n -> n -> 'a1 -> 'a1 -> 'a1

  val min_dec : n -> n -> bool

  module Private_NZPow :
   sig
   end

  module Private_NZSqrt :
   sig
   end

  val sqrt_up : n -> n

  val log2_up : n -> n

  module Private_NZGcdProp :
   sig
   end

  module Private_NDivProp :
   sig
    module Private_NZDiv :
     sig
     end
   end

  module Div0 :
   sig
   end

  module Private_NLcmProp :
   sig
    val lcm : n -> n -> n
   end

  val lcm : n -> n -> n

  module Lcm0 :
   sig
   end

  val eqb_spec : n -> n -> reflect

  val b2n : bool -> n

  val setbit : n -> n -> n

  val clearbit : n -> n -> n

  val ones : n -> n

  val lnot : n -> n -> n
 end

val pow_pos : ('a1 -> 'a1 -> 'a1) -> 'a1 -> positive -> 'a1

module Z :
 sig
  val opp : z -> z

  val to_nat : z -> nat

  val of_nat : nat -> z

  val of_N : n -> z

  val of_uint : uint -> z

  val of_int : signed_int -> z

  val to_int : z -> signed_int
 end

module Coq_Z :
 sig
  val double : z -> z

  val succ_double : z -> z

  val pred_double : z -> z

  val pos_sub : positive -> positive -> z

  val add : z -> z -> z

  val opp : z -> z

  val succ : z -> z

  val pred : z -> z

  val sub : z -> z -> z

  val mul : z -> z -> z

  val pow_pos : z -> positive -> z

  val pow : z -> z -> z

  val compare : z -> z -> comparison

  val sgn : z -> z

  val leb : z -> z -> bool

  val ltb : z -> z -> bool

  val geb : z -> z -> bool

  val gtb : z -> z -> bool

  val eqb : z -> z -> bool

  val max : z -> z -> z

  val min : z -> z -> z

  val abs : z -> z

  val to_nat : z -> nat

  val to_N : z -> n

  val of_nat : nat -> z

  val of_N : n -> z

  val to_pos : z -> positive

  val to_int : z -> signed_int

  val pos_div_eucl : positive -> z -> z * z

  val div_eucl : z -> z -> z * z

  val div : z -> z -> z

  val modulo : z -> z -> z

  val quotrem : z -> z -> z * z

  val quot : z -> z -> z

  val rem : z -> z -> z

  val div2 : z -> z

  val log2 : z -> z

  val ggcd : z -> z -> z * (z * z)

  val shiftl : z -> z -> z

  val shiftr : z -> z -> z

  val coq_lor : z -> z -> z

  val coq_land : z -> z -> z

  val ldiff : z -> z -> z

  val coq_lxor : z -> z -> z

  val eq_dec : z -> z -> bool

  val log2_up : z -> z

  val eqb_spec : z -> z -> reflect

  val b2z : bool -> z

  val lnot : z -> z

  val ones : z -> z
 end

val z_lt_dec : z -> z -> bool

val zeq_bool : z -> z -> bool

val to_N0 : char -> n

val zero0 : char

val one0 : char

val shift : bool -> char -> char

val eqb_spec0 : char -> char -> reflect

val ascii_of_pos : positive -> char

val ascii_of_N : n -> char

val n_of_digits : bool list -> n

val n_of_ascii : char -> n

val compare0 : char -> char -> comparison

val string_dec : char list -> char list -> bool

val eqb0 : char list -> char list -> bool

val eqb_spec1 : char list -> char list -> reflect

val compare1 : char list -> char list -> comparison

val append : char list -> char list -> char list

val length0 : char list -> nat

val substring : nat -> nat -> char list -> char list

val concat0 : char list -> char list list -> char list

val prefix : char list -> char list -> bool

type q = { qnum : z; qden : positive }

val inject_Z : z -> q

val qeq_bool : q -> q -> bool

val qle_bool : q -> q -> bool

val qplus : q -> q -> q

val qmult : q -> q -> q

val qopp : q -> q

val qminus : q -> q -> q

val qinv : q -> q

val qdiv : q -> q -> q

val qpower_positive : q -> positive -> q

val qpower : q -> z -> q

val qred : q -> q

val ascii_to_digit : char -> n option

module Raw :
 sig
  val of_pos : positive -> char list -> char list

  val to_N : char list -> n -> n
 end

val of_pos0 : positive -> char list

val of_Z : z -> char list

val to_N1 : char list -> n

val to_Z : char list -> z

val tab : char

val lF : char

val newPage : char

val cR : char

val newLine : char

val leb0 : char -> char -> bool

val is_upper : char -> bool

val is_lower : char -> bool

val to_lower : char -> char

val to_upper : char -> char

val is_whitespace : char -> bool

val string_of_list_ascii : char list -> char list

val list_ascii_of_string : char list -> char list

val lift_list_function : (char list -> char list) -> char list -> char list

val map0 : (char -> char) -> char list -> char list

val to_lower0 : char list -> char list

val to_upper0 : char list -> char list

val rev2 : char list -> char list

val take_while_drop_while :
  (char -> bool) -> char list -> char list * char list

val ltrim : char list -> char list

val rtrim : char list -> char list

val trim : char list -> char list

val startswith : char list -> char list -> bool

val endswith : char list -> char list -> bool

val strip_prefix_cps :
  (char list -> 'a1) -> (char list -> char list -> 'a1) -> char -> char list
  -> char list -> 'a1

val split_helper :
  char -> char list -> char list -> char list -> char list list

val split : char list -> char list -> char list list

val replace : char list -> char list -> char list -> char list

val split_newlines : char list list -> char list list

val repeat0 : char -> nat -> char list

val strip_trailing_spaces : char list -> char list

val strip_leading_newlines : char list list -> char list list

val strip_trailing_newlines : char list list -> char list list

val option_beq : ('a1 -> 'a1 -> bool) -> 'a1 option -> 'a1 option -> bool

val option_beq_hetero :
  ('a1 -> 'a2 -> bool) -> 'a1 option -> 'a2 option -> bool

val bind : 'a1 option -> ('a1 -> 'a2 option) -> 'a2 option

val sequence_return : 'a1 option -> 'a1 -> 'a1

val invert_Some : 'a1 option -> __

val prod_beq :
  ('a1 -> 'a1 -> bool) -> ('a2 -> 'a2 -> bool) -> ('a1 * 'a2) -> ('a1 * 'a2)
  -> bool

type decidable = bool

val dec : decidable -> bool

val dec_eq_Z : z -> z -> decidable

val list_beq : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list -> bool

val list_case : 'a2 -> ('a1 -> 'a1 list -> 'a2) -> 'a1 list -> 'a2

module List :
 sig
  val enumerate : 'a1 list -> (nat * 'a1) list
 end

val list_beq_hetero : ('a1 -> 'a2 -> bool) -> 'a1 list -> 'a2 list -> bool

val map2 : ('a1 -> 'a2 -> 'a3) -> 'a1 list -> 'a2 list -> 'a3 list

val update_nth : nat -> ('a1 -> 'a1) -> 'a1 list -> 'a1 list

val set_nth : nat -> 'a1 -> 'a1 list -> 'a1 list

val remove_duplicates' : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list

val remove_duplicates : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list

val find_duplicates' : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list

val find_duplicates : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list

val span_cps' :
  ('a1 -> bool) -> (('a1 list * 'a1 list) -> 'a2) -> 'a1 list -> 'a1 list ->
  'a2

val span_cps :
  ('a1 -> bool) -> 'a1 list -> (('a1 list * 'a1 list) -> 'a2) -> 'a2

val span : ('a1 -> bool) -> 'a1 list -> 'a1 list * 'a1 list

val takeWhile : ('a1 -> bool) -> 'a1 list -> 'a1 list

val dropWhile : ('a1 -> bool) -> 'a1 list -> 'a1 list

type 't tuple' = __

type 't tuple = __

val cons' : nat -> 'a1 -> 'a1 tuple' -> 'a1 tuple'

val cons : nat -> 'a1 -> 'a1 tuple -> 'a1 tuple

val tl' : nat -> 'a1 tuple' -> 'a1 tuple'

val tl0 : nat -> 'a1 tuple -> 'a1 tuple

val hd' : nat -> 'a1 tuple' -> 'a1

val hd0 : nat -> 'a1 tuple -> 'a1

val to_list' : nat -> 'a1 tuple' -> 'a1 list

val to_list : nat -> 'a1 tuple -> 'a1 list

val from_list'_obligation_1 : 'a1 -> 'a1 list -> 'a1 tuple'

val from_list'_obligation_2 : nat -> 'a1 tuple'

val from_list' : 'a1 -> nat -> 'a1 list -> 'a1 tuple'

val from_list_obligation_1 : 'a1 -> 'a1 list -> 'a1 tuple

val from_list_obligation_2 : nat -> 'a1 tuple

val from_list : nat -> 'a1 list -> 'a1 tuple

val on_tuple2 :
  ('a1 list -> 'a2 list -> 'a3 list) -> nat -> nat -> nat -> 'a1 tuple -> 'a2
  tuple -> 'a3 tuple

val map1 : nat -> ('a1 -> 'a2 -> 'a3) -> 'a1 tuple -> 'a2 tuple -> 'a3 tuple

val from_list_default' : 'a1 -> 'a1 -> nat -> 'a1 list -> 'a1 tuple'

val from_list_default : 'a1 -> nat -> 'a1 list -> 'a1 tuple

val append0 : nat -> 'a1 -> 'a1 tuple -> 'a1 tuple

val nth_default0 : nat -> 'a1 -> nat -> 'a1 tuple -> 'a1

val repeat1 : 'a1 -> nat -> 'a1 tuple

module Option :
 sig
  module List :
   sig
    val map : ('a1 -> 'a2 option) -> 'a1 list -> 'a2 list

    val bind_list : 'a1 option list -> ('a1 list -> 'a2 option) -> 'a2 option

    val lift : 'a1 option list -> 'a1 list option
   end
 end

type rEG =
| Rax
| Rcx
| Rdx
| Rbx
| Rsp
| Rbp
| Rsi
| Rdi
| R8
| R9
| R10
| R11
| R12
| R13
| R14
| R15
| Eax
| Ecx
| Edx
| Ebx
| Esp
| Ebp
| Esi
| Edi
| R8d
| R9d
| R10d
| R11d
| R12d
| R13d
| R14d
| R15d
| Ax
| Cx
| Dx
| Bx
| Sp
| Bp
| Si
| Di
| R8w
| R9w
| R10w
| R11w
| R12w
| R13w
| R14w
| R15w
| Ah
| Al
| Ch
| Cl
| Dh
| Dl
| Bh
| Bl
| Spl
| Bpl
| Sil
| Dil
| R8b
| R9b
| R10b
| R11b
| R12b
| R13b
| R14b
| R15b

val rEG_beq : rEG -> rEG -> bool

type cONST = z

val cONST_of_Z : z -> cONST

type accessSize =
| Byte
| Word
| Dword
| Qword

val accessSize_beq : accessSize -> accessSize -> bool

val bits_of_AccessSize : accessSize -> n

type mEM = { mem_bits_access_size : accessSize option;
             mem_base_reg : rEG option; mem_scale_reg : (z * rEG) option;
             mem_base_label : char list option; mem_offset : z option }

val internal_positive_beq : positive -> positive -> bool

val mem_of_reg : rEG -> mEM

type fLAG =
| CF
| PF
| AF
| ZF
| SF
| OF

type opPrefix =
| Rep
| Repz
| Repnz

val opPrefix_beq : opPrefix -> opPrefix -> bool

type opCode =
| Adc
| Adcx
| Add
| Adox
| And
| Bzhi
| Call
| Clc
| Cmovb
| Cmovc
| Cmovnz
| Cmovo
| Cmp
| Db0
| Dd0
| Dec
| Dq
| Dw
| Imul
| Inc
| Je
| Jmp
| Lea
| Mov
| Movzx
| Mul
| Mulx
| Or
| Pop
| Push
| Rcr
| Ret
| Sar
| Sbb
| Setc
| Seto
| Shl
| Shlx
| Shr
| Shrx
| Shrd
| Sub
| Test
| Xchg
| Xor

val opCode_beq : opCode -> opCode -> bool

type jUMP_LABEL = { jump_near : bool; label_name : char list }

type aRG =
| Reg of rEG
| Mem of mEM
| Const of cONST
| Label of jUMP_LABEL

type normalInstruction = { prefix0 : opPrefix option; op : opCode;
                           args : aRG list }

type rawLine =
| SECTION of char list
| GLOBAL of char list
| LABEL of char list
| ALIGN of char list
| DEFAULT_REL
| EMPTY
| INSTR of normalInstruction

type line = { indent : char list; rawline : rawLine;
              pre_comment_whitespace : char list; comment : char list option;
              line_number : n }

val internal_N_beq : n -> n -> bool

type lines = line list

val reg_size : rEG -> n

val standalone_operand_size : aRG -> n option

val opcode_size : opCode -> n option

val operation_size : normalInstruction -> n option

val operand_size : aRG -> n -> n

val reg_index : rEG -> nat

val reg_offset : rEG -> n

val index_and_shift_and_bitcount_of_reg : rEG -> (nat * n) * n

val regs_of_index : nat -> rEG list list

val widest_register_of_index : nat -> rEG

val reg_of_index_and_shift_and_bitcount_opt : ((nat * n) * n) -> rEG option

val sum_beq :
  ('a1 -> 'a1 -> bool) -> ('a2 -> 'a2 -> bool) -> ('a1, 'a2) sum -> ('a1,
  'a2) sum -> bool

val dec_sumwise :
  ('a1 -> 'a1 -> decidable) -> ('a2 -> 'a2 -> decidable) -> ('a1, 'a2) sum ->
  ('a1, 'a2) sum -> decidable

module Sum :
 sig
  val compare :
    ('a1 -> 'a1 -> comparison) -> ('a2 -> 'a2 -> comparison) -> ('a1, 'a2)
    sum -> ('a1, 'a2) sum -> comparison
 end

val reflect_of_brel : ('a1 -> 'a2 -> bool) -> 'a1 -> 'a2 -> reflect

val reflect_of_beq : ('a1 -> 'a1 -> bool) -> 'a1 -> 'a1 -> reflect

val reflect_of_BoolSpec : bool -> reflect

val reflect_rel_of_BoolSpec : ('a1 -> 'a1 -> bool) -> 'a1 -> 'a1 -> reflect

val cONST_beq : cONST -> cONST -> bool

val jUMP_LABEL_beq : jUMP_LABEL -> jUMP_LABEL -> bool

val mEM_beq : mEM -> mEM -> bool

val aRG_beq : aRG -> aRG -> bool

val normalInstruction_beq : normalInstruction -> normalInstruction -> bool

val rawLine_beq : rawLine -> rawLine -> bool

val line_beq : line -> line -> bool

type 't parserAction = char list -> ('t * char list) list

val parse_impossible : 'a1 parserAction

val parse_empty : unit parserAction

val parse_seq_gen :
  ('a1 -> 'a2 -> 'a3) -> 'a1 parserAction -> 'a2 parserAction -> 'a3
  parserAction

val parse_alt_gen :
  (('a1, 'a2) sum -> 'a3) -> 'a1 parserAction -> 'a2 parserAction -> 'a3
  parserAction

val parse_alt : 'a1 parserAction -> 'a1 parserAction -> 'a1 parserAction

val parse_or_else_gen :
  (('a1, 'a2) sum -> 'a3) -> 'a1 parserAction -> 'a2 parserAction -> 'a3
  parserAction

val parse_or_else : 'a1 parserAction -> 'a1 parserAction -> 'a1 parserAction

val parse_alpha_char : bool -> bool -> char parserAction

val parse_ascii : char -> char parserAction

val parse_str : char list -> char list parserAction

val parse_str_case_insensitive : char list -> char list parserAction

val parse_map : ('a1 -> 'a2) -> 'a1 parserAction -> 'a2 parserAction

val parse_flat_map : ('a1 -> 'a2 list) -> 'a1 parserAction -> 'a2 parserAction

val parse_option_list_map :
  ('a1 -> 'a2 option) -> 'a1 parserAction -> 'a2 parserAction

val parse_maybe : 'a1 parserAction -> 'a1 option parserAction

val option_list_to_list : 'a1 list option -> 'a1 list

val fuel : (nat -> 'a1 parserAction) -> 'a1 parserAction

val parse_plus_fueled : 'a1 parserAction -> nat -> 'a1 list parserAction

val parse_plus : 'a1 parserAction -> 'a1 list parserAction

val parse_star : 'a1 parserAction -> 'a1 list parserAction

val parse_lookahead_not : 'a1 parserAction -> unit parserAction

val parse_alt_list : 'a1 parserAction list -> 'a1 parserAction

val parse_strs : (char list * 'a1) list -> 'a1 parserAction

val parse_strs_case_insensitive : (char list * 'a1) list -> 'a1 parserAction

val parse_one_whitespace : char list parserAction

val parse_any_whitespace : char list list parserAction

val strip_whitespace_around : 'a1 parserAction -> 'a1 parserAction

val strip_whitespace_after : 'a1 parserAction -> 'a1 parserAction

val parse_list_gen :
  char list -> char list -> char list -> 'a1 parserAction -> 'a1 list
  parserAction

val parse_list : 'a1 parserAction -> 'a1 list parserAction

val parse_comma_list : 'a1 parserAction -> 'a1 list parserAction

val finalize : 'a1 parserAction -> char list -> 'a1 option

val ascii_to_digit0 : char -> n option

module Coq_Raw :
 sig
  val of_pos : positive -> char list -> char list

  val to_N : char list -> n -> n
 end

val of_pos1 : positive -> char list

val of_Z0 : z -> char list

val to_N2 : char list -> n

val to_Z0 : char list -> z

val ascii_to_digit1 : char -> n option

module Coq0_Raw :
 sig
  val of_pos : positive -> char list -> char list

  val to_N : char list -> n -> n
 end

val of_pos2 : positive -> char list

val of_Z1 : z -> char list

val to_N3 : char list -> n

val to_Z1 : char list -> z

val uint_of_char : char -> uint option -> uint option

module NilEmpty :
 sig
  val string_of_uint : uint -> char list

  val uint_of_string : char list -> uint option

  val string_of_int : signed_int -> char list

  val int_of_string : char list -> signed_int option
 end

module NilZero :
 sig
  val string_of_uint : uint -> char list

  val string_of_int : signed_int -> char list
 end

module Coq0_N :
 sig
  val to_string : n -> char list
 end

module Coq0_Pos :
 sig
  val to_string : positive -> char list
 end

module Coq0_Z :
 sig
  val of_string : char list -> z option

  val to_string : z -> char list
 end

module Coq_List :
 sig
  val groupAllBy' : ('a1 -> 'a1 -> bool) -> 'a1 list -> nat -> 'a1 list list

  val groupAllBy : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list list
 end

val parse_bin_prefix : char list parserAction

val parse_oct_prefix : char list parserAction

val parse_dec_prefix : char list parserAction

val parse_hex_prefix : char list parserAction

val parse_hex_postfix : char list parserAction

val base_accepts_E : n -> bool

val parse_digits_gen_step : n -> n parserAction

val digits_to_N : n -> n list -> n

val parse_N_digits : n -> n parserAction

val parse_num_gen :
  bool -> n -> 'a1 parserAction option -> 'a2 parserAction option -> q
  parserAction

val parse_num_gen_prefix : bool -> n -> 'a1 parserAction -> q parserAction

val parse_num_gen_postfix : bool -> n -> 'a1 parserAction -> q parserAction

val parse_num : bool -> q parserAction

type 'var qexpr_poly =
| Qvar of 'var
| Qv of q
| Qeopp of 'var qexpr_poly
| Qeadd of 'var qexpr_poly * 'var qexpr_poly
| Qesub of 'var qexpr_poly * 'var qexpr_poly
| Qemul of 'var qexpr_poly * 'var qexpr_poly
| Qediv of 'var qexpr_poly * 'var qexpr_poly
| Qepow of 'var qexpr_poly * 'var qexpr_poly

type ('t, 'var) monomial_in = ('t * ('var * z)) * ('var * z) list

type ('t, 'var) poly_in = 't * ('t, 'var) monomial_in list

val reduce_monomial :
  ('a2 -> 'a2 -> bool) -> ('a1, 'a2) monomial_in -> ('a1, ('a1, 'a2)
  monomial_in) sum

val const_poly : 'a1 -> ('a1, 'a2) poly_in

val var_monomial : 'a1 -> 'a2 -> ('a1, 'a2) monomial_in

val var_poly : 'a1 -> 'a1 -> 'a2 -> ('a1, 'a2) poly_in

val add_poly :
  ('a1 -> 'a1 -> 'a1) -> ('a1, 'a2) poly_in -> ('a1, 'a2) poly_in -> ('a1,
  'a2) poly_in

val mul_monomial :
  ('a1 -> 'a1 -> 'a1) -> ('a1, 'a2) monomial_in -> ('a1, 'a2) monomial_in ->
  ('a1, 'a2) monomial_in

val scmul_monomial :
  ('a1 -> 'a1 -> 'a1) -> 'a1 -> ('a1, 'a2) monomial_in -> ('a1, 'a2)
  monomial_in

val mul_poly :
  ('a1 -> 'a1 -> 'a1) -> ('a1 -> 'a1 -> 'a1) -> ('a1, 'a2) poly_in -> ('a1,
  'a2) poly_in -> ('a1, 'a2) poly_in

val pow_monomial :
  ('a1 -> z -> 'a1) -> ('a1, 'a2) monomial_in -> z -> ('a1, 'a2) monomial_in

val pow_poly_strict :
  ('a1 -> 'a1 -> 'a1) -> ('a1 -> 'a1 -> 'a1) -> ('a1 -> z -> 'a1 option) ->
  'a1 -> ('a1, 'a2) poly_in -> z -> ('a1, 'a2) poly_in option

val monomial_var_part_beq :
  ('a2 -> 'a2 -> bool) -> ('a1, 'a2) monomial_in -> ('a1, 'a2) monomial_in ->
  bool

val reduce_poly :
  ('a2 -> 'a2 -> bool) -> ('a1 -> bool) -> ('a1 -> 'a1) -> ('a1 -> 'a1 ->
  'a1) -> ('a1, 'a2) poly_in -> ('a1, 'a2) poly_in

val reduce_Qpoly :
  ('a1 -> 'a1 -> bool) -> (q, 'a1) poly_in -> (q, 'a1) poly_in

val poly_coef_map_strict :
  ('a1 -> 'a2 option) -> ('a1, 'a3) poly_in -> ('a2, 'a3) poly_in option

val eval_Qexpr_poly_strict : 'a1 qexpr_poly -> (q, 'a1) poly_in option

val eval_Qexpr_strict : empty_set qexpr_poly -> q option

val eval_Qexpr_poly_reduced_strict :
  ('a1 -> 'a1 -> bool) -> 'a1 qexpr_poly -> (q, 'a1) poly_in option

val parse_ops :
  (char list * ('a1 -> 'a1 -> 'a1)) list -> 'a1 parserAction -> 'a1
  parserAction

val parse_prefix_ops :
  (char list * ('a1 -> 'a1)) list -> 'a1 parserAction -> 'a1 parserAction

val parseQexpr_poly_gen_parens :
  q parserAction -> 'a1 parserAction -> 'a1 qexpr_poly parserAction -> 'a1
  qexpr_poly parserAction

val parseQexpr_poly_gen_exp :
  q parserAction -> 'a1 parserAction -> 'a1 qexpr_poly parserAction -> 'a1
  qexpr_poly parserAction

val parseQexpr_poly_gen_opp :
  q parserAction -> 'a1 parserAction -> 'a1 qexpr_poly parserAction -> 'a1
  qexpr_poly parserAction

val parseQexpr_poly_gen_mul_div :
  q parserAction -> 'a1 parserAction -> 'a1 qexpr_poly parserAction -> 'a1
  qexpr_poly parserAction

val parseQexpr_poly_gen_add_sub :
  q parserAction -> 'a1 parserAction -> 'a1 qexpr_poly parserAction -> 'a1
  qexpr_poly parserAction

val parse_Qexpr_poly_fueled :
  q parserAction -> 'a1 parserAction -> nat -> 'a1 qexpr_poly parserAction

val parse_Qexpr_poly_gen :
  q parserAction -> 'a1 parserAction -> 'a1 qexpr_poly parserAction

val parse_Qexpr_poly : 'a1 parserAction -> 'a1 qexpr_poly parserAction

val parse_Qexpr_with_vars :
  (char list * q) list -> empty_set qexpr_poly parserAction

val q_to_Z_strict : q -> z option

val parse_Q_strict_with_vars : (char list * q) list -> q parserAction

val parse_Q_poly_strict :
  ('a1 -> 'a1 -> bool) -> 'a1 parserAction -> (q, 'a1) poly_in parserAction

val parse_Z_strict_with_vars : (char list * q) list -> z parserAction

val parse_Z_poly_strict :
  ('a1 -> 'a1 -> bool) -> 'a1 parserAction -> (z, 'a1) poly_in parserAction

val parseQexpr_arith_with_vars :
  (char list * q) list -> char list -> empty_set qexpr_poly option

val parseQ_arith_strict_with_vars :
  (char list * q) list -> char list -> q option

val parseZ_arith_strict_with_vars :
  (char list * q) list -> char list -> z option

val parseN_arith_strict_with_vars :
  (char list * q) list -> char list -> n option

val parsenat_arith_strict_with_vars :
  (char list * q) list -> char list -> nat option

val parse_Qexpr : empty_set qexpr_poly parserAction

val parseQexpr_arith : char list -> empty_set qexpr_poly option

val parseQ_arith_strict : char list -> q option

val parseZ_arith_strict : char list -> z option

val parseN_arith_strict : char list -> n option

val parsenat_arith_strict : char list -> nat option

val parse_Z_arith_strict : z parserAction

val let_In : 'a1 -> ('a1 -> 'a2) -> 'a2

module Coq1_Z :
 sig
  val divideb : z -> z -> bool

  val zselect : z -> z -> z -> z

  val add_modulo : z -> z -> z -> z

  val lnot_modulo : z -> z -> z

  val bneg : z -> z

  val cc_m : z -> z -> z

  val rshi : z -> z -> z -> z -> z

  val truncating_shiftl : z -> z -> z -> z

  val get_carry : z -> z -> z * z

  val add_with_carry : z -> z -> z -> z

  val add_with_get_carry : z -> z -> z -> z -> z * z

  val add_get_carry : z -> z -> z -> z * z

  val get_borrow : z -> z -> z * z

  val sub_with_borrow : z -> z -> z -> z

  val sub_with_get_borrow : z -> z -> z -> z -> z * z

  val sub_get_borrow : z -> z -> z -> z * z

  val add_get_carry_full : z -> z -> z -> z * z

  val add_with_get_carry_full : z -> z -> z -> z -> z * z

  val sub_get_borrow_full : z -> z -> z -> z * z

  val sub_with_get_borrow_full : z -> z -> z -> z -> z * z

  val mul_split_at_bitwidth : z -> z -> z -> z * z

  val mul_split : z -> z -> z -> z * z

  val mul_high : z -> z -> z -> z

  val ltz : z -> z -> z

  val combine_at_bitwidth : z -> z -> z -> z

  val round_lor_land_bound : z -> z

  val log10_fuel : nat -> z -> z

  val log10 : z -> z

  val value_barrier : z -> z
 end

module Level :
 sig
  type coq_Level =
  | Coq_neg_inf
  | Coq_level of z
  | Coq_pos_inf

  val internal_positive_beq : positive -> positive -> bool

  val internal_Z_beq : z -> z -> bool

  val next : coq_Level -> coq_Level

  val prev : coq_Level -> coq_Level

  val compare : coq_Level -> coq_Level -> comparison

  val ltb : coq_Level -> coq_Level -> bool
 end

type associativity =
| LeftAssoc
| RightAssoc
| NoAssoc
| FullyAssoc
| ExplicitAssoc of Level.coq_Level * Level.coq_Level

type 't showLevel = 't -> Level.coq_Level -> char list

val show_lvl : 'a1 showLevel -> 'a1 -> Level.coq_Level -> char list

type ('a, 'b) showLevel2 = 'a -> 'b -> Level.coq_Level -> char list

type ('a, 'b, 'c) showLevel3 = 'a -> 'b -> 'c -> Level.coq_Level -> char list

type 't show = 't -> char list

val show0 : 'a1 show -> 'a1 -> char list

type 't showLines = 't -> char list list

val show_lines : 'a1 showLines -> 'a1 -> char list list

val show_of_ShowLevel : 'a1 showLevel -> 'a1 show

val showLines_of_Show : 'a1 show -> 'a1 showLines

val show_of_ShowLines : 'a1 showLines -> 'a1 show

val show_lvl_const : (unit -> char list) showLevel

val show_lvl_id : (Level.coq_Level -> char list) showLevel

val maybe_wrap_parens : bool -> char list -> char list

val show_wrap_parens : Level.coq_Level -> 'a1 showLevel -> 'a1 showLevel

val lvl_wrap_parens :
  Level.coq_Level -> char list -> Level.coq_Level -> char list

val neg_wrap_parens_with_lvl :
  (Level.coq_Level -> char list) -> Level.coq_Level -> char list

val neg_wrap_parens : char list -> Level.coq_Level -> char list

val showLevel2_binop_assoc :
  associativity -> Level.coq_Level -> char list -> 'a1 showLevel -> 'a2
  showLevel -> ('a1, 'a2) showLevel2

val show_lvl_binop :
  associativity -> Level.coq_Level -> 'a1 showLevel -> 'a2 showLevel -> 'a1
  -> char list -> 'a2 -> Level.coq_Level -> char list

val show_lvl_app : 'a1 showLevel -> 'a2 showLevel -> ('a1, 'a2) showLevel2

val show_lvl_app2 :
  'a1 showLevel -> 'a2 showLevel -> 'a3 showLevel -> ('a1, 'a2, 'a3)
  showLevel3

val show_lvl_preop_assoc :
  associativity -> Level.coq_Level -> 'a1 showLevel -> char list -> 'a1 ->
  Level.coq_Level -> char list

val show_lvl_postop_assoc :
  associativity -> Level.coq_Level -> 'a1 showLevel -> 'a1 -> char list ->
  Level.coq_Level -> char list

val show_lvl_unop :
  Level.coq_Level -> char list -> 'a1 showLevel -> 'a1 showLevel

val show_lvl_unit : unit showLevel

val show_lvl_bool : bool showLevel

val show_lvl_option : 'a1 showLevel -> 'a1 option showLevel

val show_lvl_list : 'a1 showLevel -> 'a1 list showLevel

val show_list : 'a1 show -> 'a1 list show

val show_lvl_prod : 'a1 showLevel -> 'a2 showLevel -> ('a1 * 'a2) showLevel

val show_prod : 'a1 show -> 'a2 show -> ('a1 * 'a2) show

val show_lvl_sum : 'a1 showLevel -> 'a2 showLevel -> ('a1, 'a2) sum showLevel

val show_lvl_string : char list showLevel

val show_lines_list : 'a1 showLines -> 'a1 list showLines

module Decimal :
 sig
  val show_lvl_positive : positive showLevel

  val show_positive : positive show

  val show_lvl_N : n showLevel

  val show_N : n show

  val show_lvl_nat : nat showLevel

  val show_nat : nat show

  val show_lvl_Z : z showLevel

  val show_Z : z show

  val show_lvl_Q_frac : q showLevel

  val show_lvl_Q : q showLevel

  val show_Q : q show
 end

module Hex :
 sig
  val show_lvl_positive : positive showLevel

  val show_lvl_Z : z showLevel

  val show_Z : z show

  val show_lvl_N : n showLevel

  val show_N : n show
 end

module PowersOfTwo :
 sig
  val show_lvl_Z_up_to' : nat -> z -> bool -> z showLevel

  val show_lvl_Z_up_to : nat -> z -> z showLevel

  val show_lvl_Z : z showLevel

  val show_Z : z show
 end

type ('errT, 't) errorT =
| Success of 't
| Error of 'errT

val bind0 :
  ('a3, 'a1) errorT -> ('a1 -> ('a3, 'a2) errorT) -> ('a3, 'a2) errorT

val map3 :
  ('a3 -> 'a4) -> ('a1 -> 'a2) -> ('a1, 'a3) errorT -> ('a2, 'a4) errorT

val map_error : ('a1 -> 'a2) -> ('a1, 'a3) errorT -> ('a2, 'a3) errorT

val show_REG : rEG show

val show_lvl_REG : rEG showLevel

val show_FLAG : fLAG show

val show_OpCode : opCode show

val show_OpPrefix : opPrefix show

val parse_REG_list : (char list * rEG) list

val parse_REG : rEG parserAction

val parse_AccessSize_list : (char list * accessSize) list

val parse_AccessSize : accessSize parserAction

val parse_label : char list parserAction

val parse_MEM : mEM parserAction

val parse_CONST : bool -> cONST parserAction

val parse_JUMP_LABEL : jUMP_LABEL parserAction

val parse_ARG : bool -> aRG parserAction

val parse_OpCode_list : (char list * opCode) list

val parse_OpCode : opCode parserAction

val parse_OpPrefix_list : (char list * opPrefix) list

val parse_OpPrefix : opPrefix parserAction

val parse_RawLine : rawLine parserAction

val parse_Line : n -> line parserAction

val parse_Lines' : char list list -> n -> (char list list, lines) errorT

val parse_Lines : char list list -> (char list list, lines) errorT

val show_lvl_MEM : mEM showLevel

val show_lvl_JUMP_LABEL : jUMP_LABEL showLevel

val show_JUMP_LABEL : jUMP_LABEL show

val show_lvl_ARG : aRG showLevel

val show_ARG : aRG show

val show_NormalInstruction : normalInstruction show

val show_RawLine : rawLine show

val show_Line : line show

val show_Line_with_line_number : line show

val show_lines_Lines : lines showLines

type parseError =
  char list list
  (* singleton inductive, whose constructor was Parse_error *)

type parseValidatedError =
| Initial_parse_error of parseError
| Reparse_error of char list list * parseError
| Lengths_not_equal of lines * lines
| Lines_not_equal of (line * line) list
| Duplicate_labels of (char list * nat) list

val show_lines_ParseError : parseError showLines

val show_lines_ParseValidatedError : parseValidatedError showLines

val parse_validated : char list list -> (parseValidatedError, lines) errorT

val find_globals : lines -> char list list

val split_code_to_functions' :
  char list list -> lines -> lines * (char list * lines) list

val split_code_to_functions : lines -> lines * (char list * lines) list

type 'x compare2 =
| LT
| EQ
| GT

module type Coq_OrderedType =
 sig
  type t

  val compare : t -> t -> t compare2

  val eq_dec : t -> t -> bool
 end

module Coq_OrderedTypeFacts :
 functor (O:Coq_OrderedType) ->
 sig
  module TO :
   sig
    type t = O.t
   end

  module IsTO :
   sig
   end

  module OrderTac :
   sig
   end

  val eq_dec : O.t -> O.t -> bool

  val lt_dec : O.t -> O.t -> bool

  val eqb : O.t -> O.t -> bool
 end

module KeyOrderedType :
 functor (O:Coq_OrderedType) ->
 sig
  module MO :
   sig
    module TO :
     sig
      type t = O.t
     end

    module IsTO :
     sig
     end

    module OrderTac :
     sig
     end

    val eq_dec : O.t -> O.t -> bool

    val lt_dec : O.t -> O.t -> bool

    val eqb : O.t -> O.t -> bool
   end
 end

module String_as_OT :
 sig
  type t = char list

  val cmp : char list -> char list -> comparison

  val compare : char list -> char list -> char list compare2

  val eq_dec : char list -> char list -> bool
 end

val append1 : positive -> positive -> positive

module PositiveMap :
 sig
  type key = positive

  type 'a tree =
  | Leaf
  | Node of 'a tree * 'a option * 'a tree

  type 'a t = 'a tree

  val empty : 'a1 t

  val find : key -> 'a1 t -> 'a1 option

  val mem : key -> 'a1 t -> bool

  val add : key -> 'a1 -> 'a1 t -> 'a1 t

  val xelements : 'a1 t -> key -> (key * 'a1) list

  val elements : 'a1 t -> (key * 'a1) list
 end

type zrange = { lower : z; upper : z }

val zrange_rect_nodep : (z -> z -> 'a1) -> zrange -> 'a1

val is_bounded_by_bool : z -> zrange -> bool

val is_tighter_than_bool : zrange -> zrange -> bool

val zrange_beq : zrange -> zrange -> bool

val reflect_zrange_eq : zrange -> zrange -> reflect

val subscript_map : (char * char list) list

module Ascii :
 sig
  val to_subscript_opt : char -> char list option

  val to_subscript : char -> char list
 end

module WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING :
 sig
  module String :
   sig
    val to_subscript : char list -> char list
   end
 end

module N_as_OT :
 sig
  type t = n

  val zero : n

  val one : n

  val two : n

  val succ_double : n -> n

  val double : n -> n

  val succ : n -> n

  val pred : n -> n

  val succ_pos : n -> positive

  val add : n -> n -> n

  val sub : n -> n -> n

  val mul : n -> n -> n

  val compare : n -> n -> comparison

  val eqb : n -> n -> bool

  val leb : n -> n -> bool

  val ltb : n -> n -> bool

  val min : n -> n -> n

  val max : n -> n -> n

  val div2 : n -> n

  val even : n -> bool

  val odd : n -> bool

  val pow : n -> n -> n

  val square : n -> n

  val log2 : n -> n

  val size : n -> n

  val size_nat : n -> nat

  val pos_div_eucl : positive -> n -> n * n

  val div_eucl : n -> n -> n * n

  val div : n -> n -> n

  val modulo : n -> n -> n

  val gcd : n -> n -> n

  val ggcd : n -> n -> n * (n * n)

  val sqrtrem : n -> n * n

  val sqrt : n -> n

  val coq_lor : n -> n -> n

  val coq_land : n -> n -> n

  val ldiff : n -> n -> n

  val coq_lxor : n -> n -> n

  val shiftl_nat : n -> nat -> n

  val shiftr_nat : n -> nat -> n

  val shiftl : n -> n -> n

  val shiftr : n -> n -> n

  val testbit_nat : n -> nat -> bool

  val testbit : n -> n -> bool

  val to_nat : n -> nat

  val of_nat : nat -> n

  val iter : n -> ('a1 -> 'a1) -> 'a1 -> 'a1

  val of_uint : uint -> n

  val of_hex_uint : uint0 -> n

  val of_num_uint : uint1 -> n

  val of_int : signed_int -> n option

  val of_hex_int : signed_int0 -> n option

  val of_num_int : signed_int1 -> n option

  val to_uint : n -> uint

  val to_hex_uint : n -> uint0

  val to_num_uint : n -> uint1

  val to_num_hex_uint : n -> uint1

  val to_int : n -> signed_int

  val to_hex_int : n -> signed_int0

  val to_num_int : n -> signed_int1

  val to_num_hex_int : n -> signed_int1

  val eq_dec : n -> n -> bool

  val discr : n -> positive option

  val binary_rect : 'a1 -> (n -> 'a1 -> 'a1) -> (n -> 'a1 -> 'a1) -> n -> 'a1

  val binary_rec : 'a1 -> (n -> 'a1 -> 'a1) -> (n -> 'a1 -> 'a1) -> n -> 'a1

  val peano_rect : 'a1 -> (n -> 'a1 -> 'a1) -> n -> 'a1

  val peano_rec : 'a1 -> (n -> 'a1 -> 'a1) -> n -> 'a1

  val recursion : 'a1 -> (n -> 'a1 -> 'a1) -> n -> 'a1

  val leb_spec0 : n -> n -> reflect

  val ltb_spec0 : n -> n -> reflect

  module Private_OrderTac :
   sig
    module IsTotal :
     sig
     end

    module Tac :
     sig
     end
   end

  val measure_right_induction :
    ('a1 -> n) -> n -> ('a1 -> __ -> ('a1 -> __ -> 'a2) -> 'a2) -> 'a1 -> 'a2

  val measure_left_induction :
    ('a1 -> n) -> n -> ('a1 -> __ -> ('a1 -> __ -> 'a2) -> 'a2) -> 'a1 -> 'a2

  val measure_induction :
    ('a1 -> n) -> ('a1 -> ('a1 -> __ -> 'a2) -> 'a2) -> 'a1 -> 'a2

  module Private_Tac :
   sig
   end

  module Private_Dec :
   sig
    val max_case_strong :
      n -> n -> (n -> n -> __ -> 'a1 -> 'a1) -> (__ -> 'a1) -> (__ -> 'a1) ->
      'a1

    val max_case : n -> n -> (n -> n -> __ -> 'a1 -> 'a1) -> 'a1 -> 'a1 -> 'a1

    val max_dec : n -> n -> bool

    val min_case_strong :
      n -> n -> (n -> n -> __ -> 'a1 -> 'a1) -> (__ -> 'a1) -> (__ -> 'a1) ->
      'a1

    val min_case : n -> n -> (n -> n -> __ -> 'a1 -> 'a1) -> 'a1 -> 'a1 -> 'a1

    val min_dec : n -> n -> bool
   end

  val max_case_strong : n -> n -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1

  val max_case : n -> n -> 'a1 -> 'a1 -> 'a1

  val max_dec : n -> n -> bool

  val min_case_strong : n -> n -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1

  val min_case : n -> n -> 'a1 -> 'a1 -> 'a1

  val min_dec : n -> n -> bool

  module Private_NZPow :
   sig
   end

  module Private_NZSqrt :
   sig
   end

  val sqrt_up : n -> n

  val log2_up : n -> n

  module Private_NZGcdProp :
   sig
   end

  module Private_NDivProp :
   sig
    module Private_NZDiv :
     sig
     end
   end

  module Div0 :
   sig
   end

  module Private_NLcmProp :
   sig
    val lcm : n -> n -> n
   end

  val lcm : n -> n -> n

  module Lcm0 :
   sig
   end

  val eqb_spec : n -> n -> reflect

  val b2n : bool -> n

  val setbit : n -> n -> n

  val clearbit : n -> n -> n

  val ones : n -> n

  val lnot : n -> n -> n
 end

module PositiveOrderedTypeBits :
 sig
  type t = positive

  val eqb : positive -> positive -> bool

  val eq_dec : positive -> positive -> bool

  val compare : positive -> positive -> comparison
 end

module Ascii_as_OT :
 sig
  val compare : char -> char -> comparison
 end

module Coq_String_as_OT :
 sig
  type t = char list

  val eqb : char list -> char list -> bool

  val eq_dec : char list -> char list -> bool

  val compare : char list -> char list -> comparison
 end

module SumOrderedType :
 functor (E1:OrderedType) ->
 functor (E2:OrderedType) ->
 sig
  type t = (E1.t, E2.t) sum

  val compare : (E1.t, E2.t) sum -> (E1.t, E2.t) sum -> comparison

  val eq_dec : (E1.t, E2.t) sum -> (E1.t, E2.t) sum -> bool
 end

module Coq0_List :
 sig
  val foldmap : ('a1 -> 'a3 -> 'a2 * 'a3) -> 'a1 list -> 'a3 -> 'a2 list * 'a3
 end

module Coq1_List :
 sig
  val indexof : ('a1 -> bool) -> 'a1 list -> nat option
 end

module Sort :
 functor (X:TotalLeBool') ->
 sig
  val merge : X.t list -> X.t list -> X.t list

  val merge_list_to_stack :
    X.t list option list -> X.t list -> X.t list option list

  val merge_stack : X.t list option list -> X.t list

  val iter_merge : X.t list option list -> X.t list -> X.t list

  val sort : X.t list -> X.t list

  val flatten_stack : X.t list option list -> X.t list
 end

module Coq1_N :
 sig
  module Order :
   sig
    type t = n

    val ltb : n -> n -> bool

    val leb : n -> n -> bool
   end

  module Sort :
   sig
    val merge : n list -> n list -> n list

    val merge_list_to_stack :
      n list option list -> n list -> n list option list

    val merge_stack : n list option list -> n list

    val iter_merge : n list option list -> n list -> n list

    val sort : n list -> n list

    val flatten_stack : n list option list -> n list
   end
 end

module type WSets =
 sig
  module E :
   DecidableType

  type elt = E.t

  type t

  val empty : t

  val is_empty : t -> bool

  val mem : elt -> t -> bool

  val add : elt -> t -> t

  val singleton : elt -> t

  val remove : elt -> t -> t

  val union : t -> t -> t

  val inter : t -> t -> t

  val diff : t -> t -> t

  val equal : t -> t -> bool

  val subset : t -> t -> bool

  val fold : (elt -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1

  val for_all : (elt -> bool) -> t -> bool

  val exists_ : (elt -> bool) -> t -> bool

  val filter : (elt -> bool) -> t -> t

  val partition : (elt -> bool) -> t -> t * t

  val cardinal : t -> nat

  val elements : t -> elt list

  val choose : t -> elt option

  val eq_dec : t -> t -> bool
 end

module type Sets =
 sig
  module E :
   OrderedType

  type elt = E.t

  type t

  val empty : t

  val is_empty : t -> bool

  val mem : elt -> t -> bool

  val add : elt -> t -> t

  val singleton : elt -> t

  val remove : elt -> t -> t

  val union : t -> t -> t

  val inter : t -> t -> t

  val diff : t -> t -> t

  val equal : t -> t -> bool

  val subset : t -> t -> bool

  val fold : (elt -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1

  val for_all : (elt -> bool) -> t -> bool

  val exists_ : (elt -> bool) -> t -> bool

  val filter : (elt -> bool) -> t -> t

  val partition : (elt -> bool) -> t -> t * t

  val cardinal : t -> nat

  val elements : t -> elt list

  val choose : t -> elt option

  val eq_dec : t -> t -> bool

  val compare : t -> t -> comparison

  val min_elt : t -> elt option

  val max_elt : t -> elt option
 end

module MakeListOrdering :
 functor (O:OrderedType) ->
 sig
  module MO :
   sig
    module OrderTac :
     sig
      module OTF :
       sig
        type t = O.t

        val compare : t -> t -> comparison

        val eq_dec : t -> t -> bool
       end

      module TO :
       sig
        type t = OTF.t

        val compare : t -> t -> comparison

        val eq_dec : t -> t -> bool
       end
     end

    val eq_dec : O.t -> O.t -> bool

    val lt_dec : O.t -> O.t -> bool

    val eqb : O.t -> O.t -> bool
   end
 end

module PositiveSet :
 sig
  module E :
   sig
    type t = positive

    val eqb : positive -> positive -> bool

    val eq_dec : positive -> positive -> bool

    val compare : positive -> positive -> comparison
   end

  type elt = positive

  type tree =
  | Leaf
  | Node of tree * bool * tree

  type t = tree

  val empty : t

  val is_empty : t -> bool

  val mem : positive -> t -> bool

  val add : positive -> t -> t

  val singleton : positive -> t

  val node : t -> bool -> t -> t

  val remove : positive -> t -> t

  val union : t -> t -> t

  val inter : t -> t -> t

  val diff : t -> t -> t

  val equal : t -> t -> bool

  val subset : t -> t -> bool

  val rev_append : elt -> elt -> elt

  val rev : elt -> elt

  val xfold : (positive -> 'a1 -> 'a1) -> t -> 'a1 -> positive -> 'a1

  val fold : (positive -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1

  val xforall : (positive -> bool) -> t -> positive -> bool

  val for_all : (positive -> bool) -> t -> bool

  val xexists : (positive -> bool) -> t -> positive -> bool

  val exists_ : (positive -> bool) -> t -> bool

  val xfilter : (positive -> bool) -> t -> positive -> t

  val filter : (positive -> bool) -> t -> t

  val xpartition : (positive -> bool) -> t -> positive -> t * t

  val partition : (positive -> bool) -> t -> t * t

  val xelements : t -> positive -> positive list -> positive list

  val elements : t -> positive list

  val cardinal : t -> nat

  val choose : t -> elt option

  val min_elt : t -> elt option

  val max_elt : t -> elt option

  val compare_bool : bool -> bool -> comparison

  val compare : t -> t -> comparison

  val eq_dec : t -> t -> bool
 end

module IsoWSets :
 functor (W':WSets) ->
 functor (E0:sig
  type t

  val eq_dec : t -> t -> bool

  val to_ : t -> W'.E.t

  val of_ : W'.E.t -> t
 end) ->
 sig
  module E :
   sig
    type t = E0.t

    val eq_dec : t -> t -> bool

    val to_ : t -> W'.E.t

    val of_ : W'.E.t -> t
   end

  type elt = E0.t

  type t = W'.t

  val lift : (W'.elt -> 'a1) -> elt -> 'a1

  val liftho : ((W'.elt -> 'a1) -> 'a2) -> (elt -> 'a1) -> 'a2

  val empty : t

  val is_empty : t -> bool

  val mem : elt -> t -> bool

  val add : elt -> t -> t

  val remove : elt -> t -> t

  val singleton : elt -> t

  val union : t -> t -> t

  val inter : t -> t -> t

  val diff : t -> t -> t

  val equal : t -> t -> bool

  val subset : t -> t -> bool

  val fold : (elt -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1

  val for_all : (elt -> bool) -> t -> bool

  val exists_ : (elt -> bool) -> t -> bool

  val filter : (elt -> bool) -> t -> t

  val partition : (elt -> bool) -> t -> t * t

  val cardinal : t -> nat

  val elements : t -> elt list

  val choose : t -> elt option

  val eq_dec : t -> t -> bool
 end

module IsoSets :
 functor (W':Sets) ->
 functor (E0:sig
  type t

  val compare : t -> t -> comparison

  val eq_dec : t -> t -> bool

  val to_ : t -> W'.E.t

  val of_ : W'.E.t -> t
 end) ->
 sig
  module E :
   sig
    type t = E0.t

    val compare : t -> t -> comparison

    val eq_dec : t -> t -> bool

    val to_ : t -> W'.E.t

    val of_ : W'.E.t -> t
   end

  type elt = E0.t

  type t = W'.t

  val lift : (W'.elt -> 'a1) -> elt -> 'a1

  val liftho : ((W'.elt -> 'a1) -> 'a2) -> (elt -> 'a1) -> 'a2

  val empty : t

  val is_empty : t -> bool

  val mem : elt -> t -> bool

  val add : elt -> t -> t

  val remove : elt -> t -> t

  val singleton : elt -> t

  val union : t -> t -> t

  val inter : t -> t -> t

  val diff : t -> t -> t

  val equal : t -> t -> bool

  val subset : t -> t -> bool

  val fold : (elt -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1

  val for_all : (elt -> bool) -> t -> bool

  val exists_ : (elt -> bool) -> t -> bool

  val filter : (elt -> bool) -> t -> t

  val partition : (elt -> bool) -> t -> t * t

  val cardinal : t -> nat

  val elements : t -> elt list

  val choose : t -> elt option

  val eq_dec : t -> t -> bool

  val compare : t -> t -> comparison

  val min_elt : t -> elt option

  val max_elt : t -> elt option
 end

module NIsoPositive :
 sig
  type t = n

  val eq_dec : t -> t -> bool

  val to_ : t -> PositiveSet.E.t

  val of_ : PositiveSet.E.t -> t

  val compare : t -> t -> comparison
 end

module NSet :
 sig
  module E :
   sig
    type t = n

    val compare : n -> n -> comparison

    val eq_dec : n -> n -> bool

    val to_ : n -> positive

    val of_ : positive -> n
   end

  type elt = n

  type t = PositiveSet.t

  val lift : (PositiveSet.elt -> 'a1) -> elt -> 'a1

  val liftho : ((PositiveSet.elt -> 'a1) -> 'a2) -> (elt -> 'a1) -> 'a2

  val empty : t

  val is_empty : t -> bool

  val mem : elt -> t -> bool

  val add : elt -> t -> t

  val remove : elt -> t -> t

  val singleton : elt -> t

  val union : t -> t -> t

  val inter : t -> t -> t

  val diff : t -> t -> t

  val equal : t -> t -> bool

  val subset : t -> t -> bool

  val fold : (elt -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1

  val for_all : (elt -> bool) -> t -> bool

  val exists_ : (elt -> bool) -> t -> bool

  val filter : (elt -> bool) -> t -> t

  val partition : (elt -> bool) -> t -> t * t

  val cardinal : t -> nat

  val elements : t -> elt list

  val choose : t -> elt option

  val eq_dec : t -> t -> bool

  val compare : t -> t -> comparison

  val min_elt : t -> elt option

  val max_elt : t -> elt option
 end

module ZRange :
 sig
  val union : zrange -> zrange -> zrange

  val normalize : zrange -> zrange

  val opp : zrange -> zrange

  val split_range_at_0 :
    zrange -> (zrange option * zrange option) * zrange option

  val apply_to_split_range : (zrange -> zrange) -> zrange -> zrange

  val apply_to_range : (z -> zrange) -> zrange -> zrange

  val apply_to_each_split_range : (z -> zrange) -> zrange -> zrange

  val constant : z -> zrange

  val two_corners : (z -> z) -> zrange -> zrange

  val four_corners : (z -> z -> z) -> zrange -> zrange -> zrange

  val eight_corners :
    (z -> z -> z -> z) -> zrange -> zrange -> zrange -> zrange

  val two_corners_and_zero : (z -> z) -> zrange -> zrange

  val four_corners_and_zero : (z -> z -> z) -> zrange -> zrange -> zrange

  val extend_land_lor_bounds : zrange -> zrange

  val land_lor_bounds : (z -> z -> z) -> zrange -> zrange -> zrange

  val lor_bounds : zrange -> zrange -> zrange

  val land_bounds : zrange -> zrange -> zrange

  val split_bounds_pos : zrange -> z -> zrange * zrange

  val split_bounds : zrange -> z -> zrange * zrange
 end
module Coq__9 : module type of struct include ZRange end

val bool_rect_nodep : 'a1 -> 'a1 -> bool -> 'a1

module Thunked :
 sig
  val bool_rect : (unit -> 'a1) -> (unit -> 'a1) -> bool -> 'a1
 end

val option_beq0 : ('a1 -> 'a1 -> bool) -> 'a1 option -> 'a1 option -> bool

module Coq_Thunked :
 sig
  val option_rect : ('a1 -> 'a2) -> (unit -> 'a2) -> 'a1 option -> 'a2
 end

val option_beq_hetero0 :
  ('a1 -> 'a2 -> bool) -> 'a1 option -> 'a2 option -> bool

val lift0 : 'a1 option option -> 'a1 option option

val bind1 : 'a1 option -> ('a1 -> 'a2 option) -> 'a2 option

val sequence : 'a1 option -> 'a1 option -> 'a1 option

val sequence_return0 : 'a1 option -> 'a1 -> 'a1

val combine0 : 'a1 option -> 'a2 option -> ('a1 * 'a2) option

val is_None : 'a1 option -> bool

val is_Some : 'a1 option -> bool

val invert_Some0 : 'a1 option -> __

val prod_beq0 :
  ('a1 -> 'a1 -> bool) -> ('a2 -> 'a2 -> bool) -> ('a1 * 'a2) -> ('a1 * 'a2)
  -> bool

val prod_beq_hetero :
  ('a1 -> 'a3 -> bool) -> ('a2 -> 'a4 -> bool) -> ('a1 * 'a2) -> ('a3 * 'a4)
  -> bool

val prod_rect_nodep : ('a1 -> 'a2 -> 'a3) -> ('a1 * 'a2) -> 'a3

val nat_beq : nat -> nat -> bool

val nat_rect_nodep : 'a1 -> (nat -> 'a1 -> 'a1) -> nat -> 'a1

val nat_rect_arrow_nodep :
  ('a1 -> 'a2) -> (nat -> ('a1 -> 'a2) -> 'a1 -> 'a2) -> nat -> 'a1 -> 'a2

module Coq0_Thunked :
 sig
  val nat_rect : (unit -> 'a1) -> (nat -> 'a1 -> 'a1) -> nat -> 'a1
 end

type decidable0 = bool

val dec0 : decidable0 -> bool

val dec_or : decidable0 -> decidable0 -> decidable0

val dec_eq_list :
  ('a1 -> 'a1 -> decidable0) -> 'a1 list -> 'a1 list -> decidable0

val dec_eq_sum :
  ('a1 -> 'a1 -> decidable0) -> ('a2 -> 'a2 -> decidable0) -> ('a1, 'a2) sum
  -> ('a1, 'a2) sum -> decidable0

val dec_eq_N : n -> n -> decidable0

val dec_eq_Z0 : z -> z -> decidable0

val dec_lt_Z : z -> z -> decidable0

val decidable_iff_to_impl : decidable0 -> decidable0

val list_beq0 : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list -> bool

val list_case0 : 'a2 -> ('a1 -> 'a1 list -> 'a2) -> 'a1 list -> 'a2

val list_rect_nodep :
  'a2 -> ('a1 -> 'a1 list -> 'a2 -> 'a2) -> 'a1 list -> 'a2

val list_rect_arrow_nodep :
  ('a2 -> 'a3) -> ('a1 -> 'a1 list -> ('a2 -> 'a3) -> 'a2 -> 'a3) -> 'a1 list
  -> 'a2 -> 'a3

module Coq1_Thunked :
 sig
  val list_rect :
    (unit -> 'a2) -> ('a1 -> 'a1 list -> 'a2 -> 'a2) -> 'a1 list -> 'a2

  val list_case : (unit -> 'a2) -> ('a1 -> 'a1 list -> 'a2) -> 'a1 list -> 'a2
 end

module Coq2_List :
 sig
  val enumerate : 'a1 list -> (nat * 'a1) list
 end

val list_beq_hetero0 : ('a1 -> 'a2 -> bool) -> 'a1 list -> 'a2 list -> bool

val update_nth0 : nat -> ('a1 -> 'a1) -> 'a1 list -> 'a1 list

val set_nth0 : nat -> 'a1 -> 'a1 list -> 'a1 list

module Primitive :
 sig
  type ('a, 'b) prod = { fst : 'a; snd : 'b }

  val fst : ('a1, 'a2) prod -> 'a1

  val snd : ('a1, 'a2) prod -> 'a2
 end

type ('a, 'p) hlist = __

val combine_hlist : 'a1 list -> ('a1, 'a2) hlist -> ('a1, 'a2) sigT list

module Pre :
 sig
  module Coq_ident :
   sig
    val literal : 'a1 -> 'a1

    val eagerly : 'a1 -> 'a1
   end
 end

module Named :
 sig
  type maybe_name =
  | Coq_no_name
  | Coq_a_name

  type t = { value : __; naming : maybe_name }
 end

module Coq_ident :
 sig
  val is_more_pos_than_neg : zrange -> z -> bool

  val cast : zrange -> z -> z

  val cast2 : (zrange * zrange) -> (z * z) -> z * z

  val comment : 'a1 -> unit

  val comment_no_keep : 'a1 -> unit

  module Coq_fancy :
   sig
    val add : ((z * z) * (z * z)) -> z * z

    val addc : ((z * z) * ((z * z) * z)) -> z * z

    val sub : ((z * z) * (z * z)) -> z * z

    val subb : ((z * z) * ((z * z) * z)) -> z * z

    val mulll : (z * (z * z)) -> z

    val mullh : (z * (z * z)) -> z

    val mulhl : (z * (z * z)) -> z

    val mulhh : (z * (z * z)) -> z

    val selm : (z * ((z * z) * z)) -> z

    val rshi : ((z * z) * (z * z)) -> z

    val selc : ((z * z) * z) -> z

    val sell : ((z * z) * z) -> z

    val addm : ((z * z) * z) -> z
   end
 end

module Coq_Option :
 sig
  module List :
   sig
    val lift : 'a1 option list -> 'a1 list option
   end
 end

val cpscall : (__ -> ('a1 -> __) -> __) -> ('a1 -> 'a2) -> 'a2

val cpsreturn : 'a1 -> 'a1

val cpsbind :
  (__ -> ('a1 -> __) -> __) -> ('a1 -> __ -> ('a2 -> __) -> __) -> ('a2 ->
  'a3) -> 'a3

val cps_option_bind :
  (__ -> ('a1 option -> __) -> __) -> ('a1 -> __ -> ('a2 option -> __) -> __)
  -> ('a2 option -> 'a3) -> 'a3

val reflect_of_brel0 : ('a1 -> 'a2 -> bool) -> 'a1 -> 'a2 -> reflect

val reflect_of_beq0 : ('a1 -> 'a1 -> bool) -> 'a1 -> 'a1 -> reflect

val dec_of_reflect : bool -> reflect -> decidable0

val eq_decb_hprop : 'a1 -> 'a1 -> reflect

val reflect_eq_unit : unit -> unit -> reflect

val reflect_eq_bool : bool -> bool -> reflect

val reflect_eq_prod :
  ('a1 -> 'a1 -> bool) -> ('a2 -> 'a2 -> bool) -> ('a1 -> 'a1 -> reflect) ->
  ('a2 -> 'a2 -> reflect) -> ('a1 * 'a2) -> ('a1 * 'a2) -> reflect

module Compilers :
 sig
  module Coq_type :
   sig
    type 'base_type coq_type =
    | Coq_base of 'base_type
    | Coq_arrow of 'base_type coq_type * 'base_type coq_type

    val type_beq :
      ('a1 -> 'a1 -> bool) -> 'a1 coq_type -> 'a1 coq_type -> bool

    val final_codomain : 'a1 coq_type -> 'a1

    type ('base_type, 'f) for_each_lhs_of_arrow = __

    val forall_each_lhs_of_arrow :
      ('a1 coq_type -> 'a2) -> 'a1 coq_type -> ('a1, 'a2)
      for_each_lhs_of_arrow

    type ('base_type, 'base_interp) interp = __

    val app_curried :
      'a1 coq_type -> ('a1, 'a2) interp -> ('a1, ('a1, 'a2) interp)
      for_each_lhs_of_arrow -> 'a2

    val map_for_each_lhs_of_arrow :
      ('a1 coq_type -> 'a2 -> 'a3) -> 'a1 coq_type -> ('a1, 'a2)
      for_each_lhs_of_arrow -> ('a1, 'a3) for_each_lhs_of_arrow

    type ('base_type, 'm, 'base_interp) interpM_final' = __

    type ('base_type, 'm, 'base_interp) interpM_final =
      ('base_type, 'm, 'base_interp) interpM_final'

    val interpM_return : 'a1 coq_type -> 'a2 -> ('a1, 'a2, 'a3) interpM_final

    type 'base try_make_transport_cpsT =
      __ -> 'base -> 'base -> __ -> ((__ -> __) option -> __) -> __

    val try_make_transport_cpsv :
      'a1 try_make_transport_cpsT -> 'a1 -> 'a1 -> (('a2 -> 'a2) option ->
      'a3) -> 'a3

    val try_make_transport_cps :
      'a1 try_make_transport_cpsT -> 'a1 coq_type -> 'a1 coq_type -> (('a2 ->
      'a2) option -> 'a3) -> 'a3

    val try_transport_cps :
      'a1 try_make_transport_cpsT -> 'a1 coq_type -> 'a1 coq_type -> 'a2 ->
      ('a2 option -> 'a3) -> 'a3

    val try_transport :
      'a1 try_make_transport_cpsT -> 'a1 coq_type -> 'a1 coq_type -> 'a2 ->
      'a2 option
   end
  module Coq__2 : module type of struct include Coq_type end

  module Coq_base :
   sig
    module Coq_type :
     sig
      type 'base_type coq_type =
      | Coq_type_base of 'base_type
      | Coq_prod of 'base_type coq_type * 'base_type coq_type
      | Coq_list of 'base_type coq_type
      | Coq_option of 'base_type coq_type
      | Coq_unit

      val type_beq :
        ('a1 -> 'a1 -> bool) -> 'a1 coq_type -> 'a1 coq_type -> bool

      type 'base coq_BaseTypeHasNatT = 'base

      val nat : 'a1 coq_BaseTypeHasNatT -> 'a1
     end

    type ('base, 'base_interp) coq_BaseHasNatCorrectT = { to_nat : ('base_interp
                                                                   -> nat);
                                                          of_nat : (nat ->
                                                                   'base_interp);
                                                          of_to_nat : 
                                                          (__ -> 'base_interp
                                                          -> __ -> __);
                                                          to_of_nat : 
                                                          (__ -> nat -> __ ->
                                                          __) }

    val to_nat :
      'a1 Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2) coq_BaseHasNatCorrectT
      -> 'a2 -> nat

    val of_nat :
      'a1 Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2) coq_BaseHasNatCorrectT
      -> nat -> 'a2

    val reflect_type_beq :
      ('a1 -> 'a1 -> bool) -> ('a1 -> 'a1 -> reflect) -> 'a1
      Coq_type.coq_type -> 'a1 Coq_type.coq_type -> reflect

    type ('base, 'base_interp) interp = __

    val interp_beq :
      ('a1 -> 'a2 -> 'a2 -> bool) -> 'a1 Coq_type.coq_type -> ('a1, 'a2)
      interp -> ('a1, 'a2) interp -> bool

    val interp_beq_hetero :
      ('a1 -> 'a1 -> 'a2 -> 'a2 -> bool) -> 'a1 Coq_type.coq_type -> 'a1
      Coq_type.coq_type -> ('a1, 'a2) interp -> ('a1, 'a2) interp -> bool

    val try_make_transport_cps :
      'a1 Coq__2.try_make_transport_cpsT -> 'a1 Coq_type.coq_type -> 'a1
      Coq_type.coq_type -> (('a2 -> 'a2) option -> 'a3) -> 'a3
   end
  module Coq__3 : module type of struct include Coq_base end

  module Coq_pattern :
   sig
    module Coq_base :
     sig
      module Coq_type :
       sig
        type 'base_type coq_type =
        | Coq_var of positive
        | Coq_type_base of 'base_type
        | Coq_prod of 'base_type coq_type * 'base_type coq_type
        | Coq_list of 'base_type coq_type
        | Coq_option of 'base_type coq_type
        | Coq_unit

        val internal_positive_beq : positive -> positive -> bool

        val type_beq :
          ('a1 -> 'a1 -> bool) -> 'a1 coq_type -> 'a1 coq_type -> bool
       end
     end
   end

  module Coq_expr :
   sig
    type ('base_type, 'ident, 'var) expr =
    | Ident of 'base_type Coq_type.coq_type * 'ident
    | Var of 'base_type Coq_type.coq_type * 'var
    | Abs of 'base_type Coq_type.coq_type * 'base_type Coq_type.coq_type
       * ('var -> ('base_type, 'ident, 'var) expr)
    | App of 'base_type Coq_type.coq_type * 'base_type Coq_type.coq_type
       * ('base_type, 'ident, 'var) expr * ('base_type, 'ident, 'var) expr
    | LetIn of 'base_type Coq_type.coq_type * 'base_type Coq_type.coq_type
       * ('base_type, 'ident, 'var) expr
       * ('var -> ('base_type, 'ident, 'var) expr)

    type ('base_type, 'ident) coq_Expr = __ -> ('base_type, 'ident, __) expr

    val coq_APP :
      'a1 Coq_type.coq_type -> 'a1 Coq_type.coq_type -> ('a1, 'a2) coq_Expr
      -> ('a1, 'a2) coq_Expr -> ('a1, 'a2, __) expr
   end

  module Coq_ident :
   sig
    type ('base, 'base_interp, 'ident) coq_BuildIdentT = { ident_Literal : 
                                                           ('base ->
                                                           'base_interp ->
                                                           'ident);
                                                           ident_nil : 
                                                           ('base
                                                           Coq_base.Coq_type.coq_type
                                                           -> 'ident);
                                                           ident_cons : 
                                                           ('base
                                                           Coq_base.Coq_type.coq_type
                                                           -> 'ident);
                                                           ident_Some : 
                                                           ('base
                                                           Coq_base.Coq_type.coq_type
                                                           -> 'ident);
                                                           ident_None : 
                                                           ('base
                                                           Coq_base.Coq_type.coq_type
                                                           -> 'ident);
                                                           ident_pair : 
                                                           ('base
                                                           Coq_base.Coq_type.coq_type
                                                           -> 'base
                                                           Coq_base.Coq_type.coq_type
                                                           -> 'ident);
                                                           ident_tt : 
                                                           'ident }

    val ident_Literal : ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a1 -> 'a2 -> 'a3

    val ident_nil :
      ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a3

    val ident_cons :
      ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a3

    val ident_Some :
      ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a3

    val ident_None :
      ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a3

    val ident_pair :
      ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a1 Coq_base.Coq_type.coq_type ->
      'a1 Coq_base.Coq_type.coq_type -> 'a3

    val ident_tt : ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a3

    val reify_list :
      ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a1 Coq_base.Coq_type.coq_type ->
      ('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr list -> ('a1
      Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr

    val reify_option :
      ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a1 Coq_base.Coq_type.coq_type ->
      ('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr option -> ('a1
      Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr

    val smart_Literal :
      ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a1 Coq_base.Coq_type.coq_type ->
      ('a1, 'a2) Coq_base.interp -> ('a1 Coq_base.Coq_type.coq_type, 'a3,
      'a4) Coq_expr.expr

    type 'base restricted_ident =
    | Coq_restricted_ident_nat_rect of 'base Coq_base.Coq_type.coq_type
    | Coq_restricted_ident_nat_rect_arrow of 'base Coq_base.Coq_type.coq_type
       * 'base Coq_base.Coq_type.coq_type
    | Coq_restricted_ident_list_rect of 'base Coq_base.Coq_type.coq_type
       * 'base Coq_base.Coq_type.coq_type
    | Coq_restricted_ident_list_rect_arrow of 'base Coq_base.Coq_type.coq_type
       * 'base Coq_base.Coq_type.coq_type * 'base Coq_base.Coq_type.coq_type
    | Coq_restricted_ident_List_nth_default of 'base
                                               Coq_base.Coq_type.coq_type
    | Coq_restricted_ident_eager_nat_rect of 'base Coq_base.Coq_type.coq_type
    | Coq_restricted_ident_eager_nat_rect_arrow of 'base
                                                   Coq_base.Coq_type.coq_type
       * 'base Coq_base.Coq_type.coq_type
    | Coq_restricted_ident_eager_list_rect of 'base Coq_base.Coq_type.coq_type
       * 'base Coq_base.Coq_type.coq_type
    | Coq_restricted_ident_eager_list_rect_arrow of 'base
                                                    Coq_base.Coq_type.coq_type
       * 'base Coq_base.Coq_type.coq_type * 'base Coq_base.Coq_type.coq_type
    | Coq_restricted_ident_eager_List_nth_default of 'base
                                                     Coq_base.Coq_type.coq_type

    type ('base, 'ident) coq_BuildEagerIdentT = { ident_nat_rect : ('base
                                                                   Coq_base.Coq_type.coq_type
                                                                   -> 'ident);
                                                  ident_nat_rect_arrow : 
                                                  ('base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'ident);
                                                  ident_list_rect : ('base
                                                                    Coq_base.Coq_type.coq_type
                                                                    -> 'base
                                                                    Coq_base.Coq_type.coq_type
                                                                    -> 'ident);
                                                  ident_list_rect_arrow : 
                                                  ('base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'ident);
                                                  ident_List_nth_default : 
                                                  ('base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'ident);
                                                  ident_eager_nat_rect : 
                                                  ('base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'ident);
                                                  ident_eager_nat_rect_arrow : 
                                                  ('base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'ident);
                                                  ident_eager_list_rect : 
                                                  ('base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'ident);
                                                  ident_eager_list_rect_arrow : 
                                                  ('base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'ident);
                                                  ident_eager_List_nth_default : 
                                                  ('base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'ident) }

    val ident_nat_rect :
      'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
      coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a2

    val ident_nat_rect_arrow :
      'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
      coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a1
      Coq_base.Coq_type.coq_type -> 'a2

    val ident_list_rect :
      'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
      coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a1
      Coq_base.Coq_type.coq_type -> 'a2

    val ident_list_rect_arrow :
      'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
      coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a1
      Coq_base.Coq_type.coq_type -> 'a1 Coq_base.Coq_type.coq_type -> 'a2

    val ident_List_nth_default :
      'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
      coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a2

    val ident_eager_nat_rect :
      'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
      coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a2

    val ident_eager_nat_rect_arrow :
      'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
      coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a1
      Coq_base.Coq_type.coq_type -> 'a2

    val ident_eager_list_rect :
      'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
      coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a1
      Coq_base.Coq_type.coq_type -> 'a2

    val ident_eager_list_rect_arrow :
      'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
      coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a1
      Coq_base.Coq_type.coq_type -> 'a1 Coq_base.Coq_type.coq_type -> 'a2

    val ident_eager_List_nth_default :
      'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
      coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a2

    val fromRestrictedIdent :
      'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
      coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type
      Coq_type.coq_type -> 'a1 restricted_ident -> 'a2

    type ('base, 'ident) coq_ToRestrictedIdentT =
      'base Coq_base.Coq_type.coq_type Coq_type.coq_type -> 'ident -> 'base
      restricted_ident option

    val eager_ident_rect :
      'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
      coq_BuildEagerIdentT -> ('a1, 'a2) coq_ToRestrictedIdentT -> ('a1
      Coq_base.Coq_type.coq_type -> 'a3) -> ('a1 Coq_base.Coq_type.coq_type
      -> 'a1 Coq_base.Coq_type.coq_type -> 'a3) -> ('a1
      Coq_base.Coq_type.coq_type -> 'a1 Coq_base.Coq_type.coq_type -> 'a3) ->
      ('a1 Coq_base.Coq_type.coq_type -> 'a1 Coq_base.Coq_type.coq_type ->
      'a1 Coq_base.Coq_type.coq_type -> 'a3) -> ('a1
      Coq_base.Coq_type.coq_type -> 'a3) -> 'a1 Coq_base.Coq_type.coq_type
      Coq_type.coq_type -> 'a2 -> 'a3 option
   end

  module Coq_invert_expr :
   sig
    val invert_Ident :
      'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> 'a2 option

    val invert_App_cps :
      'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1
      Coq_type.coq_type -> 'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3)
      Coq_expr.expr -> 'a4) -> ('a1 Coq_type.coq_type -> ('a1, 'a2, 'a3)
      Coq_expr.expr -> 'a5) -> ('a1 Coq_type.coq_type, 'a4 * 'a5) sigT option

    val invert_App :
      'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1
      Coq_type.coq_type, ('a1, 'a2, 'a3) Coq_expr.expr * ('a1, 'a2, 'a3)
      Coq_expr.expr) sigT option

    val invert_Abs :
      'a1 Coq_type.coq_type -> 'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3)
      Coq_expr.expr -> ('a3 -> ('a1, 'a2, 'a3) Coq_expr.expr) option

    val invert_App2_cps :
      'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1
      Coq_type.coq_type -> 'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3)
      Coq_expr.expr -> 'a4) -> ('a1 Coq_type.coq_type -> ('a1, 'a2, 'a3)
      Coq_expr.expr -> 'a5) -> ('a1 Coq_type.coq_type -> ('a1, 'a2, 'a3)
      Coq_expr.expr -> 'a6) -> ('a1 Coq_type.coq_type * 'a1
      Coq_type.coq_type, ('a4 * 'a5) * 'a6) sigT option

    val invert_AppIdent_cps :
      'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1
      Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> 'a4) -> ('a1
      Coq_type.coq_type, 'a2 * 'a4) sigT option

    val invert_AppIdent :
      'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1
      Coq_type.coq_type, 'a2 * ('a1, 'a2, 'a3) Coq_expr.expr) sigT option

    val invert_AppIdent2_cps :
      'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1
      Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> 'a4) -> ('a1
      Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> 'a5) -> ('a1
      Coq_type.coq_type * 'a1 Coq_type.coq_type, ('a2 * 'a4) * 'a5) sigT
      option

    val invert_Var :
      'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> 'a3 option

    val coq_App_curried :
      'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1, ('a1,
      'a2, 'a3) Coq_expr.expr) Coq_type.for_each_lhs_of_arrow -> ('a1, 'a2,
      'a3) Coq_expr.expr

    val smart_App_curried :
      'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1, 'a3)
      Coq_type.for_each_lhs_of_arrow -> ('a1, 'a2, 'a3) Coq_expr.expr

    val invert_App_curried :
      'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1, ('a1,
      'a2, 'a3) Coq_expr.expr) Coq_type.for_each_lhs_of_arrow -> ('a1
      Coq_type.coq_type, ('a1, 'a2, 'a3) Coq_expr.expr * ('a1, ('a1, 'a2,
      'a3) Coq_expr.expr) Coq_type.for_each_lhs_of_arrow) sigT

    val invert_AppIdent_curried :
      'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1
      Coq_type.coq_type, 'a2 * ('a1, ('a1, 'a2, 'a3) Coq_expr.expr)
      Coq_type.for_each_lhs_of_arrow) sigT option

    type ('base, 'base_interp, 'ident) coq_InvertIdentT = { invert_ident_Literal : 
                                                            ('base
                                                            Coq_base.Coq_type.coq_type
                                                            Coq_type.coq_type
                                                            -> 'ident ->
                                                            ('base
                                                            Coq_base.Coq_type.coq_type,
                                                            ('base,
                                                            'base_interp)
                                                            Coq_base.interp)
                                                            Coq_type.interp
                                                            option);
                                                            is_nil : 
                                                            ('base
                                                            Coq_base.Coq_type.coq_type
                                                            Coq_type.coq_type
                                                            -> 'ident -> bool);
                                                            is_cons : 
                                                            ('base
                                                            Coq_base.Coq_type.coq_type
                                                            Coq_type.coq_type
                                                            -> 'ident -> bool);
                                                            is_Some : 
                                                            ('base
                                                            Coq_base.Coq_type.coq_type
                                                            Coq_type.coq_type
                                                            -> 'ident -> bool);
                                                            is_None : 
                                                            ('base
                                                            Coq_base.Coq_type.coq_type
                                                            Coq_type.coq_type
                                                            -> 'ident -> bool);
                                                            is_pair : 
                                                            ('base
                                                            Coq_base.Coq_type.coq_type
                                                            Coq_type.coq_type
                                                            -> 'ident -> bool);
                                                            is_tt : ('base
                                                                    Coq_base.Coq_type.coq_type
                                                                    Coq_type.coq_type
                                                                    -> 'ident
                                                                    -> bool) }

    val invert_ident_Literal :
      ('a1, 'a2, 'a3) coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type
      Coq_type.coq_type -> 'a3 -> ('a1 Coq_base.Coq_type.coq_type, ('a1, 'a2)
      Coq_base.interp) Coq_type.interp option

    val is_nil :
      ('a1, 'a2, 'a3) coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type
      Coq_type.coq_type -> 'a3 -> bool

    val is_cons :
      ('a1, 'a2, 'a3) coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type
      Coq_type.coq_type -> 'a3 -> bool

    val is_Some :
      ('a1, 'a2, 'a3) coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type
      Coq_type.coq_type -> 'a3 -> bool

    val is_None :
      ('a1, 'a2, 'a3) coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type
      Coq_type.coq_type -> 'a3 -> bool

    val is_pair :
      ('a1, 'a2, 'a3) coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type
      Coq_type.coq_type -> 'a3 -> bool

    val is_tt :
      ('a1, 'a2, 'a3) coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type
      Coq_type.coq_type -> 'a3 -> bool

    val reflect_list_cps' :
      'a1 Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
      coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type Coq_type.coq_type ->
      ('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> (('a1
      Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr list option -> 'a5)
      -> 'a5

    val reflect_list_cps :
      'a1 Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
      coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type -> ('a1
      Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> (('a1
      Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr list option -> 'a5)
      -> 'a5

    val reflect_list :
      'a1 Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
      coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type -> ('a1
      Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> ('a1
      Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr list option

    val invert_pair_cps :
      'a1 Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
      coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type Coq_type.coq_type ->
      ('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> ('a1
      Coq_base.Coq_type.coq_type Coq_type.coq_type -> ('a1
      Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> 'a5) -> ('a1
      Coq_base.Coq_type.coq_type Coq_type.coq_type -> ('a1
      Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> 'a6) ->
      ('a5 * 'a6) option

    val invert_pair :
      'a1 Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
      coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a1
      Coq_base.Coq_type.coq_type -> ('a1 Coq_base.Coq_type.coq_type, 'a3,
      'a4) Coq_expr.expr -> (('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4)
      Coq_expr.expr * ('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4)
      Coq_expr.expr) option

    val invert_Literal :
      ('a1, 'a2, 'a3) coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type
      Coq_type.coq_type -> ('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4)
      Coq_expr.expr -> ('a1 Coq_base.Coq_type.coq_type, ('a1, 'a2)
      Coq_base.interp) Coq_type.interp option

    val invert_None :
      ('a1, 'a2, 'a3) coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type ->
      ('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> bool

    val invert_Some :
      'a1 Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
      coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type -> ('a1
      Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> ('a1
      Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr option

    val invert_tt :
      ('a1, 'a2, 'a3) coq_InvertIdentT -> ('a1 Coq_base.Coq_type.coq_type,
      'a3, 'a4) Coq_expr.expr -> bool

    val reflect_option :
      'a1 Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
      coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type -> ('a1
      Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> ('a1
      Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr option option

    val reflect_smart_Literal :
      'a1 Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
      coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type -> ('a1
      Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> ('a1, 'a2)
      Coq_base.interp option
   end

  module DefaultValue :
   sig
    module Coq_type :
     sig
      module Coq_base :
       sig
        type ('base, 'base_interp) coq_DefaultT = 'base -> 'base_interp

        val defaultv : ('a1, 'a2) coq_DefaultT -> 'a1 -> 'a2

        val default :
          ('a1, 'a2) coq_DefaultT -> 'a1 Coq_base.Coq_type.coq_type -> ('a1,
          'a2) Coq_base.interp
       end
     end

    module Coq_expr :
     sig
      module Coq_base :
       sig
        val default :
          ('a1, 'a2) Coq_type.Coq_base.coq_DefaultT -> ('a1, 'a2, 'a3)
          Coq_ident.coq_BuildIdentT -> 'a1 Coq_base.Coq_type.coq_type -> ('a1
          Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr
       end

      val default :
        ('a1, 'a2) Coq_type.Coq_base.coq_DefaultT -> ('a1, 'a2, 'a3)
        Coq_ident.coq_BuildIdentT -> 'a1 Coq__3.Coq_type.coq_type
        Coq__2.coq_type -> ('a1 Coq__3.Coq_type.coq_type, 'a3, 'a4)
        Coq_expr.expr
     end
   end

  module GallinaReify :
   sig
    type ('base, 'base_interp, 'var) value = __

    val reify :
      ('a1, 'a2, 'a3) Coq_ident.coq_BuildIdentT -> 'a1
      Coq_base.Coq_type.coq_type Coq_type.coq_type -> ('a1, 'a2, 'a4) value
      -> ('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr

    val coq_Reify_as :
      ('a1, 'a2, 'a3) Coq_ident.coq_BuildIdentT -> 'a1
      Coq_base.Coq_type.coq_type Coq_type.coq_type -> (__ -> ('a1, 'a2, __)
      value) -> ('a1 Coq_base.Coq_type.coq_type, 'a3, __) Coq_expr.expr
   end

  module GeneralizeVar :
   sig
    module Flat :
     sig
      type ('base_type, 'ident) expr =
      | Ident of 'base_type Coq_type.coq_type * 'ident
      | Var of 'base_type Coq_type.coq_type * positive
      | Abs of 'base_type Coq_type.coq_type * positive
         * 'base_type Coq_type.coq_type * ('base_type, 'ident) expr
      | App of 'base_type Coq_type.coq_type * 'base_type Coq_type.coq_type
         * ('base_type, 'ident) expr * ('base_type, 'ident) expr
      | LetIn of 'base_type Coq_type.coq_type * 'base_type Coq_type.coq_type
         * positive * ('base_type, 'ident) expr * ('base_type, 'ident) expr
     end

    val coq_ERROR : 'a1 -> 'a1

    val to_flat' :
      'a1 Coq_type.coq_type -> ('a1, 'a2, PositiveMap.key) Coq_expr.expr ->
      PositiveMap.key -> ('a1, 'a2) Flat.expr

    val from_flat :
      'a1 Coq_type.try_make_transport_cpsT -> (__ -> ('a1 Coq_type.coq_type,
      ('a1, 'a2, __) Coq_expr.expr)
      DefaultValue.Coq_type.Coq_base.coq_DefaultT) -> 'a1 Coq_type.coq_type
      -> ('a1, 'a2) Flat.expr -> ('a1 Coq_type.coq_type, 'a3) sigT
      PositiveMap.t -> ('a1, 'a2, 'a3) Coq_expr.expr

    val to_flat :
      'a1 Coq_type.coq_type -> ('a1, 'a2, PositiveMap.key) Coq_expr.expr ->
      ('a1, 'a2) Flat.expr

    val coq_ToFlat :
      'a1 Coq_type.coq_type -> ('a1, 'a2) Coq_expr.coq_Expr -> ('a1, 'a2)
      Flat.expr

    val coq_FromFlat :
      'a1 Coq_type.try_make_transport_cpsT -> (__ -> ('a1 Coq_type.coq_type,
      ('a1, 'a2, __) Coq_expr.expr)
      DefaultValue.Coq_type.Coq_base.coq_DefaultT) -> 'a1 Coq_type.coq_type
      -> ('a1, 'a2) Flat.expr -> ('a1, 'a2, __) Coq_expr.expr

    val coq_GeneralizeVar :
      'a1 Coq_type.try_make_transport_cpsT -> (__ -> ('a1 Coq_type.coq_type,
      ('a1, 'a2, __) Coq_expr.expr)
      DefaultValue.Coq_type.Coq_base.coq_DefaultT) -> 'a1 Coq_type.coq_type
      -> ('a1, 'a2, PositiveMap.key) Coq_expr.expr -> ('a1, 'a2, __)
      Coq_expr.expr
   end

  module Classes :
   sig
    type coq_ExprInfoT =
      __ Coq_base.Coq_type.coq_type Coq_type.coq_type -> __ -> (__
      Coq_base.Coq_type.coq_type, (__, __) Coq_base.interp) Coq_type.interp
      (* singleton inductive, whose constructor was Build_ExprInfoT *)

    type coq_ExprExtraInfoT = { base_beq : (__ -> __ -> bool);
                                base_interp_beq : (__ -> __ -> __ -> __ ->
                                                  bool);
                                try_make_transport_base_cps : __
                                                              Coq_type.try_make_transport_cpsT;
                                baseHasNat : __
                                             Coq_base.Coq_type.coq_BaseTypeHasNatT;
                                buildIdent : (__, __, __)
                                             Coq_ident.coq_BuildIdentT;
                                toRestrictedIdent : (__, __)
                                                    Coq_ident.coq_ToRestrictedIdentT;
                                buildEagerIdent : (__, __)
                                                  Coq_ident.coq_BuildEagerIdentT;
                                invertIdent : (__, __, __)
                                              Coq_invert_expr.coq_InvertIdentT;
                                defaultBase : (__, __)
                                              DefaultValue.Coq_type.Coq_base.coq_DefaultT;
                                reflect_base_beq : (__ -> __ -> reflect);
                                reflect_base_interp_beq : (__ -> __ -> __ ->
                                                          reflect);
                                baseHasNatCorrect : (__, __)
                                                    Coq_base.coq_BaseHasNatCorrectT }

    val base_beq : coq_ExprInfoT -> coq_ExprExtraInfoT -> __ -> __ -> bool

    val try_make_transport_base_cps :
      coq_ExprInfoT -> coq_ExprExtraInfoT -> __ -> __ -> ((__ -> __) option
      -> __) -> __
   end
 end

module Coq_Compilers :
 sig
  module SubstVarLike :
   sig
    val is_recursively_var_or_ident :
      ('a1 Compilers.Coq_type.coq_type -> 'a2 -> bool) -> 'a1
      Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) Compilers.Coq_expr.expr
      -> bool
   end

  module UnderLets :
   sig
    type ('base_type, 'ident, 'var, 't) coq_UnderLets =
    | Base of 't
    | UnderLet of 'base_type Compilers.Coq_type.coq_type
       * ('base_type, 'ident, 'var) Compilers.Coq_expr.expr
       * ('var -> ('base_type, 'ident, 'var, 't) coq_UnderLets)

    val splice :
      ('a1, 'a2, 'a3, 'a4) coq_UnderLets -> ('a4 -> ('a1, 'a2, 'a3, 'a5)
      coq_UnderLets) -> ('a1, 'a2, 'a3, 'a5) coq_UnderLets

    val splice_list :
      ('a1, 'a2, 'a3, 'a4) coq_UnderLets list -> ('a4 list -> ('a1, 'a2, 'a3,
      'a5) coq_UnderLets) -> ('a1, 'a2, 'a3, 'a5) coq_UnderLets

    val splice_option :
      ('a1, 'a2, 'a3, 'a4) coq_UnderLets option -> ('a4 option -> ('a1, 'a2,
      'a3, 'a5) coq_UnderLets) -> ('a1, 'a2, 'a3, 'a5) coq_UnderLets

    val to_expr :
      'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3, ('a1, 'a2, 'a3)
      Compilers.Coq_expr.expr) coq_UnderLets -> ('a1, 'a2, 'a3)
      Compilers.Coq_expr.expr

    val of_expr :
      'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3)
      Compilers.Coq_expr.expr -> ('a1, 'a2, 'a3, ('a1, 'a2, 'a3)
      Compilers.Coq_expr.expr) coq_UnderLets

    val flat_map :
      ('a1 Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3)
      Compilers.Coq_expr.expr -> ('a1, 'a4, 'a5, ('a1, 'a4, 'a5)
      Compilers.Coq_expr.expr) coq_UnderLets) -> ('a1
      Compilers.Coq_type.coq_type -> 'a5 -> 'a3) -> ('a1, 'a2, 'a3, 'a6)
      coq_UnderLets -> ('a1, 'a4, 'a5, 'a6) coq_UnderLets

    val reify_and_let_binds_base_cps :
      'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
      Compilers.Coq_invert_expr.coq_InvertIdentT -> ('a1, 'a2, 'a3)
      Compilers.Coq_ident.coq_BuildIdentT -> ('a1
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type -> 'a3
      -> bool) -> 'a1 Compilers.Coq_base.Coq_type.coq_type -> ('a1
      Compilers.Coq_base.Coq_type.coq_type, 'a3, 'a4) Compilers.Coq_expr.expr
      -> (('a1 Compilers.Coq_base.Coq_type.coq_type, 'a3, 'a4)
      Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
      'a3, 'a4, 'a5) coq_UnderLets) -> ('a1
      Compilers.Coq_base.Coq_type.coq_type, 'a3, 'a4, 'a5) coq_UnderLets

    val let_bind_return :
      'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
      Compilers.Coq_invert_expr.coq_InvertIdentT -> ('a1, 'a2, 'a3)
      Compilers.Coq_ident.coq_BuildIdentT -> ('a1
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type -> 'a3
      -> bool) -> 'a1 Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> ('a1
      Compilers.Coq_base.Coq_type.coq_type, 'a3, 'a4) Compilers.Coq_expr.expr
      -> ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a3, 'a4)
      Compilers.Coq_expr.expr

    val coq_LetBindReturn :
      'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
      Compilers.Coq_invert_expr.coq_InvertIdentT -> ('a1, 'a2, 'a3)
      Compilers.Coq_ident.coq_BuildIdentT -> ('a1
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type -> 'a3
      -> bool) -> 'a1 Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> ('a1
      Compilers.Coq_base.Coq_type.coq_type, 'a3) Compilers.Coq_expr.coq_Expr
      -> ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a3, __)
      Compilers.Coq_expr.expr
   end
 end

module Coq_Primitive :
 sig
  type ('a, 'p) sigT = { projT1 : 'a; projT2 : 'p }

  val projT1 : ('a1, 'a2) sigT -> 'a1

  val projT2 : ('a1, 'a2) sigT -> 'a2
 end

module Coq0_Compilers :
 sig
  val app_type_of_list : __ list -> __ -> __ -> 'a1

  module Coq_pattern :
   sig
    module Coq_base :
     sig
      val relax :
        'a1 Compilers.Coq_base.Coq_type.coq_type -> 'a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type

      val lookup_default :
        positive -> 'a1 Compilers.Coq_base.Coq_type.coq_type PositiveMap.t ->
        'a1 Compilers.Coq_base.Coq_type.coq_type

      val subst_default :
        'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> 'a1
        Compilers.Coq_base.Coq_type.coq_type

      val collect_vars :
        'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type -> PositiveSet.t
     end

    module Coq_type :
     sig
      val relax :
        'a1 Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
        -> 'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type

      val subst_default :
        'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type

      val collect_vars :
        'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> PositiveSet.t
     end

    module Raw :
     sig
      module Coq_ident :
       sig
        type kind_of_type =
        | GallinaType
        | BaseBaseType
        | BaseType

        type ('base, 'cident) preident_infos = { dep_types : __ list;
                                                 indep_types : kind_of_type
                                                               list;
                                                 indep_args : (__ -> __ list);
                                                 to_type : (__ -> __ -> 'base
                                                           Compilers.Coq_base.Coq_type.coq_type
                                                           Compilers.Coq_type.coq_type);
                                                 to_ident : (__ -> __ -> __
                                                            -> 'cident) }

        val dep_types : ('a1, 'a2) preident_infos -> __ list

        val indep_types : ('a1, 'a2) preident_infos -> kind_of_type list

        val indep_args : ('a1, 'a2) preident_infos -> __ -> __ list

        val to_type :
          ('a1, 'a2) preident_infos -> __ -> __ -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type

        val to_ident : ('a1, 'a2) preident_infos -> __ -> __ -> __ -> 'a2

        type ('base, 'cident) ident_infos = { preinfos : ('base, 'cident)
                                                         preident_infos;
                                              dep_types_dec_transparent : 
                                              (__ -> __ -> bool);
                                              indep_args_beq : (__ -> __ ->
                                                               __ -> bool);
                                              indep_args_reflect : (__ -> __
                                                                   -> __ ->
                                                                   reflect);
                                              indep_types_beq : (__ -> __ ->
                                                                bool);
                                              indep_types_reflect : (__ -> __
                                                                    ->
                                                                    reflect) }

        val preinfos : ('a1, 'a2) ident_infos -> ('a1, 'a2) preident_infos

        type ('base, 'cident) ident_args = (__, __ * __) Coq_Primitive.sigT

        val eta_ident_cps_gen2 :
          (__ -> ('a1 -> __) -> ('a1 -> __)) -> ('a1 -> 'a2) -> ('a1 -> 'a3)
          -> ('a1 -> 'a3)

        val eta_ident_cps_gen3 :
          (__ -> ('a1 -> __) -> ('a1 -> __)) -> ('a1 -> 'a2) -> ('a1 -> 'a3)
          -> ('a1 -> 'a4) -> ('a1 -> 'a4)

        type ('base, 'cident, 'ident) full_types = __

        val is_simple : ('a3 -> ('a1, 'a2) ident_infos) -> 'a3 -> bool

        val type_of :
          (__ -> ('a3 -> __) -> ('a3 -> __)) -> ('a3 -> ('a1, 'a2)
          ident_infos) -> 'a3 -> ('a1, 'a2, 'a3) full_types -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type

        val to_typed :
          (__ -> ('a3 -> __) -> ('a3 -> __)) -> ('a3 -> ('a1, 'a2)
          ident_infos) -> 'a3 -> ('a1, 'a2, 'a3) full_types -> 'a2
       end
     end

    module Coq_ident :
     sig
      val prearg_types :
        ('a3 -> ('a1, 'a2) Raw.Coq_ident.ident_infos) -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a4 -> ('a3, __ * __)
        Coq_Primitive.sigT) -> 'a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a4 -> __ list

      val arg_types :
        ('a3 -> ('a1, 'a2) Raw.Coq_ident.ident_infos) -> (__ -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a4 -> __) -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a4 -> __)) -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a4 -> ('a3, __ * __)
        Coq_Primitive.sigT) -> 'a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a4 -> __ list

      module GoalType :
       sig
        type ('base, 'ident) package = { all_base : 'base list;
                                         all_idents : (__, __)
                                                      Coq_Primitive.sigT list;
                                         ident_index : ('base
                                                       Compilers.Coq_base.Coq_type.coq_type
                                                       Compilers.Coq_type.coq_type
                                                       -> 'ident -> nat);
                                         eta_ident_cps_gen : (__ -> ('base
                                                             Compilers.Coq_base.Coq_type.coq_type
                                                             Compilers.Coq_type.coq_type
                                                             -> 'ident -> __)
                                                             -> ('base
                                                             Compilers.Coq_base.Coq_type.coq_type
                                                             Compilers.Coq_type.coq_type
                                                             -> 'ident -> __));
                                         eta_ident_cps_gen_expand_literal : 
                                         (__ -> ('base
                                         Compilers.Coq_base.Coq_type.coq_type
                                         Compilers.Coq_type.coq_type ->
                                         'ident -> __) -> ('base
                                         Compilers.Coq_base.Coq_type.coq_type
                                         Compilers.Coq_type.coq_type ->
                                         'ident -> __));
                                         eta_ident_cps : (__ -> 'base
                                                         Compilers.Coq_base.Coq_type.coq_type
                                                         Compilers.Coq_type.coq_type
                                                         -> 'ident -> ('base
                                                         Compilers.Coq_base.Coq_type.coq_type
                                                         Compilers.Coq_type.coq_type
                                                         -> 'ident -> __) ->
                                                         __);
                                         simple_idents : ('base
                                                         Compilers.Coq_base.Coq_type.coq_type
                                                         Compilers.Coq_type.coq_type,
                                                         'ident)
                                                         Coq_Primitive.sigT
                                                         list;
                                         all_raw_idents : __ list;
                                         raw_ident_index : (__ -> nat);
                                         eta_raw_ident_cps_gen : (__ -> (__
                                                                 -> __) ->
                                                                 (__ -> __));
                                         raw_ident_infos_of : (__ -> ('base,
                                                              'ident)
                                                              Raw.Coq_ident.ident_infos);
                                         split_raw_ident_gen : ('base
                                                               Compilers.Coq_base.Coq_type.coq_type
                                                               Compilers.Coq_type.coq_type
                                                               -> 'ident ->
                                                               (__, ('base,
                                                               'ident)
                                                               Raw.Coq_ident.ident_args)
                                                               Coq_Primitive.sigT);
                                         invert_bind_args : ('base
                                                            Compilers.Coq_base.Coq_type.coq_type
                                                            Compilers.Coq_type.coq_type
                                                            -> 'ident -> __
                                                            -> ('base,
                                                            'ident, __)
                                                            Raw.Coq_ident.full_types
                                                            option);
                                         invert_bind_args_unknown : ('base
                                                                    Compilers.Coq_base.Coq_type.coq_type
                                                                    Compilers.Coq_type.coq_type
                                                                    -> 'ident
                                                                    -> __ ->
                                                                    ('base,
                                                                    'ident,
                                                                    __)
                                                                    Raw.Coq_ident.full_types
                                                                    option);
                                         all_pattern_idents : (__, __)
                                                              Coq_Primitive.sigT
                                                              list;
                                         eta_pattern_ident_cps_gen : 
                                         (__ -> ('base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                         Compilers.Coq_type.coq_type -> __ ->
                                         __) -> ('base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                         Compilers.Coq_type.coq_type -> __ ->
                                         __));
                                         eta_pattern_ident_cps_gen_expand_literal : 
                                         (__ -> ('base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                         Compilers.Coq_type.coq_type -> __ ->
                                         __) -> ('base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                         Compilers.Coq_type.coq_type -> __ ->
                                         __));
                                         split_types : ('base
                                                       Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                                       Compilers.Coq_type.coq_type
                                                       -> __ -> (__, __ * __)
                                                       Coq_Primitive.sigT);
                                         add_types_from_raw_sig : (__ -> __
                                                                  -> __ ->
                                                                  ('base
                                                                  Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                                                  Compilers.Coq_type.coq_type,
                                                                  __)
                                                                  Coq_Primitive.sigT);
                                         arg_types_unfolded : ('base
                                                              Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                                              Compilers.Coq_type.coq_type
                                                              -> __ -> __
                                                              list);
                                         to_typed_unfolded : ('base
                                                             Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                                             Compilers.Coq_type.coq_type
                                                             -> __ -> 'base
                                                             Compilers.Coq_base.Coq_type.coq_type
                                                             PositiveMap.t ->
                                                             __ -> 'ident);
                                         type_of_list_arg_types_beq_unfolded : 
                                         ('base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                         Compilers.Coq_type.coq_type -> __ ->
                                         __ -> __ -> bool);
                                         of_typed_ident_unfolded : ('base
                                                                   Compilers.Coq_base.Coq_type.coq_type
                                                                   Compilers.Coq_type.coq_type
                                                                   -> 'ident
                                                                   -> __);
                                         arg_types_of_typed_ident_unfolded : 
                                         ('base
                                         Compilers.Coq_base.Coq_type.coq_type
                                         Compilers.Coq_type.coq_type ->
                                         'ident -> __);
                                         unify : ('base
                                                 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                                 Compilers.Coq_type.coq_type
                                                 -> 'base
                                                 Compilers.Coq_base.Coq_type.coq_type
                                                 Compilers.Coq_type.coq_type
                                                 -> __ -> 'ident -> __ option);
                                         unify_unknown : ('base
                                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                                         Compilers.Coq_type.coq_type
                                                         -> 'base
                                                         Compilers.Coq_base.Coq_type.coq_type
                                                         Compilers.Coq_type.coq_type
                                                         -> __ -> 'ident ->
                                                         __ option) }

        val eta_ident_cps :
          ('a1, 'a2) package -> 'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a2 -> ('a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a2 -> 'a3) -> 'a3

        val eta_raw_ident_cps_gen :
          ('a1, 'a2) package -> (__ -> 'a3) -> (__ -> 'a3)

        val raw_ident_infos_of :
          ('a1, 'a2) package -> __ -> ('a1, 'a2) Raw.Coq_ident.ident_infos

        val invert_bind_args :
          ('a1, 'a2) package -> 'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a2 -> __ -> ('a1, 'a2, __)
          Raw.Coq_ident.full_types option

        val invert_bind_args_unknown :
          ('a1, 'a2) package -> 'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a2 -> __ -> ('a1, 'a2, __)
          Raw.Coq_ident.full_types option

        val eta_pattern_ident_cps_gen :
          ('a1, 'a2) package -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> __ -> 'a3) -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> __ -> 'a3)

        val split_types :
          ('a1, 'a2) package -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> __ -> (__, __ * __)
          Coq_Primitive.sigT

        val unify :
          ('a1, 'a2) package -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          __ -> 'a2 -> __ option

        val unify_unknown :
          ('a1, 'a2) package -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          __ -> 'a2 -> __ option
       end
     end
   end
 end

module Coq1_Compilers :
 sig
  module Coq_pattern :
   sig
    module Coq_base :
     sig
      val subst :
        'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> 'a1
        Compilers.Coq_base.Coq_type.coq_type option

      type 'base var_types_of = __

      val add_var_types_cps :
        'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type -> 'a1
        var_types_of -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        PositiveMap.t -> ('a1 Compilers.Coq_base.Coq_type.coq_type
        PositiveMap.t -> 'a2) -> 'a2

      val unify_extracted :
        ('a1 -> 'a1 -> bool) -> 'a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type -> 'a1 var_types_of option
     end

    module Coq_type :
     sig
      val subst :
        'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
        option

      type 'base var_types_of = __

      val add_var_types_cps :
        'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a1 var_types_of -> 'a1
        Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> ('a1
        Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> 'a2) -> 'a2

      val unify_extracted :
        ('a1 -> 'a1 -> bool) -> 'a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a1 var_types_of option

      type ('base, 'k) forall_vars = __

      val app_forall_vars_gen :
        'a1 Compilers.Coq_base.Coq_type.coq_type PositiveMap.t ->
        PositiveMap.key list -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        PositiveMap.t -> __ -> 'a2 option

      val app_forall_vars :
        PositiveSet.t -> ('a1, 'a2) forall_vars -> 'a1
        Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> 'a2 option
     end

    type ('base, 'ident) pattern =
    | Wildcard of 'base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                  Compilers.Coq_type.coq_type
    | Ident of 'base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
               Compilers.Coq_type.coq_type * 'ident
    | App of 'base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
             Compilers.Coq_type.coq_type
       * 'base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
         Compilers.Coq_type.coq_type * ('base, 'ident) pattern
       * ('base, 'ident) pattern

    type ('base, 'ident) anypattern = { type_of_anypattern : 'base
                                                             Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                                             Compilers.Coq_type.coq_type;
                                        pattern_of_anypattern : ('base,
                                                                'ident)
                                                                pattern }

    val type_of_anypattern :
      ('a1, 'a2) anypattern -> 'a1
      Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type

    val pattern_of_anypattern : ('a1, 'a2) anypattern -> ('a1, 'a2) pattern

    val collect_vars :
      'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> ('a1, 'a2) pattern -> PositiveSet.t
   end

  module RewriteRules :
   sig
    module Compile :
     sig
      type ('base_type, 'ident, 'var) value' = __

      type ('base_type, 'ident, 'var) value =
        ('base_type, 'ident, 'var) value'

      type ('base_type, 'ident, 'var) value_with_lets =
        ('base_type, 'ident, 'var) value'

      val coq_Base_value :
        'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) value -> ('a1,
        'a2, 'a3) value_with_lets

      val splice_under_lets_with_value :
        'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3, 'a4)
        Coq_Compilers.UnderLets.coq_UnderLets -> ('a4 -> ('a1, 'a2, 'a3)
        value_with_lets) -> ('a1, 'a2, 'a3) value_with_lets

      val splice_value_with_lets :
        'a1 Compilers.Coq_type.coq_type -> 'a1 Compilers.Coq_type.coq_type ->
        ('a1, 'a2, 'a3) value_with_lets -> (('a1, 'a2, 'a3) value -> ('a1,
        'a2, 'a3) value_with_lets) -> ('a1, 'a2, 'a3) value_with_lets

      val reify :
        bool -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value' -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
        Compilers.Coq_expr.expr

      val reflect :
        bool -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a3) value'

      val reflect_expr_beta_iota :
        ('a1 Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
        -> 'a2 -> ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value
        option) -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a3, ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
        Coq_Compilers.UnderLets.coq_UnderLets

      val reify_to_UnderLets :
        bool -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value' -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3, ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets

      val reify_expr_beta_iota :
        ('a1 Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
        -> 'a2 -> ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value
        option) -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a3, ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets

      val reify_and_let_binds_cps :
        ('a1 Compilers.Coq_base.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
        Compilers.Coq_expr.expr -> __ -> (('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a3, __) Coq_Compilers.UnderLets.coq_UnderLets) -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3, __)
        Coq_Compilers.UnderLets.coq_UnderLets) -> bool -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value' -> (('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a3, 'a4) Coq_Compilers.UnderLets.coq_UnderLets) -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3, 'a4)
        Coq_Compilers.UnderLets.coq_UnderLets

      type ('base, 'ident, 'var) rawexpr =
      | Coq_rIdent of bool
         * 'base Compilers.Coq_base.Coq_type.coq_type
           Compilers.Coq_type.coq_type * 'ident
         * 'base Compilers.Coq_base.Coq_type.coq_type
           Compilers.Coq_type.coq_type
         * ('base Compilers.Coq_base.Coq_type.coq_type, 'ident, 'var)
           Compilers.Coq_expr.expr
      | Coq_rApp of ('base, 'ident, 'var) rawexpr
         * ('base, 'ident, 'var) rawexpr
         * 'base Compilers.Coq_base.Coq_type.coq_type
           Compilers.Coq_type.coq_type
         * ('base Compilers.Coq_base.Coq_type.coq_type, 'ident, 'var)
           Compilers.Coq_expr.expr
      | Coq_rExpr of 'base Compilers.Coq_base.Coq_type.coq_type
                     Compilers.Coq_type.coq_type
         * ('base Compilers.Coq_base.Coq_type.coq_type, 'ident, 'var)
           Compilers.Coq_expr.expr
      | Coq_rValue of 'base Compilers.Coq_base.Coq_type.coq_type
                      Compilers.Coq_type.coq_type
         * ('base Compilers.Coq_base.Coq_type.coq_type, 'ident, 'var) value

      val type_of_rawexpr :
        ('a1, 'a2, 'a3) rawexpr -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type

      val expr_of_rawexpr :
        ('a1, 'a2, 'a3) rawexpr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a3) Compilers.Coq_expr.expr

      val value_of_rawexpr :
        ('a1, 'a2, 'a3) rawexpr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a3) value

      val rValueOrExpr2 :
        'a1 Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
        -> ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
        Compilers.Coq_expr.expr -> ('a1, 'a2, 'a3) rawexpr

      val reveal_rawexpr_cps_gen :
        bool option -> ('a1, 'a2, 'a3) rawexpr -> (('a1, 'a2, 'a3) rawexpr ->
        'a4) -> 'a4

      val reveal_rawexpr_cps :
        ('a1, 'a2, 'a3) rawexpr -> (('a1, 'a2, 'a3) rawexpr -> 'a4) -> 'a4

      type ('base, 'pident, 'var) unification_resultT' = __

      type ('base, 'pident, 'var, 'k) with_unification_resultT' = __

      val app_transport_with_unification_resultT'_cps :
        'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a2 -> __ list) -> 'a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1, 'a2) Coq_pattern.pattern -> 'a1
        Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> 'a1
        Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> ('a1, 'a2, 'a3,
        'a4) with_unification_resultT' -> ('a1, 'a2, 'a3)
        unification_resultT' -> ('a4 -> 'a5 option) -> 'a5 option

      type ('base, 'pident, 'var, 'k) with_unification_resultT =
        ('base, ('base, 'pident, 'var, 'k) with_unification_resultT')
        Coq_pattern.Coq_type.forall_vars

      type ('base, 'pident, 'var) unification_resultT =
        ('base Compilers.Coq_base.Coq_type.coq_type PositiveMap.t, ('base,
        'pident, 'var) unification_resultT') sigT

      val app_with_unification_resultT_cps :
        'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a2 -> __ list) -> 'a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1, 'a2) Coq_pattern.pattern ->
        ('a1, 'a2, 'a3, 'a4) with_unification_resultT -> ('a1, 'a2, 'a3)
        unification_resultT -> (('a1 Compilers.Coq_base.Coq_type.coq_type
        PositiveMap.t, 'a4) sigT -> 'a5 option) -> 'a5 option

      val preunify_types :
        ('a1 -> 'a1 -> bool) -> 'a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) rawexpr -> ('a1, 'a4)
        Coq_pattern.pattern -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type * 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type)
        option option

      val option_type_type_beq :
        ('a1 -> 'a1 -> bool) -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type option -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
        option -> bool

      val unify_types :
        ('a1 -> 'a1 -> bool) -> 'a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) rawexpr -> ('a1, 'a4)
        Coq_pattern.pattern -> ('a1 Compilers.Coq_base.Coq_type.coq_type
        PositiveMap.t option -> 'a5) -> 'a5

      val option_bind' : 'a1 option -> ('a1 -> 'a2 option) -> 'a2 option

      val reveal_rawexpr_of_pattern_cps :
        'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) rawexpr -> ('a1, 'a4)
        Coq_pattern.pattern -> (('a1, 'a2, 'a3) rawexpr -> 'a5) -> 'a5

      val unify_pattern' :
        'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a4 -> 'a2 -> __ option) -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a4 -> 'a2 -> __ option) -> 'a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) rawexpr -> ('a1, 'a4)
        Coq_pattern.pattern -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        PositiveMap.t -> (('a1, 'a4, ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
        unification_resultT' -> 'a5 option) -> 'a5 option

      val reveal_rawexpr_of_pattern_as_necessary_cps :
        bool -> 'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) rawexpr -> ('a1, 'a4)
        Coq_pattern.pattern -> (('a1, 'a2, 'a3) rawexpr -> 'a5) -> 'a5

      val unify_pattern :
        'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1 -> 'a1 ->
        bool) -> ('a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a4 -> 'a2 -> __ option) -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a4 -> 'a2 -> __ option) -> bool -> 'a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) rawexpr -> ('a1, 'a4)
        Coq_pattern.pattern -> (('a1, 'a4, ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
        unification_resultT -> 'a5 option) -> 'a5 option

      type 'raw_pident decision_tree =
      | TryLeaf of nat * 'raw_pident decision_tree
      | Failure
      | Switch of ('raw_pident * 'raw_pident decision_tree) list
         * 'raw_pident decision_tree option * 'raw_pident decision_tree
      | Swap of nat * 'raw_pident decision_tree

      val swap_list : nat -> nat -> 'a1 list -> 'a1 list option

      val eval_decision_tree :
        ('a1 Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
        -> 'a2 -> 'a4 -> 'a5 option) -> ('a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a2 -> 'a4 -> 'a5 option) -> ('a4 -> 'a5 -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type) ->
        ('a4 -> 'a5 -> 'a2) -> ('a4 -> bool) -> ('a1, 'a2, 'a3) rawexpr list
        -> 'a4 decision_tree -> (nat -> ('a1, 'a2, 'a3) rawexpr list -> 'a6
        option) -> 'a6 option

      type ('base, 'ident, 'var) deep_rewrite_ruleTP_gen = __

      val normalize_deep_rewrite_rule :
        bool -> bool -> bool -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3)
        deep_rewrite_ruleTP_gen -> ('a1, 'a2, 'a3) deep_rewrite_ruleTP_gen

      type ('base, 'ident, 'var0, 'pident, 'var) with_unif_rewrite_ruleTP_gen =
        ('base, 'pident, 'var, __) with_unification_resultT

      type ('base, 'ident, 'var, 'pident) rewrite_rule_data = { rew_should_do_again : 
                                                                bool;
                                                                rew_with_opt : 
                                                                bool;
                                                                rew_under_lets : 
                                                                bool;
                                                                rew_replacement : 
                                                                ('base,
                                                                'ident, 'var,
                                                                'pident,
                                                                ('base
                                                                Compilers.Coq_base.Coq_type.coq_type,
                                                                'ident, 'var)
                                                                value)
                                                                with_unif_rewrite_ruleTP_gen }

      val rew_should_do_again :
        ('a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> 'a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1, 'a4) Coq_pattern.pattern ->
        ('a1, 'a2, 'a3, 'a4) rewrite_rule_data -> bool

      val rew_with_opt :
        ('a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> 'a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1, 'a4) Coq_pattern.pattern ->
        ('a1, 'a2, 'a3, 'a4) rewrite_rule_data -> bool

      val rew_under_lets :
        ('a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> 'a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1, 'a4) Coq_pattern.pattern ->
        ('a1, 'a2, 'a3, 'a4) rewrite_rule_data -> bool

      val rew_replacement :
        ('a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> 'a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1, 'a4) Coq_pattern.pattern ->
        ('a1, 'a2, 'a3, 'a4) rewrite_rule_data -> ('a1, 'a2, 'a3, 'a4, ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
        with_unif_rewrite_ruleTP_gen

      type ('base, 'ident, 'var, 'pident) rewrite_ruleTP =
        ('base, 'ident, 'var, 'pident) rewrite_rule_data

      type ('base, 'ident, 'var, 'pident) rewrite_ruleT =
        (('base, 'pident) Coq_pattern.anypattern, ('base, 'ident, 'var,
        'pident) rewrite_ruleTP) sigT

      type ('base, 'ident, 'var, 'pident) rewrite_rulesT =
        ('base, 'ident, 'var, 'pident) rewrite_ruleT list

      type ('base, 'ident, 'var) maybe_do_againT =
        ('base Compilers.Coq_base.Coq_type.coq_type, 'ident, __)
        Compilers.Coq_expr.expr -> ('base
        Compilers.Coq_base.Coq_type.coq_type, 'ident, 'var, ('base
        Compilers.Coq_base.Coq_type.coq_type, 'ident, 'var)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets

      val maybe_do_again :
        ('a1 Compilers.Coq_base.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a3, ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        bool -> 'a1 Compilers.Coq_base.Coq_type.coq_type -> ('a1, 'a2, 'a3)
        maybe_do_againT

      val rewrite_with_rule :
        'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1 -> 'a1 ->
        bool) -> ('a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a4 -> 'a2 -> __ option) -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a4 -> 'a2 -> __ option) -> ('a1 Compilers.Coq_base.Coq_type.coq_type
        -> ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a3, ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        bool -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) rawexpr -> ('a1, 'a2,
        'a3, 'a4) rewrite_ruleT -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a3, ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets option

      val eval_rewrite_rules :
        'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1 -> 'a1 ->
        bool) -> ('a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a4 -> 'a2 -> __ option) -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a4 -> 'a2 -> __ option) -> ('a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a2 -> 'a5 -> 'a6 option) -> ('a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a2 -> 'a5 -> 'a6 option) -> ('a5 -> 'a6 -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type) ->
        ('a5 -> 'a6 -> 'a2) -> ('a5 -> bool) -> ('a1
        Compilers.Coq_base.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a3, ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        'a5 decision_tree option -> ('a1, 'a2, 'a3, 'a4) rewrite_rulesT ->
        ('a1, 'a2, 'a3) rawexpr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a3, ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets

      val assemble_identifier_rewriters' :
        'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1 -> 'a1 ->
        bool) -> ('a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a4 -> 'a2 -> __ option) -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a4 -> 'a2 -> __ option) -> ('a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a2 -> 'a5 -> 'a6 option) -> ('a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a2 -> 'a5 -> 'a6 option) -> ('a5 -> 'a6 -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type) ->
        ('a5 -> 'a6 -> 'a2) -> ('a5 -> bool) -> 'a5 decision_tree option ->
        ('a1, 'a2, 'a3, 'a4) rewrite_rulesT -> ('a1
        Compilers.Coq_base.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a3, ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        'a1 Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
        -> ('a1, 'a2, 'a3) rawexpr -> (__ -> __ -> __) -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value_with_lets

      val assemble_identifier_rewriters :
        'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1 -> 'a1 ->
        bool) -> (__ -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a2 -> ('a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a2 -> __) -> __) -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a4 -> 'a2 -> __ option) -> ('a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a4 -> 'a2 -> __ option) -> ('a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> 'a2 -> 'a5 -> 'a6 option) -> ('a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a2 -> 'a5 -> 'a6 option) -> ('a5 -> 'a6 -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type) ->
        ('a5 -> 'a6 -> 'a2) -> ('a5 -> bool) -> 'a5 decision_tree option ->
        ('a1, 'a2, 'a3, 'a4) rewrite_rulesT -> ('a1
        Compilers.Coq_base.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a3, ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        'a1 Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
        -> 'a2 -> ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
        value_with_lets

      val reflect_ident_iota :
        'a1 Compilers.Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a3,
        'a2) Compilers.Coq_ident.coq_BuildIdentT -> ('a1, 'a2)
        Compilers.Coq_ident.coq_BuildEagerIdentT -> ('a1, 'a2)
        Compilers.Coq_ident.coq_ToRestrictedIdentT -> ('a1, 'a3, 'a2)
        Compilers.Coq_invert_expr.coq_InvertIdentT -> ('a1, 'a3)
        Compilers.Coq_base.coq_BaseHasNatCorrectT -> 'a1
        Compilers.Coq_type.try_make_transport_cpsT -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a2 -> ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4) value
        option

      val rewrite_bottomup :
        ('a1 Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
        -> 'a2 -> bool) -> ('a1, 'a3, 'a2)
        Compilers.Coq_ident.coq_BuildIdentT -> ('a1, 'a3, 'a2)
        Compilers.Coq_invert_expr.coq_InvertIdentT -> 'a1
        Compilers.Coq_type.try_make_transport_cpsT -> ('a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a2 -> ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4)
        value_with_lets) -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4) value)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a4) value_with_lets

      val repeat_rewrite :
        ('a1 Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
        -> 'a2 -> bool) -> ('a1, 'a3, 'a2)
        Compilers.Coq_ident.coq_BuildIdentT -> ('a1, 'a3, 'a2)
        Compilers.Coq_invert_expr.coq_InvertIdentT -> 'a1
        Compilers.Coq_type.try_make_transport_cpsT -> (('a1
        Compilers.Coq_base.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4) value)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a4, ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        'a1 Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
        -> 'a2 -> ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4)
        value_with_lets) -> nat -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4) value)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a4) value_with_lets

      val rewrite :
        ('a1 Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
        -> 'a2 -> bool) -> ('a1, 'a3, 'a2)
        Compilers.Coq_ident.coq_BuildIdentT -> ('a1, 'a3, 'a2)
        Compilers.Coq_invert_expr.coq_InvertIdentT -> 'a1
        Compilers.Coq_type.try_make_transport_cpsT -> (('a1
        Compilers.Coq_base.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4) value)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a4, ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        'a1 Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
        -> 'a2 -> ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4)
        value_with_lets) -> nat -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4) value)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a4) Compilers.Coq_expr.expr

      val coq_Rewrite :
        ('a1 Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
        -> 'a2 -> bool) -> ('a1, 'a3, 'a2)
        Compilers.Coq_ident.coq_BuildIdentT -> ('a1, 'a3, 'a2)
        Compilers.Coq_invert_expr.coq_InvertIdentT -> 'a1
        Compilers.Coq_type.try_make_transport_cpsT -> (__ -> ('a1
        Compilers.Coq_base.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, __) value)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, __, ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, __)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        'a1 Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
        -> 'a2 -> ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, __)
        value_with_lets) -> nat -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2)
        Compilers.Coq_expr.coq_Expr -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, __) Compilers.Coq_expr.expr
     end

    module Reify :
     sig
      val expr_value_to_rewrite_rule_replacement :
        ('a1 Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
        -> 'a2 -> ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
        Compile.value option) -> bool -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) Compile.value)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a2, 'a3, ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, __)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets
     end

    module Make :
     sig
      module GoalType :
       sig
        type rewriter_dataT = { ident_is_var_like : (__
                                                    Compilers.Coq_base.Coq_type.coq_type
                                                    Compilers.Coq_type.coq_type
                                                    -> __ -> bool);
                                rewrite_rules_specs : (bool * __) list;
                                dummy_count : nat;
                                dtree : __ Compile.decision_tree;
                                rewrite_rules : (__ -> (__, __, __, __)
                                                Compile.rewrite_rulesT);
                                all_rewrite_rules : (__ -> (__, __, __, __)
                                                    Compile.rewrite_rulesT);
                                default_fuel : nat;
                                rewrite_head : (__ -> (__
                                               Compilers.Coq_base.Coq_type.coq_type
                                               -> (__
                                               Compilers.Coq_base.Coq_type.coq_type,
                                               __, (__
                                               Compilers.Coq_base.Coq_type.coq_type,
                                               __, __) Compile.value)
                                               Compilers.Coq_expr.expr -> (__
                                               Compilers.Coq_base.Coq_type.coq_type,
                                               __, __, (__
                                               Compilers.Coq_base.Coq_type.coq_type,
                                               __, __)
                                               Compilers.Coq_expr.expr)
                                               Coq_Compilers.UnderLets.coq_UnderLets)
                                               -> __
                                               Compilers.Coq_base.Coq_type.coq_type
                                               Compilers.Coq_type.coq_type ->
                                               __ -> (__
                                               Compilers.Coq_base.Coq_type.coq_type,
                                               __, __)
                                               Compile.value_with_lets);
                                rewrite_head_no_dtree : (__ -> (__
                                                        Compilers.Coq_base.Coq_type.coq_type
                                                        -> (__
                                                        Compilers.Coq_base.Coq_type.coq_type,
                                                        __, (__
                                                        Compilers.Coq_base.Coq_type.coq_type,
                                                        __, __)
                                                        Compile.value)
                                                        Compilers.Coq_expr.expr
                                                        -> (__
                                                        Compilers.Coq_base.Coq_type.coq_type,
                                                        __, __, (__
                                                        Compilers.Coq_base.Coq_type.coq_type,
                                                        __, __)
                                                        Compilers.Coq_expr.expr)
                                                        Coq_Compilers.UnderLets.coq_UnderLets)
                                                        -> __
                                                        Compilers.Coq_base.Coq_type.coq_type
                                                        Compilers.Coq_type.coq_type
                                                        -> __ -> (__
                                                        Compilers.Coq_base.Coq_type.coq_type,
                                                        __, __)
                                                        Compile.value_with_lets) }

        val dtree :
          Compilers.Classes.coq_ExprInfoT ->
          Compilers.Classes.coq_ExprExtraInfoT -> (__, __)
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.package ->
          rewriter_dataT -> __ Compile.decision_tree

        val all_rewrite_rules :
          Compilers.Classes.coq_ExprInfoT ->
          Compilers.Classes.coq_ExprExtraInfoT -> (__, __)
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.package ->
          rewriter_dataT -> (__, __, 'a1, __) Compile.rewrite_rulesT

        val rewrite_head :
          Compilers.Classes.coq_ExprInfoT ->
          Compilers.Classes.coq_ExprExtraInfoT -> (__, __)
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.package ->
          rewriter_dataT -> (__ Compilers.Coq_base.Coq_type.coq_type -> (__
          Compilers.Coq_base.Coq_type.coq_type, __, (__
          Compilers.Coq_base.Coq_type.coq_type, __, 'a1) Compile.value)
          Compilers.Coq_expr.expr -> (__
          Compilers.Coq_base.Coq_type.coq_type, __, 'a1, (__
          Compilers.Coq_base.Coq_type.coq_type, __, 'a1)
          Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
          __ Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
          -> __ -> (__ Compilers.Coq_base.Coq_type.coq_type, __, 'a1)
          Compile.value_with_lets

        val rewrite_head_no_dtree :
          Compilers.Classes.coq_ExprInfoT ->
          Compilers.Classes.coq_ExprExtraInfoT -> (__, __)
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.package ->
          rewriter_dataT -> (__ Compilers.Coq_base.Coq_type.coq_type -> (__
          Compilers.Coq_base.Coq_type.coq_type, __, (__
          Compilers.Coq_base.Coq_type.coq_type, __, 'a1) Compile.value)
          Compilers.Coq_expr.expr -> (__
          Compilers.Coq_base.Coq_type.coq_type, __, 'a1, (__
          Compilers.Coq_base.Coq_type.coq_type, __, 'a1)
          Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
          __ Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
          -> __ -> (__ Compilers.Coq_base.Coq_type.coq_type, __, 'a1)
          Compile.value_with_lets

        val rewrite_head_gen :
          Compilers.Classes.coq_ExprInfoT ->
          Compilers.Classes.coq_ExprExtraInfoT -> (__, __)
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.package ->
          rewriter_dataT -> bool -> bool -> (__
          Compilers.Coq_base.Coq_type.coq_type -> (__
          Compilers.Coq_base.Coq_type.coq_type, __, (__
          Compilers.Coq_base.Coq_type.coq_type, __, 'a1) Compile.value)
          Compilers.Coq_expr.expr -> (__
          Compilers.Coq_base.Coq_type.coq_type, __, 'a1, (__
          Compilers.Coq_base.Coq_type.coq_type, __, 'a1)
          Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
          __ Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
          -> __ -> (__ Compilers.Coq_base.Coq_type.coq_type, __, 'a1)
          Compile.value_with_lets
       end
     end
   end
 end

module Coq2_Compilers :
 sig
  module RewriteRules :
   sig
    module GoalType :
     sig
      module DefaultOptionType :
       sig
        type coq_RewriterOptions = { use_decision_tree : bool;
                                     use_precomputed_functions : bool }

        val use_decision_tree : coq_RewriterOptions -> bool

        val use_precomputed_functions : coq_RewriterOptions -> bool
       end
     end
   end
 end

module Coq3_Compilers :
 sig
  type base =
  | Z
  | Coq_bool
  | Coq_nat
  | Coq_zrange
  | Coq_string

  val base_rect : 'a1 -> 'a1 -> 'a1 -> 'a1 -> 'a1 -> base -> 'a1

  val base_rec : 'a1 -> 'a1 -> 'a1 -> 'a1 -> 'a1 -> base -> 'a1

  type ident =
  | Coq_ident_Literal of base * __
  | Coq_ident_comment of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_comment_no_keep of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_value_barrier
  | Coq_ident_Nat_succ
  | Coq_ident_Nat_pred
  | Coq_ident_Nat_max
  | Coq_ident_Nat_mul
  | Coq_ident_Nat_add
  | Coq_ident_Nat_sub
  | Coq_ident_Nat_eqb
  | Coq_ident_nil of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_cons of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_tt
  | Coq_ident_pair of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_fst of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_snd of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_prod_rect of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_bool_rect of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_bool_rect_nodep of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_nat_rect of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_eager_nat_rect of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_nat_rect_arrow of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_eager_nat_rect_arrow of base
                                      Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_list_rect of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_eager_list_rect of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_list_rect_arrow of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_eager_list_rect_arrow of base
                                       Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_list_case of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_length of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_seq
  | Coq_ident_List_firstn of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_skipn of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_repeat of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_combine of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_map of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_app of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_rev of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_flat_map of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_partition of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_filter of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_fold_right of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_update_nth of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_nth_default of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_eager_List_nth_default of base
                                        Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_Z_add
  | Coq_ident_Z_mul
  | Coq_ident_Z_pow
  | Coq_ident_Z_sub
  | Coq_ident_Z_opp
  | Coq_ident_Z_div
  | Coq_ident_Z_modulo
  | Coq_ident_Z_eqb
  | Coq_ident_Z_leb
  | Coq_ident_Z_ltb
  | Coq_ident_Z_geb
  | Coq_ident_Z_gtb
  | Coq_ident_Z_log2
  | Coq_ident_Z_log2_up
  | Coq_ident_Z_of_nat
  | Coq_ident_Z_to_nat
  | Coq_ident_Z_shiftr
  | Coq_ident_Z_shiftl
  | Coq_ident_Z_land
  | Coq_ident_Z_lor
  | Coq_ident_Z_min
  | Coq_ident_Z_max
  | Coq_ident_Z_mul_split
  | Coq_ident_Z_mul_high
  | Coq_ident_Z_add_get_carry
  | Coq_ident_Z_add_with_carry
  | Coq_ident_Z_add_with_get_carry
  | Coq_ident_Z_sub_get_borrow
  | Coq_ident_Z_sub_with_get_borrow
  | Coq_ident_Z_ltz
  | Coq_ident_Z_zselect
  | Coq_ident_Z_add_modulo
  | Coq_ident_Z_truncating_shiftl
  | Coq_ident_Z_bneg
  | Coq_ident_Z_lnot_modulo
  | Coq_ident_Z_lxor
  | Coq_ident_Z_rshi
  | Coq_ident_Z_cc_m
  | Coq_ident_Z_combine_at_bitwidth
  | Coq_ident_Z_cast
  | Coq_ident_Z_cast2
  | Coq_ident_Some of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_None of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_option_rect of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_Build_zrange
  | Coq_ident_zrange_rect of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_fancy_add
  | Coq_ident_fancy_addc
  | Coq_ident_fancy_sub
  | Coq_ident_fancy_subb
  | Coq_ident_fancy_mulll
  | Coq_ident_fancy_mullh
  | Coq_ident_fancy_mulhl
  | Coq_ident_fancy_mulhh
  | Coq_ident_fancy_rshi
  | Coq_ident_fancy_selc
  | Coq_ident_fancy_selm
  | Coq_ident_fancy_sell
  | Coq_ident_fancy_addm

  type pattern_ident =
  | Coq_pattern_ident_Literal of base
  | Coq_pattern_ident_comment of base
                                 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_comment_no_keep of base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_value_barrier
  | Coq_pattern_ident_Nat_succ
  | Coq_pattern_ident_Nat_pred
  | Coq_pattern_ident_Nat_max
  | Coq_pattern_ident_Nat_mul
  | Coq_pattern_ident_Nat_add
  | Coq_pattern_ident_Nat_sub
  | Coq_pattern_ident_Nat_eqb
  | Coq_pattern_ident_nil of base
                             Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_cons of base
                              Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_tt
  | Coq_pattern_ident_pair of base
                              Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_fst of base
                             Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_snd of base
                             Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_prod_rect of base
                                   Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_bool_rect of base
                                   Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_bool_rect_nodep of base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_nat_rect of base
                                  Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_eager_nat_rect of base
                                        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_nat_rect_arrow of base
                                        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_eager_nat_rect_arrow of base
                                              Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_list_rect of base
                                   Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_eager_list_rect of base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_list_rect_arrow of base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_eager_list_rect_arrow of base
                                               Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_list_case of base
                                   Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_length of base
                                     Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_seq
  | Coq_pattern_ident_List_firstn of base
                                     Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_skipn of base
                                    Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_repeat of base
                                     Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_combine of base
                                      Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_map of base
                                  Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_app of base
                                  Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_rev of base
                                  Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_flat_map of base
                                       Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_partition of base
                                        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_filter of base
                                     Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_fold_right of base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_update_nth of base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_nth_default of base
                                          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_eager_List_nth_default of base
                                                Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_Z_add
  | Coq_pattern_ident_Z_mul
  | Coq_pattern_ident_Z_pow
  | Coq_pattern_ident_Z_sub
  | Coq_pattern_ident_Z_opp
  | Coq_pattern_ident_Z_div
  | Coq_pattern_ident_Z_modulo
  | Coq_pattern_ident_Z_eqb
  | Coq_pattern_ident_Z_leb
  | Coq_pattern_ident_Z_ltb
  | Coq_pattern_ident_Z_geb
  | Coq_pattern_ident_Z_gtb
  | Coq_pattern_ident_Z_log2
  | Coq_pattern_ident_Z_log2_up
  | Coq_pattern_ident_Z_of_nat
  | Coq_pattern_ident_Z_to_nat
  | Coq_pattern_ident_Z_shiftr
  | Coq_pattern_ident_Z_shiftl
  | Coq_pattern_ident_Z_land
  | Coq_pattern_ident_Z_lor
  | Coq_pattern_ident_Z_min
  | Coq_pattern_ident_Z_max
  | Coq_pattern_ident_Z_mul_split
  | Coq_pattern_ident_Z_mul_high
  | Coq_pattern_ident_Z_add_get_carry
  | Coq_pattern_ident_Z_add_with_carry
  | Coq_pattern_ident_Z_add_with_get_carry
  | Coq_pattern_ident_Z_sub_get_borrow
  | Coq_pattern_ident_Z_sub_with_get_borrow
  | Coq_pattern_ident_Z_ltz
  | Coq_pattern_ident_Z_zselect
  | Coq_pattern_ident_Z_add_modulo
  | Coq_pattern_ident_Z_truncating_shiftl
  | Coq_pattern_ident_Z_bneg
  | Coq_pattern_ident_Z_lnot_modulo
  | Coq_pattern_ident_Z_lxor
  | Coq_pattern_ident_Z_rshi
  | Coq_pattern_ident_Z_cc_m
  | Coq_pattern_ident_Z_combine_at_bitwidth
  | Coq_pattern_ident_Z_cast
  | Coq_pattern_ident_Z_cast2
  | Coq_pattern_ident_Some of base
                              Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_None of base
                              Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_option_rect of base
                                     Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_Build_zrange
  | Coq_pattern_ident_zrange_rect of base
                                     Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_fancy_add
  | Coq_pattern_ident_fancy_addc
  | Coq_pattern_ident_fancy_sub
  | Coq_pattern_ident_fancy_subb
  | Coq_pattern_ident_fancy_mulll
  | Coq_pattern_ident_fancy_mullh
  | Coq_pattern_ident_fancy_mulhl
  | Coq_pattern_ident_fancy_mulhh
  | Coq_pattern_ident_fancy_rshi
  | Coq_pattern_ident_fancy_selc
  | Coq_pattern_ident_fancy_selm
  | Coq_pattern_ident_fancy_sell
  | Coq_pattern_ident_fancy_addm

  type raw_ident =
  | Coq_raw_ident_Literal
  | Coq_raw_ident_comment
  | Coq_raw_ident_comment_no_keep
  | Coq_raw_ident_value_barrier
  | Coq_raw_ident_Nat_succ
  | Coq_raw_ident_Nat_pred
  | Coq_raw_ident_Nat_max
  | Coq_raw_ident_Nat_mul
  | Coq_raw_ident_Nat_add
  | Coq_raw_ident_Nat_sub
  | Coq_raw_ident_Nat_eqb
  | Coq_raw_ident_nil
  | Coq_raw_ident_cons
  | Coq_raw_ident_tt
  | Coq_raw_ident_pair
  | Coq_raw_ident_fst
  | Coq_raw_ident_snd
  | Coq_raw_ident_prod_rect
  | Coq_raw_ident_bool_rect
  | Coq_raw_ident_bool_rect_nodep
  | Coq_raw_ident_nat_rect
  | Coq_raw_ident_eager_nat_rect
  | Coq_raw_ident_nat_rect_arrow
  | Coq_raw_ident_eager_nat_rect_arrow
  | Coq_raw_ident_list_rect
  | Coq_raw_ident_eager_list_rect
  | Coq_raw_ident_list_rect_arrow
  | Coq_raw_ident_eager_list_rect_arrow
  | Coq_raw_ident_list_case
  | Coq_raw_ident_List_length
  | Coq_raw_ident_List_seq
  | Coq_raw_ident_List_firstn
  | Coq_raw_ident_List_skipn
  | Coq_raw_ident_List_repeat
  | Coq_raw_ident_List_combine
  | Coq_raw_ident_List_map
  | Coq_raw_ident_List_app
  | Coq_raw_ident_List_rev
  | Coq_raw_ident_List_flat_map
  | Coq_raw_ident_List_partition
  | Coq_raw_ident_List_filter
  | Coq_raw_ident_List_fold_right
  | Coq_raw_ident_List_update_nth
  | Coq_raw_ident_List_nth_default
  | Coq_raw_ident_eager_List_nth_default
  | Coq_raw_ident_Z_add
  | Coq_raw_ident_Z_mul
  | Coq_raw_ident_Z_pow
  | Coq_raw_ident_Z_sub
  | Coq_raw_ident_Z_opp
  | Coq_raw_ident_Z_div
  | Coq_raw_ident_Z_modulo
  | Coq_raw_ident_Z_eqb
  | Coq_raw_ident_Z_leb
  | Coq_raw_ident_Z_ltb
  | Coq_raw_ident_Z_geb
  | Coq_raw_ident_Z_gtb
  | Coq_raw_ident_Z_log2
  | Coq_raw_ident_Z_log2_up
  | Coq_raw_ident_Z_of_nat
  | Coq_raw_ident_Z_to_nat
  | Coq_raw_ident_Z_shiftr
  | Coq_raw_ident_Z_shiftl
  | Coq_raw_ident_Z_land
  | Coq_raw_ident_Z_lor
  | Coq_raw_ident_Z_min
  | Coq_raw_ident_Z_max
  | Coq_raw_ident_Z_mul_split
  | Coq_raw_ident_Z_mul_high
  | Coq_raw_ident_Z_add_get_carry
  | Coq_raw_ident_Z_add_with_carry
  | Coq_raw_ident_Z_add_with_get_carry
  | Coq_raw_ident_Z_sub_get_borrow
  | Coq_raw_ident_Z_sub_with_get_borrow
  | Coq_raw_ident_Z_ltz
  | Coq_raw_ident_Z_zselect
  | Coq_raw_ident_Z_add_modulo
  | Coq_raw_ident_Z_truncating_shiftl
  | Coq_raw_ident_Z_bneg
  | Coq_raw_ident_Z_lnot_modulo
  | Coq_raw_ident_Z_lxor
  | Coq_raw_ident_Z_rshi
  | Coq_raw_ident_Z_cc_m
  | Coq_raw_ident_Z_combine_at_bitwidth
  | Coq_raw_ident_Z_cast
  | Coq_raw_ident_Z_cast2
  | Coq_raw_ident_Some
  | Coq_raw_ident_None
  | Coq_raw_ident_option_rect
  | Coq_raw_ident_Build_zrange
  | Coq_raw_ident_zrange_rect
  | Coq_raw_ident_fancy_add
  | Coq_raw_ident_fancy_addc
  | Coq_raw_ident_fancy_sub
  | Coq_raw_ident_fancy_subb
  | Coq_raw_ident_fancy_mulll
  | Coq_raw_ident_fancy_mullh
  | Coq_raw_ident_fancy_mulhl
  | Coq_raw_ident_fancy_mulhh
  | Coq_raw_ident_fancy_rshi
  | Coq_raw_ident_fancy_selc
  | Coq_raw_ident_fancy_selm
  | Coq_raw_ident_fancy_sell
  | Coq_raw_ident_fancy_addm

  val eta_base_cps_gen : (base -> 'a1) -> (base -> 'a1)

  val eta_base_cps : (base -> 'a1) -> base -> 'a1

  type base_interp = __

  val ident_interp :
    base Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    ident -> (base Compilers.Coq_base.Coq_type.coq_type, (base, base_interp)
    Compilers.Coq_base.interp) Compilers.Coq_type.interp

  val base_eq_dec : base -> base -> bool

  val base_beq_and_reflect :
    (base -> base -> bool, base -> base -> reflect) sigT

  val base_beq : base -> base -> bool

  val reflect_base_beq : base -> base -> reflect

  val baseHasNat : base Compilers.Coq_base.Coq_type.coq_BaseTypeHasNatT

  val baseHasNatCorrect :
    (base, base_interp) Compilers.Coq_base.coq_BaseHasNatCorrectT

  val base_interp_beq : base -> base -> base_interp -> base_interp -> bool

  val reflect_base_interp_beq : base -> base_interp -> base_interp -> reflect

  val try_make_base_transport_cps :
    base -> base -> ((__ -> __) option -> __) -> __

  val buildEagerIdent : (base, ident) Compilers.Coq_ident.coq_BuildEagerIdentT

  val toRestrictedIdent :
    (base, ident) Compilers.Coq_ident.coq_ToRestrictedIdentT

  val buildIdent :
    (base, base_interp, ident) Compilers.Coq_ident.coq_BuildIdentT

  val ident_is_var_like :
    base Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    ident -> bool

  val invertIdent :
    (base, base_interp, ident) Compilers.Coq_invert_expr.coq_InvertIdentT

  val base_default :
    (base, base_interp) Compilers.DefaultValue.Coq_type.Coq_base.coq_DefaultT
 end

module Coq4_Compilers :
 sig
  module Coq_ident :
   sig
    val is_comment :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> bool

    module Notations :
     sig
     end
   end

  module Coq_invert_expr :
   sig
    module Coq_ident :
     sig
     end

    val invert_Z_cast :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr -> zrange option

    val invert_Z_cast2 :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr -> (zrange * zrange) option

    val invert_App_Z_cast :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr ->
      (zrange * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr) option

    val invert_App_Z_cast2 :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr ->
      ((zrange * zrange) * (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) option

    val invert_App_cast :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr -> ((Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base, zrange)
      Compilers.Coq_base.interp)
      Compilers.Coq_type.interp * (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) option

    val invert_Literal_through_cast :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr -> ((Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base, zrange)
      Compilers.Coq_base.interp) Compilers.Coq_type.interp
      option * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      (Coq3_Compilers.base, Coq3_Compilers.base_interp)
      Compilers.Coq_base.interp) Compilers.Coq_type.interp) option
   end

  module Coercions :
   sig
    val type_base :
      Coq3_Compilers.base -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type

    val base :
      'a1 Compilers.Coq_base.Coq_type.coq_type -> 'a1
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
   end
 end

module Coq5_Compilers :
 sig
  module Coq_ident :
   sig
    val is_comment :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> bool

    module Notations :
     sig
     end
   end

  module Coq_invert_expr :
   sig
    module Coq_ident :
     sig
     end

    val invert_Z_cast :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr -> zrange option

    val invert_Z_cast2 :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr -> (zrange * zrange) option

    val invert_App_Z_cast :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr ->
      (zrange * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr) option

    val invert_App_Z_cast2 :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr ->
      ((zrange * zrange) * (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) option

    val invert_App_cast :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr -> ((Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base, zrange)
      Compilers.Coq_base.interp)
      Compilers.Coq_type.interp * (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) option

    val invert_Literal_through_cast :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr -> ((Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base, zrange)
      Compilers.Coq_base.interp) Compilers.Coq_type.interp
      option * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      (Coq3_Compilers.base, Coq3_Compilers.base_interp)
      Compilers.Coq_base.interp) Compilers.Coq_type.interp) option
   end

  module Coercions :
   sig
    val type_base :
      Coq3_Compilers.base -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type

    val base :
      'a1 Compilers.Coq_base.Coq_type.coq_type -> 'a1
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
   end
 end

val fold_andb_map : ('a1 -> 'a2 -> bool) -> 'a1 list -> 'a2 list -> bool

module Coq6_Compilers :
 sig
  module ZRange :
   sig
    module Settings :
     sig
      type shiftr_avoid_uint1_opt = bool

      module AbstractInterpretation :
       sig
        type coq_Options =
          shiftr_avoid_uint1_opt
          (* singleton inductive, whose constructor was Build_Options *)

        val shiftr_avoid_uint1 : coq_Options -> shiftr_avoid_uint1_opt

        val default_Options : coq_Options
       end
     end

    module Coq_type :
     sig
      module Coq_base :
       sig
        module Coq__4 : sig
         type interp = __
        end
        include module type of struct include Coq__4 end

        val map_ranges :
          (zrange -> zrange) -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type -> interp -> interp

        val is_tighter_than :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> interp
          -> interp -> bool

        val is_bounded_by :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> interp
          -> (Coq3_Compilers.base, Coq3_Compilers.base_interp)
          Compilers.Coq_base.interp -> bool

        val interp_beq :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> interp
          -> interp -> bool

        module Coq_option :
         sig
          type interp = __

          val map_ranges :
            (zrange -> zrange) -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type -> interp -> interp

          val coq_None :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> interp

          val coq_Some :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            Coq__4.interp -> interp

          val lift_Some :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            interp -> Coq__4.interp option

          val is_informative :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            interp -> bool

          val strip_ranges :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            interp -> interp

          val is_tighter_than :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            interp -> interp -> bool

          val interp_beq :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            interp -> interp -> bool
         end
       end

      type interp =
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq_base.interp) Compilers.Coq_type.interp

      val is_bounded_by :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> interp -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base,
        Coq3_Compilers.base_interp) Compilers.Coq_base.interp)
        Compilers.Coq_type.interp -> bool

      module Coq_option :
       sig
        type interp =
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq_base.Coq_option.interp) Compilers.Coq_type.interp

        val coq_None :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> interp

        val strip_ranges :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> interp -> interp
       end
     end

    module Coq_ident :
     sig
      module Coq_option :
       sig
        val of_literal :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          (Coq3_Compilers.base, Coq3_Compilers.base_interp)
          Compilers.Coq_base.interp -> Coq_type.Coq_base.Coq_option.interp

        val to_literal :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          Coq_type.Coq_base.Coq_option.interp -> (Coq3_Compilers.base,
          Coq3_Compilers.base_interp) Compilers.Coq_base.interp option

        val interp_Z_cast : zrange option -> zrange option -> zrange option

        val interp_Z_cast_truncate :
          zrange option -> zrange option -> zrange option

        val interp :
          Settings.shiftr_avoid_uint1_opt -> bool -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          Coq3_Compilers.ident -> Coq_type.Coq_option.interp
       end
     end
   end
 end

type idx = n

type symbol = n

type operationSize = n

val show_OperationSize : operationSize show

type op0 =
| Old of operationSize * symbol
| Const0 of z
| Add0 of operationSize
| Addcarry of operationSize
| Subborrow of operationSize
| Addoverflow of operationSize
| Neg1 of operationSize
| Shl0 of operationSize
| Shr0 of operationSize
| Sar0 of operationSize
| Rcr0 of operationSize
| And0 of operationSize
| Or0 of operationSize
| Xor0 of operationSize
| Slice of n * n
| Mul0 of operationSize
| Set_slice of n * n
| Selectznz
| Iszero
| AddZ
| MulZ
| NegZ
| ShlZ
| ShrZ
| AndZ
| OrZ
| XorZ
| AddcarryZ of operationSize
| SubborrowZ of operationSize

val internal_op_beq0 : op0 -> op0 -> bool

val op_eq_dec : op0 -> op0 -> bool

val op_beq : op0 -> op0 -> bool

val show_op : op0 show

val show_op_subscript : op0 show

module RewritePass :
 sig
  type rewrite_pass =
  | Coq_addbyte_small
  | Coq_addcarry_bit
  | Coq_addcarry_small
  | Coq_addoverflow_bit
  | Coq_addoverflow_small
  | Coq_combine_consts
  | Coq_constprop
  | Coq_consts_commutative
  | Coq_drop_identity
  | Coq_flatten_associative
  | Coq_flatten_bounded_associative
  | Coq_fold_consts_to_and
  | Coq_set_slice0_small
  | Coq_set_slice_set_slice
  | Coq_shift_to_mul
  | Coq_slice0
  | Coq_slice01_addcarryZ
  | Coq_slice01_subborrowZ
  | Coq_slice_set_slice
  | Coq_truncate_small
  | Coq_unary_truncate
  | Coq_xor_same

  val show_rewrite_pass : rewrite_pass show

  val parse_rewrite_pass_list : (char list * rewrite_pass) list

  val parse_rewrite_pass : rewrite_pass parserAction

  val default_rewrite_pass_order : rewrite_pass list
 end

module Options :
 sig
  type rewriting_pipeline_opt = RewritePass.rewrite_pass list

  type rewriting_pass_filter_opt = RewritePass.rewrite_pass -> bool

  type rewriting_passes_opt = RewritePass.rewrite_pass list

  val default_rewriting_passes :
    rewriting_pipeline_opt -> rewriting_pass_filter_opt ->
    rewriting_passes_opt

  type symbolic_options_opt = { asm_rewriting_pipeline : rewriting_pipeline_opt;
                                asm_rewriting_pass_filter : rewriting_pass_filter_opt }

  val asm_rewriting_pipeline : symbolic_options_opt -> rewriting_pipeline_opt

  val asm_rewriting_pass_filter :
    symbolic_options_opt -> rewriting_pass_filter_opt

  type symbolic_options_computed_opt =
    rewriting_passes_opt
    (* singleton inductive, whose constructor was Build_symbolic_options_computed_opt *)

  val asm_rewriting_passes :
    symbolic_options_computed_opt -> rewriting_passes_opt
 end

val associative : op0 -> bool

val commutative : op0 -> bool

val identity : op0 -> z option

val identity_after_0 : op0 -> z option

val unary_truncate_size : op0 -> z option

val op_always_interps : op0 -> bool

val combines_to : op0 -> op0 option

type drop_kind =
| Drop_always
| Drop_if_bounded of zrange * op0

val bounds_for_drop_inner_associative : op0 -> op0 -> drop_kind option

type 'a node0 = op0 * 'a list

val show_node : 'a1 show -> 'a1 node0 show

type expr0 =
| ExprRef of idx
| ExprApp of expr0 node0

val show_expr : expr0 show

val show_infix_op : op0 -> char list option

val show_prefix_op : op0 -> (char list * Level.coq_Level) option

val show_lvl_expr_pretty : expr0 showLevel

val show_expr_pretty : expr0 show

val reflect_eq_op : op0 -> op0 -> reflect

val expr_beq : expr0 -> expr0 -> bool

val signed : n -> z -> z

val interp_op : (symbol -> z option) -> op0 -> z list -> z option

val interp0_op : op0 -> z list -> z option

val node_beq : ('a1 -> 'a1 -> bool) -> 'a1 node0 -> 'a1 node0 -> bool

val shiftr_avoid_uint1_opt_instance_0 :
  Coq6_Compilers.ZRange.Settings.shiftr_avoid_uint1_opt

val op_to_PHOAS_binop : op0 -> Coq3_Compilers.ident option

val op_to_PHOAS_unop : op0 -> Coq3_Compilers.ident option

val op_to_PHOAS_tritop : op0 -> Coq3_Compilers.ident option

val op_to_bounds : op0 -> zrange option

val op_to_PHOAS_bounds :
  op0 -> ((unit -> zrange option) list -> zrange option) option

val bound_node_idx_via_PHOAS :
  (idx -> zrange option) -> idx node0 -> zrange option

type description = ((unit -> char list) * bool) option

type eager_description = (char list * bool) option

module Old :
 sig
  module Coq_dag :
   sig
    module Coq__8 : sig
     type t = ((idx node0 * description) * zrange option) list
    end
    include module type of struct include Coq__8 end

    val empty : t

    val size : t -> n

    val lookup : t -> idx -> idx node0 option

    val lookup_bounds : t -> idx -> zrange option

    val reverse_lookup : t -> idx node0 -> idx option

    val merge_node : description -> idx node0 -> t -> idx * t

    val gensym : operationSize -> t -> idx node0

    val get_eager_description_description :
      eager_description -> char list option

    val get_eager_description_always_show : eager_description -> bool

    val force_description : description -> eager_description

    type 't coq_M = t -> 't * t

    val bind : 'a1 coq_M -> ('a1 -> 'a2 coq_M) -> 'a2 coq_M

    val ret : 'a1 -> 'a1 coq_M

    module Coq_eager :
     sig
      type t = ((idx * idx node0) * eager_description) list

      val force : Coq__8.t -> t

      val description_lookup : t -> char list -> idx list

      val elements : t -> ((idx * idx node0) * eager_description) list
     end
   end
 end

val reveal_step : Old.Coq_dag.t -> (idx -> expr0) -> idx -> expr0

val reveal : Old.Coq_dag.t -> nat -> idx -> expr0

val reveal_gather_deps_args : Old.Coq_dag.t -> NSet.t -> NSet.t

val reveal_gather_deps_step :
  Old.Coq_dag.t -> (NSet.t -> NSet.t -> NSet.t) -> NSet.t -> NSet.t -> NSet.t

val reveal_gather_deps_list :
  Old.Coq_dag.t -> nat -> NSet.t -> NSet.t -> NSet.t

val reveal_gather_deps : Old.Coq_dag.t -> nat -> idx -> NSet.t

val reveal_step_from_deps :
  Old.Coq_dag.t -> (idx -> expr0) -> NSet.t -> idx -> expr0

val reveal_from_deps_fueled : Old.Coq_dag.t -> nat -> NSet.t -> idx -> expr0

val reveal_at_least : Old.Coq_dag.t -> nat -> idx -> expr0

val reveal_node_at_least : Old.Coq_dag.t -> nat -> (op0 * idx list) -> expr0

val merge_node0 : description -> idx node0 -> idx Old.Coq_dag.coq_M

val merge0 : description -> expr0 -> Old.Coq_dag.t -> idx * Old.Coq_dag.t

val zconst : n -> z -> op0

val interp_expr : (symbol -> z option) -> expr0 -> z option

val interp0_expr : expr0 -> z option

val bound_expr_via_PHOAS : Old.Coq_dag.t -> expr0 -> zrange option

val isCst : expr0 -> bool

module Rewrite :
 sig
  val slice0 : Old.Coq_dag.t -> expr0 -> expr0

  val slice01_addcarryZ : Old.Coq_dag.t -> expr0 -> expr0

  val slice01_subborrowZ : Old.Coq_dag.t -> expr0 -> expr0

  val slice_set_slice : Old.Coq_dag.t -> expr0 -> expr0

  val set_slice_set_slice : Old.Coq_dag.t -> expr0 -> expr0

  val set_slice0_small : Old.Coq_dag.t -> expr0 -> expr0

  val truncate_small : Old.Coq_dag.t -> expr0 -> expr0

  val addcarry_bit : Old.Coq_dag.t -> expr0 -> expr0

  val addoverflow_bit : Old.Coq_dag.t -> expr0 -> expr0

  val addbyte_small : Old.Coq_dag.t -> expr0 -> expr0

  val addcarry_small : Old.Coq_dag.t -> expr0 -> expr0

  val addoverflow_small : Old.Coq_dag.t -> expr0 -> expr0

  val constprop : Old.Coq_dag.t -> expr0 -> expr0

  val unary_truncate : Old.Coq_dag.t -> expr0 -> expr0

  val flatten_associative : Old.Coq_dag.t -> expr0 -> expr0

  val flatten_bounded_associative : Old.Coq_dag.t -> expr0 -> expr0

  val consts_commutative : Old.Coq_dag.t -> expr0 -> expr0

  val neqconst : z -> expr0 -> bool

  val drop_identity : Old.Coq_dag.t -> expr0 -> expr0

  val fold_consts_to_and : Old.Coq_dag.t -> expr0 -> expr0

  val xor_same : Old.Coq_dag.t -> expr0 -> expr0

  val shift_to_mul : Old.Coq_dag.t -> expr0 -> expr0

  val split_consts :
    Old.Coq_dag.t -> op0 -> z -> expr0 list -> (expr0 * z) list

  val group_consts :
    Old.Coq_dag.t -> (expr0 * z) list -> (expr0 * z list) list

  val compress_consts :
    Old.Coq_dag.t -> op0 -> (expr0 * z list) list -> (expr0 * z) list

  val app_consts : Old.Coq_dag.t -> op0 -> (expr0 * z) list -> expr0 list

  val combine_consts_pre : Old.Coq_dag.t -> expr0 -> expr0

  val cleanup_combine_consts : Old.Coq_dag.t -> expr0 -> expr0

  val combine_consts : Old.Coq_dag.t -> expr0 -> expr0

  val named_pass : RewritePass.rewrite_pass -> Old.Coq_dag.t -> expr0 -> expr0

  val expr : Options.rewriting_passes_opt -> Old.Coq_dag.t -> expr0 -> expr0
 end

val simplify :
  Options.symbolic_options_computed_opt -> Old.Coq_dag.t -> idx node0 -> expr0

type reg_state = idx option tuple

type flag_state = idx option tuple

type mem_state = (idx * idx) list

val get_flag : flag_state -> fLAG -> idx option

val set_flag_internal : flag_state -> fLAG -> idx option -> flag_state

val set_flag : flag_state -> fLAG -> idx -> flag_state

val reverse_lookup_flag : flag_state -> idx -> fLAG option

val get_reg : reg_state -> nat -> idx option

val set_reg : reg_state -> nat -> idx -> reg_state

val reverse_lookup_widest_reg : reg_state -> idx -> rEG option

val load : idx -> mem_state -> idx option

val remove0 : idx -> mem_state -> idx list * mem_state

val store : idx -> idx -> mem_state -> mem_state option

val reverse_lookup_mem : mem_state -> idx -> (n * idx) option

type symbolic_state = { dag_state : Old.Coq_dag.t;
                        symbolic_reg_state : reg_state;
                        symbolic_flag_state : flag_state;
                        symbolic_mem_state : mem_state }

val update_dag_with :
  symbolic_state -> (Old.Coq_dag.t -> Old.Coq_dag.t) -> symbolic_state

val update_reg_with :
  symbolic_state -> (reg_state -> reg_state) -> symbolic_state

val update_flag_with :
  symbolic_state -> (flag_state -> flag_state) -> symbolic_state

val update_mem_with :
  symbolic_state -> (mem_state -> mem_state) -> symbolic_state

val show_reg_state : reg_state show

val show_flag_state : flag_state show

val show_lines_dag : Old.Coq_dag.t showLines

val show_lines_mem_state : mem_state showLines

val showLines_symbolic_state : symbolic_state showLines

module Coq_error :
 sig
  type error =
  | Coq_get_flag of fLAG * flag_state
  | Coq_get_reg of (nat, rEG) sum * reg_state
  | Coq_load of idx * symbolic_state
  | Coq_remove of idx * symbolic_state
  | Coq_remove_has_duplicates of idx * idx list * symbolic_state
  | Coq_store of idx * idx * symbolic_state
  | Coq_set_const of cONST * idx
  | Coq_expected_const of idx * expr0
  | Coq_unsupported_memory_access_size of n
  | Coq_unsupported_label_in_memory of char list
  | Coq_unsupported_label_argument of jUMP_LABEL
  | Coq_unimplemented_prefix of normalInstruction
  | Coq_unimplemented_instruction of normalInstruction
  | Coq_unsupported_line of rawLine
  | Coq_ambiguous_operation_size of normalInstruction

  val show_lines_error : error showLines

  val coq_Show_error : error show
 end

type 't m =
  symbolic_state -> (Coq_error.error * symbolic_state, 't * symbolic_state)
  errorT

val ret0 : 'a1 -> 'a1 m

val err : Coq_error.error -> 'a1 m

val some_or :
  (symbolic_state -> 'a1 option) -> (symbolic_state -> Coq_error.error) ->
  'a1 m

val bind2 : 'a1 m -> ('a1 -> 'a2 m) -> 'a2 m

val lift_dag : 'a1 Old.Coq_dag.coq_M -> 'a1 m

val mapM : ('a1 -> 'a2 m) -> 'a1 list -> 'a2 list m

val error_get_reg_of_reg_index : nat -> symbolic_state -> Coq_error.error

val getFlag : fLAG -> idx m

val getReg64 : nat -> idx m

val load64 : idx -> idx m

val remove64 : idx -> idx m

val setFlag : fLAG -> idx -> unit m

val havocFlags : unit m

val preserveFlag : fLAG -> 'a1 m -> 'a1 m

val setReg64 : nat -> idx -> unit m

val store64 : idx -> idx -> unit m

val merge1 : description -> expr0 -> idx m

val app0 :
  Options.symbolic_options_computed_opt -> description -> idx node0 -> idx m

val reveal0 : nat -> idx -> expr0 m

val revealConst : idx -> z m

val getReg :
  Options.symbolic_options_computed_opt -> description -> rEG -> idx m

val setReg :
  Options.symbolic_options_computed_opt -> description -> rEG -> idx -> unit m

type addressSize = operationSize

val address :
  Options.symbolic_options_computed_opt -> description -> addressSize -> mEM
  -> idx m

val load0 :
  Options.symbolic_options_computed_opt -> description -> operationSize ->
  addressSize -> mEM -> idx m

val store0 :
  Options.symbolic_options_computed_opt -> description -> operationSize ->
  addressSize -> mEM -> idx -> unit m

val getOperand :
  Options.symbolic_options_computed_opt -> description -> operationSize ->
  addressSize -> aRG -> idx m

val setOperand :
  Options.symbolic_options_computed_opt -> description -> operationSize ->
  addressSize -> aRG -> idx -> unit m

type pre_expr =
| PreARG of aRG
| PreFLG of fLAG
| PreRef of idx
| PreApp of op0 * pre_expr list

val symeval :
  Options.symbolic_options_computed_opt -> description -> operationSize ->
  addressSize -> pre_expr -> idx m

val rcrcnt : n -> z -> z

val symexNormalInstruction :
  Options.symbolic_options_computed_opt -> description -> normalInstruction
  -> unit m

val symexRawLine :
  Options.symbolic_options_computed_opt -> description -> rawLine -> unit m

val symexLine : Options.symbolic_options_computed_opt -> line -> unit m

val symexLines : Options.symbolic_options_computed_opt -> lines -> unit m

module SumSets :
 functor (W1:Sets) ->
 functor (W2:Sets) ->
 sig
  module E :
   sig
    type t = (W1.E.t, W2.E.t) sum

    val compare : (W1.E.t, W2.E.t) sum -> (W1.E.t, W2.E.t) sum -> comparison

    val eq_dec : (W1.E.t, W2.E.t) sum -> (W1.E.t, W2.E.t) sum -> bool
   end

  module WSumSetsOn_E :
   sig
    module E :
     sig
      type t = (W1.E.t, W2.E.t) sum

      val eq_dec : (W1.E.t, W2.E.t) sum -> (W1.E.t, W2.E.t) sum -> bool
     end
   end

  type elt = WSumSetsOn_E.E.t

  type t = W1.t * W2.t

  val lift_tT :
    ('a1 -> 'a2 -> 'a3) -> (W1.t -> 'a1) -> (W2.t -> 'a2) -> t -> 'a3

  val lift_ttT :
    ('a1 -> 'a2 -> 'a3) -> (W1.t -> W1.t -> 'a1) -> (W2.t -> W2.t -> 'a2) ->
    t -> t -> 'a3

  val lift_eT : (W1.E.t -> 'a1) -> (W2.E.t -> 'a1) -> elt -> 'a1

  val drop_eT : (elt -> 'a1) -> (W1.E.t -> 'a1) * (W2.E.t -> 'a1)

  val lift_et : (W1.E.t -> W1.t) -> (W2.E.t -> W2.t) -> elt -> t

  val lift_etT :
    (W1.E.t -> W1.t -> 'a1) -> (W2.E.t -> W2.t -> 'a1) -> elt -> t -> 'a1

  val lift_ett :
    (W1.E.t -> W1.t -> W1.t) -> (W2.E.t -> W2.t -> W2.t) -> elt -> t -> t

  val lift_ttt :
    (W1.t -> W1.t -> W1.t) -> (W2.t -> W2.t -> W2.t) -> t -> t -> t

  val lift_eT_tT :
    ('a2 -> 'a2 -> 'a2) -> ((W1.E.t -> 'a1) -> W1.t -> 'a2) -> ((W2.E.t ->
    'a1) -> W2.t -> 'a2) -> (elt -> 'a1) -> t -> 'a2

  val lift_eT_tt :
    ((W1.E.t -> 'a1) -> W1.t -> W1.t) -> ((W2.E.t -> 'a1) -> W2.t -> W2.t) ->
    (elt -> 'a1) -> t -> t

  val lift_eT_tt2 :
    ((W1.E.t -> 'a1) -> W1.t -> W1.t * W1.t) -> ((W2.E.t -> 'a1) -> W2.t ->
    W2.t * W2.t) -> (elt -> 'a1) -> t -> t * t

  val choose_option : 'a1 option -> 'a1 option -> 'a1 option

  val choose_option_sum : 'a1 option -> 'a2 option -> ('a1, 'a2) sum option

  val choose_option_sum_rev :
    'a1 option -> 'a2 option -> ('a1, 'a2) sum option

  val empty : t

  val is_empty : t -> bool

  val mem : elt -> t -> bool

  val add : elt -> t -> t

  val remove : elt -> t -> t

  val singleton : elt -> t

  val union : t -> t -> t

  val inter : t -> t -> t

  val diff : t -> t -> t

  val equal : t -> t -> bool

  val subset : t -> t -> bool

  val fold : (elt -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1

  val for_all : (elt -> bool) -> t -> bool

  val exists_ : (elt -> bool) -> t -> bool

  val filter : (elt -> bool) -> t -> t

  val partition : (elt -> bool) -> t -> t * t

  val cardinal : t -> nat

  val elements : t -> elt list

  val choose : t -> elt option

  val eq_dec : t -> t -> bool

  module SumSetsOn_E :
   sig
    module E :
     sig
      type t = (W1.E.t, W2.E.t) sum

      val compare : (W1.E.t, W2.E.t) sum -> (W1.E.t, W2.E.t) sum -> comparison

      val eq_dec : (W1.E.t, W2.E.t) sum -> (W1.E.t, W2.E.t) sum -> bool
     end
   end

  val choose_comparison : comparison -> comparison -> comparison

  val compare : t -> t -> comparison

  val min_elt : t -> elt option

  val max_elt : t -> elt option
 end

type name_case_kind =
| Lower
| Upper

type word_case_data = { first_letter_case : name_case_kind;
                        rest_letters_case : name_case_kind }

type capitalization_data = { separator : char list;
                             first_word_case : word_case_data;
                             rest_words_case : word_case_data }

type capitalization_convention = { capitalization_convention_data : capitalization_data;
                                   only_lower_first_letters : bool }

val case_adjust_ascii : name_case_kind -> char -> char

val case_adjust_string : name_case_kind -> char list -> char list

val case_adjust_word : bool -> word_case_data -> char list -> char list

val case_adjust_word_list :
  bool -> capitalization_data -> char list list -> char list list

val case_adjust_words :
  bool -> capitalization_data -> char list list -> char list

val split_before_gen : (char -> bool) -> char list -> char list list

val split_before_uppercase : char list -> char list list

val split_before_lowercase : char list -> char list list

val splitter_function :
  capitalization_data -> (char list -> char list list) option

val convert_case :
  capitalization_data -> capitalization_convention -> char list -> __

val parse_capitalization_data_list : (char list * capitalization_data) list

val parse_capitalization_data : capitalization_data parserAction

val parse_capitalization_data_strict : char list -> capitalization_data option

val show_zrange : zrange show

val show_lvl_zrange : zrange showLevel

val bool_beq : bool -> bool -> bool

module Coq7_Compilers :
 sig
  module Options :
   sig
    module PHOAS :
     sig
      type with_casts = bool

      type with_all_casts = bool

      val default_with_casts : with_casts

      val default_with_all_casts : with_all_casts
     end

    type relax_zrange_opt = zrange -> zrange

    type package_name_opt = char list option

    type class_name_opt = char list option

    type skip_typedefs_opt = bool

    val skip_typedefs : skip_typedefs_opt -> bool

    type relax_adc_sbb_return_carry_to_bitwidth_opt = z list

    val relax_adc_sbb_return_carry_to_bitwidth :
      relax_adc_sbb_return_carry_to_bitwidth_opt -> z list

    type language_specific_cast_adjustment_opt = bool

    type language_naming_conventions_opt = { public_function_naming_convention : 
                                             capitalization_convention option;
                                             private_function_naming_convention : 
                                             capitalization_convention option;
                                             public_type_naming_convention : 
                                             capitalization_convention option;
                                             private_type_naming_convention : 
                                             capitalization_convention option;
                                             variable_naming_convention : 
                                             capitalization_convention option;
                                             package_naming_convention : 
                                             capitalization_convention option;
                                             class_naming_convention : 
                                             capitalization_convention option }

    val public_function_naming_convention :
      language_naming_conventions_opt -> capitalization_convention option

    val private_function_naming_convention :
      language_naming_conventions_opt -> capitalization_convention option

    val public_type_naming_convention :
      language_naming_conventions_opt -> capitalization_convention option

    val private_type_naming_convention :
      language_naming_conventions_opt -> capitalization_convention option

    val package_naming_convention :
      language_naming_conventions_opt -> capitalization_convention option

    val class_naming_convention :
      language_naming_conventions_opt -> capitalization_convention option

    val default_language_naming_conventions : language_naming_conventions_opt

    val convert_to_naming_convention :
      capitalization_convention option -> char list -> char list

    val package_name :
      package_name_opt -> language_naming_conventions_opt -> char list ->
      char list

    val class_name :
      class_name_opt -> language_naming_conventions_opt -> char list ->
      char list

    val default_text_before_function_name : char list

    val default_text_before_type_name : char list

    type documentation_options_opt = { text_before_function_name_opt : 
                                       char list option;
                                       text_before_type_name_opt : char list
                                                                   option;
                                       newline_before_package_declaration : 
                                       bool; newline_in_typedef_bounds : 
                                       bool }

    val text_before_function_name_opt :
      documentation_options_opt -> char list option

    val text_before_function_name : documentation_options_opt -> char list

    val text_before_type_name_opt :
      documentation_options_opt -> char list option

    val text_before_type_name : documentation_options_opt -> char list

    val newline_before_package_declaration : documentation_options_opt -> bool

    val newline_in_typedef_bounds : documentation_options_opt -> bool

    val default_documentation_options : documentation_options_opt

    type output_options_opt = { skip_typedefs_ : skip_typedefs_opt;
                                relax_adc_sbb_return_carry_to_bitwidth_ : 
                                relax_adc_sbb_return_carry_to_bitwidth_opt;
                                language_specific_cast_adjustment_ : 
                                language_specific_cast_adjustment_opt }

    val skip_typedefs_ : output_options_opt -> skip_typedefs_opt

    val relax_adc_sbb_return_carry_to_bitwidth_ :
      output_options_opt -> relax_adc_sbb_return_carry_to_bitwidth_opt

    val language_specific_cast_adjustment_ :
      output_options_opt -> language_specific_cast_adjustment_opt

    val default_output_options : output_options_opt
   end

  module ToString :
   sig
    module ZRange :
     sig
      module Coq_type :
       sig
        module Coq_base :
         sig
          val show_lvl_interp :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            Coq6_Compilers.ZRange.Coq_type.Coq_base.interp showLevel

          val show_interp :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            Coq6_Compilers.ZRange.Coq_type.Coq_base.interp show

          module Coq_option :
           sig
            val show_lvl_interp :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
              Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp
              showLevel

            val show_interp :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
              Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp show
           end
         end

        module Coq_option :
         sig
          val show_lvl_interp :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type ->
            Coq6_Compilers.ZRange.Coq_type.Coq_option.interp showLevel
         end
       end
     end

    module PHOAS :
     sig
      module Coq_type :
       sig
        module Coq_base :
         sig
          val show_base : Coq3_Compilers.base show

          val show_lvl_base : Coq3_Compilers.base showLevel

          val show_lvl_type :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type showLevel

          val show_type :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type show

          val show_lvl_base_interp :
            Coq3_Compilers.base -> Coq3_Compilers.base_interp showLevel

          val show_lvl_interp :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            (Coq3_Compilers.base, Coq3_Compilers.base_interp)
            Compilers.Coq_base.interp showLevel

          val show_interp :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            (Coq3_Compilers.base, Coq3_Compilers.base_interp)
            Compilers.Coq_base.interp show

          val show_lvl :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type showLevel

          val show :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type show
         end

        val show_lvl_for_each_lhs_of_arrow :
          ('a1 Compilers.Coq_type.coq_type -> 'a2 showLevel) -> 'a1
          Compilers.Coq_type.coq_type -> ('a1, 'a2)
          Compilers.Coq_type.for_each_lhs_of_arrow showLevel

        val show_lvl_type :
          'a1 showLevel -> 'a1 Compilers.Coq_type.coq_type showLevel

        val show_lvl :
          'a1 showLevel -> 'a1 Compilers.Coq_type.coq_type showLevel

        val show_type : 'a1 show -> 'a1 Compilers.Coq_type.coq_type show

        val show : 'a1 show -> 'a1 Compilers.Coq_type.coq_type show
       end

      val show_range_or_ctype : zrange show

      val show_lvl_compact_Z : z showLevel

      val make_castb :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
        char list option

      val make_cast :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type ->
        Coq6_Compilers.ZRange.Coq_type.Coq_option.interp -> char list option

      val maybe_wrap_cast :
        bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ((Level.coq_Level ->
        char list) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp) ->
        Level.coq_Level -> char list

      val show_application :
        bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Level.coq_Level -> char list) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        (Level.coq_Level ->
        char list) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
        Compilers.Coq_type.for_each_lhs_of_arrow -> Level.coq_Level ->
        char list

      module Coq_ident :
       sig
        val show_lvl_ident :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident showLevel

        val show_ident :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident show

        val conservative_binop_precedence_table :
          (char list * (associativity * Level.coq_Level)) list

        val conservative_preop_precedence_table :
          (char list * (associativity * Level.coq_Level)) list

        val conservative_postop_precedence_table :
          (char list * (associativity * Level.coq_Level)) list

        val lookup_show_lvl_binop :
          bool -> (char list * (associativity * Level.coq_Level)) list ->
          char list -> __

        val lookup_show_lvl_preop :
          (char list * (associativity * Level.coq_Level)) list -> char list
          -> __

        val lookup_show_lvl_postop :
          (char list * (associativity * Level.coq_Level)) list -> char list
          -> __

        val ident_to_op_string :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          Coq3_Compilers.ident -> char list

        val show_ident_lvl :
          bool -> bool -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          Coq3_Compilers.ident -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, (Level.coq_Level ->
          char list) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
          Compilers.Coq_type.for_each_lhs_of_arrow -> (Level.coq_Level ->
          char list) * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp
       end

      module Coq_expr :
       sig
        val get_eta_cps_args :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> positive -> ((Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, (Level.coq_Level ->
          char list) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
          Compilers.Coq_type.for_each_lhs_of_arrow -> positive -> 'a1) ->
          char list list * 'a1

        val show_eta_abs_aux :
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> char list -> 'a1 option) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> positive -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr -> (positive * (char list
          list * (Level.coq_Level -> char list
          list))) * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
          -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          positive -> ('a1 -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr) -> (positive * (char list
          list * (Level.coq_Level -> char list
          list))) * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp

        val show_eta_abs_cps' :
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> char list -> 'a1 option) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, (Level.coq_Level ->
          char list) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
          Compilers.Coq_type.for_each_lhs_of_arrow -> positive ->
          (positive * (Level.coq_Level -> char list
          list)) * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
          -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> positive -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr -> (positive * (char list
          list * (Level.coq_Level -> char list
          list))) * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp

        val show_eta_abs_cps :
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> char list -> 'a1 option) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, (Level.coq_Level ->
          char list) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
          Compilers.Coq_type.for_each_lhs_of_arrow -> positive ->
          (positive * (Level.coq_Level -> char list
          list)) * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
          -> bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          positive -> ('a1 -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr) -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, (Level.coq_Level ->
          char list) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
          Compilers.Coq_type.for_each_lhs_of_arrow ->
          (positive * (Level.coq_Level -> char list
          list)) * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp

        val show_eta_cps :
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> char list -> 'a1 option) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, (Level.coq_Level ->
          char list) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
          Compilers.Coq_type.for_each_lhs_of_arrow -> positive ->
          (positive * (Level.coq_Level -> char list
          list)) * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
          -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> positive -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr -> (positive * (Level.coq_Level ->
          char list list)) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp

        val show_expr_lines_gen :
          bool -> bool -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a1 -> char list) -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          char list -> 'a1 option) -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          (Level.coq_Level ->
          char list) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
          Compilers.Coq_type.for_each_lhs_of_arrow -> positive ->
          (positive * (Level.coq_Level -> char list
          list)) * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp

        val show_lvl_var_expr :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr showLevel

        val show_var_expr :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr show

        val partially_show_expr :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr show

        val show_lines_expr_gen :
          Options.PHOAS.with_casts -> Options.PHOAS.with_all_casts ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1 -> char list) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> char list -> 'a1 option) ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr showLines

        val show_lines_expr :
          Options.PHOAS.with_casts -> Options.PHOAS.with_all_casts ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
          char list) Compilers.Coq_expr.expr showLines

        val show_lines_Expr :
          Options.PHOAS.with_casts -> Options.PHOAS.with_all_casts ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
          Compilers.Coq_expr.coq_Expr showLines

        val show_expr :
          Options.PHOAS.with_casts -> Options.PHOAS.with_all_casts ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
          char list) Compilers.Coq_expr.expr show
       end
     end

    val format_typedef_name :
      Options.language_naming_conventions_opt -> char list -> bool ->
      char list -> char list

    module Coq_int :
     sig
      type coq_type =
      | Coq_signed of nat
      | Coq_unsigned of nat

      val type_beq : coq_type -> coq_type -> bool

      val type_eq_dec : coq_type -> coq_type -> bool

      val lgbitwidth_of : coq_type -> nat

      val of_lgbitwidth : bool -> nat -> coq_type

      val bitwidth_of : coq_type -> z

      val of_bitwidth : bool -> z -> coq_type

      val of_bitwidth_up : bool -> z -> coq_type

      val is_signed : coq_type -> bool

      val is_unsigned : coq_type -> bool

      val to_zrange : coq_type -> zrange

      val is_tighter_than : coq_type -> coq_type -> bool

      val of_zrange_relaxed : zrange -> coq_type

      val unsigned_counterpart_of : coq_type -> coq_type

      val signed_counterpart_of : coq_type -> coq_type

      val show_lvl_type : coq_type showLevel

      val show_type : coq_type show

      val to_string_gen :
        Options.language_naming_conventions_opt -> z list -> char list ->
        char list -> char list -> char list -> bool -> char list -> coq_type
        -> char list

      val to_string_gen_opt_typedef :
        Options.language_naming_conventions_opt -> Options.skip_typedefs_opt
        -> z list -> char list -> char list -> char list -> char list -> bool
        -> bool -> char list -> coq_type -> char list option -> char list

      val union : coq_type -> coq_type -> coq_type

      val union_zrange : zrange -> coq_type -> coq_type

      module Coq_option :
       sig
        type interp = __

        module Coq_interp :
         sig
          val of_zrange_relaxed :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
            interp

          val to_union :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            interp -> coq_type option
         end

        val coq_None :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> interp
       end
     end

    module SumPositiveSet :
     sig
      module E :
       sig
        type t = (positive, positive) sum

        val compare :
          (positive, positive) sum -> (positive, positive) sum -> comparison

        val eq_dec :
          (positive, positive) sum -> (positive, positive) sum -> bool
       end

      module WSumSetsOn_E :
       sig
        module E :
         sig
          type t = (positive, positive) sum

          val eq_dec :
            (positive, positive) sum -> (positive, positive) sum -> bool
         end
       end

      type elt = WSumSetsOn_E.E.t

      type t = PositiveSet.t * PositiveSet.t

      val lift_tT :
        ('a1 -> 'a2 -> 'a3) -> (PositiveSet.t -> 'a1) -> (PositiveSet.t ->
        'a2) -> t -> 'a3

      val lift_ttT :
        ('a1 -> 'a2 -> 'a3) -> (PositiveSet.t -> PositiveSet.t -> 'a1) ->
        (PositiveSet.t -> PositiveSet.t -> 'a2) -> t -> t -> 'a3

      val lift_eT : (positive -> 'a1) -> (positive -> 'a1) -> elt -> 'a1

      val drop_eT : (elt -> 'a1) -> (positive -> 'a1) * (positive -> 'a1)

      val lift_et :
        (positive -> PositiveSet.t) -> (positive -> PositiveSet.t) -> elt -> t

      val lift_etT :
        (positive -> PositiveSet.t -> 'a1) -> (positive -> PositiveSet.t ->
        'a1) -> elt -> t -> 'a1

      val lift_ett :
        (positive -> PositiveSet.t -> PositiveSet.t) -> (positive ->
        PositiveSet.t -> PositiveSet.t) -> elt -> t -> t

      val lift_ttt :
        (PositiveSet.t -> PositiveSet.t -> PositiveSet.t) -> (PositiveSet.t
        -> PositiveSet.t -> PositiveSet.t) -> t -> t -> t

      val lift_eT_tT :
        ('a2 -> 'a2 -> 'a2) -> ((positive -> 'a1) -> PositiveSet.t -> 'a2) ->
        ((positive -> 'a1) -> PositiveSet.t -> 'a2) -> (elt -> 'a1) -> t ->
        'a2

      val lift_eT_tt :
        ((positive -> 'a1) -> PositiveSet.t -> PositiveSet.t) -> ((positive
        -> 'a1) -> PositiveSet.t -> PositiveSet.t) -> (elt -> 'a1) -> t -> t

      val lift_eT_tt2 :
        ((positive -> 'a1) -> PositiveSet.t -> PositiveSet.t * PositiveSet.t)
        -> ((positive -> 'a1) -> PositiveSet.t ->
        PositiveSet.t * PositiveSet.t) -> (elt -> 'a1) -> t -> t * t

      val choose_option : 'a1 option -> 'a1 option -> 'a1 option

      val choose_option_sum :
        'a1 option -> 'a2 option -> ('a1, 'a2) sum option

      val choose_option_sum_rev :
        'a1 option -> 'a2 option -> ('a1, 'a2) sum option

      val empty : t

      val is_empty : t -> bool

      val mem : elt -> t -> bool

      val add : elt -> t -> t

      val remove : elt -> t -> t

      val singleton : elt -> t

      val union : t -> t -> t

      val inter : t -> t -> t

      val diff : t -> t -> t

      val equal : t -> t -> bool

      val subset : t -> t -> bool

      val fold : (elt -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1

      val for_all : (elt -> bool) -> t -> bool

      val exists_ : (elt -> bool) -> t -> bool

      val filter : (elt -> bool) -> t -> t

      val partition : (elt -> bool) -> t -> t * t

      val cardinal : t -> nat

      val elements : t -> elt list

      val choose : t -> elt option

      val eq_dec : t -> t -> bool

      module SumSetsOn_E :
       sig
        module E :
         sig
          type t = (positive, positive) sum

          val compare :
            (positive, positive) sum -> (positive, positive) sum -> comparison

          val eq_dec :
            (positive, positive) sum -> (positive, positive) sum -> bool
         end
       end

      val choose_comparison : comparison -> comparison -> comparison

      val compare : t -> t -> comparison

      val min_elt : t -> elt option

      val max_elt : t -> elt option
     end

    module IntAsDecidableType :
     sig
      type t = Coq_int.coq_type

      val eq_dec : Coq_int.coq_type -> Coq_int.coq_type -> bool

      val to_ : t -> (positive, positive) sum

      val of_ : (positive, positive) sum -> t
     end

    module IntSet :
     sig
      module E :
       sig
        type t = Coq_int.coq_type

        val eq_dec : Coq_int.coq_type -> Coq_int.coq_type -> bool

        val to_ : Coq_int.coq_type -> (positive, positive) sum

        val of_ : (positive, positive) sum -> Coq_int.coq_type
       end

      type elt = Coq_int.coq_type

      type t = SumPositiveSet.t

      val lift : (SumPositiveSet.elt -> 'a1) -> elt -> 'a1

      val liftho : ((SumPositiveSet.elt -> 'a1) -> 'a2) -> (elt -> 'a1) -> 'a2

      val empty : t

      val is_empty : t -> bool

      val mem : elt -> t -> bool

      val add : elt -> t -> t

      val remove : elt -> t -> t

      val singleton : elt -> t

      val union : t -> t -> t

      val inter : t -> t -> t

      val diff : t -> t -> t

      val equal : t -> t -> bool

      val subset : t -> t -> bool

      val fold : (elt -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1

      val for_all : (elt -> bool) -> t -> bool

      val exists_ : (elt -> bool) -> t -> bool

      val filter : (elt -> bool) -> t -> t

      val partition : (elt -> bool) -> t -> t * t

      val cardinal : t -> nat

      val elements : t -> elt list

      val choose : t -> elt option

      val eq_dec : t -> t -> bool
     end

    type ident_infos = { bitwidths_used : IntSet.t;
                         addcarryx_lg_splits : PositiveSet.t;
                         mulx_lg_splits : PositiveSet.t;
                         cmovznz_bitwidths : IntSet.t;
                         value_barrier_bitwidths : IntSet.t;
                         typedefs_used : char list list }

    val bitwidths_used : ident_infos -> IntSet.t

    val addcarryx_lg_splits : ident_infos -> PositiveSet.t

    val mulx_lg_splits : ident_infos -> PositiveSet.t

    val cmovznz_bitwidths : ident_infos -> IntSet.t

    val value_barrier_bitwidths : ident_infos -> IntSet.t

    val typedefs_used : ident_infos -> char list list

    val ident_infos_equal : ident_infos -> ident_infos -> bool

    val ident_info_empty : ident_infos

    val ident_info_diff : ident_infos -> ident_infos -> ident_infos

    val ident_info_union : ident_infos -> ident_infos -> ident_infos

    val ident_info_of_bitwidths_used : IntSet.t -> ident_infos

    val ident_info_of_addcarryx : PositiveSet.t -> ident_infos

    val ident_info_of_mulx : PositiveSet.t -> ident_infos

    val ident_info_of_cmovznz : IntSet.t -> ident_infos

    val ident_info_of_value_barrier : IntSet.t -> ident_infos

    val ident_info_of_typedefs : char list list -> ident_infos

    val ident_info_with_value_barrier : ident_infos -> IntSet.t -> ident_infos

    module OfPHOAS :
     sig
      type base_var_data = __

      type var_data = __

      type base_var_typedef_data = __

      val base_var_typedef_data_None :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        base_var_typedef_data

      type var_typedef_data = __

      val var_typedef_data_None :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> var_typedef_data

      type base_var_names = __

      type var_names = __

      val names_list_of_base_var_names :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        base_var_names -> char list list

      val names_list_of_var_names :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> var_names -> char list list

      val names_of_base_var_data :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        base_var_data -> base_var_names

      val names_of_var_data :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> var_data -> var_names

      val names_list_of_var_data :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> var_data -> char list list

      val base_var_data_of_names :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        base_var_names -> base_var_data

      val var_data_of_names :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> var_names -> var_data

      val bound_to_string :
        Options.skip_typedefs_opt -> Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type -> var_data ->
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
        char list list

      val input_bounds_to_string :
        Options.skip_typedefs_opt -> Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, var_data)
        Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type,
        Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
        Compilers.Coq_type.for_each_lhs_of_arrow -> char list list
     end

    val format_special_function_name :
      Options.language_naming_conventions_opt -> bool -> char list ->
      char list -> bool -> z -> char list

    val name_of_typedef :
      Options.language_naming_conventions_opt -> char list -> bool ->
      (((char list * (char list -> char list)) * Coq_int.coq_type
      option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) ->
      char list

    val describe_typedef :
      Options.language_naming_conventions_opt ->
      Options.documentation_options_opt -> char list -> bool ->
      (((char list * (char list -> char list)) * Coq_int.coq_type
      option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) ->
      char list list

    val array_length_of_typedef :
      (((char list * (char list -> char list)) * Coq_int.coq_type
      option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) -> nat
      option option

    val name_and_type_and_describe_typedef :
      Options.language_naming_conventions_opt ->
      Options.documentation_options_opt -> char list -> bool ->
      (((char list * (char list -> char list)) * Coq_int.coq_type
      option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) ->
      (char list * (Coq_int.coq_type option * nat option option)) * char list
      list

    val format_special_function_name_ty :
      Options.language_naming_conventions_opt -> bool -> char list ->
      char list -> Coq_int.coq_type -> char list

    val normalize_newlines : char list list -> char list list

    val preprocess_comment_block : char list list -> char list list

    val prefix_and_indent : char list -> char list list -> char list list

    type coq_OutputLanguageAPI = { comment_block : (char list list ->
                                                   char list list);
                                   comment_file_header_block : (char list
                                                               list ->
                                                               char list list);
                                   coq_ToFunctionLines : (Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options
                                                         ->
                                                         Options.relax_zrange_opt
                                                         ->
                                                         Options.language_naming_conventions_opt
                                                         ->
                                                         Options.documentation_options_opt
                                                         ->
                                                         Options.output_options_opt
                                                         -> z -> bool -> bool
                                                         -> bool -> bool ->
                                                         bool -> char list ->
                                                         char list ->
                                                         Coq3_Compilers.base
                                                         Compilers.Coq_base.Coq_type.coq_type
                                                         Compilers.Coq_type.coq_type
                                                         ->
                                                         (Coq3_Compilers.base
                                                         Compilers.Coq_base.Coq_type.coq_type,
                                                         Coq3_Compilers.ident)
                                                         Compilers.Coq_expr.coq_Expr
                                                         ->
                                                         ((Coq3_Compilers.base
                                                         Compilers.Coq_base.Coq_type.coq_type,
                                                         OfPHOAS.var_data)
                                                         Compilers.Coq_type.for_each_lhs_of_arrow
                                                         -> OfPHOAS.var_data
                                                         -> char list list)
                                                         -> char list list
                                                         option ->
                                                         (Coq3_Compilers.base
                                                         Compilers.Coq_base.Coq_type.coq_type,
                                                         Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
                                                         Compilers.Coq_type.for_each_lhs_of_arrow
                                                         ->
                                                         Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp
                                                         ->
                                                         (Coq3_Compilers.base
                                                         Compilers.Coq_base.Coq_type.coq_type,
                                                         OfPHOAS.var_typedef_data)
                                                         Compilers.Coq_type.for_each_lhs_of_arrow
                                                         ->
                                                         OfPHOAS.base_var_typedef_data
                                                         -> (char list
                                                         list * ident_infos,
                                                         char list) sum);
                                   header : (Options.language_naming_conventions_opt
                                            ->
                                            Options.documentation_options_opt
                                            -> Options.package_name_opt ->
                                            Options.class_name_opt ->
                                            Options.output_options_opt -> z
                                            -> bool -> bool -> char list ->
                                            ident_infos ->
                                            (((char list * (char list ->
                                            char list)) * Coq_int.coq_type
                                            option) * (Coq3_Compilers.base
                                            Compilers.Coq_base.Coq_type.coq_type,
                                            Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
                                            sigT) list -> char list list);
                                   footer : (Options.language_naming_conventions_opt
                                            ->
                                            Options.documentation_options_opt
                                            -> Options.package_name_opt ->
                                            Options.class_name_opt -> z ->
                                            bool -> bool -> char list ->
                                            ident_infos -> char list list);
                                   strip_special_infos : (z -> ident_infos ->
                                                         ident_infos) }

    val comment_file_header_block :
      coq_OutputLanguageAPI -> char list list -> char list list

    val coq_ToFunctionLines :
      coq_OutputLanguageAPI ->
      Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
      Options.relax_zrange_opt -> Options.language_naming_conventions_opt ->
      Options.documentation_options_opt -> Options.output_options_opt -> z ->
      bool -> bool -> bool -> bool -> bool -> char list -> char list ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> ((Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, OfPHOAS.var_data)
      Compilers.Coq_type.for_each_lhs_of_arrow -> OfPHOAS.var_data ->
      char list list) -> char list list option -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      OfPHOAS.var_typedef_data) Compilers.Coq_type.for_each_lhs_of_arrow ->
      OfPHOAS.base_var_typedef_data -> (char list list * ident_infos,
      char list) sum

    val header :
      coq_OutputLanguageAPI -> Options.language_naming_conventions_opt ->
      Options.documentation_options_opt -> Options.package_name_opt ->
      Options.class_name_opt -> Options.output_options_opt -> z -> bool ->
      bool -> char list -> ident_infos -> (((char list * (char list ->
      char list)) * Coq_int.coq_type option) * (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) list
      -> char list list

    val footer :
      coq_OutputLanguageAPI -> Options.language_naming_conventions_opt ->
      Options.documentation_options_opt -> Options.package_name_opt ->
      Options.class_name_opt -> z -> bool -> bool -> char list -> ident_infos
      -> char list list

    val strip_special_infos :
      coq_OutputLanguageAPI -> z -> ident_infos -> ident_infos
   end
 end

module Coq3_List :
 sig
  val combine_extend : 'a1 -> 'a2 -> 'a1 list -> 'a2 list -> ('a1 * 'a2) list
 end

module Coq4_List :
 sig
  val removen : ('a1 -> bool) -> 'a1 list -> nat -> 'a1 list
 end

module ErrorT :
 sig
  module List :
   sig
    val bind_list :
      ('a1, 'a2) errorT list -> ('a2 list -> ('a1, 'a3) errorT) -> ('a1, 'a3)
      errorT
   end
 end

type assembly_calling_registers_opt = rEG list option

val default_assembly_calling_registers : rEG list

val assembly_calling_registers : assembly_calling_registers_opt -> rEG list

type assembly_callee_saved_registers_opt =
| Microsoft_x64
| System_V_AMD64
| Explicit_registers of rEG list

val microsoft_x64_assembly_callee_saved_registers : rEG list

val system_v_amd64_assembly_callee_saved_registers : rEG list

val default_assembly_callee_saved_registers :
  assembly_callee_saved_registers_opt

val assembly_callee_saved_registers :
  assembly_callee_saved_registers_opt -> rEG list

type assembly_output_first_opt = bool

type assembly_argument_registers_left_to_right_opt = bool

type assembly_stack_size_opt = n option

val assembly_stack_size_at : z -> line list -> z list

val microsoft_x64_assembly_stack_red_zone : n

val system_v_amd64_assembly_stack_red_zone : n

val assembly_stack_red_zone : assembly_callee_saved_registers_opt -> n

val assembly_stack_size :
  assembly_callee_saved_registers_opt -> assembly_stack_size_opt -> line list
  -> n

type assembly_conventions_opt = { assembly_calling_registers_ : assembly_calling_registers_opt;
                                  assembly_stack_size_ : assembly_stack_size_opt;
                                  assembly_output_first_ : assembly_output_first_opt;
                                  assembly_argument_registers_left_to_right_ : 
                                  assembly_argument_registers_left_to_right_opt;
                                  assembly_callee_saved_registers_ : 
                                  assembly_callee_saved_registers_opt }

module Coq_Options :
 sig
  type equivalence_checker_options_opt = { assembly_conventions_ : assembly_conventions_opt;
                                           symbolic_options_ : Options.symbolic_options_opt }

  val assembly_conventions_ :
    equivalence_checker_options_opt -> assembly_conventions_opt

  val symbolic_options_ :
    equivalence_checker_options_opt -> Options.symbolic_options_opt
 end

val show_assembly_callee_saved_registers_opt :
  assembly_callee_saved_registers_opt show

val parse_assembly_callee_saved_registers_opt :
  assembly_callee_saved_registers_opt parserAction

type equivalenceCheckingError =
| Symbolic_execution_failed of Coq_error.error * symbolic_state
| Internal_error_output_load_failed of Coq_error.error option
   * ((rEG, idx) sum, idx) sum list * symbolic_state
| Internal_error_extra_input_arguments of Coq3_Compilers.base
                                          Compilers.Coq_base.Coq_type.coq_type
                                          Compilers.Coq_type.coq_type
   * (idx, idx list) sum list
| Internal_error_lingering_memory of symbolic_state
| Internal_error_LoadOutputs_length_mismatch of ((rEG, idx) sum, idx) sum list
   * nat option list
| Not_enough_registers of nat * nat
| Registers_too_narrow of rEG list
| Callee_saved_registers_too_narrow of rEG list
| Duplicate_registers of rEG list
| Incorrect_array_input_dag_node
| Incorrect_Z_input_dag_node
| Not_enough_input_dag_nodes of Coq3_Compilers.base
                                Compilers.Coq_base.Coq_type.coq_type
                                Compilers.Coq_type.coq_type
| Expected_const_in_reference_code of idx
| Expected_power_of_two of n * idx
| Unknown_array_length of Coq3_Compilers.base
                          Compilers.Coq_base.Coq_type.coq_type
| Registers_not_saved of (rEG * (idx * idx)) list * symbolic_state
| Invalid_arrow_type of Coq3_Compilers.base
                        Compilers.Coq_base.Coq_type.coq_type
                        Compilers.Coq_type.coq_type
| Invalid_argument_type of Coq3_Compilers.base
                           Compilers.Coq_base.Coq_type.coq_type
                           Compilers.Coq_type.coq_type
| Invalid_return_type of Coq3_Compilers.base
                         Compilers.Coq_base.Coq_type.coq_type
| Invalid_higher_order_application of Coq3_Compilers.base
                                      Compilers.Coq_base.Coq_type.coq_type
                                      Compilers.Coq_type.coq_type
   * Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
     Compilers.Coq_type.coq_type
   * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
     Coq3_Compilers.ident, __) Compilers.Coq_expr.expr
   * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
     Coq3_Compilers.ident, __) Compilers.Coq_expr.expr
| Invalid_higher_order_let of Coq3_Compilers.base
                              Compilers.Coq_base.Coq_type.coq_type
                              Compilers.Coq_type.coq_type
   * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
     Coq3_Compilers.ident, __) Compilers.Coq_expr.expr
| Unhandled_identifier of Coq3_Compilers.base
                          Compilers.Coq_base.Coq_type.coq_type
                          Compilers.Coq_type.coq_type * Coq3_Compilers.ident
| Unhandled_cast of z * z
| Unable_to_unify of (idx, idx list) sum list * (idx, idx list) sum list
   * idx option * symbolic_state
| Missing_ret
| Code_after_ret of lines * lines

val symbolic_state_of_EquivalenceCheckingError :
  equivalenceCheckingError -> symbolic_state option

type annotatedLine = line * Old.Coq_dag.Coq_eager.t

type annotatedLines = lines * symbolic_state

val show_annotated_Line : annotatedLine show

val show_lines_AnnotatedLines : annotatedLines showLines

val remove_common_indices :
  ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list -> nat -> (nat * 'a1)
  list * 'a1 list

val show_expr_node_lite : expr0 show

val show_node_lite : idx node0 show

val recursive_deps_list_step :
  (NSet.t -> idx -> NSet.t) -> NSet.t -> idx list -> NSet.t

val recursive_deps_step :
  (NSet.t -> idx -> NSet.t) -> Old.Coq_dag.t -> NSet.t -> idx -> NSet.t

val recursive_deps : nat -> Old.Coq_dag.t -> NSet.t -> idx -> NSet.t

val recursive_deps_list : nat -> Old.Coq_dag.t -> NSet.t -> idx list -> NSet.t

val at_leaves_fold :
  (idx -> 'a1 -> expr0 * 'a1) -> expr0 -> 'a1 -> expr0 * 'a1

val at_leaves : (idx -> expr0) -> expr0 -> expr0

val reveal_one_except :
  Old.Coq_dag.t -> (idx -> bool) -> expr0 -> expr0 * bool

val indices_at_leaves_map : expr0 list -> idx list

val make_iteratively_revealed_exprs :
  Old.Coq_dag.t -> nat -> (idx -> bool) -> expr0 list -> expr0 list list

val describe_idx_from_state : bool -> symbolic_state -> idx -> char list list

val iteratively_describe_idxs_after :
  idx option -> Old.Coq_dag.t -> (idx -> char list list) -> bool -> idx list
  -> char list list

val iteratively_describe_idx :
  Old.Coq_dag.t -> (idx -> char list list) -> bool -> idx -> char list list

val describe_full_idx_from_state : symbolic_state -> idx -> char list list

val explain_array_unification_error_single :
  Old.Coq_dag.t -> idx option -> char list -> char list -> char list ->
  char list -> (idx -> idx -> char list list) -> (idx -> char list list) ->
  bool -> idx list -> idx list -> nat -> char list list

val iteratively_explain_array_unification_error_modulo_commutativity :
  Old.Coq_dag.t -> (idx -> char list list) -> op0 option -> bool ->
  (nat * idx) list -> idx list -> char list list

val explain_array_unification_error :
  idx option -> Old.Coq_dag.t -> char list -> char list -> char list ->
  char list -> (idx -> idx -> char list list) -> (idx -> char list list) ->
  op0 option -> idx list -> idx list -> char list list

val explain_mismatch_from_state :
  char list -> char list -> symbolic_state -> idx -> idx -> char list list

val explain_idx_unification_error :
  idx option -> char list -> char list -> symbolic_state -> nat -> idx -> idx
  -> char list list

val explain_unification_default_fuel : symbolic_state -> nat

val explain_unification_error :
  (idx, idx list) sum list -> (idx, idx list) sum list -> idx option -> nat
  -> symbolic_state -> char list list

val show_lines_EquivalenceCheckingError : equivalenceCheckingError showLines

val merge_fresh_symbol : description -> idx Old.Coq_dag.coq_M

val setRegFresh :
  Options.symbolic_options_computed_opt -> description -> rEG -> idx m

type 't symexM =
  Old.Coq_dag.t -> (equivalenceCheckingError, 't * Old.Coq_dag.t) errorT

val symex_return : 'a1 -> 'a1 symexM

val symex_error : equivalenceCheckingError -> 'a1 symexM

val symex_bind : 'a1 symexM -> ('a1 -> 'a2 symexM) -> 'a2 symexM

val app1 :
  Options.symbolic_options_computed_opt -> description -> idx node0 -> idx
  symexM

val revealConstant : idx -> n symexM

val revealWidth : idx -> n symexM

type type_spec = nat option list

val simplify_base_type :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
  Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
  (equivalenceCheckingError, type_spec) errorT

val simplify_type :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type ->
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp ->
  (equivalenceCheckingError, type_spec) errorT

val simplify_input_type :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type,
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
  Compilers.Coq_type.for_each_lhs_of_arrow -> (equivalenceCheckingError,
  type_spec) errorT

val build_inputarray : description -> nat -> idx list Old.Coq_dag.coq_M

val build_inputs :
  description -> type_spec -> (idx, idx list) sum list Old.Coq_dag.coq_M

val compute_array_address :
  Options.symbolic_options_computed_opt -> description -> idx -> nat -> idx m

val build_merge_array_addresses :
  Options.symbolic_options_computed_opt -> description -> idx -> idx list ->
  idx list m

val build_merge_base_addresses :
  Options.symbolic_options_computed_opt -> description -> bool -> (idx, idx
  list) sum list -> rEG list -> ((rEG, idx) sum, idx) sum list m

val dag_gensym_n : description -> nat -> symbol list Old.Coq_dag.coq_M

type base_var = __

type var = __

val simplify_base_var :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> base_var ->
  (equivalenceCheckingError, (idx, idx list) sum list) errorT

val build_base_var :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> (idx, idx list)
  sum list -> (equivalenceCheckingError, base_var * (idx, idx list) sum list)
  errorT

val build_var :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (idx, idx list) sum list ->
  (equivalenceCheckingError, var * (idx, idx list) sum list) errorT

val build_input_var :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (idx, idx list) sum list ->
  (equivalenceCheckingError, (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, var)
  Compilers.Coq_type.for_each_lhs_of_arrow * (idx, idx list) sum list) errorT

type symex_T = __

val symex_T_return :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> var -> symex_T

val symex_T_error :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> equivalenceCheckingError -> symex_T

val symex_T_bind_base :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> 'a1 symexM -> ('a1 -> symex_T) -> symex_T

val symex_ident :
  Options.symbolic_options_computed_opt -> description -> Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
  Coq3_Compilers.ident -> symex_T

val symex_expr :
  Options.symbolic_options_computed_opt -> description -> Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq3_Compilers.ident, var) Compilers.Coq_expr.expr -> symex_T

val symex_PHOAS_PHOAS :
  Options.symbolic_options_computed_opt -> Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, var)
  Compilers.Coq_type.for_each_lhs_of_arrow -> Old.Coq_dag.t ->
  (equivalenceCheckingError, base_var * Old.Coq_dag.t) errorT

val symex_PHOAS :
  Options.symbolic_options_computed_opt -> Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (idx, idx list) sum
  list -> Old.Coq_dag.t -> (equivalenceCheckingError, (idx, idx list) sum
  list * Old.Coq_dag.t) errorT

val init_symbolic_state_descr : description

val init_symbolic_state : Old.Coq_dag.t -> symbolic_state

val compute_stack_base :
  Options.symbolic_options_computed_opt -> description -> nat -> idx m

val build_merge_stack_placeholders :
  Options.symbolic_options_computed_opt -> description -> nat -> idx m

val loadArray :
  Options.symbolic_options_computed_opt -> description -> idx -> nat -> idx
  list m

val loadOutputs_internal :
  Options.symbolic_options_computed_opt -> description -> bool -> ((rEG, idx)
  sum, idx) sum list -> type_spec -> (idx, idx list) sum list m

val loadOutputs :
  Options.symbolic_options_computed_opt -> description -> bool -> ((rEG, idx)
  sum, idx) sum list -> type_spec -> (equivalenceCheckingError, (idx, idx
  list) sum list) errorT m

val symex_asm_func_M :
  Options.symbolic_options_computed_opt -> bool -> rEG list -> type_spec ->
  nat -> (idx, idx list) sum list -> rEG list -> lines ->
  (equivalenceCheckingError, (idx, idx list) sum list) errorT m

val symex_asm_func :
  Options.symbolic_options_computed_opt -> bool -> Old.Coq_dag.t -> rEG list
  -> type_spec -> nat -> (idx, idx list) sum list -> rEG list -> lines ->
  (equivalenceCheckingError, (idx, idx list) sum list * symbolic_state) errorT

val strip_ret : lines -> (equivalenceCheckingError, line list) errorT

val check_equivalence :
  Options.symbolic_options_computed_opt -> assembly_calling_registers_opt ->
  assembly_stack_size_opt -> assembly_callee_saved_registers_opt ->
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (char list * lines) list ->
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type,
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
  Compilers.Coq_type.for_each_lhs_of_arrow ->
  Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
  ((char list * lines) option * equivalenceCheckingError, unit) errorT

val generate_assembly_of_hinted_expr :
  Options.symbolic_options_computed_opt -> assembly_calling_registers_opt ->
  assembly_stack_size_opt -> assembly_callee_saved_registers_opt ->
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (char list * lines) list ->
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type,
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
  Compilers.Coq_type.for_each_lhs_of_arrow ->
  Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
  ((char list * lines) option * equivalenceCheckingError, (char list * lines)
  list) errorT

val parse_term_of_Qexpr : empty_set qexpr_poly -> (z * z) option

val qexpr_to_add_list : empty_set qexpr_poly -> empty_set qexpr_poly list

val parse_prime_and_taps_of_Qexpr :
  empty_set qexpr_poly -> (z * (z * z) list) option

val parseZ_arith_to_taps : char list -> (z * (z * z) list) option

module Coq1_Raw :
 functor (X:Coq_OrderedType) ->
 sig
  module MX :
   sig
    module TO :
     sig
      type t = X.t
     end

    module IsTO :
     sig
     end

    module OrderTac :
     sig
     end

    val eq_dec : X.t -> X.t -> bool

    val lt_dec : X.t -> X.t -> bool

    val eqb : X.t -> X.t -> bool
   end

  module PX :
   sig
    module MO :
     sig
      module TO :
       sig
        type t = X.t
       end

      module IsTO :
       sig
       end

      module OrderTac :
       sig
       end

      val eq_dec : X.t -> X.t -> bool

      val lt_dec : X.t -> X.t -> bool

      val eqb : X.t -> X.t -> bool
     end
   end

  type key = X.t

  type 'elt t = (X.t * 'elt) list

  val empty : 'a1 t

  val is_empty : 'a1 t -> bool

  val mem : key -> 'a1 t -> bool

  val find : key -> 'a1 t -> 'a1 option

  val add : key -> 'a1 -> 'a1 t -> 'a1 t

  val remove : key -> 'a1 t -> 'a1 t

  val elements : 'a1 t -> 'a1 t

  val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2

  val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool

  val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t

  val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t

  val option_cons : key -> 'a1 option -> (key * 'a1) list -> (key * 'a1) list

  val map2_l : ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a3 t

  val map2_r : ('a1 option -> 'a2 option -> 'a3 option) -> 'a2 t -> 'a3 t

  val map2 :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t

  val combine : 'a1 t -> 'a2 t -> ('a1 option * 'a2 option) t

  val fold_right_pair :
    ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1 * 'a2) list -> 'a3 -> 'a3

  val map2_alt :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> (key * 'a3)
    list

  val at_least_one :
    'a1 option -> 'a2 option -> ('a1 option * 'a2 option) option

  val at_least_one_then_f :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 option -> 'a2 option ->
    'a3 option
 end

module type Int =
 sig
  type t

  val i2z : t -> z

  val _0 : t

  val _1 : t

  val _2 : t

  val _3 : t

  val add : t -> t -> t

  val opp : t -> t

  val sub : t -> t -> t

  val mul : t -> t -> t

  val max : t -> t -> t

  val eqb : t -> t -> bool

  val ltb : t -> t -> bool

  val leb : t -> t -> bool

  val gt_le_dec : t -> t -> bool

  val ge_lt_dec : t -> t -> bool

  val eq_dec : t -> t -> bool
 end

module MoreInt :
 functor (I:Int) ->
 sig
  type coq_ExprI =
  | EI0
  | EI1
  | EI2
  | EI3
  | EIadd of coq_ExprI * coq_ExprI
  | EIopp of coq_ExprI
  | EIsub of coq_ExprI * coq_ExprI
  | EImul of coq_ExprI * coq_ExprI
  | EImax of coq_ExprI * coq_ExprI
  | EIraw of I.t

  val coq_ExprI_rect :
    'a1 -> 'a1 -> 'a1 -> 'a1 -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1)
    -> (coq_ExprI -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 ->
    'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) -> (coq_ExprI ->
    'a1 -> coq_ExprI -> 'a1 -> 'a1) -> (I.t -> 'a1) -> coq_ExprI -> 'a1

  val coq_ExprI_rec :
    'a1 -> 'a1 -> 'a1 -> 'a1 -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1)
    -> (coq_ExprI -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 ->
    'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) -> (coq_ExprI ->
    'a1 -> coq_ExprI -> 'a1 -> 'a1) -> (I.t -> 'a1) -> coq_ExprI -> 'a1

  type coq_ExprZ =
  | EZadd of coq_ExprZ * coq_ExprZ
  | EZopp of coq_ExprZ
  | EZsub of coq_ExprZ * coq_ExprZ
  | EZmul of coq_ExprZ * coq_ExprZ
  | EZmax of coq_ExprZ * coq_ExprZ
  | EZofI of coq_ExprI
  | EZraw of z

  val coq_ExprZ_rect :
    (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 ->
    'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ ->
    'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1
    -> 'a1) -> (coq_ExprI -> 'a1) -> (z -> 'a1) -> coq_ExprZ -> 'a1

  val coq_ExprZ_rec :
    (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 ->
    'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ ->
    'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1
    -> 'a1) -> (coq_ExprI -> 'a1) -> (z -> 'a1) -> coq_ExprZ -> 'a1

  type coq_ExprP =
  | EPeq of coq_ExprZ * coq_ExprZ
  | EPlt of coq_ExprZ * coq_ExprZ
  | EPle of coq_ExprZ * coq_ExprZ
  | EPgt of coq_ExprZ * coq_ExprZ
  | EPge of coq_ExprZ * coq_ExprZ
  | EPimpl of coq_ExprP * coq_ExprP
  | EPequiv of coq_ExprP * coq_ExprP
  | EPand of coq_ExprP * coq_ExprP
  | EPor of coq_ExprP * coq_ExprP
  | EPneg of coq_ExprP
  | EPraw

  val coq_ExprP_rect :
    (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
    (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
    (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1
    -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP ->
    'a1 -> coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1
    -> 'a1) -> (coq_ExprP -> 'a1 -> 'a1) -> (__ -> 'a1) -> coq_ExprP -> 'a1

  val coq_ExprP_rec :
    (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
    (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
    (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1
    -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP ->
    'a1 -> coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1
    -> 'a1) -> (coq_ExprP -> 'a1 -> 'a1) -> (__ -> 'a1) -> coq_ExprP -> 'a1

  val ei2i : coq_ExprI -> I.t

  val ez2z : coq_ExprZ -> z

  val norm_ei : coq_ExprI -> coq_ExprZ

  val norm_ez : coq_ExprZ -> coq_ExprZ

  val norm_ep : coq_ExprP -> coq_ExprP
 end

module Z_as_Int :
 sig
  type t = z

  val _0 : z

  val _1 : z

  val _2 : z

  val _3 : z

  val add : z -> z -> z

  val opp : z -> z

  val sub : z -> z -> z

  val mul : z -> z -> z

  val max : z -> z -> z

  val eqb : z -> z -> bool

  val ltb : z -> z -> bool

  val leb : z -> z -> bool

  val eq_dec : z -> z -> bool

  val gt_le_dec : z -> z -> bool

  val ge_lt_dec : z -> z -> bool

  val i2z : t -> z
 end

module Coq2_Raw :
 functor (I:Int) ->
 functor (X:Coq_OrderedType) ->
 sig
  type key = X.t

  type 'elt tree =
  | Leaf
  | Node of 'elt tree * key * 'elt * 'elt tree * I.t

  val tree_rect :
    'a2 -> ('a1 tree -> 'a2 -> key -> 'a1 -> 'a1 tree -> 'a2 -> I.t -> 'a2)
    -> 'a1 tree -> 'a2

  val tree_rec :
    'a2 -> ('a1 tree -> 'a2 -> key -> 'a1 -> 'a1 tree -> 'a2 -> I.t -> 'a2)
    -> 'a1 tree -> 'a2

  val height : 'a1 tree -> I.t

  val cardinal : 'a1 tree -> nat

  val empty : 'a1 tree

  val is_empty : 'a1 tree -> bool

  val mem : X.t -> 'a1 tree -> bool

  val find : X.t -> 'a1 tree -> 'a1 option

  val create : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

  val assert_false : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

  val bal : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

  val add : key -> 'a1 -> 'a1 tree -> 'a1 tree

  val remove_min :
    'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree * (key * 'a1)

  val merge : 'a1 tree -> 'a1 tree -> 'a1 tree

  val remove : X.t -> 'a1 tree -> 'a1 tree

  val join : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

  type 'elt triple = { t_left : 'elt tree; t_opt : 'elt option;
                       t_right : 'elt tree }

  val t_left : 'a1 triple -> 'a1 tree

  val t_opt : 'a1 triple -> 'a1 option

  val t_right : 'a1 triple -> 'a1 tree

  val split : X.t -> 'a1 tree -> 'a1 triple

  val concat : 'a1 tree -> 'a1 tree -> 'a1 tree

  val elements_aux : (key * 'a1) list -> 'a1 tree -> (key * 'a1) list

  val elements : 'a1 tree -> (key * 'a1) list

  val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2

  type 'elt enumeration =
  | End
  | More of key * 'elt * 'elt tree * 'elt enumeration

  val enumeration_rect :
    'a2 -> (key -> 'a1 -> 'a1 tree -> 'a1 enumeration -> 'a2 -> 'a2) -> 'a1
    enumeration -> 'a2

  val enumeration_rec :
    'a2 -> (key -> 'a1 -> 'a1 tree -> 'a1 enumeration -> 'a2 -> 'a2) -> 'a1
    enumeration -> 'a2

  val cons : 'a1 tree -> 'a1 enumeration -> 'a1 enumeration

  val equal_more :
    ('a1 -> 'a1 -> bool) -> X.t -> 'a1 -> ('a1 enumeration -> bool) -> 'a1
    enumeration -> bool

  val equal_cont :
    ('a1 -> 'a1 -> bool) -> 'a1 tree -> ('a1 enumeration -> bool) -> 'a1
    enumeration -> bool

  val equal_end : 'a1 enumeration -> bool

  val equal : ('a1 -> 'a1 -> bool) -> 'a1 tree -> 'a1 tree -> bool

  val map : ('a1 -> 'a2) -> 'a1 tree -> 'a2 tree

  val mapi : (key -> 'a1 -> 'a2) -> 'a1 tree -> 'a2 tree

  val map_option : (key -> 'a1 -> 'a2 option) -> 'a1 tree -> 'a2 tree

  val map2_opt :
    (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree) ->
    ('a2 tree -> 'a3 tree) -> 'a1 tree -> 'a2 tree -> 'a3 tree

  val map2 :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 tree -> 'a2 tree -> 'a3
    tree

  module Proofs :
   sig
    module MX :
     sig
      module TO :
       sig
        type t = X.t
       end

      module IsTO :
       sig
       end

      module OrderTac :
       sig
       end

      val eq_dec : X.t -> X.t -> bool

      val lt_dec : X.t -> X.t -> bool

      val eqb : X.t -> X.t -> bool
     end

    module PX :
     sig
      module MO :
       sig
        module TO :
         sig
          type t = X.t
         end

        module IsTO :
         sig
         end

        module OrderTac :
         sig
         end

        val eq_dec : X.t -> X.t -> bool

        val lt_dec : X.t -> X.t -> bool

        val eqb : X.t -> X.t -> bool
       end
     end

    module L :
     sig
      module MX :
       sig
        module TO :
         sig
          type t = X.t
         end

        module IsTO :
         sig
         end

        module OrderTac :
         sig
         end

        val eq_dec : X.t -> X.t -> bool

        val lt_dec : X.t -> X.t -> bool

        val eqb : X.t -> X.t -> bool
       end

      module PX :
       sig
        module MO :
         sig
          module TO :
           sig
            type t = X.t
           end

          module IsTO :
           sig
           end

          module OrderTac :
           sig
           end

          val eq_dec : X.t -> X.t -> bool

          val lt_dec : X.t -> X.t -> bool

          val eqb : X.t -> X.t -> bool
         end
       end

      type key = X.t

      type 'elt t = (X.t * 'elt) list

      val empty : 'a1 t

      val is_empty : 'a1 t -> bool

      val mem : key -> 'a1 t -> bool

      val find : key -> 'a1 t -> 'a1 option

      val add : key -> 'a1 -> 'a1 t -> 'a1 t

      val remove : key -> 'a1 t -> 'a1 t

      val elements : 'a1 t -> 'a1 t

      val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2

      val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool

      val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t

      val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t

      val option_cons :
        key -> 'a1 option -> (key * 'a1) list -> (key * 'a1) list

      val map2_l : ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a3 t

      val map2_r : ('a1 option -> 'a2 option -> 'a3 option) -> 'a2 t -> 'a3 t

      val map2 :
        ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t

      val combine : 'a1 t -> 'a2 t -> ('a1 option * 'a2 option) t

      val fold_right_pair :
        ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1 * 'a2) list -> 'a3 -> 'a3

      val map2_alt :
        ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t ->
        (key * 'a3) list

      val at_least_one :
        'a1 option -> 'a2 option -> ('a1 option * 'a2 option) option

      val at_least_one_then_f :
        ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 option -> 'a2 option
        -> 'a3 option
     end

    type 'elt coq_R_mem =
    | R_mem_0 of 'elt tree
    | R_mem_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t * 
       bool * 'elt coq_R_mem
    | R_mem_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
    | R_mem_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t * 
       bool * 'elt coq_R_mem

    val coq_R_mem_rect :
      X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
      -> 'a1 tree -> I.t -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem -> 'a2 ->
      'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ ->
      __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
      I.t -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2) -> 'a1
      tree -> bool -> 'a1 coq_R_mem -> 'a2

    val coq_R_mem_rec :
      X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
      -> 'a1 tree -> I.t -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem -> 'a2 ->
      'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ ->
      __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
      I.t -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2) -> 'a1
      tree -> bool -> 'a1 coq_R_mem -> 'a2

    type 'elt coq_R_find =
    | R_find_0 of 'elt tree
    | R_find_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
       * 'elt option * 'elt coq_R_find
    | R_find_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
    | R_find_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
       * 'elt option * 'elt coq_R_find

    val coq_R_find_rect :
      X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
      -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 option -> 'a1 coq_R_find ->
      'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t
      -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1
      tree -> I.t -> __ -> __ -> __ -> 'a1 option -> 'a1 coq_R_find -> 'a2 ->
      'a2) -> 'a1 tree -> 'a1 option -> 'a1 coq_R_find -> 'a2

    val coq_R_find_rec :
      X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
      -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 option -> 'a1 coq_R_find ->
      'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t
      -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1
      tree -> I.t -> __ -> __ -> __ -> 'a1 option -> 'a1 coq_R_find -> 'a2 ->
      'a2) -> 'a1 tree -> 'a1 option -> 'a1 coq_R_find -> 'a2

    type 'elt coq_R_bal =
    | R_bal_0 of 'elt tree * key * 'elt * 'elt tree
    | R_bal_1 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key * 
       'elt * 'elt tree * I.t
    | R_bal_2 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key * 
       'elt * 'elt tree * I.t
    | R_bal_3 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key * 
       'elt * 'elt tree * I.t * 'elt tree * key * 'elt * 'elt tree * 
       I.t
    | R_bal_4 of 'elt tree * key * 'elt * 'elt tree
    | R_bal_5 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key * 
       'elt * 'elt tree * I.t
    | R_bal_6 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key * 
       'elt * 'elt tree * I.t
    | R_bal_7 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key * 
       'elt * 'elt tree * I.t * 'elt tree * key * 'elt * 'elt tree * 
       I.t
    | R_bal_8 of 'elt tree * key * 'elt * 'elt tree

    val coq_R_bal_rect :
      ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> 'a2) -> ('a1
      tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 ->
      'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 ->
      'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
      -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __
      -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ ->
      'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2) -> ('a1 tree ->
      key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> __ -> 'a2) -> ('a1
      tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree ->
      key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
      key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key ->
      'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
      key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key ->
      'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 ->
      'a1 tree -> I.t -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree ->
      __ -> __ -> __ -> __ -> 'a2) -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
      'a1 tree -> 'a1 coq_R_bal -> 'a2

    val coq_R_bal_rec :
      ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> 'a2) -> ('a1
      tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 ->
      'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 ->
      'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
      -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __
      -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ ->
      'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2) -> ('a1 tree ->
      key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> __ -> 'a2) -> ('a1
      tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree ->
      key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
      key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key ->
      'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
      key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key ->
      'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 ->
      'a1 tree -> I.t -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree ->
      __ -> __ -> __ -> __ -> 'a2) -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
      'a1 tree -> 'a1 coq_R_bal -> 'a2

    type 'elt coq_R_add =
    | R_add_0 of 'elt tree
    | R_add_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
       * 'elt tree * 'elt coq_R_add
    | R_add_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
    | R_add_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
       * 'elt tree * 'elt coq_R_add

    val coq_R_add_rect :
      key -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
      -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
      coq_R_add -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1
      tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
      -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
      coq_R_add -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_add -> 'a2

    val coq_R_add_rec :
      key -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
      -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
      coq_R_add -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1
      tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
      -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
      coq_R_add -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_add -> 'a2

    type 'elt coq_R_remove_min =
    | R_remove_min_0 of 'elt tree * key * 'elt * 'elt tree
    | R_remove_min_1 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
       key * 'elt * 'elt tree * I.t * ('elt tree * (key * 'elt))
       * 'elt coq_R_remove_min * 'elt tree * (key * 'elt)

    val coq_R_remove_min_rect :
      ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> key
      -> 'a1 -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
      -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min -> 'a2 -> 'a1 tree
      -> (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
      ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min -> 'a2

    val coq_R_remove_min_rec :
      ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> key
      -> 'a1 -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
      -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min -> 'a2 -> 'a1 tree
      -> (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
      ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min -> 'a2

    type 'elt coq_R_merge =
    | R_merge_0 of 'elt tree * 'elt tree
    | R_merge_1 of 'elt tree * 'elt tree * 'elt tree * key * 'elt * 'elt tree
       * I.t
    | R_merge_2 of 'elt tree * 'elt tree * 'elt tree * key * 'elt * 'elt tree
       * I.t * 'elt tree * key * 'elt * 'elt tree * I.t * 'elt tree
       * (key * 'elt) * key * 'elt

    val coq_R_merge_rect :
      ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
      tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2) -> ('a1 tree
      -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1
      tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1 tree -> (key * 'a1)
      -> __ -> key -> 'a1 -> __ -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 tree
      -> 'a1 coq_R_merge -> 'a2

    val coq_R_merge_rec :
      ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
      tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2) -> ('a1 tree
      -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1
      tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1 tree -> (key * 'a1)
      -> __ -> key -> 'a1 -> __ -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 tree
      -> 'a1 coq_R_merge -> 'a2

    type 'elt coq_R_remove =
    | R_remove_0 of 'elt tree
    | R_remove_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
       I.t * 'elt tree * 'elt coq_R_remove
    | R_remove_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
    | R_remove_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
       I.t * 'elt tree * 'elt coq_R_remove

    val coq_R_remove_rect :
      X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
      -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1 coq_R_remove ->
      'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t
      -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1
      tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1 coq_R_remove -> 'a2 ->
      'a2) -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_remove -> 'a2

    val coq_R_remove_rec :
      X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
      -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1 coq_R_remove ->
      'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t
      -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1
      tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1 coq_R_remove -> 'a2 ->
      'a2) -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_remove -> 'a2

    type 'elt coq_R_concat =
    | R_concat_0 of 'elt tree * 'elt tree
    | R_concat_1 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
       * 'elt tree * I.t
    | R_concat_2 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
       * 'elt tree * I.t * 'elt tree * key * 'elt * 'elt tree * I.t
       * 'elt tree * (key * 'elt)

    val coq_R_concat_rect :
      ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
      tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2) -> ('a1 tree
      -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1
      tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1 tree -> (key * 'a1)
      -> __ -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_concat
      -> 'a2

    val coq_R_concat_rec :
      ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
      tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2) -> ('a1 tree
      -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1
      tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1 tree -> (key * 'a1)
      -> __ -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_concat
      -> 'a2

    type 'elt coq_R_split =
    | R_split_0 of 'elt tree
    | R_split_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
       * 'elt triple * 'elt coq_R_split * 'elt tree * 'elt option * 'elt tree
    | R_split_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
    | R_split_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
       * 'elt triple * 'elt coq_R_split * 'elt tree * 'elt option * 'elt tree

    val coq_R_split_rect :
      X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
      -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 triple -> 'a1 coq_R_split
      -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
      -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a2)
      -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __
      -> __ -> 'a1 triple -> 'a1 coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option
      -> 'a1 tree -> __ -> 'a2) -> 'a1 tree -> 'a1 triple -> 'a1 coq_R_split
      -> 'a2

    val coq_R_split_rec :
      X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
      -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 triple -> 'a1 coq_R_split
      -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
      -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a2)
      -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __
      -> __ -> 'a1 triple -> 'a1 coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option
      -> 'a1 tree -> __ -> 'a2) -> 'a1 tree -> 'a1 triple -> 'a1 coq_R_split
      -> 'a2

    type ('elt, 'x) coq_R_map_option =
    | R_map_option_0 of 'elt tree
    | R_map_option_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
       I.t * 'x * 'x tree * ('elt, 'x) coq_R_map_option * 'x tree
       * ('elt, 'x) coq_R_map_option
    | R_map_option_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
       I.t * 'x tree * ('elt, 'x) coq_R_map_option * 'x tree
       * ('elt, 'x) coq_R_map_option

    val coq_R_map_option_rect :
      (key -> 'a1 -> 'a2 option) -> ('a1 tree -> __ -> 'a3) -> ('a1 tree ->
      'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2 -> __ -> 'a2
      tree -> ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2)
      coq_R_map_option -> 'a3 -> 'a3) -> ('a1 tree -> 'a1 tree -> key -> 'a1
      -> 'a1 tree -> I.t -> __ -> __ -> 'a2 tree -> ('a1, 'a2)
      coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2) coq_R_map_option ->
      'a3 -> 'a3) -> 'a1 tree -> 'a2 tree -> ('a1, 'a2) coq_R_map_option ->
      'a3

    val coq_R_map_option_rec :
      (key -> 'a1 -> 'a2 option) -> ('a1 tree -> __ -> 'a3) -> ('a1 tree ->
      'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2 -> __ -> 'a2
      tree -> ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2)
      coq_R_map_option -> 'a3 -> 'a3) -> ('a1 tree -> 'a1 tree -> key -> 'a1
      -> 'a1 tree -> I.t -> __ -> __ -> 'a2 tree -> ('a1, 'a2)
      coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2) coq_R_map_option ->
      'a3 -> 'a3) -> 'a1 tree -> 'a2 tree -> ('a1, 'a2) coq_R_map_option ->
      'a3

    type ('elt, 'x0, 'x) coq_R_map2_opt =
    | R_map2_opt_0 of 'elt tree * 'x0 tree
    | R_map2_opt_1 of 'elt tree * 'x0 tree * 'elt tree * key * 'elt
       * 'elt tree * I.t
    | R_map2_opt_2 of 'elt tree * 'x0 tree * 'elt tree * key * 'elt
       * 'elt tree * I.t * 'x0 tree * key * 'x0 * 'x0 tree * I.t * 'x0 tree
       * 'x0 option * 'x0 tree * 'x * 'x tree
       * ('elt, 'x0, 'x) coq_R_map2_opt * 'x tree
       * ('elt, 'x0, 'x) coq_R_map2_opt
    | R_map2_opt_3 of 'elt tree * 'x0 tree * 'elt tree * key * 'elt
       * 'elt tree * I.t * 'x0 tree * key * 'x0 * 'x0 tree * I.t * 'x0 tree
       * 'x0 option * 'x0 tree * 'x tree * ('elt, 'x0, 'x) coq_R_map2_opt
       * 'x tree * ('elt, 'x0, 'x) coq_R_map2_opt

    val coq_R_map2_opt_rect :
      (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree) ->
      ('a2 tree -> 'a3 tree) -> ('a1 tree -> 'a2 tree -> __ -> 'a4) -> ('a1
      tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ ->
      __ -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1
      tree -> I.t -> __ -> 'a2 tree -> key -> 'a2 -> 'a2 tree -> I.t -> __ ->
      'a2 tree -> 'a2 option -> 'a2 tree -> __ -> 'a3 -> __ -> 'a3 tree ->
      ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a3 tree -> ('a1, 'a2, 'a3)
      coq_R_map2_opt -> 'a4 -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree ->
      key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2 tree -> key -> 'a2 -> 'a2
      tree -> I.t -> __ -> 'a2 tree -> 'a2 option -> 'a2 tree -> __ -> __ ->
      'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a3 tree -> ('a1,
      'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> 'a1 tree -> 'a2 tree -> 'a3
      tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4

    val coq_R_map2_opt_rec :
      (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree) ->
      ('a2 tree -> 'a3 tree) -> ('a1 tree -> 'a2 tree -> __ -> 'a4) -> ('a1
      tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ ->
      __ -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1
      tree -> I.t -> __ -> 'a2 tree -> key -> 'a2 -> 'a2 tree -> I.t -> __ ->
      'a2 tree -> 'a2 option -> 'a2 tree -> __ -> 'a3 -> __ -> 'a3 tree ->
      ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a3 tree -> ('a1, 'a2, 'a3)
      coq_R_map2_opt -> 'a4 -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree ->
      key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2 tree -> key -> 'a2 -> 'a2
      tree -> I.t -> __ -> 'a2 tree -> 'a2 option -> 'a2 tree -> __ -> __ ->
      'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a3 tree -> ('a1,
      'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> 'a1 tree -> 'a2 tree -> 'a3
      tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4

    val fold' : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2

    val flatten_e : 'a1 enumeration -> (key * 'a1) list
   end
 end

module AvlProofs :
 functor (I:Int) ->
 functor (X:Coq_OrderedType) ->
 sig
  module Raw :
   sig
    type key = X.t

    type 'elt tree =
    | Leaf
    | Node of 'elt tree * key * 'elt * 'elt tree * I.t

    val tree_rect :
      'a2 -> ('a1 tree -> 'a2 -> key -> 'a1 -> 'a1 tree -> 'a2 -> I.t -> 'a2)
      -> 'a1 tree -> 'a2

    val tree_rec :
      'a2 -> ('a1 tree -> 'a2 -> key -> 'a1 -> 'a1 tree -> 'a2 -> I.t -> 'a2)
      -> 'a1 tree -> 'a2

    val height : 'a1 tree -> I.t

    val cardinal : 'a1 tree -> nat

    val empty : 'a1 tree

    val is_empty : 'a1 tree -> bool

    val mem : X.t -> 'a1 tree -> bool

    val find : X.t -> 'a1 tree -> 'a1 option

    val create : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

    val assert_false : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

    val bal : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

    val add : key -> 'a1 -> 'a1 tree -> 'a1 tree

    val remove_min :
      'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree * (key * 'a1)

    val merge : 'a1 tree -> 'a1 tree -> 'a1 tree

    val remove : X.t -> 'a1 tree -> 'a1 tree

    val join : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

    type 'elt triple = { t_left : 'elt tree; t_opt : 'elt option;
                         t_right : 'elt tree }

    val t_left : 'a1 triple -> 'a1 tree

    val t_opt : 'a1 triple -> 'a1 option

    val t_right : 'a1 triple -> 'a1 tree

    val split : X.t -> 'a1 tree -> 'a1 triple

    val concat : 'a1 tree -> 'a1 tree -> 'a1 tree

    val elements_aux : (key * 'a1) list -> 'a1 tree -> (key * 'a1) list

    val elements : 'a1 tree -> (key * 'a1) list

    val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2

    type 'elt enumeration =
    | End
    | More of key * 'elt * 'elt tree * 'elt enumeration

    val enumeration_rect :
      'a2 -> (key -> 'a1 -> 'a1 tree -> 'a1 enumeration -> 'a2 -> 'a2) -> 'a1
      enumeration -> 'a2

    val enumeration_rec :
      'a2 -> (key -> 'a1 -> 'a1 tree -> 'a1 enumeration -> 'a2 -> 'a2) -> 'a1
      enumeration -> 'a2

    val cons : 'a1 tree -> 'a1 enumeration -> 'a1 enumeration

    val equal_more :
      ('a1 -> 'a1 -> bool) -> X.t -> 'a1 -> ('a1 enumeration -> bool) -> 'a1
      enumeration -> bool

    val equal_cont :
      ('a1 -> 'a1 -> bool) -> 'a1 tree -> ('a1 enumeration -> bool) -> 'a1
      enumeration -> bool

    val equal_end : 'a1 enumeration -> bool

    val equal : ('a1 -> 'a1 -> bool) -> 'a1 tree -> 'a1 tree -> bool

    val map : ('a1 -> 'a2) -> 'a1 tree -> 'a2 tree

    val mapi : (key -> 'a1 -> 'a2) -> 'a1 tree -> 'a2 tree

    val map_option : (key -> 'a1 -> 'a2 option) -> 'a1 tree -> 'a2 tree

    val map2_opt :
      (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree) ->
      ('a2 tree -> 'a3 tree) -> 'a1 tree -> 'a2 tree -> 'a3 tree

    val map2 :
      ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 tree -> 'a2 tree -> 'a3
      tree

    module Proofs :
     sig
      module MX :
       sig
        module TO :
         sig
          type t = X.t
         end

        module IsTO :
         sig
         end

        module OrderTac :
         sig
         end

        val eq_dec : X.t -> X.t -> bool

        val lt_dec : X.t -> X.t -> bool

        val eqb : X.t -> X.t -> bool
       end

      module PX :
       sig
        module MO :
         sig
          module TO :
           sig
            type t = X.t
           end

          module IsTO :
           sig
           end

          module OrderTac :
           sig
           end

          val eq_dec : X.t -> X.t -> bool

          val lt_dec : X.t -> X.t -> bool

          val eqb : X.t -> X.t -> bool
         end
       end

      module L :
       sig
        module MX :
         sig
          module TO :
           sig
            type t = X.t
           end

          module IsTO :
           sig
           end

          module OrderTac :
           sig
           end

          val eq_dec : X.t -> X.t -> bool

          val lt_dec : X.t -> X.t -> bool

          val eqb : X.t -> X.t -> bool
         end

        module PX :
         sig
          module MO :
           sig
            module TO :
             sig
              type t = X.t
             end

            module IsTO :
             sig
             end

            module OrderTac :
             sig
             end

            val eq_dec : X.t -> X.t -> bool

            val lt_dec : X.t -> X.t -> bool

            val eqb : X.t -> X.t -> bool
           end
         end

        type key = X.t

        type 'elt t = (X.t * 'elt) list

        val empty : 'a1 t

        val is_empty : 'a1 t -> bool

        val mem : key -> 'a1 t -> bool

        val find : key -> 'a1 t -> 'a1 option

        val add : key -> 'a1 -> 'a1 t -> 'a1 t

        val remove : key -> 'a1 t -> 'a1 t

        val elements : 'a1 t -> 'a1 t

        val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2

        val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool

        val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t

        val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t

        val option_cons :
          key -> 'a1 option -> (key * 'a1) list -> (key * 'a1) list

        val map2_l :
          ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a3 t

        val map2_r :
          ('a1 option -> 'a2 option -> 'a3 option) -> 'a2 t -> 'a3 t

        val map2 :
          ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t

        val combine : 'a1 t -> 'a2 t -> ('a1 option * 'a2 option) t

        val fold_right_pair :
          ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1 * 'a2) list -> 'a3 -> 'a3

        val map2_alt :
          ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t ->
          (key * 'a3) list

        val at_least_one :
          'a1 option -> 'a2 option -> ('a1 option * 'a2 option) option

        val at_least_one_then_f :
          ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 option -> 'a2
          option -> 'a3 option
       end

      type 'elt coq_R_mem =
      | R_mem_0 of 'elt tree
      | R_mem_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
         * bool * 'elt coq_R_mem
      | R_mem_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
      | R_mem_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
         * bool * 'elt coq_R_mem

      val coq_R_mem_rect :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem -> 'a2
        -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t ->
        __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> I.t -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2)
        -> 'a1 tree -> bool -> 'a1 coq_R_mem -> 'a2

      val coq_R_mem_rec :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem -> 'a2
        -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t ->
        __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> I.t -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2)
        -> 'a1 tree -> bool -> 'a1 coq_R_mem -> 'a2

      type 'elt coq_R_find =
      | R_find_0 of 'elt tree
      | R_find_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
         I.t * 'elt option * 'elt coq_R_find
      | R_find_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
      | R_find_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
         I.t * 'elt option * 'elt coq_R_find

      val coq_R_find_rect :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 option -> 'a1 coq_R_find
        -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 option -> 'a1 coq_R_find
        -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 option -> 'a1 coq_R_find -> 'a2

      val coq_R_find_rec :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 option -> 'a1 coq_R_find
        -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 option -> 'a1 coq_R_find
        -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 option -> 'a1 coq_R_find -> 'a2

      type 'elt coq_R_bal =
      | R_bal_0 of 'elt tree * key * 'elt * 'elt tree
      | R_bal_1 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key
         * 'elt * 'elt tree * I.t
      | R_bal_2 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key
         * 'elt * 'elt tree * I.t
      | R_bal_3 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key
         * 'elt * 'elt tree * I.t * 'elt tree * key * 'elt * 'elt tree * 
         I.t
      | R_bal_4 of 'elt tree * key * 'elt * 'elt tree
      | R_bal_5 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key
         * 'elt * 'elt tree * I.t
      | R_bal_6 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key
         * 'elt * 'elt tree * I.t
      | R_bal_7 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key
         * 'elt * 'elt tree * I.t * 'elt tree * key * 'elt * 'elt tree * 
         I.t
      | R_bal_8 of 'elt tree * key * 'elt * 'elt tree

      val coq_R_bal_rect :
        ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> 'a2) -> ('a1
        tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key ->
        'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        I.t -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1
        tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ ->
        'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __
        -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ ->
        __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ ->
        __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __
        -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __
        -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ ->
        __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ ->
        __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2) -> ('a1
        tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a2) -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_bal -> 'a2

      val coq_R_bal_rec :
        ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> 'a2) -> ('a1
        tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key ->
        'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        I.t -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1
        tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ ->
        'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __
        -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ ->
        __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ ->
        __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __
        -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __
        -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ ->
        __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ ->
        __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2) -> ('a1
        tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a2) -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_bal -> 'a2

      type 'elt coq_R_add =
      | R_add_0 of 'elt tree
      | R_add_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
         * 'elt tree * 'elt coq_R_add
      | R_add_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
      | R_add_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
         * 'elt tree * 'elt coq_R_add

      val coq_R_add_rect :
        key -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
        coq_R_add -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
        key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
        coq_R_add -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_add ->
        'a2

      val coq_R_add_rec :
        key -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
        coq_R_add -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
        key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
        coq_R_add -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_add ->
        'a2

      type 'elt coq_R_remove_min =
      | R_remove_min_0 of 'elt tree * key * 'elt * 'elt tree
      | R_remove_min_1 of 'elt tree * key * 'elt * 'elt tree * 'elt tree
         * key * 'elt * 'elt tree * I.t * ('elt tree * (key * 'elt))
         * 'elt coq_R_remove_min * 'elt tree * (key * 'elt)

      val coq_R_remove_min_rect :
        ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> key
        -> 'a1 -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min -> 'a2 -> 'a1
        tree -> (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min -> 'a2

      val coq_R_remove_min_rec :
        ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> key
        -> 'a1 -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min -> 'a2 -> 'a1
        tree -> (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min -> 'a2

      type 'elt coq_R_merge =
      | R_merge_0 of 'elt tree * 'elt tree
      | R_merge_1 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
         * 'elt tree * I.t
      | R_merge_2 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
         * 'elt tree * I.t * 'elt tree * key * 'elt * 'elt tree * I.t
         * 'elt tree * (key * 'elt) * key * 'elt

      val coq_R_merge_rect :
        ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2) -> ('a1
        tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1 tree ->
        (key * 'a1) -> __ -> key -> 'a1 -> __ -> 'a2) -> 'a1 tree -> 'a1 tree
        -> 'a1 tree -> 'a1 coq_R_merge -> 'a2

      val coq_R_merge_rec :
        ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2) -> ('a1
        tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1 tree ->
        (key * 'a1) -> __ -> key -> 'a1 -> __ -> 'a2) -> 'a1 tree -> 'a1 tree
        -> 'a1 tree -> 'a1 coq_R_merge -> 'a2

      type 'elt coq_R_remove =
      | R_remove_0 of 'elt tree
      | R_remove_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
         I.t * 'elt tree * 'elt coq_R_remove
      | R_remove_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
      | R_remove_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
         I.t * 'elt tree * 'elt coq_R_remove

      val coq_R_remove_rect :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1 coq_R_remove
        -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1 coq_R_remove
        -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_remove -> 'a2

      val coq_R_remove_rec :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1 coq_R_remove
        -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1 coq_R_remove
        -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_remove -> 'a2

      type 'elt coq_R_concat =
      | R_concat_0 of 'elt tree * 'elt tree
      | R_concat_1 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
         * 'elt tree * I.t
      | R_concat_2 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
         * 'elt tree * I.t * 'elt tree * key * 'elt * 'elt tree * I.t
         * 'elt tree * (key * 'elt)

      val coq_R_concat_rect :
        ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2) -> ('a1
        tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1 tree ->
        (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1
        coq_R_concat -> 'a2

      val coq_R_concat_rec :
        ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2) -> ('a1
        tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1 tree ->
        (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1
        coq_R_concat -> 'a2

      type 'elt coq_R_split =
      | R_split_0 of 'elt tree
      | R_split_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
         I.t * 'elt triple * 'elt coq_R_split * 'elt tree * 'elt option
         * 'elt tree
      | R_split_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
      | R_split_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
         I.t * 'elt triple * 'elt coq_R_split * 'elt tree * 'elt option
         * 'elt tree

      val coq_R_split_rect :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 triple -> 'a1 coq_R_split
        -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __ -> 'a2) -> ('a1
        tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __
        -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t ->
        __ -> __ -> __ -> 'a1 triple -> 'a1 coq_R_split -> 'a2 -> 'a1 tree ->
        'a1 option -> 'a1 tree -> __ -> 'a2) -> 'a1 tree -> 'a1 triple -> 'a1
        coq_R_split -> 'a2

      val coq_R_split_rec :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 triple -> 'a1 coq_R_split
        -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __ -> 'a2) -> ('a1
        tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __
        -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t ->
        __ -> __ -> __ -> 'a1 triple -> 'a1 coq_R_split -> 'a2 -> 'a1 tree ->
        'a1 option -> 'a1 tree -> __ -> 'a2) -> 'a1 tree -> 'a1 triple -> 'a1
        coq_R_split -> 'a2

      type ('elt, 'x) coq_R_map_option =
      | R_map_option_0 of 'elt tree
      | R_map_option_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * I.t * 'x * 'x tree * ('elt, 'x) coq_R_map_option * 'x tree
         * ('elt, 'x) coq_R_map_option
      | R_map_option_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * I.t * 'x tree * ('elt, 'x) coq_R_map_option * 'x tree
         * ('elt, 'x) coq_R_map_option

      val coq_R_map_option_rect :
        (key -> 'a1 -> 'a2 option) -> ('a1 tree -> __ -> 'a3) -> ('a1 tree ->
        'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2 -> __ -> 'a2
        tree -> ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2)
        coq_R_map_option -> 'a3 -> 'a3) -> ('a1 tree -> 'a1 tree -> key ->
        'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2 tree -> ('a1, 'a2)
        coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2) coq_R_map_option ->
        'a3 -> 'a3) -> 'a1 tree -> 'a2 tree -> ('a1, 'a2) coq_R_map_option ->
        'a3

      val coq_R_map_option_rec :
        (key -> 'a1 -> 'a2 option) -> ('a1 tree -> __ -> 'a3) -> ('a1 tree ->
        'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2 -> __ -> 'a2
        tree -> ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2)
        coq_R_map_option -> 'a3 -> 'a3) -> ('a1 tree -> 'a1 tree -> key ->
        'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2 tree -> ('a1, 'a2)
        coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2) coq_R_map_option ->
        'a3 -> 'a3) -> 'a1 tree -> 'a2 tree -> ('a1, 'a2) coq_R_map_option ->
        'a3

      type ('elt, 'x0, 'x) coq_R_map2_opt =
      | R_map2_opt_0 of 'elt tree * 'x0 tree
      | R_map2_opt_1 of 'elt tree * 'x0 tree * 'elt tree * key * 'elt
         * 'elt tree * I.t
      | R_map2_opt_2 of 'elt tree * 'x0 tree * 'elt tree * key * 'elt
         * 'elt tree * I.t * 'x0 tree * key * 'x0 * 'x0 tree * I.t * 
         'x0 tree * 'x0 option * 'x0 tree * 'x * 'x tree
         * ('elt, 'x0, 'x) coq_R_map2_opt * 'x tree
         * ('elt, 'x0, 'x) coq_R_map2_opt
      | R_map2_opt_3 of 'elt tree * 'x0 tree * 'elt tree * key * 'elt
         * 'elt tree * I.t * 'x0 tree * key * 'x0 * 'x0 tree * I.t * 
         'x0 tree * 'x0 option * 'x0 tree * 'x tree
         * ('elt, 'x0, 'x) coq_R_map2_opt * 'x tree
         * ('elt, 'x0, 'x) coq_R_map2_opt

      val coq_R_map2_opt_rect :
        (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree) ->
        ('a2 tree -> 'a3 tree) -> ('a1 tree -> 'a2 tree -> __ -> 'a4) -> ('a1
        tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> __ -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> I.t -> __ -> 'a2 tree -> key -> 'a2 -> 'a2 tree -> I.t ->
        __ -> 'a2 tree -> 'a2 option -> 'a2 tree -> __ -> 'a3 -> __ -> 'a3
        tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a3 tree -> ('a1,
        'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> ('a1 tree -> 'a2 tree ->
        'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2 tree -> key ->
        'a2 -> 'a2 tree -> I.t -> __ -> 'a2 tree -> 'a2 option -> 'a2 tree ->
        __ -> __ -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a3
        tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> 'a1 tree ->
        'a2 tree -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4

      val coq_R_map2_opt_rec :
        (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree) ->
        ('a2 tree -> 'a3 tree) -> ('a1 tree -> 'a2 tree -> __ -> 'a4) -> ('a1
        tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> __ -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> I.t -> __ -> 'a2 tree -> key -> 'a2 -> 'a2 tree -> I.t ->
        __ -> 'a2 tree -> 'a2 option -> 'a2 tree -> __ -> 'a3 -> __ -> 'a3
        tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a3 tree -> ('a1,
        'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> ('a1 tree -> 'a2 tree ->
        'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2 tree -> key ->
        'a2 -> 'a2 tree -> I.t -> __ -> 'a2 tree -> 'a2 option -> 'a2 tree ->
        __ -> __ -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a3
        tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> 'a1 tree ->
        'a2 tree -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4

      val fold' : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2

      val flatten_e : 'a1 enumeration -> (key * 'a1) list
     end
   end

  module II :
   sig
    type coq_ExprI =
    | EI0
    | EI1
    | EI2
    | EI3
    | EIadd of coq_ExprI * coq_ExprI
    | EIopp of coq_ExprI
    | EIsub of coq_ExprI * coq_ExprI
    | EImul of coq_ExprI * coq_ExprI
    | EImax of coq_ExprI * coq_ExprI
    | EIraw of I.t

    val coq_ExprI_rect :
      'a1 -> 'a1 -> 'a1 -> 'a1 -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 ->
      'a1) -> (coq_ExprI -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI ->
      'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) ->
      (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) -> (I.t -> 'a1) ->
      coq_ExprI -> 'a1

    val coq_ExprI_rec :
      'a1 -> 'a1 -> 'a1 -> 'a1 -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 ->
      'a1) -> (coq_ExprI -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI ->
      'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) ->
      (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) -> (I.t -> 'a1) ->
      coq_ExprI -> 'a1

    type coq_ExprZ =
    | EZadd of coq_ExprZ * coq_ExprZ
    | EZopp of coq_ExprZ
    | EZsub of coq_ExprZ * coq_ExprZ
    | EZmul of coq_ExprZ * coq_ExprZ
    | EZmax of coq_ExprZ * coq_ExprZ
    | EZofI of coq_ExprI
    | EZraw of z

    val coq_ExprZ_rect :
      (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 ->
      'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ ->
      'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ ->
      'a1 -> 'a1) -> (coq_ExprI -> 'a1) -> (z -> 'a1) -> coq_ExprZ -> 'a1

    val coq_ExprZ_rec :
      (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 ->
      'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ ->
      'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ ->
      'a1 -> 'a1) -> (coq_ExprI -> 'a1) -> (z -> 'a1) -> coq_ExprZ -> 'a1

    type coq_ExprP =
    | EPeq of coq_ExprZ * coq_ExprZ
    | EPlt of coq_ExprZ * coq_ExprZ
    | EPle of coq_ExprZ * coq_ExprZ
    | EPgt of coq_ExprZ * coq_ExprZ
    | EPge of coq_ExprZ * coq_ExprZ
    | EPimpl of coq_ExprP * coq_ExprP
    | EPequiv of coq_ExprP * coq_ExprP
    | EPand of coq_ExprP * coq_ExprP
    | EPor of coq_ExprP * coq_ExprP
    | EPneg of coq_ExprP
    | EPraw

    val coq_ExprP_rect :
      (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
      (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
      (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP ->
      'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) ->
      (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 ->
      coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> 'a1) -> (__ -> 'a1) ->
      coq_ExprP -> 'a1

    val coq_ExprP_rec :
      (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
      (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
      (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP ->
      'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) ->
      (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 ->
      coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> 'a1) -> (__ -> 'a1) ->
      coq_ExprP -> 'a1

    val ei2i : coq_ExprI -> I.t

    val ez2z : coq_ExprZ -> z

    val norm_ei : coq_ExprI -> coq_ExprZ

    val norm_ez : coq_ExprZ -> coq_ExprZ

    val norm_ep : coq_ExprP -> coq_ExprP
   end
 end

module IntMake :
 functor (I:Int) ->
 functor (X:Coq_OrderedType) ->
 sig
  module E :
   sig
    type t = X.t

    val compare : t -> t -> t compare2

    val eq_dec : t -> t -> bool
   end

  module AvlProofs :
   sig
    module Raw :
     sig
      type key = X.t

      type 'elt tree =
      | Leaf
      | Node of 'elt tree * key * 'elt * 'elt tree * I.t

      val tree_rect :
        'a2 -> ('a1 tree -> 'a2 -> key -> 'a1 -> 'a1 tree -> 'a2 -> I.t ->
        'a2) -> 'a1 tree -> 'a2

      val tree_rec :
        'a2 -> ('a1 tree -> 'a2 -> key -> 'a1 -> 'a1 tree -> 'a2 -> I.t ->
        'a2) -> 'a1 tree -> 'a2

      val height : 'a1 tree -> I.t

      val cardinal : 'a1 tree -> nat

      val empty : 'a1 tree

      val is_empty : 'a1 tree -> bool

      val mem : X.t -> 'a1 tree -> bool

      val find : X.t -> 'a1 tree -> 'a1 option

      val create : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

      val assert_false : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

      val bal : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

      val add : key -> 'a1 -> 'a1 tree -> 'a1 tree

      val remove_min :
        'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree * (key * 'a1)

      val merge : 'a1 tree -> 'a1 tree -> 'a1 tree

      val remove : X.t -> 'a1 tree -> 'a1 tree

      val join : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

      type 'elt triple = { t_left : 'elt tree; t_opt : 'elt option;
                           t_right : 'elt tree }

      val t_left : 'a1 triple -> 'a1 tree

      val t_opt : 'a1 triple -> 'a1 option

      val t_right : 'a1 triple -> 'a1 tree

      val split : X.t -> 'a1 tree -> 'a1 triple

      val concat : 'a1 tree -> 'a1 tree -> 'a1 tree

      val elements_aux : (key * 'a1) list -> 'a1 tree -> (key * 'a1) list

      val elements : 'a1 tree -> (key * 'a1) list

      val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2

      type 'elt enumeration =
      | End
      | More of key * 'elt * 'elt tree * 'elt enumeration

      val enumeration_rect :
        'a2 -> (key -> 'a1 -> 'a1 tree -> 'a1 enumeration -> 'a2 -> 'a2) ->
        'a1 enumeration -> 'a2

      val enumeration_rec :
        'a2 -> (key -> 'a1 -> 'a1 tree -> 'a1 enumeration -> 'a2 -> 'a2) ->
        'a1 enumeration -> 'a2

      val cons : 'a1 tree -> 'a1 enumeration -> 'a1 enumeration

      val equal_more :
        ('a1 -> 'a1 -> bool) -> X.t -> 'a1 -> ('a1 enumeration -> bool) ->
        'a1 enumeration -> bool

      val equal_cont :
        ('a1 -> 'a1 -> bool) -> 'a1 tree -> ('a1 enumeration -> bool) -> 'a1
        enumeration -> bool

      val equal_end : 'a1 enumeration -> bool

      val equal : ('a1 -> 'a1 -> bool) -> 'a1 tree -> 'a1 tree -> bool

      val map : ('a1 -> 'a2) -> 'a1 tree -> 'a2 tree

      val mapi : (key -> 'a1 -> 'a2) -> 'a1 tree -> 'a2 tree

      val map_option : (key -> 'a1 -> 'a2 option) -> 'a1 tree -> 'a2 tree

      val map2_opt :
        (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree) ->
        ('a2 tree -> 'a3 tree) -> 'a1 tree -> 'a2 tree -> 'a3 tree

      val map2 :
        ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 tree -> 'a2 tree ->
        'a3 tree

      module Proofs :
       sig
        module MX :
         sig
          module TO :
           sig
            type t = X.t
           end

          module IsTO :
           sig
           end

          module OrderTac :
           sig
           end

          val eq_dec : X.t -> X.t -> bool

          val lt_dec : X.t -> X.t -> bool

          val eqb : X.t -> X.t -> bool
         end

        module PX :
         sig
          module MO :
           sig
            module TO :
             sig
              type t = X.t
             end

            module IsTO :
             sig
             end

            module OrderTac :
             sig
             end

            val eq_dec : X.t -> X.t -> bool

            val lt_dec : X.t -> X.t -> bool

            val eqb : X.t -> X.t -> bool
           end
         end

        module L :
         sig
          module MX :
           sig
            module TO :
             sig
              type t = X.t
             end

            module IsTO :
             sig
             end

            module OrderTac :
             sig
             end

            val eq_dec : X.t -> X.t -> bool

            val lt_dec : X.t -> X.t -> bool

            val eqb : X.t -> X.t -> bool
           end

          module PX :
           sig
            module MO :
             sig
              module TO :
               sig
                type t = X.t
               end

              module IsTO :
               sig
               end

              module OrderTac :
               sig
               end

              val eq_dec : X.t -> X.t -> bool

              val lt_dec : X.t -> X.t -> bool

              val eqb : X.t -> X.t -> bool
             end
           end

          type key = X.t

          type 'elt t = (X.t * 'elt) list

          val empty : 'a1 t

          val is_empty : 'a1 t -> bool

          val mem : key -> 'a1 t -> bool

          val find : key -> 'a1 t -> 'a1 option

          val add : key -> 'a1 -> 'a1 t -> 'a1 t

          val remove : key -> 'a1 t -> 'a1 t

          val elements : 'a1 t -> 'a1 t

          val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2

          val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool

          val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t

          val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t

          val option_cons :
            key -> 'a1 option -> (key * 'a1) list -> (key * 'a1) list

          val map2_l :
            ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a3 t

          val map2_r :
            ('a1 option -> 'a2 option -> 'a3 option) -> 'a2 t -> 'a3 t

          val map2 :
            ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3
            t

          val combine : 'a1 t -> 'a2 t -> ('a1 option * 'a2 option) t

          val fold_right_pair :
            ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1 * 'a2) list -> 'a3 -> 'a3

          val map2_alt :
            ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t ->
            (key * 'a3) list

          val at_least_one :
            'a1 option -> 'a2 option -> ('a1 option * 'a2 option) option

          val at_least_one_then_f :
            ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 option -> 'a2
            option -> 'a3 option
         end

        type 'elt coq_R_mem =
        | R_mem_0 of 'elt tree
        | R_mem_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
           I.t * bool * 'elt coq_R_mem
        | R_mem_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
        | R_mem_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
           I.t * bool * 'elt coq_R_mem

        val coq_R_mem_rect :
          X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem
          -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree
          -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem
          -> 'a2 -> 'a2) -> 'a1 tree -> bool -> 'a1 coq_R_mem -> 'a2

        val coq_R_mem_rec :
          X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem
          -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree
          -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem
          -> 'a2 -> 'a2) -> 'a1 tree -> bool -> 'a1 coq_R_mem -> 'a2

        type 'elt coq_R_find =
        | R_find_0 of 'elt tree
        | R_find_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
           I.t * 'elt option * 'elt coq_R_find
        | R_find_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
        | R_find_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
           I.t * 'elt option * 'elt coq_R_find

        val coq_R_find_rect :
          X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 option -> 'a1
          coq_R_find -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
          'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree
          -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 option ->
          'a1 coq_R_find -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 option -> 'a1
          coq_R_find -> 'a2

        val coq_R_find_rec :
          X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 option -> 'a1
          coq_R_find -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
          'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree
          -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 option ->
          'a1 coq_R_find -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 option -> 'a1
          coq_R_find -> 'a2

        type 'elt coq_R_bal =
        | R_bal_0 of 'elt tree * key * 'elt * 'elt tree
        | R_bal_1 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
           key * 'elt * 'elt tree * I.t
        | R_bal_2 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
           key * 'elt * 'elt tree * I.t
        | R_bal_3 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
           key * 'elt * 'elt tree * I.t * 'elt tree * key * 'elt * 'elt tree
           * I.t
        | R_bal_4 of 'elt tree * key * 'elt * 'elt tree
        | R_bal_5 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
           key * 'elt * 'elt tree * I.t
        | R_bal_6 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
           key * 'elt * 'elt tree * I.t
        | R_bal_7 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
           key * 'elt * 'elt tree * I.t * 'elt tree * key * 'elt * 'elt tree
           * I.t
        | R_bal_8 of 'elt tree * key * 'elt * 'elt tree

        val coq_R_bal_rect :
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> 'a2) ->
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key
          -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
          key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
          tree -> I.t -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key ->
          'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree
          -> I.t -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          I.t -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ ->
          __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree
          -> __ -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1
          tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree
          -> I.t -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1
          -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 ->
          'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
          tree -> I.t -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree ->
          __ -> __ -> __ -> __ -> 'a2) -> 'a1 tree -> key -> 'a1 -> 'a1 tree
          -> 'a1 tree -> 'a1 coq_R_bal -> 'a2

        val coq_R_bal_rec :
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> 'a2) ->
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key
          -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
          key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
          tree -> I.t -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key ->
          'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree
          -> I.t -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          I.t -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ ->
          __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree
          -> __ -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1
          tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree
          -> I.t -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1
          -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 ->
          'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
          tree -> I.t -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree ->
          __ -> __ -> __ -> __ -> 'a2) -> 'a1 tree -> key -> 'a1 -> 'a1 tree
          -> 'a1 tree -> 'a1 coq_R_bal -> 'a2

        type 'elt coq_R_add =
        | R_add_0 of 'elt tree
        | R_add_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
           I.t * 'elt tree * 'elt coq_R_add
        | R_add_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
        | R_add_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
           I.t * 'elt tree * 'elt coq_R_add

        val coq_R_add_rect :
          key -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
          coq_R_add -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
          'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree
          -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree ->
          'a1 coq_R_add -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1
          coq_R_add -> 'a2

        val coq_R_add_rec :
          key -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
          coq_R_add -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
          'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree
          -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree ->
          'a1 coq_R_add -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1
          coq_R_add -> 'a2

        type 'elt coq_R_remove_min =
        | R_remove_min_0 of 'elt tree * key * 'elt * 'elt tree
        | R_remove_min_1 of 'elt tree * key * 'elt * 'elt tree * 'elt tree
           * key * 'elt * 'elt tree * I.t * ('elt tree * (key * 'elt))
           * 'elt coq_R_remove_min * 'elt tree * (key * 'elt)

        val coq_R_remove_min_rect :
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1 tree ->
          key -> 'a1 -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t
          -> __ -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min -> 'a2 ->
          'a1 tree -> (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> key -> 'a1 ->
          'a1 tree -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min -> 'a2

        val coq_R_remove_min_rec :
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1 tree ->
          key -> 'a1 -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t
          -> __ -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min -> 'a2 ->
          'a1 tree -> (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> key -> 'a1 ->
          'a1 tree -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min -> 'a2

        type 'elt coq_R_merge =
        | R_merge_0 of 'elt tree * 'elt tree
        | R_merge_1 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
           * 'elt tree * I.t
        | R_merge_2 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
           * 'elt tree * I.t * 'elt tree * key * 'elt * 'elt tree * I.t
           * 'elt tree * (key * 'elt) * key * 'elt

        val coq_R_merge_rect :
          ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2) -> ('a1
          tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
          -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1 tree ->
          (key * 'a1) -> __ -> key -> 'a1 -> __ -> 'a2) -> 'a1 tree -> 'a1
          tree -> 'a1 tree -> 'a1 coq_R_merge -> 'a2

        val coq_R_merge_rec :
          ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2) -> ('a1
          tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
          -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1 tree ->
          (key * 'a1) -> __ -> key -> 'a1 -> __ -> 'a2) -> 'a1 tree -> 'a1
          tree -> 'a1 tree -> 'a1 coq_R_merge -> 'a2

        type 'elt coq_R_remove =
        | R_remove_0 of 'elt tree
        | R_remove_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
           I.t * 'elt tree * 'elt coq_R_remove
        | R_remove_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
        | R_remove_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
           I.t * 'elt tree * 'elt coq_R_remove

        val coq_R_remove_rect :
          X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
          coq_R_remove -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
          -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree
          -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1
          coq_R_remove -> 'a2

        val coq_R_remove_rec :
          X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
          coq_R_remove -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
          -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree
          -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1
          coq_R_remove -> 'a2

        type 'elt coq_R_concat =
        | R_concat_0 of 'elt tree * 'elt tree
        | R_concat_1 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
           * 'elt tree * I.t
        | R_concat_2 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
           * 'elt tree * I.t * 'elt tree * key * 'elt * 'elt tree * I.t
           * 'elt tree * (key * 'elt)

        val coq_R_concat_rect :
          ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2) -> ('a1
          tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
          -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1 tree ->
          (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 tree ->
          'a1 coq_R_concat -> 'a2

        val coq_R_concat_rec :
          ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2) -> ('a1
          tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
          -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1 tree ->
          (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 tree ->
          'a1 coq_R_concat -> 'a2

        type 'elt coq_R_split =
        | R_split_0 of 'elt tree
        | R_split_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
           I.t * 'elt triple * 'elt coq_R_split * 'elt tree * 'elt option
           * 'elt tree
        | R_split_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
        | R_split_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
           I.t * 'elt triple * 'elt coq_R_split * 'elt tree * 'elt option
           * 'elt tree

        val coq_R_split_rect :
          X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 triple -> 'a1
          coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __ ->
          'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t ->
          __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
          'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 triple -> 'a1 coq_R_split
          -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __ -> 'a2) -> 'a1
          tree -> 'a1 triple -> 'a1 coq_R_split -> 'a2

        val coq_R_split_rec :
          X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 triple -> 'a1
          coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __ ->
          'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t ->
          __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
          'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 triple -> 'a1 coq_R_split
          -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __ -> 'a2) -> 'a1
          tree -> 'a1 triple -> 'a1 coq_R_split -> 'a2

        type ('elt, 'x) coq_R_map_option =
        | R_map_option_0 of 'elt tree
        | R_map_option_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * I.t * 'x * 'x tree * ('elt, 'x) coq_R_map_option * 'x tree
           * ('elt, 'x) coq_R_map_option
        | R_map_option_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * I.t * 'x tree * ('elt, 'x) coq_R_map_option * 'x tree
           * ('elt, 'x) coq_R_map_option

        val coq_R_map_option_rect :
          (key -> 'a1 -> 'a2 option) -> ('a1 tree -> __ -> 'a3) -> ('a1 tree
          -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2 -> __ ->
          'a2 tree -> ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1,
          'a2) coq_R_map_option -> 'a3 -> 'a3) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2 tree -> ('a1, 'a2)
          coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2) coq_R_map_option
          -> 'a3 -> 'a3) -> 'a1 tree -> 'a2 tree -> ('a1, 'a2)
          coq_R_map_option -> 'a3

        val coq_R_map_option_rec :
          (key -> 'a1 -> 'a2 option) -> ('a1 tree -> __ -> 'a3) -> ('a1 tree
          -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2 -> __ ->
          'a2 tree -> ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1,
          'a2) coq_R_map_option -> 'a3 -> 'a3) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2 tree -> ('a1, 'a2)
          coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2) coq_R_map_option
          -> 'a3 -> 'a3) -> 'a1 tree -> 'a2 tree -> ('a1, 'a2)
          coq_R_map_option -> 'a3

        type ('elt, 'x0, 'x) coq_R_map2_opt =
        | R_map2_opt_0 of 'elt tree * 'x0 tree
        | R_map2_opt_1 of 'elt tree * 'x0 tree * 'elt tree * key * 'elt
           * 'elt tree * I.t
        | R_map2_opt_2 of 'elt tree * 'x0 tree * 'elt tree * key * 'elt
           * 'elt tree * I.t * 'x0 tree * key * 'x0 * 'x0 tree * I.t
           * 'x0 tree * 'x0 option * 'x0 tree * 'x * 'x tree
           * ('elt, 'x0, 'x) coq_R_map2_opt * 'x tree
           * ('elt, 'x0, 'x) coq_R_map2_opt
        | R_map2_opt_3 of 'elt tree * 'x0 tree * 'elt tree * key * 'elt
           * 'elt tree * I.t * 'x0 tree * key * 'x0 * 'x0 tree * I.t
           * 'x0 tree * 'x0 option * 'x0 tree * 'x tree
           * ('elt, 'x0, 'x) coq_R_map2_opt * 'x tree
           * ('elt, 'x0, 'x) coq_R_map2_opt

        val coq_R_map2_opt_rect :
          (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree)
          -> ('a2 tree -> 'a3 tree) -> ('a1 tree -> 'a2 tree -> __ -> 'a4) ->
          ('a1 tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t
          -> __ -> __ -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> I.t -> __ -> 'a2 tree -> key -> 'a2 -> 'a2 tree
          -> I.t -> __ -> 'a2 tree -> 'a2 option -> 'a2 tree -> __ -> 'a3 ->
          __ -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a3 tree
          -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> ('a1 tree ->
          'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2
          tree -> key -> 'a2 -> 'a2 tree -> I.t -> __ -> 'a2 tree -> 'a2
          option -> 'a2 tree -> __ -> __ -> 'a3 tree -> ('a1, 'a2, 'a3)
          coq_R_map2_opt -> 'a4 -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt
          -> 'a4 -> 'a4) -> 'a1 tree -> 'a2 tree -> 'a3 tree -> ('a1, 'a2,
          'a3) coq_R_map2_opt -> 'a4

        val coq_R_map2_opt_rec :
          (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree)
          -> ('a2 tree -> 'a3 tree) -> ('a1 tree -> 'a2 tree -> __ -> 'a4) ->
          ('a1 tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t
          -> __ -> __ -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> I.t -> __ -> 'a2 tree -> key -> 'a2 -> 'a2 tree
          -> I.t -> __ -> 'a2 tree -> 'a2 option -> 'a2 tree -> __ -> 'a3 ->
          __ -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a3 tree
          -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> ('a1 tree ->
          'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2
          tree -> key -> 'a2 -> 'a2 tree -> I.t -> __ -> 'a2 tree -> 'a2
          option -> 'a2 tree -> __ -> __ -> 'a3 tree -> ('a1, 'a2, 'a3)
          coq_R_map2_opt -> 'a4 -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt
          -> 'a4 -> 'a4) -> 'a1 tree -> 'a2 tree -> 'a3 tree -> ('a1, 'a2,
          'a3) coq_R_map2_opt -> 'a4

        val fold' : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2

        val flatten_e : 'a1 enumeration -> (key * 'a1) list
       end
     end

    module II :
     sig
      type coq_ExprI =
      | EI0
      | EI1
      | EI2
      | EI3
      | EIadd of coq_ExprI * coq_ExprI
      | EIopp of coq_ExprI
      | EIsub of coq_ExprI * coq_ExprI
      | EImul of coq_ExprI * coq_ExprI
      | EImax of coq_ExprI * coq_ExprI
      | EIraw of I.t

      val coq_ExprI_rect :
        'a1 -> 'a1 -> 'a1 -> 'a1 -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 ->
        'a1) -> (coq_ExprI -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI
        -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) ->
        (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) -> (I.t -> 'a1) ->
        coq_ExprI -> 'a1

      val coq_ExprI_rec :
        'a1 -> 'a1 -> 'a1 -> 'a1 -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 ->
        'a1) -> (coq_ExprI -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI
        -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) ->
        (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) -> (I.t -> 'a1) ->
        coq_ExprI -> 'a1

      type coq_ExprZ =
      | EZadd of coq_ExprZ * coq_ExprZ
      | EZopp of coq_ExprZ
      | EZsub of coq_ExprZ * coq_ExprZ
      | EZmul of coq_ExprZ * coq_ExprZ
      | EZmax of coq_ExprZ * coq_ExprZ
      | EZofI of coq_ExprI
      | EZraw of z

      val coq_ExprZ_rect :
        (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 ->
        'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ
        -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ
        -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1) -> (z -> 'a1) -> coq_ExprZ -> 'a1

      val coq_ExprZ_rec :
        (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 ->
        'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ
        -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ
        -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1) -> (z -> 'a1) -> coq_ExprZ -> 'a1

      type coq_ExprP =
      | EPeq of coq_ExprZ * coq_ExprZ
      | EPlt of coq_ExprZ * coq_ExprZ
      | EPle of coq_ExprZ * coq_ExprZ
      | EPgt of coq_ExprZ * coq_ExprZ
      | EPge of coq_ExprZ * coq_ExprZ
      | EPimpl of coq_ExprP * coq_ExprP
      | EPequiv of coq_ExprP * coq_ExprP
      | EPand of coq_ExprP * coq_ExprP
      | EPor of coq_ExprP * coq_ExprP
      | EPneg of coq_ExprP
      | EPraw

      val coq_ExprP_rect :
        (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
        (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
        (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP ->
        'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) ->
        (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 ->
        coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> 'a1) -> (__ -> 'a1)
        -> coq_ExprP -> 'a1

      val coq_ExprP_rec :
        (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
        (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
        (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP ->
        'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) ->
        (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 ->
        coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> 'a1) -> (__ -> 'a1)
        -> coq_ExprP -> 'a1

      val ei2i : coq_ExprI -> I.t

      val ez2z : coq_ExprZ -> z

      val norm_ei : coq_ExprI -> coq_ExprZ

      val norm_ez : coq_ExprZ -> coq_ExprZ

      val norm_ep : coq_ExprP -> coq_ExprP
     end
   end

  type 'elt bbst =
    'elt AvlProofs.Raw.tree
    (* singleton inductive, whose constructor was Bbst *)

  val this : 'a1 bbst -> 'a1 AvlProofs.Raw.tree

  type 'elt t = 'elt bbst

  type key = E.t

  val empty : 'a1 t

  val is_empty : 'a1 t -> bool

  val add : key -> 'a1 -> 'a1 t -> 'a1 t

  val remove : key -> 'a1 t -> 'a1 t

  val mem : key -> 'a1 t -> bool

  val find : key -> 'a1 t -> 'a1 option

  val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t

  val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t

  val map2 :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t

  val elements : 'a1 t -> (key * 'a1) list

  val cardinal : 'a1 t -> nat

  val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2

  val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool
 end

module Make :
 functor (X:Coq_OrderedType) ->
 sig
  module E :
   sig
    type t = X.t

    val compare : t -> t -> t compare2

    val eq_dec : t -> t -> bool
   end

  module AvlProofs :
   sig
    module Raw :
     sig
      type key = X.t

      type 'elt tree =
      | Leaf
      | Node of 'elt tree * key * 'elt * 'elt tree * Z_as_Int.t

      val tree_rect :
        'a2 -> ('a1 tree -> 'a2 -> key -> 'a1 -> 'a1 tree -> 'a2 ->
        Z_as_Int.t -> 'a2) -> 'a1 tree -> 'a2

      val tree_rec :
        'a2 -> ('a1 tree -> 'a2 -> key -> 'a1 -> 'a1 tree -> 'a2 ->
        Z_as_Int.t -> 'a2) -> 'a1 tree -> 'a2

      val height : 'a1 tree -> Z_as_Int.t

      val cardinal : 'a1 tree -> nat

      val empty : 'a1 tree

      val is_empty : 'a1 tree -> bool

      val mem : X.t -> 'a1 tree -> bool

      val find : X.t -> 'a1 tree -> 'a1 option

      val create : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

      val assert_false : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

      val bal : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

      val add : key -> 'a1 -> 'a1 tree -> 'a1 tree

      val remove_min :
        'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree * (key * 'a1)

      val merge : 'a1 tree -> 'a1 tree -> 'a1 tree

      val remove : X.t -> 'a1 tree -> 'a1 tree

      val join : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

      type 'elt triple = { t_left : 'elt tree; t_opt : 'elt option;
                           t_right : 'elt tree }

      val t_left : 'a1 triple -> 'a1 tree

      val t_opt : 'a1 triple -> 'a1 option

      val t_right : 'a1 triple -> 'a1 tree

      val split : X.t -> 'a1 tree -> 'a1 triple

      val concat : 'a1 tree -> 'a1 tree -> 'a1 tree

      val elements_aux : (key * 'a1) list -> 'a1 tree -> (key * 'a1) list

      val elements : 'a1 tree -> (key * 'a1) list

      val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2

      type 'elt enumeration =
      | End
      | More of key * 'elt * 'elt tree * 'elt enumeration

      val enumeration_rect :
        'a2 -> (key -> 'a1 -> 'a1 tree -> 'a1 enumeration -> 'a2 -> 'a2) ->
        'a1 enumeration -> 'a2

      val enumeration_rec :
        'a2 -> (key -> 'a1 -> 'a1 tree -> 'a1 enumeration -> 'a2 -> 'a2) ->
        'a1 enumeration -> 'a2

      val cons : 'a1 tree -> 'a1 enumeration -> 'a1 enumeration

      val equal_more :
        ('a1 -> 'a1 -> bool) -> X.t -> 'a1 -> ('a1 enumeration -> bool) ->
        'a1 enumeration -> bool

      val equal_cont :
        ('a1 -> 'a1 -> bool) -> 'a1 tree -> ('a1 enumeration -> bool) -> 'a1
        enumeration -> bool

      val equal_end : 'a1 enumeration -> bool

      val equal : ('a1 -> 'a1 -> bool) -> 'a1 tree -> 'a1 tree -> bool

      val map : ('a1 -> 'a2) -> 'a1 tree -> 'a2 tree

      val mapi : (key -> 'a1 -> 'a2) -> 'a1 tree -> 'a2 tree

      val map_option : (key -> 'a1 -> 'a2 option) -> 'a1 tree -> 'a2 tree

      val map2_opt :
        (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree) ->
        ('a2 tree -> 'a3 tree) -> 'a1 tree -> 'a2 tree -> 'a3 tree

      val map2 :
        ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 tree -> 'a2 tree ->
        'a3 tree

      module Proofs :
       sig
        module MX :
         sig
          module TO :
           sig
            type t = X.t
           end

          module IsTO :
           sig
           end

          module OrderTac :
           sig
           end

          val eq_dec : X.t -> X.t -> bool

          val lt_dec : X.t -> X.t -> bool

          val eqb : X.t -> X.t -> bool
         end

        module PX :
         sig
          module MO :
           sig
            module TO :
             sig
              type t = X.t
             end

            module IsTO :
             sig
             end

            module OrderTac :
             sig
             end

            val eq_dec : X.t -> X.t -> bool

            val lt_dec : X.t -> X.t -> bool

            val eqb : X.t -> X.t -> bool
           end
         end

        module L :
         sig
          module MX :
           sig
            module TO :
             sig
              type t = X.t
             end

            module IsTO :
             sig
             end

            module OrderTac :
             sig
             end

            val eq_dec : X.t -> X.t -> bool

            val lt_dec : X.t -> X.t -> bool

            val eqb : X.t -> X.t -> bool
           end

          module PX :
           sig
            module MO :
             sig
              module TO :
               sig
                type t = X.t
               end

              module IsTO :
               sig
               end

              module OrderTac :
               sig
               end

              val eq_dec : X.t -> X.t -> bool

              val lt_dec : X.t -> X.t -> bool

              val eqb : X.t -> X.t -> bool
             end
           end

          type key = X.t

          type 'elt t = (X.t * 'elt) list

          val empty : 'a1 t

          val is_empty : 'a1 t -> bool

          val mem : key -> 'a1 t -> bool

          val find : key -> 'a1 t -> 'a1 option

          val add : key -> 'a1 -> 'a1 t -> 'a1 t

          val remove : key -> 'a1 t -> 'a1 t

          val elements : 'a1 t -> 'a1 t

          val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2

          val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool

          val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t

          val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t

          val option_cons :
            key -> 'a1 option -> (key * 'a1) list -> (key * 'a1) list

          val map2_l :
            ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a3 t

          val map2_r :
            ('a1 option -> 'a2 option -> 'a3 option) -> 'a2 t -> 'a3 t

          val map2 :
            ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3
            t

          val combine : 'a1 t -> 'a2 t -> ('a1 option * 'a2 option) t

          val fold_right_pair :
            ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1 * 'a2) list -> 'a3 -> 'a3

          val map2_alt :
            ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t ->
            (key * 'a3) list

          val at_least_one :
            'a1 option -> 'a2 option -> ('a1 option * 'a2 option) option

          val at_least_one_then_f :
            ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 option -> 'a2
            option -> 'a3 option
         end

        type 'elt coq_R_mem =
        | R_mem_0 of 'elt tree
        | R_mem_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * bool * 'elt coq_R_mem
        | R_mem_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t
        | R_mem_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * bool * 'elt coq_R_mem

        val coq_R_mem_rect :
          X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> bool -> 'a1
          coq_R_mem -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
          'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
          'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __
          -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2) -> 'a1 tree -> bool -> 'a1
          coq_R_mem -> 'a2

        val coq_R_mem_rec :
          X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> bool -> 'a1
          coq_R_mem -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
          'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
          'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __
          -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2) -> 'a1 tree -> bool -> 'a1
          coq_R_mem -> 'a2

        type 'elt coq_R_find =
        | R_find_0 of 'elt tree
        | R_find_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt option * 'elt coq_R_find
        | R_find_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t
        | R_find_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt option * 'elt coq_R_find

        val coq_R_find_rect :
          X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 option ->
          'a1 coq_R_find -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1
          tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ ->
          __ -> __ -> 'a1 option -> 'a1 coq_R_find -> 'a2 -> 'a2) -> 'a1 tree
          -> 'a1 option -> 'a1 coq_R_find -> 'a2

        val coq_R_find_rec :
          X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 option ->
          'a1 coq_R_find -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1
          tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ ->
          __ -> __ -> 'a1 option -> 'a1 coq_R_find -> 'a2 -> 'a2) -> 'a1 tree
          -> 'a1 option -> 'a1 coq_R_find -> 'a2

        type 'elt coq_R_bal =
        | R_bal_0 of 'elt tree * key * 'elt * 'elt tree
        | R_bal_1 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
           key * 'elt * 'elt tree * Z_as_Int.t
        | R_bal_2 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
           key * 'elt * 'elt tree * Z_as_Int.t
        | R_bal_3 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
           key * 'elt * 'elt tree * Z_as_Int.t * 'elt tree * key * 'elt
           * 'elt tree * Z_as_Int.t
        | R_bal_4 of 'elt tree * key * 'elt * 'elt tree
        | R_bal_5 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
           key * 'elt * 'elt tree * Z_as_Int.t
        | R_bal_6 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
           key * 'elt * 'elt tree * Z_as_Int.t
        | R_bal_7 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
           key * 'elt * 'elt tree * Z_as_Int.t * 'elt tree * key * 'elt
           * 'elt tree * Z_as_Int.t
        | R_bal_8 of 'elt tree * key * 'elt * 'elt tree

        val coq_R_bal_rect :
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> 'a2) ->
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key
          -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1
          tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> __ -> 'a2) ->
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key
          -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2) -> ('a1 tree ->
          key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> __ -> 'a2) ->
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ ->
          'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __
          -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ ->
          __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __
          -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t ->
          __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
          -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ ->
          __ -> __ -> 'a2) -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree
          -> 'a1 coq_R_bal -> 'a2

        val coq_R_bal_rec :
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> 'a2) ->
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key
          -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1
          tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> __ -> 'a2) ->
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key
          -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2) -> ('a1 tree ->
          key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> __ -> 'a2) ->
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ ->
          'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __
          -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ ->
          __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __
          -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t ->
          __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
          -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ ->
          __ -> __ -> 'a2) -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree
          -> 'a1 coq_R_bal -> 'a2

        type 'elt coq_R_add =
        | R_add_0 of 'elt tree
        | R_add_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt tree * 'elt coq_R_add
        | R_add_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t
        | R_add_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt tree * 'elt coq_R_add

        val coq_R_add_rect :
          key -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree
          -> 'a1 coq_R_add -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1
          tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ ->
          __ -> __ -> 'a1 tree -> 'a1 coq_R_add -> 'a2 -> 'a2) -> 'a1 tree ->
          'a1 tree -> 'a1 coq_R_add -> 'a2

        val coq_R_add_rec :
          key -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree
          -> 'a1 coq_R_add -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1
          tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ ->
          __ -> __ -> 'a1 tree -> 'a1 coq_R_add -> 'a2 -> 'a2) -> 'a1 tree ->
          'a1 tree -> 'a1 coq_R_add -> 'a2

        type 'elt coq_R_remove_min =
        | R_remove_min_0 of 'elt tree * key * 'elt * 'elt tree
        | R_remove_min_1 of 'elt tree * key * 'elt * 'elt tree * 'elt tree
           * key * 'elt * 'elt tree * Z_as_Int.t * ('elt tree * (key * 'elt))
           * 'elt coq_R_remove_min * 'elt tree * (key * 'elt)

        val coq_R_remove_min_rect :
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1 tree ->
          key -> 'a1 -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> ('a1 tree * (key * 'a1)) -> 'a1
          coq_R_remove_min -> 'a2 -> 'a1 tree -> (key * 'a1) -> __ -> 'a2) ->
          'a1 tree -> key -> 'a1 -> 'a1 tree -> ('a1 tree * (key * 'a1)) ->
          'a1 coq_R_remove_min -> 'a2

        val coq_R_remove_min_rec :
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1 tree ->
          key -> 'a1 -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> ('a1 tree * (key * 'a1)) -> 'a1
          coq_R_remove_min -> 'a2 -> 'a1 tree -> (key * 'a1) -> __ -> 'a2) ->
          'a1 tree -> key -> 'a1 -> 'a1 tree -> ('a1 tree * (key * 'a1)) ->
          'a1 coq_R_remove_min -> 'a2

        type 'elt coq_R_merge =
        | R_merge_0 of 'elt tree * 'elt tree
        | R_merge_1 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
           * 'elt tree * Z_as_Int.t
        | R_merge_2 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
           * 'elt tree * Z_as_Int.t * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt tree * (key * 'elt) * key * 'elt

        val coq_R_merge_rect :
          ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2) ->
          ('a1 tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> 'a1 tree -> (key * 'a1) -> __ -> key -> 'a1 ->
          __ -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_merge
          -> 'a2

        val coq_R_merge_rec :
          ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2) ->
          ('a1 tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> 'a1 tree -> (key * 'a1) -> __ -> key -> 'a1 ->
          __ -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_merge
          -> 'a2

        type 'elt coq_R_remove =
        | R_remove_0 of 'elt tree
        | R_remove_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt tree * 'elt coq_R_remove
        | R_remove_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t
        | R_remove_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt tree * 'elt coq_R_remove

        val coq_R_remove_rect :
          X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
          coq_R_remove -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
          -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
          'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __
          -> 'a1 tree -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1 tree -> 'a1
          tree -> 'a1 coq_R_remove -> 'a2

        val coq_R_remove_rec :
          X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
          coq_R_remove -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
          -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
          'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __
          -> 'a1 tree -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1 tree -> 'a1
          tree -> 'a1 coq_R_remove -> 'a2

        type 'elt coq_R_concat =
        | R_concat_0 of 'elt tree * 'elt tree
        | R_concat_1 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
           * 'elt tree * Z_as_Int.t
        | R_concat_2 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
           * 'elt tree * Z_as_Int.t * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt tree * (key * 'elt)

        val coq_R_concat_rect :
          ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2) ->
          ('a1 tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> 'a1 tree -> (key * 'a1) -> __ -> 'a2) -> 'a1
          tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_concat -> 'a2

        val coq_R_concat_rec :
          ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2) ->
          ('a1 tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> 'a1 tree -> (key * 'a1) -> __ -> 'a2) -> 'a1
          tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_concat -> 'a2

        type 'elt coq_R_split =
        | R_split_0 of 'elt tree
        | R_split_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt triple * 'elt coq_R_split * 'elt tree
           * 'elt option * 'elt tree
        | R_split_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t
        | R_split_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt triple * 'elt coq_R_split * 'elt tree
           * 'elt option * 'elt tree

        val coq_R_split_rect :
          X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 triple ->
          'a1 coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __
          -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1
          triple -> 'a1 coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1
          tree -> __ -> 'a2) -> 'a1 tree -> 'a1 triple -> 'a1 coq_R_split ->
          'a2

        val coq_R_split_rec :
          X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 triple ->
          'a1 coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __
          -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1
          triple -> 'a1 coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1
          tree -> __ -> 'a2) -> 'a1 tree -> 'a1 triple -> 'a1 coq_R_split ->
          'a2

        type ('elt, 'x) coq_R_map_option =
        | R_map_option_0 of 'elt tree
        | R_map_option_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'x * 'x tree * ('elt, 'x) coq_R_map_option
           * 'x tree * ('elt, 'x) coq_R_map_option
        | R_map_option_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'x tree * ('elt, 'x) coq_R_map_option * 'x tree
           * ('elt, 'x) coq_R_map_option

        val coq_R_map_option_rect :
          (key -> 'a1 -> 'a2 option) -> ('a1 tree -> __ -> 'a3) -> ('a1 tree
          -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 ->
          __ -> 'a2 tree -> ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree ->
          ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a3) -> ('a1 tree -> 'a1 tree
          -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2 tree ->
          ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2)
          coq_R_map_option -> 'a3 -> 'a3) -> 'a1 tree -> 'a2 tree -> ('a1,
          'a2) coq_R_map_option -> 'a3

        val coq_R_map_option_rec :
          (key -> 'a1 -> 'a2 option) -> ('a1 tree -> __ -> 'a3) -> ('a1 tree
          -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 ->
          __ -> 'a2 tree -> ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree ->
          ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a3) -> ('a1 tree -> 'a1 tree
          -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2 tree ->
          ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2)
          coq_R_map_option -> 'a3 -> 'a3) -> 'a1 tree -> 'a2 tree -> ('a1,
          'a2) coq_R_map_option -> 'a3

        type ('elt, 'x0, 'x) coq_R_map2_opt =
        | R_map2_opt_0 of 'elt tree * 'x0 tree
        | R_map2_opt_1 of 'elt tree * 'x0 tree * 'elt tree * key * 'elt
           * 'elt tree * Z_as_Int.t
        | R_map2_opt_2 of 'elt tree * 'x0 tree * 'elt tree * key * 'elt
           * 'elt tree * Z_as_Int.t * 'x0 tree * key * 'x0 * 'x0 tree
           * Z_as_Int.t * 'x0 tree * 'x0 option * 'x0 tree * 'x * 'x tree
           * ('elt, 'x0, 'x) coq_R_map2_opt * 'x tree
           * ('elt, 'x0, 'x) coq_R_map2_opt
        | R_map2_opt_3 of 'elt tree * 'x0 tree * 'elt tree * key * 'elt
           * 'elt tree * Z_as_Int.t * 'x0 tree * key * 'x0 * 'x0 tree
           * Z_as_Int.t * 'x0 tree * 'x0 option * 'x0 tree * 'x tree
           * ('elt, 'x0, 'x) coq_R_map2_opt * 'x tree
           * ('elt, 'x0, 'x) coq_R_map2_opt

        val coq_R_map2_opt_rect :
          (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree)
          -> ('a2 tree -> 'a3 tree) -> ('a1 tree -> 'a2 tree -> __ -> 'a4) ->
          ('a1 tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> __ -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree
          -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 tree -> key ->
          'a2 -> 'a2 tree -> Z_as_Int.t -> __ -> 'a2 tree -> 'a2 option ->
          'a2 tree -> __ -> 'a3 -> __ -> 'a3 tree -> ('a1, 'a2, 'a3)
          coq_R_map2_opt -> 'a4 -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt
          -> 'a4 -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree -> key -> 'a1
          -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 tree -> key -> 'a2 -> 'a2
          tree -> Z_as_Int.t -> __ -> 'a2 tree -> 'a2 option -> 'a2 tree ->
          __ -> __ -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 ->
          'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> 'a1
          tree -> 'a2 tree -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt ->
          'a4

        val coq_R_map2_opt_rec :
          (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree)
          -> ('a2 tree -> 'a3 tree) -> ('a1 tree -> 'a2 tree -> __ -> 'a4) ->
          ('a1 tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> __ -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree
          -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 tree -> key ->
          'a2 -> 'a2 tree -> Z_as_Int.t -> __ -> 'a2 tree -> 'a2 option ->
          'a2 tree -> __ -> 'a3 -> __ -> 'a3 tree -> ('a1, 'a2, 'a3)
          coq_R_map2_opt -> 'a4 -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt
          -> 'a4 -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree -> key -> 'a1
          -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 tree -> key -> 'a2 -> 'a2
          tree -> Z_as_Int.t -> __ -> 'a2 tree -> 'a2 option -> 'a2 tree ->
          __ -> __ -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 ->
          'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> 'a1
          tree -> 'a2 tree -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt ->
          'a4

        val fold' : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2

        val flatten_e : 'a1 enumeration -> (key * 'a1) list
       end
     end

    module II :
     sig
      type coq_ExprI =
      | EI0
      | EI1
      | EI2
      | EI3
      | EIadd of coq_ExprI * coq_ExprI
      | EIopp of coq_ExprI
      | EIsub of coq_ExprI * coq_ExprI
      | EImul of coq_ExprI * coq_ExprI
      | EImax of coq_ExprI * coq_ExprI
      | EIraw of Z_as_Int.t

      val coq_ExprI_rect :
        'a1 -> 'a1 -> 'a1 -> 'a1 -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 ->
        'a1) -> (coq_ExprI -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI
        -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) ->
        (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) -> (Z_as_Int.t -> 'a1)
        -> coq_ExprI -> 'a1

      val coq_ExprI_rec :
        'a1 -> 'a1 -> 'a1 -> 'a1 -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 ->
        'a1) -> (coq_ExprI -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI
        -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) ->
        (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) -> (Z_as_Int.t -> 'a1)
        -> coq_ExprI -> 'a1

      type coq_ExprZ =
      | EZadd of coq_ExprZ * coq_ExprZ
      | EZopp of coq_ExprZ
      | EZsub of coq_ExprZ * coq_ExprZ
      | EZmul of coq_ExprZ * coq_ExprZ
      | EZmax of coq_ExprZ * coq_ExprZ
      | EZofI of coq_ExprI
      | EZraw of z

      val coq_ExprZ_rect :
        (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 ->
        'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ
        -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ
        -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1) -> (z -> 'a1) -> coq_ExprZ -> 'a1

      val coq_ExprZ_rec :
        (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 ->
        'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ
        -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ
        -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1) -> (z -> 'a1) -> coq_ExprZ -> 'a1

      type coq_ExprP =
      | EPeq of coq_ExprZ * coq_ExprZ
      | EPlt of coq_ExprZ * coq_ExprZ
      | EPle of coq_ExprZ * coq_ExprZ
      | EPgt of coq_ExprZ * coq_ExprZ
      | EPge of coq_ExprZ * coq_ExprZ
      | EPimpl of coq_ExprP * coq_ExprP
      | EPequiv of coq_ExprP * coq_ExprP
      | EPand of coq_ExprP * coq_ExprP
      | EPor of coq_ExprP * coq_ExprP
      | EPneg of coq_ExprP
      | EPraw

      val coq_ExprP_rect :
        (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
        (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
        (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP ->
        'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) ->
        (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 ->
        coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> 'a1) -> (__ -> 'a1)
        -> coq_ExprP -> 'a1

      val coq_ExprP_rec :
        (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
        (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
        (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP ->
        'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) ->
        (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 ->
        coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> 'a1) -> (__ -> 'a1)
        -> coq_ExprP -> 'a1

      val ei2i : coq_ExprI -> Z_as_Int.t

      val ez2z : coq_ExprZ -> z

      val norm_ei : coq_ExprI -> coq_ExprZ

      val norm_ez : coq_ExprZ -> coq_ExprZ

      val norm_ep : coq_ExprP -> coq_ExprP
     end
   end

  type 'elt bbst =
    'elt AvlProofs.Raw.tree
    (* singleton inductive, whose constructor was Bbst *)

  val this : 'a1 bbst -> 'a1 AvlProofs.Raw.tree

  type 'elt t = 'elt bbst

  type key = E.t

  val empty : 'a1 t

  val is_empty : 'a1 t -> bool

  val add : key -> 'a1 -> 'a1 t -> 'a1 t

  val remove : key -> 'a1 t -> 'a1 t

  val mem : key -> 'a1 t -> bool

  val find : key -> 'a1 t -> 'a1 option

  val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t

  val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t

  val map2 :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t

  val elements : 'a1 t -> (key * 'a1) list

  val cardinal : 'a1 t -> nat

  val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2

  val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool
 end

module StringMap :
 sig
  module E :
   sig
    type t = char list

    val compare : char list -> char list -> char list compare2

    val eq_dec : char list -> char list -> bool
   end

  module AvlProofs :
   sig
    module Raw :
     sig
      type key = char list

      type 'elt tree =
      | Leaf
      | Node of 'elt tree * key * 'elt * 'elt tree * Z_as_Int.t

      val tree_rect :
        'a2 -> ('a1 tree -> 'a2 -> key -> 'a1 -> 'a1 tree -> 'a2 ->
        Z_as_Int.t -> 'a2) -> 'a1 tree -> 'a2

      val tree_rec :
        'a2 -> ('a1 tree -> 'a2 -> key -> 'a1 -> 'a1 tree -> 'a2 ->
        Z_as_Int.t -> 'a2) -> 'a1 tree -> 'a2

      val height : 'a1 tree -> Z_as_Int.t

      val cardinal : 'a1 tree -> nat

      val empty : 'a1 tree

      val is_empty : 'a1 tree -> bool

      val mem : char list -> 'a1 tree -> bool

      val find : char list -> 'a1 tree -> 'a1 option

      val create : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

      val assert_false : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

      val bal : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

      val add : key -> 'a1 -> 'a1 tree -> 'a1 tree

      val remove_min :
        'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree * (key * 'a1)

      val merge : 'a1 tree -> 'a1 tree -> 'a1 tree

      val remove : char list -> 'a1 tree -> 'a1 tree

      val join : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree

      type 'elt triple = { t_left : 'elt tree; t_opt : 'elt option;
                           t_right : 'elt tree }

      val t_left : 'a1 triple -> 'a1 tree

      val t_opt : 'a1 triple -> 'a1 option

      val t_right : 'a1 triple -> 'a1 tree

      val split : char list -> 'a1 tree -> 'a1 triple

      val concat : 'a1 tree -> 'a1 tree -> 'a1 tree

      val elements_aux : (key * 'a1) list -> 'a1 tree -> (key * 'a1) list

      val elements : 'a1 tree -> (key * 'a1) list

      val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2

      type 'elt enumeration =
      | End
      | More of key * 'elt * 'elt tree * 'elt enumeration

      val enumeration_rect :
        'a2 -> (key -> 'a1 -> 'a1 tree -> 'a1 enumeration -> 'a2 -> 'a2) ->
        'a1 enumeration -> 'a2

      val enumeration_rec :
        'a2 -> (key -> 'a1 -> 'a1 tree -> 'a1 enumeration -> 'a2 -> 'a2) ->
        'a1 enumeration -> 'a2

      val cons : 'a1 tree -> 'a1 enumeration -> 'a1 enumeration

      val equal_more :
        ('a1 -> 'a1 -> bool) -> char list -> 'a1 -> ('a1 enumeration -> bool)
        -> 'a1 enumeration -> bool

      val equal_cont :
        ('a1 -> 'a1 -> bool) -> 'a1 tree -> ('a1 enumeration -> bool) -> 'a1
        enumeration -> bool

      val equal_end : 'a1 enumeration -> bool

      val equal : ('a1 -> 'a1 -> bool) -> 'a1 tree -> 'a1 tree -> bool

      val map : ('a1 -> 'a2) -> 'a1 tree -> 'a2 tree

      val mapi : (key -> 'a1 -> 'a2) -> 'a1 tree -> 'a2 tree

      val map_option : (key -> 'a1 -> 'a2 option) -> 'a1 tree -> 'a2 tree

      val map2_opt :
        (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree) ->
        ('a2 tree -> 'a3 tree) -> 'a1 tree -> 'a2 tree -> 'a3 tree

      val map2 :
        ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 tree -> 'a2 tree ->
        'a3 tree

      module Proofs :
       sig
        module MX :
         sig
          module TO :
           sig
            type t = char list
           end

          module IsTO :
           sig
           end

          module OrderTac :
           sig
           end

          val eq_dec : char list -> char list -> bool

          val lt_dec : char list -> char list -> bool

          val eqb : char list -> char list -> bool
         end

        module PX :
         sig
          module MO :
           sig
            module TO :
             sig
              type t = char list
             end

            module IsTO :
             sig
             end

            module OrderTac :
             sig
             end

            val eq_dec : char list -> char list -> bool

            val lt_dec : char list -> char list -> bool

            val eqb : char list -> char list -> bool
           end
         end

        module L :
         sig
          module MX :
           sig
            module TO :
             sig
              type t = char list
             end

            module IsTO :
             sig
             end

            module OrderTac :
             sig
             end

            val eq_dec : char list -> char list -> bool

            val lt_dec : char list -> char list -> bool

            val eqb : char list -> char list -> bool
           end

          module PX :
           sig
            module MO :
             sig
              module TO :
               sig
                type t = char list
               end

              module IsTO :
               sig
               end

              module OrderTac :
               sig
               end

              val eq_dec : char list -> char list -> bool

              val lt_dec : char list -> char list -> bool

              val eqb : char list -> char list -> bool
             end
           end

          type key = char list

          type 'elt t = (char list * 'elt) list

          val empty : 'a1 t

          val is_empty : 'a1 t -> bool

          val mem : key -> 'a1 t -> bool

          val find : key -> 'a1 t -> 'a1 option

          val add : key -> 'a1 -> 'a1 t -> 'a1 t

          val remove : key -> 'a1 t -> 'a1 t

          val elements : 'a1 t -> 'a1 t

          val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2

          val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool

          val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t

          val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t

          val option_cons :
            key -> 'a1 option -> (key * 'a1) list -> (key * 'a1) list

          val map2_l :
            ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a3 t

          val map2_r :
            ('a1 option -> 'a2 option -> 'a3 option) -> 'a2 t -> 'a3 t

          val map2 :
            ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3
            t

          val combine : 'a1 t -> 'a2 t -> ('a1 option * 'a2 option) t

          val fold_right_pair :
            ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1 * 'a2) list -> 'a3 -> 'a3

          val map2_alt :
            ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t ->
            (key * 'a3) list

          val at_least_one :
            'a1 option -> 'a2 option -> ('a1 option * 'a2 option) option

          val at_least_one_then_f :
            ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 option -> 'a2
            option -> 'a3 option
         end

        type 'elt coq_R_mem =
        | R_mem_0 of 'elt tree
        | R_mem_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * bool * 'elt coq_R_mem
        | R_mem_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t
        | R_mem_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * bool * 'elt coq_R_mem

        val coq_R_mem_rect :
          char list -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> bool ->
          'a1 coq_R_mem -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
          -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
          'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __
          -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2) -> 'a1 tree -> bool -> 'a1
          coq_R_mem -> 'a2

        val coq_R_mem_rec :
          char list -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> bool ->
          'a1 coq_R_mem -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
          -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
          'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __
          -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2) -> 'a1 tree -> bool -> 'a1
          coq_R_mem -> 'a2

        type 'elt coq_R_find =
        | R_find_0 of 'elt tree
        | R_find_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt option * 'elt coq_R_find
        | R_find_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t
        | R_find_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt option * 'elt coq_R_find

        val coq_R_find_rect :
          char list -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1
          option -> 'a1 coq_R_find -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) ->
          ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __
          -> __ -> __ -> 'a1 option -> 'a1 coq_R_find -> 'a2 -> 'a2) -> 'a1
          tree -> 'a1 option -> 'a1 coq_R_find -> 'a2

        val coq_R_find_rec :
          char list -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1
          option -> 'a1 coq_R_find -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) ->
          ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __
          -> __ -> __ -> 'a1 option -> 'a1 coq_R_find -> 'a2 -> 'a2) -> 'a1
          tree -> 'a1 option -> 'a1 coq_R_find -> 'a2

        type 'elt coq_R_bal =
        | R_bal_0 of 'elt tree * key * 'elt * 'elt tree
        | R_bal_1 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
           key * 'elt * 'elt tree * Z_as_Int.t
        | R_bal_2 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
           key * 'elt * 'elt tree * Z_as_Int.t
        | R_bal_3 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
           key * 'elt * 'elt tree * Z_as_Int.t * 'elt tree * key * 'elt
           * 'elt tree * Z_as_Int.t
        | R_bal_4 of 'elt tree * key * 'elt * 'elt tree
        | R_bal_5 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
           key * 'elt * 'elt tree * Z_as_Int.t
        | R_bal_6 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
           key * 'elt * 'elt tree * Z_as_Int.t
        | R_bal_7 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
           key * 'elt * 'elt tree * Z_as_Int.t * 'elt tree * key * 'elt
           * 'elt tree * Z_as_Int.t
        | R_bal_8 of 'elt tree * key * 'elt * 'elt tree

        val coq_R_bal_rect :
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> 'a2) ->
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key
          -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1
          tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> __ -> 'a2) ->
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key
          -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2) -> ('a1 tree ->
          key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> __ -> 'a2) ->
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ ->
          'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __
          -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ ->
          __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __
          -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t ->
          __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
          -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ ->
          __ -> __ -> 'a2) -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree
          -> 'a1 coq_R_bal -> 'a2

        val coq_R_bal_rec :
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> 'a2) ->
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key
          -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1
          tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> __ -> 'a2) ->
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key
          -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2) -> ('a1 tree ->
          key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> __ -> 'a2) ->
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ ->
          'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __
          -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ ->
          __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __
          -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t ->
          __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
          -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ ->
          __ -> __ -> 'a2) -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree
          -> 'a1 coq_R_bal -> 'a2

        type 'elt coq_R_add =
        | R_add_0 of 'elt tree
        | R_add_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt tree * 'elt coq_R_add
        | R_add_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t
        | R_add_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt tree * 'elt coq_R_add

        val coq_R_add_rect :
          key -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree
          -> 'a1 coq_R_add -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1
          tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ ->
          __ -> __ -> 'a1 tree -> 'a1 coq_R_add -> 'a2 -> 'a2) -> 'a1 tree ->
          'a1 tree -> 'a1 coq_R_add -> 'a2

        val coq_R_add_rec :
          key -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree
          -> 'a1 coq_R_add -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key ->
          'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1
          tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ ->
          __ -> __ -> 'a1 tree -> 'a1 coq_R_add -> 'a2 -> 'a2) -> 'a1 tree ->
          'a1 tree -> 'a1 coq_R_add -> 'a2

        type 'elt coq_R_remove_min =
        | R_remove_min_0 of 'elt tree * key * 'elt * 'elt tree
        | R_remove_min_1 of 'elt tree * key * 'elt * 'elt tree * 'elt tree
           * key * 'elt * 'elt tree * Z_as_Int.t * ('elt tree * (key * 'elt))
           * 'elt coq_R_remove_min * 'elt tree * (key * 'elt)

        val coq_R_remove_min_rect :
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1 tree ->
          key -> 'a1 -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> ('a1 tree * (key * 'a1)) -> 'a1
          coq_R_remove_min -> 'a2 -> 'a1 tree -> (key * 'a1) -> __ -> 'a2) ->
          'a1 tree -> key -> 'a1 -> 'a1 tree -> ('a1 tree * (key * 'a1)) ->
          'a1 coq_R_remove_min -> 'a2

        val coq_R_remove_min_rec :
          ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1 tree ->
          key -> 'a1 -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> ('a1 tree * (key * 'a1)) -> 'a1
          coq_R_remove_min -> 'a2 -> 'a1 tree -> (key * 'a1) -> __ -> 'a2) ->
          'a1 tree -> key -> 'a1 -> 'a1 tree -> ('a1 tree * (key * 'a1)) ->
          'a1 coq_R_remove_min -> 'a2

        type 'elt coq_R_merge =
        | R_merge_0 of 'elt tree * 'elt tree
        | R_merge_1 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
           * 'elt tree * Z_as_Int.t
        | R_merge_2 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
           * 'elt tree * Z_as_Int.t * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt tree * (key * 'elt) * key * 'elt

        val coq_R_merge_rect :
          ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2) ->
          ('a1 tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> 'a1 tree -> (key * 'a1) -> __ -> key -> 'a1 ->
          __ -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_merge
          -> 'a2

        val coq_R_merge_rec :
          ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2) ->
          ('a1 tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> 'a1 tree -> (key * 'a1) -> __ -> key -> 'a1 ->
          __ -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_merge
          -> 'a2

        type 'elt coq_R_remove =
        | R_remove_0 of 'elt tree
        | R_remove_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt tree * 'elt coq_R_remove
        | R_remove_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t
        | R_remove_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt tree * 'elt coq_R_remove

        val coq_R_remove_rect :
          char list -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree
          -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key
          -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1
          tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ ->
          __ -> __ -> 'a1 tree -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1 tree
          -> 'a1 tree -> 'a1 coq_R_remove -> 'a2

        val coq_R_remove_rec :
          char list -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree
          -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key
          -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1
          tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ ->
          __ -> __ -> 'a1 tree -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1 tree
          -> 'a1 tree -> 'a1 coq_R_remove -> 'a2

        type 'elt coq_R_concat =
        | R_concat_0 of 'elt tree * 'elt tree
        | R_concat_1 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
           * 'elt tree * Z_as_Int.t
        | R_concat_2 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
           * 'elt tree * Z_as_Int.t * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt tree * (key * 'elt)

        val coq_R_concat_rect :
          ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2) ->
          ('a1 tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> 'a1 tree -> (key * 'a1) -> __ -> 'a2) -> 'a1
          tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_concat -> 'a2

        val coq_R_concat_rec :
          ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2) ->
          ('a1 tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> 'a1 tree -> (key * 'a1) -> __ -> 'a2) -> 'a1
          tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_concat -> 'a2

        type 'elt coq_R_split =
        | R_split_0 of 'elt tree
        | R_split_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt triple * 'elt coq_R_split * 'elt tree
           * 'elt option * 'elt tree
        | R_split_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t
        | R_split_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'elt triple * 'elt coq_R_split * 'elt tree
           * 'elt option * 'elt tree

        val coq_R_split_rect :
          char list -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1
          triple -> 'a1 coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1
          tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1
          tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ ->
          'a1 triple -> 'a1 coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option ->
          'a1 tree -> __ -> 'a2) -> 'a1 tree -> 'a1 triple -> 'a1 coq_R_split
          -> 'a2

        val coq_R_split_rec :
          char list -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
          key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1
          triple -> 'a1 coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1
          tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1
          tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
          tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ ->
          'a1 triple -> 'a1 coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option ->
          'a1 tree -> __ -> 'a2) -> 'a1 tree -> 'a1 triple -> 'a1 coq_R_split
          -> 'a2

        type ('elt, 'x) coq_R_map_option =
        | R_map_option_0 of 'elt tree
        | R_map_option_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'x * 'x tree * ('elt, 'x) coq_R_map_option
           * 'x tree * ('elt, 'x) coq_R_map_option
        | R_map_option_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
           * Z_as_Int.t * 'x tree * ('elt, 'x) coq_R_map_option * 'x tree
           * ('elt, 'x) coq_R_map_option

        val coq_R_map_option_rect :
          (key -> 'a1 -> 'a2 option) -> ('a1 tree -> __ -> 'a3) -> ('a1 tree
          -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 ->
          __ -> 'a2 tree -> ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree ->
          ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a3) -> ('a1 tree -> 'a1 tree
          -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2 tree ->
          ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2)
          coq_R_map_option -> 'a3 -> 'a3) -> 'a1 tree -> 'a2 tree -> ('a1,
          'a2) coq_R_map_option -> 'a3

        val coq_R_map_option_rec :
          (key -> 'a1 -> 'a2 option) -> ('a1 tree -> __ -> 'a3) -> ('a1 tree
          -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 ->
          __ -> 'a2 tree -> ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree ->
          ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a3) -> ('a1 tree -> 'a1 tree
          -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2 tree ->
          ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2)
          coq_R_map_option -> 'a3 -> 'a3) -> 'a1 tree -> 'a2 tree -> ('a1,
          'a2) coq_R_map_option -> 'a3

        type ('elt, 'x0, 'x) coq_R_map2_opt =
        | R_map2_opt_0 of 'elt tree * 'x0 tree
        | R_map2_opt_1 of 'elt tree * 'x0 tree * 'elt tree * key * 'elt
           * 'elt tree * Z_as_Int.t
        | R_map2_opt_2 of 'elt tree * 'x0 tree * 'elt tree * key * 'elt
           * 'elt tree * Z_as_Int.t * 'x0 tree * key * 'x0 * 'x0 tree
           * Z_as_Int.t * 'x0 tree * 'x0 option * 'x0 tree * 'x * 'x tree
           * ('elt, 'x0, 'x) coq_R_map2_opt * 'x tree
           * ('elt, 'x0, 'x) coq_R_map2_opt
        | R_map2_opt_3 of 'elt tree * 'x0 tree * 'elt tree * key * 'elt
           * 'elt tree * Z_as_Int.t * 'x0 tree * key * 'x0 * 'x0 tree
           * Z_as_Int.t * 'x0 tree * 'x0 option * 'x0 tree * 'x tree
           * ('elt, 'x0, 'x) coq_R_map2_opt * 'x tree
           * ('elt, 'x0, 'x) coq_R_map2_opt

        val coq_R_map2_opt_rect :
          (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree)
          -> ('a2 tree -> 'a3 tree) -> ('a1 tree -> 'a2 tree -> __ -> 'a4) ->
          ('a1 tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> __ -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree
          -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 tree -> key ->
          'a2 -> 'a2 tree -> Z_as_Int.t -> __ -> 'a2 tree -> 'a2 option ->
          'a2 tree -> __ -> 'a3 -> __ -> 'a3 tree -> ('a1, 'a2, 'a3)
          coq_R_map2_opt -> 'a4 -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt
          -> 'a4 -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree -> key -> 'a1
          -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 tree -> key -> 'a2 -> 'a2
          tree -> Z_as_Int.t -> __ -> 'a2 tree -> 'a2 option -> 'a2 tree ->
          __ -> __ -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 ->
          'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> 'a1
          tree -> 'a2 tree -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt ->
          'a4

        val coq_R_map2_opt_rec :
          (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree)
          -> ('a2 tree -> 'a3 tree) -> ('a1 tree -> 'a2 tree -> __ -> 'a4) ->
          ('a1 tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
          Z_as_Int.t -> __ -> __ -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree
          -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 tree -> key ->
          'a2 -> 'a2 tree -> Z_as_Int.t -> __ -> 'a2 tree -> 'a2 option ->
          'a2 tree -> __ -> 'a3 -> __ -> 'a3 tree -> ('a1, 'a2, 'a3)
          coq_R_map2_opt -> 'a4 -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt
          -> 'a4 -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree -> key -> 'a1
          -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 tree -> key -> 'a2 -> 'a2
          tree -> Z_as_Int.t -> __ -> 'a2 tree -> 'a2 option -> 'a2 tree ->
          __ -> __ -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 ->
          'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> 'a1
          tree -> 'a2 tree -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt ->
          'a4

        val fold' : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2

        val flatten_e : 'a1 enumeration -> (key * 'a1) list
       end
     end

    module II :
     sig
      type coq_ExprI =
      | EI0
      | EI1
      | EI2
      | EI3
      | EIadd of coq_ExprI * coq_ExprI
      | EIopp of coq_ExprI
      | EIsub of coq_ExprI * coq_ExprI
      | EImul of coq_ExprI * coq_ExprI
      | EImax of coq_ExprI * coq_ExprI
      | EIraw of Z_as_Int.t

      val coq_ExprI_rect :
        'a1 -> 'a1 -> 'a1 -> 'a1 -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 ->
        'a1) -> (coq_ExprI -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI
        -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) ->
        (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) -> (Z_as_Int.t -> 'a1)
        -> coq_ExprI -> 'a1

      val coq_ExprI_rec :
        'a1 -> 'a1 -> 'a1 -> 'a1 -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 ->
        'a1) -> (coq_ExprI -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI
        -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) ->
        (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) -> (Z_as_Int.t -> 'a1)
        -> coq_ExprI -> 'a1

      type coq_ExprZ =
      | EZadd of coq_ExprZ * coq_ExprZ
      | EZopp of coq_ExprZ
      | EZsub of coq_ExprZ * coq_ExprZ
      | EZmul of coq_ExprZ * coq_ExprZ
      | EZmax of coq_ExprZ * coq_ExprZ
      | EZofI of coq_ExprI
      | EZraw of z

      val coq_ExprZ_rect :
        (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 ->
        'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ
        -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ
        -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1) -> (z -> 'a1) -> coq_ExprZ -> 'a1

      val coq_ExprZ_rec :
        (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 ->
        'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ
        -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ
        -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1) -> (z -> 'a1) -> coq_ExprZ -> 'a1

      type coq_ExprP =
      | EPeq of coq_ExprZ * coq_ExprZ
      | EPlt of coq_ExprZ * coq_ExprZ
      | EPle of coq_ExprZ * coq_ExprZ
      | EPgt of coq_ExprZ * coq_ExprZ
      | EPge of coq_ExprZ * coq_ExprZ
      | EPimpl of coq_ExprP * coq_ExprP
      | EPequiv of coq_ExprP * coq_ExprP
      | EPand of coq_ExprP * coq_ExprP
      | EPor of coq_ExprP * coq_ExprP
      | EPneg of coq_ExprP
      | EPraw

      val coq_ExprP_rect :
        (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
        (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
        (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP ->
        'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) ->
        (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 ->
        coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> 'a1) -> (__ -> 'a1)
        -> coq_ExprP -> 'a1

      val coq_ExprP_rec :
        (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
        (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
        (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP ->
        'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) ->
        (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 ->
        coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> 'a1) -> (__ -> 'a1)
        -> coq_ExprP -> 'a1

      val ei2i : coq_ExprI -> Z_as_Int.t

      val ez2z : coq_ExprZ -> z

      val norm_ei : coq_ExprI -> coq_ExprZ

      val norm_ez : coq_ExprZ -> coq_ExprZ

      val norm_ep : coq_ExprP -> coq_ExprP
     end
   end

  type 'elt bbst =
    'elt AvlProofs.Raw.tree
    (* singleton inductive, whose constructor was Bbst *)

  val this : 'a1 bbst -> 'a1 AvlProofs.Raw.tree

  type 'elt t = 'elt bbst

  type key = char list

  val empty : 'a1 t

  val is_empty : 'a1 t -> bool

  val add : key -> 'a1 -> 'a1 t -> 'a1 t

  val remove : key -> 'a1 t -> 'a1 t

  val mem : key -> 'a1 t -> bool

  val find : key -> 'a1 t -> 'a1 option

  val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t

  val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t

  val map2 :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t

  val elements : 'a1 t -> (key * 'a1) list

  val cardinal : 'a1 t -> nat

  val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2

  val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool
 end

module MakeRaw :
 functor (I:Int) ->
 functor (X:OrderedType) ->
 sig
  type elt = X.t

  type tree =
  | Leaf
  | Node of I.t * tree * X.t * tree

  val empty : tree

  val is_empty : tree -> bool

  val mem : X.t -> tree -> bool

  val min_elt : tree -> elt option

  val max_elt : tree -> elt option

  val choose : tree -> elt option

  val fold : (elt -> 'a1 -> 'a1) -> tree -> 'a1 -> 'a1

  val elements_aux : X.t list -> tree -> X.t list

  val elements : tree -> X.t list

  val rev_elements_aux : X.t list -> tree -> X.t list

  val rev_elements : tree -> X.t list

  val cardinal : tree -> nat

  val maxdepth : tree -> nat

  val mindepth : tree -> nat

  val for_all : (elt -> bool) -> tree -> bool

  val exists_ : (elt -> bool) -> tree -> bool

  type enumeration =
  | End
  | More of elt * tree * enumeration

  val cons : tree -> enumeration -> enumeration

  val compare_more :
    X.t -> (enumeration -> comparison) -> enumeration -> comparison

  val compare_cont :
    tree -> (enumeration -> comparison) -> enumeration -> comparison

  val compare_end : enumeration -> comparison

  val compare : tree -> tree -> comparison

  val equal : tree -> tree -> bool

  val subsetl : (tree -> bool) -> X.t -> tree -> bool

  val subsetr : (tree -> bool) -> X.t -> tree -> bool

  val subset : tree -> tree -> bool

  type t = tree

  val height : t -> I.t

  val singleton : X.t -> tree

  val create : t -> X.t -> t -> tree

  val assert_false : t -> X.t -> t -> tree

  val bal : t -> X.t -> t -> tree

  val add : X.t -> tree -> tree

  val join : tree -> elt -> t -> t

  val remove_min : tree -> elt -> t -> t * elt

  val merge : tree -> tree -> tree

  val remove : X.t -> tree -> tree

  val concat : tree -> tree -> tree

  type triple = { t_left : t; t_in : bool; t_right : t }

  val t_left : triple -> t

  val t_in : triple -> bool

  val t_right : triple -> t

  val split : X.t -> tree -> triple

  val inter : tree -> tree -> tree

  val diff : tree -> tree -> tree

  val union : tree -> tree -> tree

  val filter : (elt -> bool) -> tree -> tree

  val partition : (elt -> bool) -> t -> t * t

  val ltb_tree : X.t -> tree -> bool

  val gtb_tree : X.t -> tree -> bool

  val isok : tree -> bool

  module MX :
   sig
    module OrderTac :
     sig
      module OTF :
       sig
        type t = X.t

        val compare : t -> t -> comparison

        val eq_dec : t -> t -> bool
       end

      module TO :
       sig
        type t = OTF.t

        val compare : t -> t -> comparison

        val eq_dec : t -> t -> bool
       end
     end

    val eq_dec : X.t -> X.t -> bool

    val lt_dec : X.t -> X.t -> bool

    val eqb : X.t -> X.t -> bool
   end

  module L :
   sig
    module MO :
     sig
      module OrderTac :
       sig
        module OTF :
         sig
          type t = X.t

          val compare : t -> t -> comparison

          val eq_dec : t -> t -> bool
         end

        module TO :
         sig
          type t = OTF.t

          val compare : t -> t -> comparison

          val eq_dec : t -> t -> bool
         end
       end

      val eq_dec : X.t -> X.t -> bool

      val lt_dec : X.t -> X.t -> bool

      val eqb : X.t -> X.t -> bool
     end
   end

  val flatten_e : enumeration -> elt list

  type coq_R_bal =
  | R_bal_0 of t * X.t * t
  | R_bal_1 of t * X.t * t * I.t * tree * X.t * tree
  | R_bal_2 of t * X.t * t * I.t * tree * X.t * tree
  | R_bal_3 of t * X.t * t * I.t * tree * X.t * tree * I.t * tree * X.t * tree
  | R_bal_4 of t * X.t * t
  | R_bal_5 of t * X.t * t * I.t * tree * X.t * tree
  | R_bal_6 of t * X.t * t * I.t * tree * X.t * tree
  | R_bal_7 of t * X.t * t * I.t * tree * X.t * tree * I.t * tree * X.t * tree
  | R_bal_8 of t * X.t * t

  type coq_R_remove_min =
  | R_remove_min_0 of tree * elt * t
  | R_remove_min_1 of tree * elt * t * I.t * tree * X.t * tree * (t * elt)
     * coq_R_remove_min * t * elt

  type coq_R_merge =
  | R_merge_0 of tree * tree
  | R_merge_1 of tree * tree * I.t * tree * X.t * tree
  | R_merge_2 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
     X.t * tree * t * elt

  type coq_R_concat =
  | R_concat_0 of tree * tree
  | R_concat_1 of tree * tree * I.t * tree * X.t * tree
  | R_concat_2 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
     X.t * tree * t * elt

  type coq_R_inter =
  | R_inter_0 of tree * tree
  | R_inter_1 of tree * tree * I.t * tree * X.t * tree
  | R_inter_2 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
     X.t * tree * t * bool * t * tree * coq_R_inter * tree * coq_R_inter
  | R_inter_3 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
     X.t * tree * t * bool * t * tree * coq_R_inter * tree * coq_R_inter

  type coq_R_diff =
  | R_diff_0 of tree * tree
  | R_diff_1 of tree * tree * I.t * tree * X.t * tree
  | R_diff_2 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
     X.t * tree * t * bool * t * tree * coq_R_diff * tree * coq_R_diff
  | R_diff_3 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
     X.t * tree * t * bool * t * tree * coq_R_diff * tree * coq_R_diff

  type coq_R_union =
  | R_union_0 of tree * tree
  | R_union_1 of tree * tree * I.t * tree * X.t * tree
  | R_union_2 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
     X.t * tree * t * bool * t * tree * coq_R_union * tree * coq_R_union
 end

module Coq_IntMake :
 functor (I:Int) ->
 functor (X:OrderedType) ->
 sig
  module Raw :
   sig
    type elt = X.t

    type tree =
    | Leaf
    | Node of I.t * tree * X.t * tree

    val empty : tree

    val is_empty : tree -> bool

    val mem : X.t -> tree -> bool

    val min_elt : tree -> elt option

    val max_elt : tree -> elt option

    val choose : tree -> elt option

    val fold : (elt -> 'a1 -> 'a1) -> tree -> 'a1 -> 'a1

    val elements_aux : X.t list -> tree -> X.t list

    val elements : tree -> X.t list

    val rev_elements_aux : X.t list -> tree -> X.t list

    val rev_elements : tree -> X.t list

    val cardinal : tree -> nat

    val maxdepth : tree -> nat

    val mindepth : tree -> nat

    val for_all : (elt -> bool) -> tree -> bool

    val exists_ : (elt -> bool) -> tree -> bool

    type enumeration =
    | End
    | More of elt * tree * enumeration

    val cons : tree -> enumeration -> enumeration

    val compare_more :
      X.t -> (enumeration -> comparison) -> enumeration -> comparison

    val compare_cont :
      tree -> (enumeration -> comparison) -> enumeration -> comparison

    val compare_end : enumeration -> comparison

    val compare : tree -> tree -> comparison

    val equal : tree -> tree -> bool

    val subsetl : (tree -> bool) -> X.t -> tree -> bool

    val subsetr : (tree -> bool) -> X.t -> tree -> bool

    val subset : tree -> tree -> bool

    type t = tree

    val height : t -> I.t

    val singleton : X.t -> tree

    val create : t -> X.t -> t -> tree

    val assert_false : t -> X.t -> t -> tree

    val bal : t -> X.t -> t -> tree

    val add : X.t -> tree -> tree

    val join : tree -> elt -> t -> t

    val remove_min : tree -> elt -> t -> t * elt

    val merge : tree -> tree -> tree

    val remove : X.t -> tree -> tree

    val concat : tree -> tree -> tree

    type triple = { t_left : t; t_in : bool; t_right : t }

    val t_left : triple -> t

    val t_in : triple -> bool

    val t_right : triple -> t

    val split : X.t -> tree -> triple

    val inter : tree -> tree -> tree

    val diff : tree -> tree -> tree

    val union : tree -> tree -> tree

    val filter : (elt -> bool) -> tree -> tree

    val partition : (elt -> bool) -> t -> t * t

    val ltb_tree : X.t -> tree -> bool

    val gtb_tree : X.t -> tree -> bool

    val isok : tree -> bool

    module MX :
     sig
      module OrderTac :
       sig
        module OTF :
         sig
          type t = X.t

          val compare : t -> t -> comparison

          val eq_dec : t -> t -> bool
         end

        module TO :
         sig
          type t = OTF.t

          val compare : t -> t -> comparison

          val eq_dec : t -> t -> bool
         end
       end

      val eq_dec : X.t -> X.t -> bool

      val lt_dec : X.t -> X.t -> bool

      val eqb : X.t -> X.t -> bool
     end

    module L :
     sig
      module MO :
       sig
        module OrderTac :
         sig
          module OTF :
           sig
            type t = X.t

            val compare : t -> t -> comparison

            val eq_dec : t -> t -> bool
           end

          module TO :
           sig
            type t = OTF.t

            val compare : t -> t -> comparison

            val eq_dec : t -> t -> bool
           end
         end

        val eq_dec : X.t -> X.t -> bool

        val lt_dec : X.t -> X.t -> bool

        val eqb : X.t -> X.t -> bool
       end
     end

    val flatten_e : enumeration -> elt list

    type coq_R_bal =
    | R_bal_0 of t * X.t * t
    | R_bal_1 of t * X.t * t * I.t * tree * X.t * tree
    | R_bal_2 of t * X.t * t * I.t * tree * X.t * tree
    | R_bal_3 of t * X.t * t * I.t * tree * X.t * tree * I.t * tree * 
       X.t * tree
    | R_bal_4 of t * X.t * t
    | R_bal_5 of t * X.t * t * I.t * tree * X.t * tree
    | R_bal_6 of t * X.t * t * I.t * tree * X.t * tree
    | R_bal_7 of t * X.t * t * I.t * tree * X.t * tree * I.t * tree * 
       X.t * tree
    | R_bal_8 of t * X.t * t

    type coq_R_remove_min =
    | R_remove_min_0 of tree * elt * t
    | R_remove_min_1 of tree * elt * t * I.t * tree * X.t * tree * (t * elt)
       * coq_R_remove_min * t * elt

    type coq_R_merge =
    | R_merge_0 of tree * tree
    | R_merge_1 of tree * tree * I.t * tree * X.t * tree
    | R_merge_2 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
       X.t * tree * t * elt

    type coq_R_concat =
    | R_concat_0 of tree * tree
    | R_concat_1 of tree * tree * I.t * tree * X.t * tree
    | R_concat_2 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
       X.t * tree * t * elt

    type coq_R_inter =
    | R_inter_0 of tree * tree
    | R_inter_1 of tree * tree * I.t * tree * X.t * tree
    | R_inter_2 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
       X.t * tree * t * bool * t * tree * coq_R_inter * tree * coq_R_inter
    | R_inter_3 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
       X.t * tree * t * bool * t * tree * coq_R_inter * tree * coq_R_inter

    type coq_R_diff =
    | R_diff_0 of tree * tree
    | R_diff_1 of tree * tree * I.t * tree * X.t * tree
    | R_diff_2 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
       X.t * tree * t * bool * t * tree * coq_R_diff * tree * coq_R_diff
    | R_diff_3 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
       X.t * tree * t * bool * t * tree * coq_R_diff * tree * coq_R_diff

    type coq_R_union =
    | R_union_0 of tree * tree
    | R_union_1 of tree * tree * I.t * tree * X.t * tree
    | R_union_2 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
       X.t * tree * t * bool * t * tree * coq_R_union * tree * coq_R_union
   end

  module E :
   sig
    type t = X.t

    val compare : t -> t -> comparison

    val eq_dec : t -> t -> bool
   end

  type elt = X.t

  type t_ = Raw.t
    (* singleton inductive, whose constructor was Mkt *)

  val this : t_ -> Raw.t

  type t = t_

  val mem : elt -> t -> bool

  val add : elt -> t -> t

  val remove : elt -> t -> t

  val singleton : elt -> t

  val union : t -> t -> t

  val inter : t -> t -> t

  val diff : t -> t -> t

  val equal : t -> t -> bool

  val subset : t -> t -> bool

  val empty : t

  val is_empty : t -> bool

  val elements : t -> elt list

  val choose : t -> elt option

  val fold : (elt -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1

  val cardinal : t -> nat

  val filter : (elt -> bool) -> t -> t

  val for_all : (elt -> bool) -> t -> bool

  val exists_ : (elt -> bool) -> t -> bool

  val partition : (elt -> bool) -> t -> t * t

  val eq_dec : t -> t -> bool

  val compare : t -> t -> comparison

  val min_elt : t -> elt option

  val max_elt : t -> elt option
 end

module Coq_Make :
 functor (X:OrderedType) ->
 sig
  module Raw :
   sig
    type elt = X.t

    type tree =
    | Leaf
    | Node of Z_as_Int.t * tree * X.t * tree

    val empty : tree

    val is_empty : tree -> bool

    val mem : X.t -> tree -> bool

    val min_elt : tree -> elt option

    val max_elt : tree -> elt option

    val choose : tree -> elt option

    val fold : (elt -> 'a1 -> 'a1) -> tree -> 'a1 -> 'a1

    val elements_aux : X.t list -> tree -> X.t list

    val elements : tree -> X.t list

    val rev_elements_aux : X.t list -> tree -> X.t list

    val rev_elements : tree -> X.t list

    val cardinal : tree -> nat

    val maxdepth : tree -> nat

    val mindepth : tree -> nat

    val for_all : (elt -> bool) -> tree -> bool

    val exists_ : (elt -> bool) -> tree -> bool

    type enumeration =
    | End
    | More of elt * tree * enumeration

    val cons : tree -> enumeration -> enumeration

    val compare_more :
      X.t -> (enumeration -> comparison) -> enumeration -> comparison

    val compare_cont :
      tree -> (enumeration -> comparison) -> enumeration -> comparison

    val compare_end : enumeration -> comparison

    val compare : tree -> tree -> comparison

    val equal : tree -> tree -> bool

    val subsetl : (tree -> bool) -> X.t -> tree -> bool

    val subsetr : (tree -> bool) -> X.t -> tree -> bool

    val subset : tree -> tree -> bool

    type t = tree

    val height : t -> Z_as_Int.t

    val singleton : X.t -> tree

    val create : t -> X.t -> t -> tree

    val assert_false : t -> X.t -> t -> tree

    val bal : t -> X.t -> t -> tree

    val add : X.t -> tree -> tree

    val join : tree -> elt -> t -> t

    val remove_min : tree -> elt -> t -> t * elt

    val merge : tree -> tree -> tree

    val remove : X.t -> tree -> tree

    val concat : tree -> tree -> tree

    type triple = { t_left : t; t_in : bool; t_right : t }

    val t_left : triple -> t

    val t_in : triple -> bool

    val t_right : triple -> t

    val split : X.t -> tree -> triple

    val inter : tree -> tree -> tree

    val diff : tree -> tree -> tree

    val union : tree -> tree -> tree

    val filter : (elt -> bool) -> tree -> tree

    val partition : (elt -> bool) -> t -> t * t

    val ltb_tree : X.t -> tree -> bool

    val gtb_tree : X.t -> tree -> bool

    val isok : tree -> bool

    module MX :
     sig
      module OrderTac :
       sig
        module OTF :
         sig
          type t = X.t

          val compare : t -> t -> comparison

          val eq_dec : t -> t -> bool
         end

        module TO :
         sig
          type t = OTF.t

          val compare : t -> t -> comparison

          val eq_dec : t -> t -> bool
         end
       end

      val eq_dec : X.t -> X.t -> bool

      val lt_dec : X.t -> X.t -> bool

      val eqb : X.t -> X.t -> bool
     end

    module L :
     sig
      module MO :
       sig
        module OrderTac :
         sig
          module OTF :
           sig
            type t = X.t

            val compare : t -> t -> comparison

            val eq_dec : t -> t -> bool
           end

          module TO :
           sig
            type t = OTF.t

            val compare : t -> t -> comparison

            val eq_dec : t -> t -> bool
           end
         end

        val eq_dec : X.t -> X.t -> bool

        val lt_dec : X.t -> X.t -> bool

        val eqb : X.t -> X.t -> bool
       end
     end

    val flatten_e : enumeration -> elt list

    type coq_R_bal =
    | R_bal_0 of t * X.t * t
    | R_bal_1 of t * X.t * t * Z_as_Int.t * tree * X.t * tree
    | R_bal_2 of t * X.t * t * Z_as_Int.t * tree * X.t * tree
    | R_bal_3 of t * X.t * t * Z_as_Int.t * tree * X.t * tree * Z_as_Int.t
       * tree * X.t * tree
    | R_bal_4 of t * X.t * t
    | R_bal_5 of t * X.t * t * Z_as_Int.t * tree * X.t * tree
    | R_bal_6 of t * X.t * t * Z_as_Int.t * tree * X.t * tree
    | R_bal_7 of t * X.t * t * Z_as_Int.t * tree * X.t * tree * Z_as_Int.t
       * tree * X.t * tree
    | R_bal_8 of t * X.t * t

    type coq_R_remove_min =
    | R_remove_min_0 of tree * elt * t
    | R_remove_min_1 of tree * elt * t * Z_as_Int.t * tree * X.t * tree
       * (t * elt) * coq_R_remove_min * t * elt

    type coq_R_merge =
    | R_merge_0 of tree * tree
    | R_merge_1 of tree * tree * Z_as_Int.t * tree * X.t * tree
    | R_merge_2 of tree * tree * Z_as_Int.t * tree * X.t * tree * Z_as_Int.t
       * tree * X.t * tree * t * elt

    type coq_R_concat =
    | R_concat_0 of tree * tree
    | R_concat_1 of tree * tree * Z_as_Int.t * tree * X.t * tree
    | R_concat_2 of tree * tree * Z_as_Int.t * tree * X.t * tree * Z_as_Int.t
       * tree * X.t * tree * t * elt

    type coq_R_inter =
    | R_inter_0 of tree * tree
    | R_inter_1 of tree * tree * Z_as_Int.t * tree * X.t * tree
    | R_inter_2 of tree * tree * Z_as_Int.t * tree * X.t * tree * Z_as_Int.t
       * tree * X.t * tree * t * bool * t * tree * coq_R_inter * tree
       * coq_R_inter
    | R_inter_3 of tree * tree * Z_as_Int.t * tree * X.t * tree * Z_as_Int.t
       * tree * X.t * tree * t * bool * t * tree * coq_R_inter * tree
       * coq_R_inter

    type coq_R_diff =
    | R_diff_0 of tree * tree
    | R_diff_1 of tree * tree * Z_as_Int.t * tree * X.t * tree
    | R_diff_2 of tree * tree * Z_as_Int.t * tree * X.t * tree * Z_as_Int.t
       * tree * X.t * tree * t * bool * t * tree * coq_R_diff * tree
       * coq_R_diff
    | R_diff_3 of tree * tree * Z_as_Int.t * tree * X.t * tree * Z_as_Int.t
       * tree * X.t * tree * t * bool * t * tree * coq_R_diff * tree
       * coq_R_diff

    type coq_R_union =
    | R_union_0 of tree * tree
    | R_union_1 of tree * tree * Z_as_Int.t * tree * X.t * tree
    | R_union_2 of tree * tree * Z_as_Int.t * tree * X.t * tree * Z_as_Int.t
       * tree * X.t * tree * t * bool * t * tree * coq_R_union * tree
       * coq_R_union
   end

  module E :
   sig
    type t = X.t

    val compare : t -> t -> comparison

    val eq_dec : t -> t -> bool
   end

  type elt = X.t

  type t_ = Raw.t
    (* singleton inductive, whose constructor was Mkt *)

  val this : t_ -> Raw.t

  type t = t_

  val mem : elt -> t -> bool

  val add : elt -> t -> t

  val remove : elt -> t -> t

  val singleton : elt -> t

  val union : t -> t -> t

  val inter : t -> t -> t

  val diff : t -> t -> t

  val equal : t -> t -> bool

  val subset : t -> t -> bool

  val empty : t

  val is_empty : t -> bool

  val elements : t -> elt list

  val choose : t -> elt option

  val fold : (elt -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1

  val cardinal : t -> nat

  val filter : (elt -> bool) -> t -> t

  val for_all : (elt -> bool) -> t -> bool

  val exists_ : (elt -> bool) -> t -> bool

  val partition : (elt -> bool) -> t -> t * t

  val eq_dec : t -> t -> bool

  val compare : t -> t -> comparison

  val min_elt : t -> elt option

  val max_elt : t -> elt option
 end

module StringSet :
 sig
  module Raw :
   sig
    type elt = char list

    type tree =
    | Leaf
    | Node of Z_as_Int.t * tree * char list * tree

    val empty : tree

    val is_empty : tree -> bool

    val mem : char list -> tree -> bool

    val min_elt : tree -> elt option

    val max_elt : tree -> elt option

    val choose : tree -> elt option

    val fold : (elt -> 'a1 -> 'a1) -> tree -> 'a1 -> 'a1

    val elements_aux : char list list -> tree -> char list list

    val elements : tree -> char list list

    val rev_elements_aux : char list list -> tree -> char list list

    val rev_elements : tree -> char list list

    val cardinal : tree -> nat

    val maxdepth : tree -> nat

    val mindepth : tree -> nat

    val for_all : (elt -> bool) -> tree -> bool

    val exists_ : (elt -> bool) -> tree -> bool

    type enumeration =
    | End
    | More of elt * tree * enumeration

    val cons : tree -> enumeration -> enumeration

    val compare_more :
      char list -> (enumeration -> comparison) -> enumeration -> comparison

    val compare_cont :
      tree -> (enumeration -> comparison) -> enumeration -> comparison

    val compare_end : enumeration -> comparison

    val compare : tree -> tree -> comparison

    val equal : tree -> tree -> bool

    val subsetl : (tree -> bool) -> char list -> tree -> bool

    val subsetr : (tree -> bool) -> char list -> tree -> bool

    val subset : tree -> tree -> bool

    type t = tree

    val height : t -> Z_as_Int.t

    val singleton : char list -> tree

    val create : t -> char list -> t -> tree

    val assert_false : t -> char list -> t -> tree

    val bal : t -> char list -> t -> tree

    val add : char list -> tree -> tree

    val join : tree -> elt -> t -> t

    val remove_min : tree -> elt -> t -> t * elt

    val merge : tree -> tree -> tree

    val remove : char list -> tree -> tree

    val concat : tree -> tree -> tree

    type triple = { t_left : t; t_in : bool; t_right : t }

    val t_left : triple -> t

    val t_in : triple -> bool

    val t_right : triple -> t

    val split : char list -> tree -> triple

    val inter : tree -> tree -> tree

    val diff : tree -> tree -> tree

    val union : tree -> tree -> tree

    val filter : (elt -> bool) -> tree -> tree

    val partition : (elt -> bool) -> t -> t * t

    val ltb_tree : char list -> tree -> bool

    val gtb_tree : char list -> tree -> bool

    val isok : tree -> bool

    module MX :
     sig
      module OrderTac :
       sig
        module OTF :
         sig
          type t = char list

          val compare : char list -> char list -> comparison

          val eq_dec : char list -> char list -> bool
         end

        module TO :
         sig
          type t = char list

          val compare : char list -> char list -> comparison

          val eq_dec : char list -> char list -> bool
         end
       end

      val eq_dec : char list -> char list -> bool

      val lt_dec : char list -> char list -> bool

      val eqb : char list -> char list -> bool
     end

    module L :
     sig
      module MO :
       sig
        module OrderTac :
         sig
          module OTF :
           sig
            type t = char list

            val compare : char list -> char list -> comparison

            val eq_dec : char list -> char list -> bool
           end

          module TO :
           sig
            type t = char list

            val compare : char list -> char list -> comparison

            val eq_dec : char list -> char list -> bool
           end
         end

        val eq_dec : char list -> char list -> bool

        val lt_dec : char list -> char list -> bool

        val eqb : char list -> char list -> bool
       end
     end

    val flatten_e : enumeration -> elt list

    type coq_R_bal =
    | R_bal_0 of t * char list * t
    | R_bal_1 of t * char list * t * Z_as_Int.t * tree * char list * tree
    | R_bal_2 of t * char list * t * Z_as_Int.t * tree * char list * tree
    | R_bal_3 of t * char list * t * Z_as_Int.t * tree * char list * 
       tree * Z_as_Int.t * tree * char list * tree
    | R_bal_4 of t * char list * t
    | R_bal_5 of t * char list * t * Z_as_Int.t * tree * char list * tree
    | R_bal_6 of t * char list * t * Z_as_Int.t * tree * char list * tree
    | R_bal_7 of t * char list * t * Z_as_Int.t * tree * char list * 
       tree * Z_as_Int.t * tree * char list * tree
    | R_bal_8 of t * char list * t

    type coq_R_remove_min =
    | R_remove_min_0 of tree * elt * t
    | R_remove_min_1 of tree * elt * t * Z_as_Int.t * tree * char list * 
       tree * (t * elt) * coq_R_remove_min * t * elt

    type coq_R_merge =
    | R_merge_0 of tree * tree
    | R_merge_1 of tree * tree * Z_as_Int.t * tree * char list * tree
    | R_merge_2 of tree * tree * Z_as_Int.t * tree * char list * tree
       * Z_as_Int.t * tree * char list * tree * t * elt

    type coq_R_concat =
    | R_concat_0 of tree * tree
    | R_concat_1 of tree * tree * Z_as_Int.t * tree * char list * tree
    | R_concat_2 of tree * tree * Z_as_Int.t * tree * char list * tree
       * Z_as_Int.t * tree * char list * tree * t * elt

    type coq_R_inter =
    | R_inter_0 of tree * tree
    | R_inter_1 of tree * tree * Z_as_Int.t * tree * char list * tree
    | R_inter_2 of tree * tree * Z_as_Int.t * tree * char list * tree
       * Z_as_Int.t * tree * char list * tree * t * bool * t * tree
       * coq_R_inter * tree * coq_R_inter
    | R_inter_3 of tree * tree * Z_as_Int.t * tree * char list * tree
       * Z_as_Int.t * tree * char list * tree * t * bool * t * tree
       * coq_R_inter * tree * coq_R_inter

    type coq_R_diff =
    | R_diff_0 of tree * tree
    | R_diff_1 of tree * tree * Z_as_Int.t * tree * char list * tree
    | R_diff_2 of tree * tree * Z_as_Int.t * tree * char list * tree
       * Z_as_Int.t * tree * char list * tree * t * bool * t * tree
       * coq_R_diff * tree * coq_R_diff
    | R_diff_3 of tree * tree * Z_as_Int.t * tree * char list * tree
       * Z_as_Int.t * tree * char list * tree * t * bool * t * tree
       * coq_R_diff * tree * coq_R_diff

    type coq_R_union =
    | R_union_0 of tree * tree
    | R_union_1 of tree * tree * Z_as_Int.t * tree * char list * tree
    | R_union_2 of tree * tree * Z_as_Int.t * tree * char list * tree
       * Z_as_Int.t * tree * char list * tree * t * bool * t * tree
       * coq_R_union * tree * coq_R_union
   end

  module E :
   sig
    type t = char list

    val compare : char list -> char list -> comparison

    val eq_dec : char list -> char list -> bool
   end

  type elt = char list

  type t_ = Raw.t
    (* singleton inductive, whose constructor was Mkt *)

  val this : t_ -> Raw.t

  type t = t_

  val mem : elt -> t -> bool

  val add : elt -> t -> t

  val remove : elt -> t -> t

  val singleton : elt -> t

  val union : t -> t -> t

  val inter : t -> t -> t

  val diff : t -> t -> t

  val equal : t -> t -> bool

  val subset : t -> t -> bool

  val empty : t

  val is_empty : t -> bool

  val elements : t -> elt list

  val choose : t -> elt option

  val fold : (elt -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1

  val cardinal : t -> nat

  val filter : (elt -> bool) -> t -> t

  val for_all : (elt -> bool) -> t -> bool

  val exists_ : (elt -> bool) -> t -> bool

  val partition : (elt -> bool) -> t -> t * t

  val eq_dec : t -> t -> bool

  val compare : t -> t -> comparison

  val min_elt : t -> elt option

  val max_elt : t -> elt option
 end

type flag_status =
| Enabled
| Disabled

type full_flag_status =
| Explicit of flag_status
| Elided

val bool_of_flag_status : flag_status -> bool

val bool_of_full_flag_status : full_flag_status -> bool -> bool

type flag_option_kind =
| All
| Alias of char list list

val simple : char list -> flag_option_kind

val preparse_flag_opts :
  (char list * flag_option_kind) list -> char list list ->
  (flag_option_kind * flag_status) list

val aggregate_flag_opts :
  (flag_option_kind * flag_status) list -> full_flag_status * flag_status
  StringMap.t

val format_flag_opts :
  char list list -> flag_status StringMap.t -> full_flag_status tuple

val post_parse_flag_opts :
  char list list -> (full_flag_status * flag_status StringMap.t) ->
  (full_flag_status * (char list * flag_status) list) * full_flag_status tuple

val post_parse_flag_opts_to_filter :
  char list list -> (full_flag_status * flag_status StringMap.t) ->
  (full_flag_status * (char list * flag_status) list) * (char list ->
  full_flag_status)

val parse_flag_opts :
  (char list * flag_option_kind) list -> char list list -> char list list ->
  (full_flag_status * (char list * flag_status) list) * full_flag_status tuple

val parse_flag_opts_to_filter :
  (char list * flag_option_kind) list -> char list list -> char list list ->
  (full_flag_status * (char list * flag_status) list) * (char list ->
  full_flag_status)

val parse_flag_opts_to_bool_filter :
  bool -> (char list * flag_option_kind) list -> char list list -> char list
  list -> (char list * flag_status) list * (char list -> bool)

module Coq_tree :
 sig
  type 't t =
  | Coq_empty
  | Coq_singleton of 't
  | Coq_app of 't t * 't t

  val smart_app : 'a1 t -> 'a1 t -> 'a1 t

  val fold : ('a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2

  val to_list : 'a1 t -> 'a1 list
 end

type ('dbg, 't) debugM = (unit -> 'dbg list) Coq_tree.t * 't

module Debug :
 sig
  val debug' : (unit -> 'a1 list) -> ('a1, unit) debugM

  val bind :
    ('a1, 'a2) debugM -> ('a2 -> ('a1, 'a3) debugM) -> ('a1, 'a3) debugM

  val sequence : ('a1, unit) debugM -> ('a1, 'a2) debugM -> ('a1, 'a2) debugM

  val ret : 'a2 -> ('a1, 'a2) debugM

  val eval_result : ('a1, 'a2) debugM -> 'a2

  val copy_debug_info : ('a1, 'a2) debugM -> ('a1, unit) debugM

  val with_debug_info :
    ('a1, 'a2) debugM -> ('a1, 'a3) debugM -> ('a1, 'a3) debugM

  val get_debug_info : ('a1, 'a2) debugM -> (unit -> 'a1 list) list
 end

val qfloor : q -> z

val qceiling : q -> z

module Coq8_Compilers :
 sig
  module Coq_partial :
   sig
    type ('base_type, 'x) abstract_domain =
      ('base_type, 'x) Compilers.Coq_type.interp

    type ('base_type, 'ident, 'var, 'x) value = __

    type ('base_type, 'ident, 'var, 'x) value_with_lets =
      ('base_type, 'ident, 'var, ('base_type, 'ident, 'var, 'x) value)
      Coq_Compilers.UnderLets.coq_UnderLets

    val bottom :
      ('a1 -> 'a2) -> 'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2)
      abstract_domain

    val bottom_for_each_lhs_of_arrow :
      ('a1 -> 'a2) -> 'a1 Compilers.Coq_type.coq_type -> ('a1, ('a1, 'a2)
      abstract_domain) Compilers.Coq_type.for_each_lhs_of_arrow

    val state_of_value :
      ('a1 -> 'a4) -> 'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3, 'a4)
      value -> ('a1, 'a4) abstract_domain

    val bottomify :
      ('a1 -> 'a4) -> 'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3, 'a4)
      value -> ('a1, 'a2, 'a3, 'a4) value_with_lets

    val reify :
      (bool -> 'a1 -> 'a4 -> ('a1, 'a2, 'a3) Compilers.Coq_expr.expr -> ('a1,
      'a2, 'a3, ('a1, 'a2, 'a3) Compilers.Coq_expr.expr)
      Coq_Compilers.UnderLets.coq_UnderLets) -> ('a1 -> 'a4) -> bool -> bool
      -> 'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3, 'a4) value ->
      ('a1, ('a1, 'a4) abstract_domain)
      Compilers.Coq_type.for_each_lhs_of_arrow -> ('a1, 'a2, 'a3, ('a1, 'a2,
      'a3) Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets

    val reflect :
      (bool -> 'a1 -> 'a4 -> ('a1, 'a2, 'a3) Compilers.Coq_expr.expr -> ('a1,
      'a2, 'a3, ('a1, 'a2, 'a3) Compilers.Coq_expr.expr)
      Coq_Compilers.UnderLets.coq_UnderLets) -> ('a1 -> 'a4) -> bool -> 'a1
      Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) Compilers.Coq_expr.expr
      -> ('a1, 'a4) abstract_domain -> ('a1, 'a2, 'a3, 'a4) value

    val skip_annotations_for_App :
      ('a1 Compilers.Coq_type.coq_type -> 'a2 -> bool) -> 'a1
      Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) Compilers.Coq_expr.expr
      -> bool

    val interp :
      (bool -> 'a1 -> 'a4 -> ('a1, 'a2, 'a3) Compilers.Coq_expr.expr -> ('a1,
      'a2, 'a3, ('a1, 'a2, 'a3) Compilers.Coq_expr.expr)
      Coq_Compilers.UnderLets.coq_UnderLets) -> ('a1 -> 'a4) -> ('a1
      Compilers.Coq_type.coq_type -> 'a2 -> bool) -> (bool -> 'a1
      Compilers.Coq_type.coq_type -> 'a2 -> ('a1, 'a2, 'a3, 'a4)
      value_with_lets) -> bool -> 'a1 Compilers.Coq_type.coq_type -> ('a1,
      'a2, ('a1, 'a2, 'a3, 'a4) value_with_lets) Compilers.Coq_expr.expr ->
      ('a1, 'a2, 'a3, 'a4) value_with_lets

    val eval_with_bound' :
      (bool -> 'a1 -> 'a4 -> ('a1, 'a2, 'a3) Compilers.Coq_expr.expr -> ('a1,
      'a2, 'a3, ('a1, 'a2, 'a3) Compilers.Coq_expr.expr)
      Coq_Compilers.UnderLets.coq_UnderLets) -> ('a1 -> 'a4) -> ('a1
      Compilers.Coq_type.coq_type -> 'a2 -> bool) -> (bool -> 'a1
      Compilers.Coq_type.coq_type -> 'a2 -> ('a1, 'a2, 'a3, 'a4)
      value_with_lets) -> bool -> 'a1 Compilers.Coq_type.coq_type -> ('a1,
      'a2, ('a1, 'a2, 'a3, 'a4) value_with_lets) Compilers.Coq_expr.expr ->
      ('a1, ('a1, 'a4) abstract_domain)
      Compilers.Coq_type.for_each_lhs_of_arrow -> ('a1, 'a2, 'a3)
      Compilers.Coq_expr.expr

    val eta_expand_with_bound' :
      (bool -> 'a1 -> 'a4 -> ('a1, 'a2, 'a3) Compilers.Coq_expr.expr -> ('a1,
      'a2, 'a3, ('a1, 'a2, 'a3) Compilers.Coq_expr.expr)
      Coq_Compilers.UnderLets.coq_UnderLets) -> ('a1 -> 'a4) -> 'a1
      Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) Compilers.Coq_expr.expr
      -> ('a1, ('a1, 'a4) abstract_domain)
      Compilers.Coq_type.for_each_lhs_of_arrow -> ('a1, 'a2, 'a3)
      Compilers.Coq_expr.expr

    val extract' :
      ('a1 -> 'a3) -> ('a1 Compilers.Coq_type.coq_type -> 'a2 -> ('a1, 'a3)
      abstract_domain) -> 'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2, ('a1,
      'a3) abstract_domain) Compilers.Coq_expr.expr -> ('a1, 'a3)
      abstract_domain

    val extract_gen :
      ('a1 -> 'a3) -> ('a1 Compilers.Coq_type.coq_type -> 'a2 -> ('a1, 'a3)
      abstract_domain) -> 'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2, ('a1,
      'a3) abstract_domain) Compilers.Coq_expr.expr -> ('a1, ('a1, 'a3)
      abstract_domain) Compilers.Coq_type.for_each_lhs_of_arrow -> 'a3

    module Coq_ident :
     sig
      val update_annotation :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr option) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr -> 'a2 -> bool) -> Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type -> 'a2 -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr

      val annotate_with_expr :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr option) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr -> 'a2 -> bool) -> bool ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets

      val annotate_base :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr option) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr -> 'a2 -> bool) -> bool ->
        Coq3_Compilers.base -> 'a2 -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1,
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr)
        Coq_Compilers.UnderLets.coq_UnderLets

      val annotate :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr option) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, 'a2)
        Compilers.Coq_type.interp) -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type -> 'a2 -> 'a2 list option) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
        'a2 option option) -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr -> 'a2 -> bool) ->
        bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        'a2 -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets

      val interp_ident :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr option) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, 'a2)
        Compilers.Coq_type.interp) -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type -> 'a2 -> 'a2 list option) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
        'a2 option option) -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr -> 'a2 -> bool) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, 'a2) value option) -> bool ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, 'a2) value_with_lets

      val eval_with_bound :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr option) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, 'a2)
        Compilers.Coq_type.interp) -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type -> 'a2 -> 'a2 list option) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
        'a2 option option) -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr -> 'a2 -> bool) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, 'a2) value option) -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        Coq3_Compilers.ident -> bool) -> bool -> Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1, 'a2)
        value_with_lets) Compilers.Coq_expr.expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, 'a2) abstract_domain)
        Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr

      val eta_expand_with_bound :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr option) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, 'a2)
        Compilers.Coq_type.interp) -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type -> 'a2 -> 'a2 list option) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
        'a2 option option) -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr -> 'a2 -> bool) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, 'a2) abstract_domain)
        Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr

      val extract :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a1) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, 'a1)
        Compilers.Coq_type.interp) -> Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, 'a1) abstract_domain)
        Compilers.Coq_expr.expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, 'a1) abstract_domain)
        Compilers.Coq_type.for_each_lhs_of_arrow -> 'a1
     end

    val default_relax_zrange : zrange -> zrange option

    val annotation_of_state :
      (zrange -> zrange option) ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp -> zrange
      option

    val annotate_expr :
      (zrange -> zrange option) -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr option

    val abstract_interp_ident :
      Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
      bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
      Compilers.Coq_type.interp

    val always_strip_annotation :
      Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
      bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) value option

    val strip_annotation :
      Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
      bool -> bool -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      Coq3_Compilers.ident -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) value option

    val is_annotated_for :
      (zrange -> zrange option) -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp -> bool

    val annotation_to_expr :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr -> (__ -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr) option

    val bottom' :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp

    val extract_list_state :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp list option

    val extract_option_state :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp option option

    val eval_with_bound :
      (zrange -> zrange option) ->
      Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
      bool -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> bool) -> bool ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
      value_with_lets) Compilers.Coq_expr.expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
      abstract_domain) Compilers.Coq_type.for_each_lhs_of_arrow ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr

    val eta_expand_with_bound :
      (zrange -> zrange option) -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
      abstract_domain) Compilers.Coq_type.for_each_lhs_of_arrow ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr

    val coq_EvalWithBound :
      (zrange -> zrange option) ->
      Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
      bool -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> bool) -> bool ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
      abstract_domain) Compilers.Coq_type.for_each_lhs_of_arrow ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

    val coq_EtaExpandWithBound :
      (zrange -> zrange option) -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
      abstract_domain) Compilers.Coq_type.for_each_lhs_of_arrow ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

    val coq_EtaExpandWithListInfoFromBound :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
      abstract_domain) Compilers.Coq_type.for_each_lhs_of_arrow ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

    val coq_Extract :
      Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
      bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
      abstract_domain) Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp
   end

  module CheckCasts :
   sig
    val get_casts :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type, __ -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr) sigT list) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type, __ -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr) sigT list

    val coq_GetUnsupportedCasts :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type, __ ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr) sigT list
   end

  val coq_PartialEvaluateWithBounds :
    Coq6_Compilers.ZRange.Settings.shiftr_avoid_uint1_opt -> (zrange ->
    zrange option) -> bool -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    Coq3_Compilers.ident -> bool) -> bool -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
    Compilers.Coq_expr.expr

  val coq_PartialEvaluateWithListInfoFromBounds :
    Coq6_Compilers.ZRange.Settings.shiftr_avoid_uint1_opt ->
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
    Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
    Compilers.Coq_expr.expr

  val coq_CheckedPartialEvaluateWithBounds :
    Coq6_Compilers.ZRange.Settings.shiftr_avoid_uint1_opt -> (zrange ->
    zrange option) -> bool -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    Coq3_Compilers.ident -> bool) -> bool -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
    ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr,
    (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp * (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
    Compilers.Coq_expr.coq_Expr, (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type, __ ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr) sigT list) sum) sum
 end

module Associational :
 sig
  val eval : (z * z) list -> z

  val mul : (z * z) list -> (z * z) list -> (z * z) list

  val split : z -> (z * z) list -> (z * z) list * (z * z) list

  val reduce : z -> (z * z) list -> (z * z) list -> (z * z) list

  val repeat_reduce : nat -> z -> (z * z) list -> (z * z) list -> (z * z) list

  val let_bind_for_reduce_square :
    (z * z) list -> (z * z) list -> ((((z * z) * (z * z) list) * (z * z)
    list) * (z * z) list) list

  val reduce_square : z -> (z * z) list -> (z * z) list -> (z * z) list

  val carryterm : z -> z -> (z * z) -> (z * z) list

  val carry : z -> z -> (z * z) list -> (z * z) list
 end

module Positional :
 sig
  val to_associational : (nat -> z) -> nat -> z list -> (z * z) list

  val eval : (nat -> z) -> nat -> z list -> z

  val zeros : nat -> z list

  val add_to_nth : nat -> z -> z list -> z list

  val place : (nat -> z) -> (z * z) -> nat -> nat * z

  val from_associational : (nat -> z) -> nat -> (z * z) list -> z list

  val squaremod : (nat -> z) -> z -> (z * z) list -> nat -> z list -> z list

  val carry : (nat -> z) -> nat -> nat -> nat -> z list -> z list

  val carry_reduce :
    (nat -> z) -> nat -> z -> (z * z) list -> nat -> z list -> z list

  val chained_carries :
    (nat -> z) -> nat -> z -> (z * z) list -> z list -> nat list -> z list

  val encode : (nat -> z) -> nat -> z -> (z * z) list -> z -> z list

  val scmul : (nat -> z) -> nat -> z -> z list -> z list
 end

val weight : z -> z -> nat -> z

module Partition :
 sig
  val partition : (nat -> z) -> nat -> z -> z list
 end

module Rows :
 sig
  val adjust_s : (nat -> z) -> nat -> z -> z * bool
 end

module Coq9_Compilers :
 sig
  module Subst01 :
   sig
    val contains_always_live_ident :
      ('a1 Compilers.Coq_type.coq_type -> 'a2 -> bool) -> ('a1
      Compilers.Coq_type.coq_type -> 'a3) -> 'a1 Compilers.Coq_type.coq_type
      -> ('a1, 'a2, 'a3) Compilers.Coq_expr.expr -> bool

    val compute_live_counts' :
      'a1 -> ('a1 -> 'a1) -> ('a1 option -> 'a1) -> ('a2
      Compilers.Coq_type.coq_type -> 'a3 -> bool) -> 'a2
      Compilers.Coq_type.coq_type -> ('a2, 'a3, positive)
      Compilers.Coq_expr.expr -> positive -> 'a1 PositiveMap.t ->
      positive * 'a1 PositiveMap.t

    val compute_live_counts :
      'a1 -> ('a1 -> 'a1) -> ('a1 option -> 'a1) -> ('a2
      Compilers.Coq_type.coq_type -> 'a3 -> bool) -> 'a2
      Compilers.Coq_type.coq_type -> ('a2, 'a3, positive)
      Compilers.Coq_expr.expr -> 'a1 PositiveMap.t

    val coq_ComputeLiveCounts :
      'a1 -> ('a1 -> 'a1) -> ('a1 option -> 'a1) -> ('a2
      Compilers.Coq_type.coq_type -> 'a3 -> bool) -> 'a2
      Compilers.Coq_type.coq_type -> ('a2, 'a3) Compilers.Coq_expr.coq_Expr
      -> 'a1 PositiveMap.t

    val subst0n' :
      (__ -> __ -> __ -> (unit -> __) -> __) -> ('a1 -> bool) -> 'a1
      PositiveMap.t -> 'a2 Compilers.Coq_type.coq_type -> ('a2, 'a3, ('a2,
      'a3, 'a4) Compilers.Coq_expr.expr) Compilers.Coq_expr.expr -> positive
      -> positive * ('a2, 'a3, 'a4) Compilers.Coq_expr.expr

    val subst0n :
      (__ -> __ -> __ -> (unit -> __) -> __) -> ('a1 -> bool) -> 'a1
      PositiveMap.t -> 'a2 Compilers.Coq_type.coq_type -> ('a2, 'a3, ('a2,
      'a3, 'a4) Compilers.Coq_expr.expr) Compilers.Coq_expr.expr -> ('a2,
      'a3, 'a4) Compilers.Coq_expr.expr

    val coq_Subst0n :
      'a1 -> ('a1 -> 'a1) -> ('a1 option -> 'a1) -> ('a2
      Compilers.Coq_type.coq_type -> 'a3 -> bool) -> (__ -> __ -> __ -> (unit
      -> __) -> __) -> ('a1 -> bool) -> 'a2 Compilers.Coq_type.coq_type ->
      ('a2, 'a3) Compilers.Coq_expr.coq_Expr -> ('a2, 'a3, __)
      Compilers.Coq_expr.expr

    type one_or_more =
    | Coq_one
    | Coq_more

    val coq_Subst01 :
      ('a1 Compilers.Coq_type.coq_type -> 'a2 -> bool) -> 'a1
      Compilers.Coq_type.coq_type -> ('a1, 'a2) Compilers.Coq_expr.coq_Expr
      -> ('a1, 'a2, __) Compilers.Coq_expr.expr
   end

  module DeadCodeElimination :
   sig
    val coq_OUGHT_TO_BE_UNUSED : 'a1 -> 'a2 -> 'a1

    val coq_EliminateDead :
      ('a1 Compilers.Coq_type.coq_type -> 'a2 -> bool) -> 'a1
      Compilers.Coq_type.coq_type -> ('a1, 'a2) Compilers.Coq_expr.coq_Expr
      -> ('a1, 'a2, __) Compilers.Coq_expr.expr
   end
 end

module Coq10_Compilers :
 sig
  module Coq_pattern :
   sig
    module Coq_ident :
     sig
      val all_base0 : Coq3_Compilers.base list

      val all_idents0 : (__, __) Coq_Primitive.sigT list

      val ident_index :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> nat

      val eta_ident_cps_gen :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> 'a1) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> 'a1)

      val eta_ident_cps_gen_expand_literal :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> 'a1) ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> 'a1)

      val eta_ident_cps :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> 'a1) -> 'a1

      val simple_idents :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type, Coq3_Compilers.ident) Coq_Primitive.sigT
        list

      val all_raw_idents : Coq3_Compilers.raw_ident list

      val ident_index0 : Coq3_Compilers.raw_ident -> nat

      val eta_ident_cps_gen0 :
        (Coq3_Compilers.raw_ident -> 'a1) -> (Coq3_Compilers.raw_ident -> 'a1)

      val raw_ident_infos_of :
        Coq3_Compilers.raw_ident -> (Coq3_Compilers.base,
        Coq3_Compilers.ident)
        Coq0_Compilers.Coq_pattern.Raw.Coq_ident.ident_infos

      val split_raw_ident_gen :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.raw_ident, (Coq3_Compilers.base,
        Coq3_Compilers.ident)
        Coq0_Compilers.Coq_pattern.Raw.Coq_ident.ident_args)
        Coq_Primitive.sigT

      val raw_invert_bind_args :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        Coq3_Compilers.raw_ident -> __ option

      val invert_bind_args_unknown :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        Coq3_Compilers.raw_ident -> __ option

      val all_pattern_idents : (__, __) Coq_Primitive.sigT list

      val eta_ident_cps_gen1 :
        (Coq3_Compilers.base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.pattern_ident -> 'a1)
        -> (Coq3_Compilers.base
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.pattern_ident -> 'a1)

      val eta_ident_cps_gen_expand_literal0 :
        (Coq3_Compilers.base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.pattern_ident -> 'a1)
        -> (Coq3_Compilers.base
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.pattern_ident -> 'a1)

      val split_types :
        Coq3_Compilers.base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.pattern_ident ->
        (Coq3_Compilers.raw_ident, __ * __) Coq_Primitive.sigT

      val add_types_from_raw_sig :
        Coq3_Compilers.raw_ident -> __ -> __ -> (Coq3_Compilers.base
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type, Coq3_Compilers.pattern_ident)
        Coq_Primitive.sigT

      val arg_types_unfolded :
        Coq3_Compilers.base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.pattern_ident -> __ list

      val type_of_list_arg_types_beq_unfolded :
        Coq3_Compilers.base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.pattern_ident -> __ ->
        __ -> bool

      val to_typed_unfolded :
        Coq3_Compilers.base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.pattern_ident ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        PositiveMap.tree -> __ -> Coq3_Compilers.ident

      val of_typed_ident_unfolded :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        Coq3_Compilers.pattern_ident

      val arg_types_of_typed_ident_unfolded :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> __

      val unify :
        Coq3_Compilers.base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        Coq3_Compilers.pattern_ident -> Coq3_Compilers.ident -> __ option

      val unify_unknown :
        Coq3_Compilers.base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        Coq3_Compilers.pattern_ident -> Coq3_Compilers.ident -> __ option
     end
   end
 end

val nbe_rewrite_rulesT : (bool * __) list

val unfold_value_barrier_rewrite_rulesT : (bool * __) list

val arith_rewrite_rulesT : z -> (bool * __) list

val arith_with_casts_rewrite_rulesT : bool -> (bool * __) list

val strip_literal_casts_rewrite_rulesT : (bool * __) list

val add_assoc_left_rewrite_rulesT : (bool * __) list

val flatten_thunked_rects_rewrite_rulesT : (bool * __) list

val relax_bitwidth_adc_sbb_rewrite_rulesT : z list -> (bool * __) list

val fancy_rewrite_rulesT : (bool * __) list

val fancy_with_casts_rewrite_rulesT :
  (z -> z -> z option) -> (z -> z -> z option) -> zrange -> zrange ->
  (bool * __) list

val mul_split_rewrite_rulesT : z -> z -> (bool * __) list

val multiret_split_rewrite_rulesT : z -> z -> (bool * __) list

val noselect_rewrite_rulesT : z -> (bool * __) list

module Coq11_Compilers :
 sig
  module RewriteRules :
   sig
    val rewrite_rules :
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_rule_data) sigT list

    val dtree :
      Coq3_Compilers.raw_ident
      Coq1_Compilers.RewriteRules.Compile.decision_tree

    val pr2_rewrite_rules :
      ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_rule_data,
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_rule_data) hlist)
      Primitive.prod

    val all_rewrite_rules :
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list

    val rewrite_head :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value'

    val rewrite_head_no_dtree0 :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val rewrite_head1 :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val coq_RewriteNBE :
      Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
      -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr
   end

  val coq_PartialEvaluate :
    Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
    -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
    Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
    Compilers.Coq_expr.expr
 end

module Coq12_Compilers :
 sig
  module RewriteRules :
   sig
    val rewrite_rules :
      (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list

    val dtree :
      Coq3_Compilers.raw_ident
      Coq1_Compilers.RewriteRules.Compile.decision_tree

    val pr2_rewrite_rules :
      ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
      Primitive.prod

    val all_rewrite_rules :
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list

    val rewrite_head :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value'

    val rewrite_head_no_dtree0 :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val rewrite_head1 :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val coq_RewriteAddAssocLeft :
      Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
      -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr
   end
 end

module Coq13_Compilers :
 sig
  module RewriteRules :
   sig
    val rewrite_rules :
      z -> (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list

    val dtree :
      Coq3_Compilers.raw_ident
      Coq1_Compilers.RewriteRules.Compile.decision_tree

    val pr2_rewrite_rules :
      z -> ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
      Primitive.prod

    val all_rewrite_rules :
      z -> ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list

    val rewrite_head :
      z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value'

    val rewrite_head_no_dtree0 :
      z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val rewrite_head1 :
      z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val coq_RewriteArith :
      z ->
      Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
      -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr
   end
 end

module Coq14_Compilers :
 sig
  module RewriteRules :
   sig
    val rewrite_rules :
      bool -> (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list

    val dtree :
      Coq3_Compilers.raw_ident
      Coq1_Compilers.RewriteRules.Compile.decision_tree

    val pr2_rewrite_rules :
      bool -> ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
      Primitive.prod

    val all_rewrite_rules :
      bool -> ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list

    val rewrite_head :
      bool -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value'

    val rewrite_head_no_dtree0 :
      bool -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val rewrite_head1 :
      bool -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val coq_RewriteArithWithCasts :
      bool ->
      Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
      -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr
   end
 end

module Coq15_Compilers :
 sig
  module RewriteRules :
   sig
    val rewrite_rules :
      (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list

    val dtree :
      Coq3_Compilers.raw_ident
      Coq1_Compilers.RewriteRules.Compile.decision_tree

    val pr2_rewrite_rules :
      ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
      Primitive.prod

    val all_rewrite_rules :
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list

    val rewrite_head :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value'

    val rewrite_head_no_dtree0 :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val rewrite_head1 :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val coq_RewriteStripLiteralCasts :
      Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
      -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr
   end
 end

module Coq16_Compilers :
 sig
  module RewriteRules :
   sig
    val rewrite_rules :
      (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list

    val dtree :
      Coq3_Compilers.raw_ident
      Coq1_Compilers.RewriteRules.Compile.decision_tree

    val pr2_rewrite_rules :
      ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
      Primitive.prod

    val all_rewrite_rules :
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list

    val rewrite_head :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value'

    val rewrite_head_no_dtree0 :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val rewrite_head1 :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val coq_RewriteFlattenThunkedRects :
      Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
      -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr
   end
 end

module Coq17_Compilers :
 sig
  module RewriteRules :
   sig
    val rewrite_rules :
      z -> z -> (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list

    val dtree :
      Coq3_Compilers.raw_ident
      Coq1_Compilers.RewriteRules.Compile.decision_tree

    val pr2_rewrite_rules :
      z -> z -> ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
      Primitive.prod

    val all_rewrite_rules :
      z -> z -> ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list

    val rewrite_head :
      z -> z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value'

    val rewrite_head_no_dtree0 :
      z -> z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val rewrite_head1 :
      z -> z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val coq_RewriteMulSplit :
      z -> z ->
      Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
      -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr
   end
 end

module Coq18_Compilers :
 sig
  module RewriteRules :
   sig
    val rewrite_rules :
      z -> z -> (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list

    val dtree :
      Coq3_Compilers.raw_ident
      Coq1_Compilers.RewriteRules.Compile.decision_tree

    val pr2_rewrite_rules :
      z -> z -> ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
      Primitive.prod

    val all_rewrite_rules :
      z -> z -> ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list

    val rewrite_head :
      z -> z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value'

    val rewrite_head_no_dtree0 :
      z -> z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val rewrite_head1 :
      z -> z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val coq_RewriteMultiRetSplit :
      z -> z ->
      Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
      -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr
   end
 end

module Coq19_Compilers :
 sig
  module RewriteRules :
   sig
    val rewrite_rules :
      z -> (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list

    val dtree :
      Coq3_Compilers.raw_ident
      Coq1_Compilers.RewriteRules.Compile.decision_tree

    val pr2_rewrite_rules :
      z -> ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
      Primitive.prod

    val all_rewrite_rules :
      z -> ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list

    val rewrite_head :
      z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value'

    val rewrite_head_no_dtree0 :
      z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val rewrite_head1 :
      z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val coq_RewriteNoSelect :
      z ->
      Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
      -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr
   end
 end

module Coq20_Compilers :
 sig
  module RewriteRules :
   sig
    val rewrite_rules :
      z list -> (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list

    val dtree :
      Coq3_Compilers.raw_ident
      Coq1_Compilers.RewriteRules.Compile.decision_tree

    val pr2_rewrite_rules :
      z list -> ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
      Primitive.prod

    val all_rewrite_rules :
      z list -> ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list

    val rewrite_head :
      z list -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value'

    val rewrite_head_no_dtree0 :
      z list -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val rewrite_head1 :
      z list -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val coq_RewriteRelaxBitwidthAdcSbb :
      z list ->
      Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
      -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr
   end
 end

module Coq21_Compilers :
 sig
  module RewriteRules :
   sig
    val rewrite_rules :
      (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list

    val dtree :
      Coq3_Compilers.raw_ident
      Coq1_Compilers.RewriteRules.Compile.decision_tree

    val pr2_rewrite_rules : unit

    val all_rewrite_rules :
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list

    val rewrite_head :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value'

    val rewrite_head_no_dtree0 :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val rewrite_head1 :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val coq_RewriteToFancy :
      (z -> z -> z option) -> (z -> z -> z option) ->
      Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
      -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr
   end
 end

module Coq22_Compilers :
 sig
  module RewriteRules :
   sig
    val rewrite_rules :
      (z -> z -> z option) -> (z -> z -> z option) -> zrange -> zrange ->
      (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list

    val dtree :
      Coq3_Compilers.raw_ident
      Coq1_Compilers.RewriteRules.Compile.decision_tree

    val pr2_rewrite_rules :
      (z -> z -> z option) -> (z -> z -> z option) -> zrange -> zrange ->
      ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
      Primitive.prod

    val all_rewrite_rules :
      (z -> z -> z option) -> (z -> z -> z option) -> zrange -> zrange ->
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list

    val rewrite_head :
      (z -> z -> z option) -> (z -> z -> z option) -> zrange -> zrange ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value'

    val rewrite_head_no_dtree0 :
      (z -> z -> z option) -> (z -> z -> z option) -> zrange -> zrange ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val rewrite_head1 :
      (z -> z -> z option) -> (z -> z -> z option) -> zrange -> zrange ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val coq_RewriteToFancyWithCasts :
      (z -> z -> z option) -> (z -> z -> z option) -> zrange -> zrange ->
      Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
      -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr
   end
 end

module Coq23_Compilers :
 sig
  module RewriteRules :
   sig
    val rewrite_rules :
      (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list

    val dtree :
      Coq3_Compilers.raw_ident
      Coq1_Compilers.RewriteRules.Compile.decision_tree

    val pr2_rewrite_rules :
      ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
      Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
      Primitive.prod

    val all_rewrite_rules :
      ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
      Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
      Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list

    val rewrite_head :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value'

    val rewrite_head_no_dtree0 :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val rewrite_head1 :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
      Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, 'a1)
      Coq1_Compilers.RewriteRules.Compile.value_with_lets

    val coq_RewriteUnfoldValueBarrier :
      Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
      -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr
   end
 end

val relax_zrange_gen_ranges : zrange list -> zrange -> zrange option

type kind_of_range =
| Signed
| Unsigned

val ranges_of_bitwidths : (z * kind_of_range) list -> zrange list

val relax_zrange_gen : bool -> z list -> zrange -> zrange option

module Coq_typedef :
 sig
  type typedef = { name : char list; description : (char list -> char list) }

  val name :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp -> typedef ->
    char list

  val description :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp -> typedef ->
    char list -> char list
 end

type low_level_rewriter_method_opt =
| Precomputed_decision_tree
| Unreduced_decision_tree
| Unreduced_naive

val default_low_level_rewriter_method : low_level_rewriter_method_opt

type machine_wordsize_opt = z

val machine_wordsize : machine_wordsize_opt -> z

type static_opt = bool

type inline_internal_opt = bool

type inline_opt = bool

type internal_static_opt = bool

type use_mul_for_cmovznz_opt = bool

type emit_primitives_opt = bool

type only_signed_opt = bool

type no_select_opt = bool

val no_select : no_select_opt -> bool

type no_select_size_opt = z option

type should_split_mul_opt = bool

val should_split_mul : should_split_mul_opt -> bool

type split_mul_to_opt = (z * z) option

type should_split_multiret_opt = bool

val should_split_multiret : should_split_multiret_opt -> bool

type split_multiret_to_opt = (z * z) option

type widen_carry_opt = bool

val widen_carry : widen_carry_opt -> bool

type widen_bytes_opt = bool

val widen_bytes : widen_bytes_opt -> bool

type debug_rewriting_opt = bool

type to_fancy_args = { invert_low : (z -> z -> z option);
                       invert_high : (z -> z -> z option);
                       value_range : zrange; flag_range : zrange }

type translate_to_fancy_opt = to_fancy_args option

val default_translate_to_fancy : translate_to_fancy_opt

type unfold_value_barrier_opt = bool

type assembly_hints_lines_opt = (char list * char list list) list

type error_on_unused_assembly_functions_opt = bool

type ignore_unique_asm_names_opt = bool

type synthesis_output_kind =
| Normal_output
| Assembly_output

val typedef_info_of_typedef :
  Coq7_Compilers.Options.relax_zrange_opt -> Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type ->
  Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
  Coq_typedef.typedef -> ((char list * (char list ->
  char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
  option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT

module Pipeline :
 sig
  type coq_BoundsPipelineOptions = { coq_AbstractInterpretation_opts : 
                                     Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options;
                                     low_level_rewriter_method : low_level_rewriter_method_opt;
                                     only_signed : only_signed_opt;
                                     no_select_size : no_select_size_opt;
                                     split_mul_to : split_mul_to_opt;
                                     split_multiret_to : split_multiret_to_opt;
                                     unfold_value_barrier : unfold_value_barrier_opt;
                                     relax_adc_sbb_return_carry_to_bitwidth : 
                                     Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt;
                                     translate_to_fancy : translate_to_fancy_opt;
                                     debug_rewriting : debug_rewriting_opt }

  val coq_AbstractInterpretation_opts :
    coq_BoundsPipelineOptions ->
    Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options

  val low_level_rewriter_method :
    coq_BoundsPipelineOptions -> low_level_rewriter_method_opt

  val only_signed : coq_BoundsPipelineOptions -> only_signed_opt

  val no_select_size : coq_BoundsPipelineOptions -> no_select_size_opt

  val split_mul_to : coq_BoundsPipelineOptions -> split_mul_to_opt

  val split_multiret_to : coq_BoundsPipelineOptions -> split_multiret_to_opt

  val unfold_value_barrier :
    coq_BoundsPipelineOptions -> unfold_value_barrier_opt

  val relax_adc_sbb_return_carry_to_bitwidth :
    coq_BoundsPipelineOptions ->
    Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt

  val translate_to_fancy : coq_BoundsPipelineOptions -> translate_to_fancy_opt

  val debug_rewriting : coq_BoundsPipelineOptions -> debug_rewriting_opt

  val with_dead_code_elimination : coq_BoundsPipelineOptions -> bool

  val with_let_bind_return : coq_BoundsPipelineOptions -> bool

  val adc_no_carry_to_add : coq_BoundsPipelineOptions -> bool

  type coq_ErrorMessage =
  | Computed_bounds_are_not_tight_enough of Coq3_Compilers.base
                                            Compilers.Coq_base.Coq_type.coq_type
                                            Compilers.Coq_type.coq_type
     * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp
     * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp
     * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
       Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr
     * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
       Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
       Compilers.Coq_type.for_each_lhs_of_arrow
  | No_modular_inverse of char list * z * z
  | Value_not_leZ of char list * z * z
  | Value_not_leQ of char list * q * q
  | Value_not_ltZ of char list * z * z
  | Value_not_lt_listZ of char list * z list * z list
  | Value_not_le_listZ of char list * z list * z list
  | Values_not_provably_distinctZ of char list * z * z
  | Values_not_provably_equalZ of char list * z * z
  | Values_not_provably_equal_listZ of char list * z list * z list
  | Unsupported_casts_in_input of Coq3_Compilers.base
                                  Compilers.Coq_base.Coq_type.coq_type
                                  Compilers.Coq_type.coq_type
     * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
       Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr
     * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
       Compilers.Coq_type.coq_type, (Coq3_Compilers.base
       Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, char list)
       Compilers.Coq_expr.expr) sigT list
  | Stringification_failed of Coq3_Compilers.base
                              Compilers.Coq_base.Coq_type.coq_type
                              Compilers.Coq_type.coq_type
     * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
       Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr * char list
  | Invalid_argument of char list
  | Assembly_parsing_error of char list * parseValidatedError
  | Assembly_without_any_global_labels of char list list
  | Unused_global_assembly_labels of (char list * char list list) list
     * char list list
  | Equivalence_checking_failure_pre_asm of Coq3_Compilers.base
                                            Compilers.Coq_base.Coq_type.coq_type
                                            Compilers.Coq_type.coq_type
     * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
       Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr
     * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
       Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
       Compilers.Coq_type.for_each_lhs_of_arrow * equivalenceCheckingError
  | Equivalence_checking_failure of Coq3_Compilers.base
                                    Compilers.Coq_base.Coq_type.coq_type
                                    Compilers.Coq_type.coq_type
     * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
       Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr * char list * 
     lines
     * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
       Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
       Compilers.Coq_type.for_each_lhs_of_arrow * equivalenceCheckingError

  module M :
   sig
    val bind :
      (char list, (coq_ErrorMessage, 'a1) errorT) debugM -> ('a1 ->
      (char list, (coq_ErrorMessage, 'a2) errorT) debugM) -> (char list,
      (coq_ErrorMessage, 'a2) errorT) debugM
   end

  type coq_ExtendedSynthesisResult = { lines : char list list;
                                       ident_infos : Coq7_Compilers.ToString.ident_infos;
                                       arg_bounds : (Coq3_Compilers.base
                                                    Compilers.Coq_base.Coq_type.coq_type,
                                                    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
                                                    Compilers.Coq_type.for_each_lhs_of_arrow;
                                       out_bounds : Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp;
                                       arg_typedefs : (Coq3_Compilers.base
                                                      Compilers.Coq_base.Coq_type.coq_type,
                                                      Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
                                                      Compilers.Coq_type.for_each_lhs_of_arrow;
                                       out_typedefs : Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data;
                                       expr : (Coq3_Compilers.base
                                              Compilers.Coq_base.Coq_type.coq_type,
                                              Coq3_Compilers.ident)
                                              Compilers.Coq_expr.coq_Expr }

  val lines :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> coq_ExtendedSynthesisResult -> char list
    list

  val ident_infos :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> coq_ExtendedSynthesisResult ->
    Coq7_Compilers.ToString.ident_infos

  val arg_bounds :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> coq_ExtendedSynthesisResult ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow

  val out_bounds :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> coq_ExtendedSynthesisResult ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp

  val expr :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> coq_ExtendedSynthesisResult ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val find_too_loose_base_bounds :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
    (bool * (nat * nat) list) * (zrange * zrange) list

  val find_too_loose_bounds :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type ->
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp ->
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp -> (bool * (nat * nat)
    list) * (zrange * zrange) list

  val explain_too_loose_bounds :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type ->
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp ->
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp -> char list

  val show_lines_Expr_with_and_without_casts :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
    Compilers.Coq_expr.coq_Expr showLines

  val show_lines_Expr :
    machine_wordsize_opt -> Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow -> bool -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
    Compilers.Coq_expr.coq_Expr showLines

  val show_lines_ErrorMessage :
    machine_wordsize_opt -> Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    coq_ErrorMessage showLines

  val debug_after_rewrite :
    debug_rewriting_opt -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    char list -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (char list, unit)
    debugM

  val wrap_debug_rewrite :
    debug_rewriting_opt -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    char list -> ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
    Compilers.Coq_expr.coq_Expr) -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
    Compilers.Coq_expr.coq_Expr -> (char list, (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
    Compilers.Coq_expr.coq_Expr) debugM

  val coq_RewriteAndEliminateDeadAndInline_gen :
    debug_rewriting_opt -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    char list -> ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (char list,
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr) debugM) -> bool ->
    bool -> bool -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
    Compilers.Coq_expr.coq_Expr -> (char list, (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
    Compilers.Coq_expr.coq_Expr) debugM

  val coq_RewriteAndEliminateDeadAndInline :
    debug_rewriting_opt -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    char list -> ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
    Compilers.Coq_expr.coq_Expr) -> bool -> bool -> bool ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (char list,
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr) debugM

  val opts_of_method :
    low_level_rewriter_method_opt ->
    Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions

  val coq_PreBoundsPipeline :
    Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
    low_level_rewriter_method_opt -> only_signed_opt ->
    unfold_value_barrier_opt -> translate_to_fancy_opt -> debug_rewriting_opt
    -> bool -> bool -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow -> (char list,
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr) debugM

  val coq_RepeatRewriteAddAssocLeftAndFlattenThunkedRectsWithDebug :
    low_level_rewriter_method_opt -> debug_rewriting_opt -> nat ->
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (char list, (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
    Compilers.Coq_expr.coq_Expr) debugM -> (char list, (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
    Compilers.Coq_expr.coq_Expr) debugM

  val coq_RepeatRewriteAddAssocLeftAndFlattenThunkedRects :
    low_level_rewriter_method_opt -> debug_rewriting_opt -> nat ->
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (char list, (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
    Compilers.Coq_expr.coq_Expr) debugM -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
    Compilers.Coq_expr.expr

  val coq_BoundsPipelineWithDebug :
    coq_BoundsPipelineOptions -> bool -> z list -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp -> (char list,
    (coq_ErrorMessage, (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
    Compilers.Coq_expr.coq_Expr) errorT) debugM
 end

val bytes_n : z -> nat

val qabs : q -> q

val uweight : z -> nat -> z

val fueled_lub :
  ('a1 -> 'a1 -> bool) -> ('a1 -> 'a1 -> 'a1) -> nat -> ('a1 -> 'a1) -> 'a1
  -> bool * 'a1

val reified_id_gen :
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

val reified_selectznz_gen :
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

val reified_mulx_gen :
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

val reified_addcarryx_gen :
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

val reified_subborrowx_gen :
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

val reified_value_barrier_gen :
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

val reified_cmovznz_gen :
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

val reified_cmovznz_by_mul_gen :
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

val request_present : char list list -> char list -> bool

val check_args_of_list :
  (bool * (bool * Pipeline.coq_ErrorMessage)) list ->
  (Pipeline.coq_ErrorMessage, 'a1) errorT -> (Pipeline.coq_ErrorMessage, 'a1)
  errorT

module Coq0_Options :
 sig
  type coq_PipelineOptions = { absint_opts : Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options;
                               widen_carry : widen_carry_opt;
                               widen_bytes : widen_bytes_opt;
                               unfold_value_barrier : unfold_value_barrier_opt;
                               should_split_multiret : should_split_multiret_opt;
                               should_split_mul : should_split_mul_opt;
                               output_options : Coq7_Compilers.Options.output_options_opt;
                               only_signed : only_signed_opt;
                               no_select : no_select_opt;
                               low_level_rewriter_method : low_level_rewriter_method_opt;
                               debug_rewriting : debug_rewriting_opt }

  val absint_opts :
    coq_PipelineOptions ->
    Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options

  val widen_carry : coq_PipelineOptions -> widen_carry_opt

  val widen_bytes : coq_PipelineOptions -> widen_bytes_opt

  val unfold_value_barrier : coq_PipelineOptions -> unfold_value_barrier_opt

  val should_split_multiret : coq_PipelineOptions -> should_split_multiret_opt

  val should_split_mul : coq_PipelineOptions -> should_split_mul_opt

  val output_options :
    coq_PipelineOptions -> Coq7_Compilers.Options.output_options_opt

  val only_signed : coq_PipelineOptions -> only_signed_opt

  val no_select : coq_PipelineOptions -> no_select_opt

  val low_level_rewriter_method :
    coq_PipelineOptions -> low_level_rewriter_method_opt

  val debug_rewriting : coq_PipelineOptions -> debug_rewriting_opt

  type coq_PipelineToStringOptions = { static : static_opt;
                                       language_naming_conventions : 
                                       Coq7_Compilers.Options.language_naming_conventions_opt;
                                       internal_static : internal_static_opt;
                                       inline_internal : inline_internal_opt;
                                       inline : inline_opt;
                                       documentation_options : Coq7_Compilers.Options.documentation_options_opt }

  val static : coq_PipelineToStringOptions -> static_opt

  val language_naming_conventions :
    coq_PipelineToStringOptions ->
    Coq7_Compilers.Options.language_naming_conventions_opt

  val internal_static : coq_PipelineToStringOptions -> internal_static_opt

  val inline_internal : coq_PipelineToStringOptions -> inline_internal_opt

  val inline : coq_PipelineToStringOptions -> inline_opt

  val documentation_options :
    coq_PipelineToStringOptions ->
    Coq7_Compilers.Options.documentation_options_opt

  type coq_SynthesisOptions = { use_mul_for_cmovznz : use_mul_for_cmovznz_opt;
                                package_namev : Coq7_Compilers.Options.package_name_opt;
                                ignore_unique_asm_names : ignore_unique_asm_names_opt;
                                error_on_unused_assembly_functions : 
                                error_on_unused_assembly_functions_opt;
                                emit_primitives : emit_primitives_opt;
                                class_namev : Coq7_Compilers.Options.class_name_opt;
                                assembly_hints_lines : assembly_hints_lines_opt;
                                equivalence_checker_options : Coq_Options.equivalence_checker_options_opt }

  val use_mul_for_cmovznz : coq_SynthesisOptions -> use_mul_for_cmovznz_opt

  val package_namev :
    coq_SynthesisOptions -> Coq7_Compilers.Options.package_name_opt

  val ignore_unique_asm_names :
    coq_SynthesisOptions -> ignore_unique_asm_names_opt

  val error_on_unused_assembly_functions :
    coq_SynthesisOptions -> error_on_unused_assembly_functions_opt

  val emit_primitives : coq_SynthesisOptions -> emit_primitives_opt

  val class_namev :
    coq_SynthesisOptions -> Coq7_Compilers.Options.class_name_opt

  val assembly_hints_lines : coq_SynthesisOptions -> assembly_hints_lines_opt

  val equivalence_checker_options :
    coq_SynthesisOptions -> Coq_Options.equivalence_checker_options_opt
 end

val word_bound : machine_wordsize_opt -> Coq6_Compilers.ZRange.Coq_type.interp

val saturated_bounds :
  nat -> machine_wordsize_opt ->
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list

val possible_values_of_machine_wordsize :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt -> z list

val possible_values_of_machine_wordsize_with_bytes :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt -> z list

val no_select_size0 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
  no_select_size_opt

val split_mul_to0 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt -> split_mul_to_opt

val split_multiret_to0 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
  split_multiret_to_opt

val absint_opts_with_no_shiftr_avoid_uint1 :
  Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options

val sselectznz :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> nat -> machine_wordsize_opt ->
  char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val smulx :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> machine_wordsize_opt ->
  char list -> z -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val saddcarryx :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> machine_wordsize_opt ->
  char list -> z -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val ssubborrowx :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> machine_wordsize_opt ->
  char list -> z -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val svalue_barrier :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> machine_wordsize_opt ->
  char list -> Coq7_Compilers.ToString.Coq_int.coq_type ->
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val scmovznz :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> machine_wordsize_opt ->
  char list -> z -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val scmovznz_by_mul :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> machine_wordsize_opt ->
  char list -> z -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val aggregate_infos :
  (char list * (char list, (Pipeline.coq_ErrorMessage, (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
  Pipeline.coq_ExtendedSynthesisResult) sigT) errorT) debugM) list ->
  Coq7_Compilers.ToString.ident_infos

val push_sig_type :
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type, char list * (char list,
  (Pipeline.coq_ErrorMessage, Pipeline.coq_ExtendedSynthesisResult) errorT)
  debugM) sigT -> char list * (char list, (Pipeline.coq_ErrorMessage,
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type, Pipeline.coq_ExtendedSynthesisResult) sigT)
  errorT) debugM

val extra_synthesis :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions ->
  Coq0_Options.coq_SynthesisOptions -> machine_wordsize_opt -> char list ->
  Coq7_Compilers.ToString.ident_infos -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM) sigT
  list * Coq7_Compilers.ToString.ident_infos

val union_extra_infos_of_extra_synthesis :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions ->
  Coq0_Options.coq_SynthesisOptions -> machine_wordsize_opt ->
  Coq7_Compilers.ToString.ident_infos -> Coq7_Compilers.ToString.ident_infos

val synthesize_of_name :
  char list -> (char list * (char list -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM) sigT)) list ->
  (char list -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type, char list * (char list,
  (Pipeline.coq_ErrorMessage, Pipeline.coq_ExtendedSynthesisResult) errorT)
  debugM) sigT option list) -> char list -> char list ->
  char list * (char list, (Pipeline.coq_ErrorMessage, (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
  Pipeline.coq_ExtendedSynthesisResult) sigT) errorT) debugM

val parse_asm_files_lines :
  (char list * char list list) list -> (Pipeline.coq_ErrorMessage,
  (char list * (lines * (char list * lines) list)) list) errorT

val parse_asm_hints :
  Coq0_Options.coq_SynthesisOptions -> (Pipeline.coq_ErrorMessage,
  (char list * (lines * (char list * lines) list)) list) errorT

val split_to_assembly_functions :
  Coq0_Options.coq_SynthesisOptions -> (char list * (char list * 'a1) list)
  list -> (char list * 'a2) list -> (((char list * ((char list * 'a1)
  list * 'a2)) list * (char list * 'a2)
  list) * (char list * (char list * 'a1) list) list) * char list list

val synthesize :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions ->
  Coq0_Options.coq_SynthesisOptions -> machine_wordsize_opt -> char list ->
  (char list * (char list -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM) sigT)) list ->
  (char list -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type, char list * (char list,
  (Pipeline.coq_ErrorMessage, Pipeline.coq_ExtendedSynthesisResult) errorT)
  debugM) sigT option list) -> (((char list * (char list ->
  char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
  option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) list ->
  (char list list -> (Pipeline.coq_ErrorMessage, char list list) errorT ->
  (Pipeline.coq_ErrorMessage, char list list) errorT) -> char list list ->
  char list -> char list list ->
  ((synthesis_output_kind * char list) * (char list,
  (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list

module SaturatedSolinas :
 sig
  val reified_mul_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr
 end

val override_pipeline_opts :
  Coq0_Options.coq_PipelineOptions -> Coq0_Options.coq_PipelineOptions

val possible_values_of_machine_wordsize0 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt -> z list

val n0 : z -> machine_wordsize_opt -> nat

val m0 : z -> (z * z) list -> z

val nreductions : z -> (z * z) list -> machine_wordsize_opt -> nat

val no_select_size1 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
  no_select_size_opt

val split_mul_to1 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt -> split_mul_to_opt

val split_multiret_to1 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
  split_multiret_to_opt

val check_args :
  z -> (z * z) list -> machine_wordsize_opt -> char list list ->
  (Pipeline.coq_ErrorMessage, 'a1) errorT -> (Pipeline.coq_ErrorMessage, 'a1)
  errorT

val smul :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> (z * z) list ->
  machine_wordsize_opt -> char list -> char list * (char list,
  (Pipeline.coq_ErrorMessage, Pipeline.coq_ExtendedSynthesisResult) errorT)
  debugM

val known_functions :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> (z * z) list ->
  machine_wordsize_opt -> (char list * (char list -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM) sigT)) list

val valid_names : char list

val synthesize0 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions ->
  Coq0_Options.coq_SynthesisOptions -> z -> (z * z) list ->
  machine_wordsize_opt -> char list list -> char list -> char list list ->
  ((synthesis_output_kind * char list) * (char list,
  (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list

module TAPOrder :
 sig
  type t = z * z

  val leb : t -> t -> bool
 end

module TAPSort :
 sig
  val merge : (z * z) list -> (z * z) list -> (z * z) list

  val merge_list_to_stack :
    (z * z) list option list -> (z * z) list -> (z * z) list option list

  val merge_stack : (z * z) list option list -> (z * z) list

  val iter_merge : (z * z) list option list -> (z * z) list -> (z * z) list

  val sort : (z * z) list -> (z * z) list

  val flatten_stack : (z * z) list option list -> (z * z) list
 end

type tight_upperbound_fraction_opt = q

val carry_chains : nat -> z -> (z * z) list -> nat list

val default_tight_upperbound_fraction : q

val coef : z

val prime_upperbound_list : nat -> z -> (z * z) list -> z list

val tight_upperbounds :
  tight_upperbound_fraction_opt -> nat -> z -> (z * z) list -> z list

val headspace_add_count : nat

val headspace_sub_count : nat

val distribute_balance_step :
  nat -> z -> (z * z) list -> z list -> nat -> z list -> z list

val distribute_balance :
  nat -> z -> (z * z) list -> z list -> z list -> z list

val balance :
  tight_upperbound_fraction_opt -> nat -> z -> (z * z) list -> z list

val loose_upperbounds :
  tight_upperbound_fraction_opt -> nat -> z -> (z * z) list -> z list

val tight_bounds :
  tight_upperbound_fraction_opt -> nat -> z -> (z * z) list -> zrange option
  list

val loose_bounds :
  tight_upperbound_fraction_opt -> nat -> z -> (z * z) list -> zrange option
  list

val overflow_free :
  tight_upperbound_fraction_opt -> nat -> z -> (z * z) list -> z -> bool

type maybeLimbCount =
| NumLimbs of nat
| Auto of nat

val get_possible_limbs :
  tight_upperbound_fraction_opt -> z -> (z * z) list -> z -> nat list

val get_num_limbs :
  tight_upperbound_fraction_opt -> z -> (z * z) list -> z -> maybeLimbCount
  -> nat option

module UnsaturatedSolinas :
 sig
  val reified_carry_mul_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_carry_square_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_carry_scmul_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_carry_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_add_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_sub_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_opp_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_carry_add_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_carry_sub_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_carry_opp_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_eval_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_bytes_eval_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_to_bytes_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_from_bytes_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr
 end

val idxs : nat -> z -> (z * z) list -> nat list

val n_bytes : z -> nat

val prime_bytes_upperbound_list : z -> z list

val tight_bounds_typedef :
  Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
  -> nat -> z -> (z * z) list -> Coq_typedef.typedef

val loose_bounds_typedef :
  Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
  -> nat -> z -> (z * z) list -> Coq_typedef.typedef

val prime_bytes_bounds :
  z -> Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list

val m1 : z -> (z * z) list -> z

val m_enc_min :
  tight_upperbound_fraction_opt -> nat -> z -> (z * z) list -> z list

val m_enc :
  tight_upperbound_fraction_opt -> nat -> z -> (z * z) list -> z list

val no_select_size2 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
  no_select_size_opt

val split_mul_to2 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt -> split_mul_to_opt

val split_multiret_to2 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
  split_multiret_to_opt

val check_args0 :
  tight_upperbound_fraction_opt -> nat -> z -> (z * z) list ->
  machine_wordsize_opt -> char list list -> (Pipeline.coq_ErrorMessage, 'a1)
  errorT -> (Pipeline.coq_ErrorMessage, 'a1) errorT

val scarry_mul :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
  -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val scarry_square :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
  -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val scarry_scmul_const :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
  -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list -> z ->
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val scarry :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
  -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val sadd :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
  -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val ssub :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
  -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val sopp :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
  -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val scarry_add :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
  -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val scarry_sub :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
  -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val scarry_opp :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
  -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val srelax :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
  -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val sto_bytes :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
  -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val sfrom_bytes :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
  -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val reval :
  Coq0_Options.coq_PipelineOptions -> tight_upperbound_fraction_opt -> nat ->
  z -> (z * z) list -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
  Compilers.Coq_expr.expr

val seval :
  Coq0_Options.coq_PipelineOptions -> tight_upperbound_fraction_opt -> nat ->
  z -> (z * z) list -> char list -> char list

val rbytes_eval :
  Coq0_Options.coq_PipelineOptions -> z -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
  Compilers.Coq_expr.expr

val sbytes_eval :
  Coq0_Options.coq_PipelineOptions -> z -> char list -> char list

val sselectznz0 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> nat -> machine_wordsize_opt ->
  char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val known_functions0 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
  -> nat -> z -> (z * z) list -> machine_wordsize_opt ->
  (char list * (char list -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM) sigT)) list

val valid_names0 : char list

val extra_special_synthesis :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
  -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
  char list -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type, char list * (char list,
  (Pipeline.coq_ErrorMessage, Pipeline.coq_ExtendedSynthesisResult) errorT)
  debugM) sigT option list

val synthesize1 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions ->
  Coq0_Options.coq_SynthesisOptions -> tight_upperbound_fraction_opt -> nat
  -> z -> (z * z) list -> machine_wordsize_opt -> char list list -> char list
  -> char list list -> ((synthesis_output_kind * char list) * (char list,
  (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list

module Coq2_Z :
 sig
  val egcd_by_wf_step :
    z -> (z -> __ -> z -> ((z * z) * z) option) -> z -> ((z * z) * z) option

  val egcd_by_wf : z -> z -> ((z * z) * z) option

  val modinv_of_egcd : (z -> z -> ((z * z) * z) option) -> z -> z -> z option

  val modinv_by_wf : z -> z -> z option

  val modinv_opt : z -> z -> z option

  val modinv : z -> z -> z
 end

module Coq3_Z :
 sig
  val modexp_pos : z -> positive -> z -> z

  val modexp : z -> z -> z -> z
 end

module WordByWordMontgomery :
 sig
  val reified_mul_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_add_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_sub_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_opp_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_to_bytes_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_from_bytes_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_nonzero_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_eval_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_bytes_eval_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_square_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_encode_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_from_montgomery_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_to_montgomery_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_one_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr
 end

module WordByWordMontgomeryInversion :
 sig
  val reified_divstep_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_msat_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_eval_twos_complement_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr
 end

val s : z -> z

val c : z -> z

val n1 : z -> machine_wordsize_opt -> nat

val sat_limbs : z -> machine_wordsize_opt -> nat

val r : machine_wordsize_opt -> z

val r' : z -> machine_wordsize_opt -> z

val m' : z -> machine_wordsize_opt -> z

val n_bytes0 : z -> nat

val divstep_precompmod : z -> z

val prime_upperbound_list0 : z -> machine_wordsize_opt -> z list

val prime_bytes_upperbound_list0 : z -> z list

val prime_bounds :
  z -> machine_wordsize_opt ->
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list

val prime_bytes_bounds0 :
  z -> Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list

val divstep_input :
  z -> machine_wordsize_opt -> zrange option * (zrange option list
  option * (zrange option list option * (zrange option list option * (zrange
  option list option * unit))))

val divstep_output :
  z -> machine_wordsize_opt -> (((zrange option * zrange option list
  option) * zrange option list option) * zrange option list option) * zrange
  option list option

val bounds :
  z -> machine_wordsize_opt ->
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list

val larger_bounds :
  z -> machine_wordsize_opt ->
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list

val montgomery_domain_bounds :
  z -> machine_wordsize_opt ->
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list

val non_montgomery_domain_bounds :
  z -> machine_wordsize_opt ->
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list

val montgomery_domain_bounds_typedef :
  Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
  Coq_typedef.typedef

val non_montgomery_domain_bounds_typedef :
  Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
  Coq_typedef.typedef

val no_select_size3 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
  no_select_size_opt

val split_mul_to3 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt -> split_mul_to_opt

val split_multiret_to3 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
  split_multiret_to_opt

val check_args1 :
  z -> machine_wordsize_opt -> char list list -> (Pipeline.coq_ErrorMessage,
  'a1) errorT -> (Pipeline.coq_ErrorMessage, 'a1) errorT

val smul0 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
  char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val ssquare :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
  char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val sadd0 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
  char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val ssub0 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
  char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val sopp0 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
  char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val sfrom_montgomery :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
  char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val sto_montgomery :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
  char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val snonzero :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
  char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val sto_bytes0 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
  char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val sfrom_bytes0 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
  char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val sone :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
  char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val reval0 :
  Coq0_Options.coq_PipelineOptions -> z -> machine_wordsize_opt ->
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

val seval0 :
  Coq0_Options.coq_PipelineOptions -> z -> machine_wordsize_opt -> char list
  -> char list

val rbytes_eval0 :
  Coq0_Options.coq_PipelineOptions -> z -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
  Compilers.Coq_expr.expr

val sbytes_eval0 :
  Coq0_Options.coq_PipelineOptions -> z -> char list -> char list

val reval_twos_complement :
  Coq0_Options.coq_PipelineOptions -> z -> machine_wordsize_opt ->
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

val seval_twos_complement :
  Coq0_Options.coq_PipelineOptions -> z -> machine_wordsize_opt -> char list
  -> char list

val sselectznz1 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
  char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val smsat :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
  char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val sdivstep_precomp :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
  char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val sdivstep :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
  char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val known_functions1 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
  (char list * (char list -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM) sigT)) list

val valid_names1 : char list

val synthesize2 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions ->
  Coq0_Options.coq_SynthesisOptions -> z -> machine_wordsize_opt -> char list
  list -> char list -> char list list ->
  ((synthesis_output_kind * char list) * (char list,
  (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list

module BaseConversion :
 sig
  val reified_convert_bases_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr
 end

type bounds0 =
| Exactly of z list
| Use_prime
| Use_bitwidth

val show_bounds : bounds0 show

val in_bounds :
  z -> nat -> q -> q option -> bounds0 ->
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list

val out_bounds0 :
  z -> nat -> q -> q -> q option -> bounds0 ->
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list

val no_select_size4 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
  no_select_size_opt

val split_mul_to4 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt -> split_mul_to_opt

val split_multiret_to4 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
  split_multiret_to_opt

val check_args2 :
  z -> (z * z) list -> nat -> q -> q -> machine_wordsize_opt -> q option -> q
  option -> bounds0 -> bounds0 -> char list list ->
  (Pipeline.coq_ErrorMessage, 'a1) errorT -> (Pipeline.coq_ErrorMessage, 'a1)
  errorT

val sconvert_bases :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> nat -> q -> q ->
  machine_wordsize_opt -> q option -> q option -> bounds0 -> bounds0 ->
  char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val known_functions2 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> nat -> q -> q ->
  machine_wordsize_opt -> q option -> q option -> bounds0 -> bounds0 ->
  (char list * (char list -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM) sigT)) list

val valid_names2 : char list

val synthesize3 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions ->
  Coq0_Options.coq_SynthesisOptions -> z -> (z * z) list -> nat -> q -> q ->
  machine_wordsize_opt -> q option -> q option -> bounds0 -> bounds0 ->
  char list list -> char list -> char list list ->
  ((synthesis_output_kind * char list) * (char list,
  (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list

module Coq_dettman_multiplication_mod_ops :
 sig
  val limbwidth_num : z -> nat -> z

  val limbwidth_den : nat -> z

  val weight : z -> nat -> nat -> nat -> z
 end

module DettmanMultiplication :
 sig
  val reified_mul_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_square_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr
 end

val override_pipeline_opts0 :
  Coq0_Options.coq_PipelineOptions -> Coq0_Options.coq_PipelineOptions

val possible_values_of_machine_wordsize1 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt -> z list

val m2 : z -> (z * z) list -> z

val input_magnitude : q option -> q

val output_magnitude_first_limbs : q option -> q

val output_magnitude_last_limb : q option -> q

val weightf : z -> nat -> nat -> nat -> z

val input_bounds :
  z -> nat -> nat -> q option ->
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list

val output_bounds :
  z -> nat -> nat -> q option ->
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list

val no_select_size5 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
  no_select_size_opt

val split_mul_to5 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt -> split_mul_to_opt

val split_multiret_to5 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
  split_multiret_to_opt

val check_args3 :
  machine_wordsize_opt -> z -> (z * z) list -> nat -> nat -> char list list
  -> (Pipeline.coq_ErrorMessage, 'a1) errorT -> (Pipeline.coq_ErrorMessage,
  'a1) errorT

val smul1 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> machine_wordsize_opt -> z ->
  (z * z) list -> nat -> nat -> nat -> q option -> char list ->
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val ssquare0 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> machine_wordsize_opt -> z ->
  (z * z) list -> nat -> nat -> nat -> q option -> char list ->
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM

val known_functions3 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> machine_wordsize_opt -> z ->
  (z * z) list -> nat -> nat -> nat -> q option -> (char list * (char list ->
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type, char list * (char list,
  (Pipeline.coq_ErrorMessage, Pipeline.coq_ExtendedSynthesisResult) errorT)
  debugM) sigT)) list

val valid_names3 : char list

val synthesize4 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions ->
  Coq0_Options.coq_SynthesisOptions -> machine_wordsize_opt -> z -> (z * z)
  list -> nat -> nat -> nat -> q option -> char list list -> char list ->
  char list list -> ((synthesis_output_kind * char list) * (char list,
  (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list

module SolinasReduction :
 sig
  val reified_mul_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr

  val reified_square_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr
 end

val override_pipeline_opts1 :
  Coq0_Options.coq_PipelineOptions -> Coq0_Options.coq_PipelineOptions

val possible_values_of_machine_wordsize2 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt -> z list

val n2 : z -> machine_wordsize_opt -> nat

val m3 : z -> (z * z) list -> z

val weight0 : machine_wordsize_opt -> nat -> z

val up_bound : machine_wordsize_opt -> z

val base0 : machine_wordsize_opt -> z

val no_select_size6 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
  no_select_size_opt

val split_mul_to6 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt -> split_mul_to_opt

val split_multiret_to6 :
  Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
  split_multiret_to_opt

val check_args4 :
  z -> (z * z) list -> machine_wordsize_opt -> char list list ->
  (Pipeline.coq_ErrorMessage, 'a1) errorT -> (Pipeline.coq_ErrorMessage, 'a1)
  errorT

val smul2 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> (z * z) list ->
  machine_wordsize_opt -> char list -> char list * (char list,
  (Pipeline.coq_ErrorMessage, Pipeline.coq_ExtendedSynthesisResult) errorT)
  debugM

val ssquare1 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> (z * z) list ->
  machine_wordsize_opt -> char list -> char list * (char list,
  (Pipeline.coq_ErrorMessage, Pipeline.coq_ExtendedSynthesisResult) errorT)
  debugM

val known_functions4 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions -> z -> (z * z) list ->
  machine_wordsize_opt -> (char list * (char list -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
  char list * (char list, (Pipeline.coq_ErrorMessage,
  Pipeline.coq_ExtendedSynthesisResult) errorT) debugM) sigT)) list

val valid_names4 : char list

val synthesize5 :
  Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
  Coq0_Options.coq_PipelineOptions ->
  Coq0_Options.coq_PipelineToStringOptions ->
  Coq0_Options.coq_SynthesisOptions -> z -> (z * z) list ->
  machine_wordsize_opt -> char list list -> char list -> char list list ->
  ((synthesis_output_kind * char list) * (char list,
  (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list

module Coq24_Compilers :
 sig
  module ToString :
   sig
    module IR :
     sig
      module Coq_type :
       sig
        type primitive =
        | Z
        | Zptr

        type coq_type =
        | Coq_type_primitive of primitive
        | Coq_prod of coq_type * coq_type
        | Coq_unit
       end

      type coq_Z_binop =
      | Z_land
      | Z_lor
      | Z_lxor
      | Z_add
      | Z_mul
      | Z_sub

      type coq_Z_unop =
      | Z_shiftr of z
      | Z_shiftl of z
      | Z_lnot of Coq7_Compilers.ToString.Coq_int.coq_type
      | Z_bneg
      | Z_value_barrier of Coq7_Compilers.ToString.Coq_int.coq_type

      type ident =
      | Coq_literal of z
      | List_nth of nat
      | Addr
      | Dereference
      | Coq_iunop of coq_Z_unop
      | Coq_ibinop of coq_Z_binop
      | Z_mul_split of z
      | Z_add_with_get_carry of z
      | Z_sub_with_get_borrow of z
      | Z_zselect of Coq7_Compilers.ToString.Coq_int.coq_type
      | Z_add_modulo
      | Z_static_cast of Coq7_Compilers.ToString.Coq_int.coq_type

      type arith_expr =
      | AppIdent of Coq_type.coq_type * Coq_type.coq_type * ident * arith_expr
      | Var of Coq_type.primitive * char list
      | Pair of Coq_type.coq_type * Coq_type.coq_type * arith_expr
         * arith_expr
      | TT

      type stmt =
      | Call of arith_expr
      | Comment of char list list
         * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
           Compilers.Coq_type.coq_type,
           Coq7_Compilers.ToString.OfPHOAS.var_data) sigT list
      | Assign of bool * Coq_type.primitive
         * Coq7_Compilers.ToString.Coq_int.coq_type option * char list
         * arith_expr
      | AssignZPtr of char list
         * Coq7_Compilers.ToString.Coq_int.coq_type option * arith_expr
      | DeclareVar of Coq_type.primitive
         * Coq7_Compilers.ToString.Coq_int.coq_type option * char list
      | AssignNth of char list * nat * arith_expr

      type expr = stmt list

      val invert_literal : Coq_type.coq_type -> arith_expr -> z option

      module Coq_ident_infos :
       sig
        val collect_infos_of_ident :
          Coq_type.coq_type -> Coq_type.coq_type -> ident ->
          Coq7_Compilers.ToString.ident_infos

        val collect_infos_of_arith_expr :
          Coq_type.coq_type -> arith_expr ->
          Coq7_Compilers.ToString.ident_infos

        val collect_infos_of_stmt :
          stmt -> Coq7_Compilers.ToString.ident_infos

        val collect_infos_of_base_typedef_data :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data ->
          Coq7_Compilers.ToString.ident_infos

        val collect_infos_of_typedef_data :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type ->
          Coq7_Compilers.ToString.OfPHOAS.var_typedef_data ->
          Coq7_Compilers.ToString.ident_infos

        val collect_infos_of_arg_typedef_data :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
          Compilers.Coq_type.for_each_lhs_of_arrow ->
          Coq7_Compilers.ToString.ident_infos

        val collect_infos : expr -> Coq7_Compilers.ToString.ident_infos

        val collect_all_infos :
          Coq7_Compilers.Options.skip_typedefs_opt -> expr ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
          Compilers.Coq_type.for_each_lhs_of_arrow ->
          Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data ->
          Coq7_Compilers.ToString.ident_infos
       end

      module Coq_name_infos :
       sig
        val mem : char list -> char list list -> bool

        val add : char list -> char list list -> char list list

        val union : char list list -> char list list -> char list list

        val empty : char list list

        val singleton : char list -> char list list

        val of_list : char list list -> char list list

        val collect_live_of_arith_expr :
          (Coq_type.coq_type -> Coq_type.coq_type -> ident -> bool) ->
          (Coq_type.coq_type -> Coq_type.coq_type -> ident -> bool) ->
          Coq_type.coq_type -> arith_expr -> char list list

        val collect_live_of_stmt :
          (Coq_type.coq_type -> Coq_type.coq_type -> ident -> bool) -> stmt
          -> char list list

        val collect_live :
          (Coq_type.coq_type -> Coq_type.coq_type -> ident -> bool) -> expr
          -> char list list

        val rename_if_dead :
          (char list -> char list) -> char list list -> char list -> char list

        val adjust_dead_of_arith_expr :
          (char list -> char list) -> char list list -> Coq_type.coq_type ->
          arith_expr -> arith_expr

        val adjust_dead_of_stmt :
          (char list -> char list) -> char list list -> stmt -> stmt list

        val adjust_dead_of_expr :
          (char list -> char list) -> char list list -> expr -> expr

        val adjust_dead :
          (Coq_type.coq_type -> Coq_type.coq_type -> ident -> bool) ->
          (char list -> char list) -> expr -> expr
       end

      module LiftDeclare :
       sig
        val split_declare : stmt -> stmt list * stmt list

        val split_declarations : expr -> expr * expr

        val lift_declarations : expr -> expr
       end

      module OfPHOAS :
       sig
        type arith_expr_for_base = __

        type arith_expr_for = __

        type coq_LanguageCasts = { bin_op_natural_output : (coq_Z_binop ->
                                                           (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
                                                           ->
                                                           Coq7_Compilers.ToString.Coq_int.coq_type);
                                   bin_op_casts : (coq_Z_binop ->
                                                  Coq7_Compilers.ToString.Coq_int.coq_type
                                                  option ->
                                                  (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
                                                  ->
                                                  Coq7_Compilers.ToString.Coq_int.coq_type
                                                  option * (Coq7_Compilers.ToString.Coq_int.coq_type
                                                  option * Coq7_Compilers.ToString.Coq_int.coq_type
                                                  option));
                                   un_op_casts : (coq_Z_unop ->
                                                 Coq7_Compilers.ToString.Coq_int.coq_type
                                                 option ->
                                                 Coq7_Compilers.ToString.Coq_int.coq_type
                                                 ->
                                                 Coq7_Compilers.ToString.Coq_int.coq_type
                                                 option * Coq7_Compilers.ToString.Coq_int.coq_type
                                                 option);
                                   upcast_on_assignment : bool;
                                   upcast_on_funcall : bool;
                                   explicit_pointer_variables : bool }

        val bin_op_natural_output :
          coq_LanguageCasts -> coq_Z_binop ->
          (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
          -> Coq7_Compilers.ToString.Coq_int.coq_type

        val bin_op_casts :
          coq_LanguageCasts -> coq_Z_binop ->
          Coq7_Compilers.ToString.Coq_int.coq_type option ->
          (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
          -> Coq7_Compilers.ToString.Coq_int.coq_type
          option * (Coq7_Compilers.ToString.Coq_int.coq_type
          option * Coq7_Compilers.ToString.Coq_int.coq_type option)

        val un_op_casts :
          coq_LanguageCasts -> coq_Z_unop ->
          Coq7_Compilers.ToString.Coq_int.coq_type option ->
          Coq7_Compilers.ToString.Coq_int.coq_type ->
          Coq7_Compilers.ToString.Coq_int.coq_type
          option * Coq7_Compilers.ToString.Coq_int.coq_type option

        val upcast_on_assignment : coq_LanguageCasts -> bool

        val upcast_on_funcall : coq_LanguageCasts -> bool

        val explicit_pointer_variables : coq_LanguageCasts -> bool

        type consider_retargs_live_opt =
          Coq_type.coq_type -> Coq_type.coq_type -> ident -> bool

        type rename_dead_opt = char list -> char list

        type lift_declarations_opt = bool

        val bin_op_natural_output_opt :
          coq_LanguageCasts -> coq_Z_binop ->
          (Coq7_Compilers.ToString.Coq_int.coq_type
          option * Coq7_Compilers.ToString.Coq_int.coq_type option) ->
          Coq7_Compilers.ToString.Coq_int.coq_type option

        val bin_op_casts_opt :
          coq_LanguageCasts -> coq_Z_binop ->
          Coq7_Compilers.ToString.Coq_int.coq_type option ->
          (Coq7_Compilers.ToString.Coq_int.coq_type
          option * Coq7_Compilers.ToString.Coq_int.coq_type option) ->
          Coq7_Compilers.ToString.Coq_int.coq_type
          option * (Coq7_Compilers.ToString.Coq_int.coq_type
          option * Coq7_Compilers.ToString.Coq_int.coq_type option)

        val un_op_casts_opt :
          coq_LanguageCasts -> coq_Z_unop ->
          Coq7_Compilers.ToString.Coq_int.coq_type option ->
          Coq7_Compilers.ToString.Coq_int.coq_type option ->
          Coq7_Compilers.ToString.Coq_int.coq_type
          option * Coq7_Compilers.ToString.Coq_int.coq_type option

        val coq_Zcast :
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          bool -> Coq7_Compilers.ToString.Coq_int.coq_type option ->
          arith_expr_for_base -> arith_expr_for_base

        val get_Zcast_down_if_needed :
          Coq7_Compilers.ToString.Coq_int.coq_type option ->
          Coq7_Compilers.ToString.Coq_int.coq_type option ->
          Coq7_Compilers.ToString.Coq_int.coq_type option

        val coq_Zcast_down_if_needed :
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq7_Compilers.ToString.Coq_int.coq_type option ->
          arith_expr_for_base -> arith_expr_for_base

        val cast_down_if_needed :
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
          arith_expr_for_base -> arith_expr_for_base

        val get_Zcast_up_if_needed :
          Coq7_Compilers.ToString.Coq_int.coq_type option ->
          Coq7_Compilers.ToString.Coq_int.coq_type option ->
          Coq7_Compilers.ToString.Coq_int.coq_type option

        val coq_Zcast_up_if_needed :
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq7_Compilers.ToString.Coq_int.coq_type option ->
          arith_expr_for_base -> arith_expr_for_base

        val cast_up_if_needed :
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
          arith_expr_for_base -> arith_expr_for_base

        val cast :
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
          arith_expr_for_base -> arith_expr_for_base

        val arith_bin_arith_expr_of_PHOAS_ident :
          coq_LanguageCasts ->
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          coq_Z_binop -> Coq7_Compilers.ToString.Coq_int.coq_type option ->
          arith_expr_for -> arith_expr_for

        val arith_un_arith_expr_of_PHOAS_ident :
          coq_LanguageCasts ->
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          coq_Z_unop -> Coq7_Compilers.ToString.Coq_int.coq_type option ->
          arith_expr_for -> arith_expr_for

        val maybe_log2 : z -> z option

        val maybe_loglog2 : z -> nat option

        val arith_expr_of_PHOAS_literal_Z :
          Coq7_Compilers.Options.relax_zrange_opt ->
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt -> z
          -> Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
          arith_expr_for_base

        val arith_expr_of_PHOAS_ident :
          coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
          Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, (__,
          char list list) sum, arith_expr_for_base)
          Compilers.Coq_type.interpM_final

        val collect_args_and_apply_unknown_casts :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type ->
          (Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, (__,
          char list list) sum, arith_expr_for_base)
          Compilers.Coq_type.interpM_final) -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, (__, char list list) sum,
          Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
          (arith_expr_for_base, char list list) sum)
          Compilers.Coq_type.interpM_final

        val collect_args_and_apply_known_casts :
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
          ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, (__,
          char list list) sum,
          Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
          (arith_expr_for_base, char list list) sum)
          Compilers.Coq_type.interpM_final, char list list) sum

        val collect_args_and_apply_casts :
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
          (Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, (__,
          char list list) sum, arith_expr_for_base)
          Compilers.Coq_type.interpM_final) -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, (__, char list list) sum,
          Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
          (arith_expr_for_base, char list list) sum)
          Compilers.Coq_type.interpM_final

        val arith_expr_of_base_PHOAS_Var :
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          Coq7_Compilers.ToString.OfPHOAS.base_var_data ->
          Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
          (arith_expr_for_base, char list list) sum

        val arith_expr_of_PHOAS :
          coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
          Coq7_Compilers.ToString.OfPHOAS.var_data) Compilers.Coq_expr.expr
          -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, (__,
          char list list) sum,
          Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
          (arith_expr_for_base, char list list) sum)
          Compilers.Coq_type.interpM_final

        val arith_expr_of_base_PHOAS :
          coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_expr.expr ->
          Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
          (arith_expr_for_base, char list list) sum

        val result_upcast :
          coq_LanguageCasts ->
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
          arith_expr_for_base -> arith_expr_for_base

        val funcall_upcast :
          coq_LanguageCasts ->
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
          arith_expr_for_base -> arith_expr_for_base

        val make_return_assignment_of_base_arith :
          coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          Coq7_Compilers.ToString.OfPHOAS.base_var_data ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_expr.expr -> (expr, char list list) sum

        val make_return_assignment_of_arith :
          coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type ->
          Coq7_Compilers.ToString.OfPHOAS.var_data -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
          Coq7_Compilers.ToString.OfPHOAS.var_data) Compilers.Coq_expr.expr
          -> (expr, char list list) sum

        val report_type_mismatch :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          char list

        val arith_expr_of_PHOAS_args :
          coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
          Coq7_Compilers.ToString.OfPHOAS.var_data) Compilers.Coq_expr.expr)
          Compilers.Coq_type.for_each_lhs_of_arrow -> ((Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
          Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_expr.expr * (arith_expr * Coq7_Compilers.ToString.Coq_int.coq_type
          option)) Compilers.Coq_type.for_each_lhs_of_arrow, char list list)
          sum

        val base_var_names_of_string_opt :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          char list -> Coq7_Compilers.ToString.OfPHOAS.base_var_names option

        val string_of_base_var_names :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          Coq7_Compilers.ToString.OfPHOAS.base_var_names -> char list

        val var_names_of_string_opt :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> char list ->
          Coq7_Compilers.ToString.OfPHOAS.var_names option

        val string_of_var_names :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type ->
          Coq7_Compilers.ToString.OfPHOAS.var_names -> char list

        val var_data_of_string_opt :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> char list ->
          Coq7_Compilers.ToString.OfPHOAS.var_data option

        val string_of_var_data :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type ->
          Coq7_Compilers.ToString.OfPHOAS.var_data -> char list

        val extract_var_data_list :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
          Coq7_Compilers.ToString.OfPHOAS.var_data) Compilers.Coq_expr.expr
          -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_data) sigT list

        val bounds_check :
          Coq7_Compilers.Options.relax_zrange_opt -> bool -> char list ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> z ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
          Coq7_Compilers.ToString.OfPHOAS.var_data) Compilers.Coq_expr.expr
          -> Coq7_Compilers.ToString.Coq_int.coq_type option -> (unit,
          char list list) sum

        val declare_name :
          coq_LanguageCasts -> char list -> positive -> (positive ->
          char list option) -> Coq7_Compilers.ToString.Coq_int.coq_type
          option -> (((expr * char list) * bool) * arith_expr, char list
          list) sum

        val size_of_type :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> positive

        val make_assign_expr_of_PHOAS :
          coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt
          -> bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
          Coq7_Compilers.ToString.OfPHOAS.var_data) Compilers.Coq_expr.expr
          -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          (Coq7_Compilers.ToString.OfPHOAS.var_data ->
          Coq7_Compilers.ToString.OfPHOAS.var_data -> (expr, char list list)
          sum) -> positive -> (positive -> char list option) ->
          Coq7_Compilers.ToString.OfPHOAS.var_data -> (expr, char list list)
          sum

        val expr_of_base_PHOAS :
          coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt
          -> bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
          Coq7_Compilers.ToString.OfPHOAS.var_data) Compilers.Coq_expr.expr
          -> positive -> (positive -> char list option) ->
          Coq7_Compilers.ToString.OfPHOAS.var_data -> (expr, char list list)
          sum

        val base_var_data_of_bounds_and_typedefs :
          Coq7_Compilers.Options.relax_zrange_opt -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type -> bool -> positive ->
          (positive -> char list option) ->
          Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
          Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data ->
          (positive * Coq7_Compilers.ToString.OfPHOAS.var_data) option

        val var_data_of_bounds_and_typedefs :
          Coq7_Compilers.Options.relax_zrange_opt -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          bool -> positive -> (positive -> char list option) ->
          Coq6_Compilers.ZRange.Coq_type.Coq_option.interp ->
          Coq7_Compilers.ToString.OfPHOAS.var_typedef_data ->
          (positive * Coq7_Compilers.ToString.OfPHOAS.var_data) option

        val expr_of_PHOAS'_cps :
          Coq7_Compilers.Options.relax_zrange_opt -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_expr.expr -> (positive -> char list option) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
          Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
          Compilers.Coq_type.for_each_lhs_of_arrow -> positive ->
          ((positive * ((Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_type.for_each_lhs_of_arrow * (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
          Coq7_Compilers.ToString.OfPHOAS.var_data) Compilers.Coq_expr.expr))
          -> ('a1, char list list) sum) -> ('a1, char list list) sum

        val expr_of_PHOAS'_cont :
          coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
          consider_retargs_live_opt -> rename_dead_opt ->
          lift_declarations_opt ->
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt
          -> bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (positive -> char list option) ->
          Coq7_Compilers.ToString.OfPHOAS.var_data -> (positive -> positive)
          -> (positive * ((Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_type.for_each_lhs_of_arrow * (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
          Coq7_Compilers.ToString.OfPHOAS.var_data) Compilers.Coq_expr.expr))
          -> (((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * expr,
          char list list) sum

        val expr_of_PHOAS_cont :
          coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
          consider_retargs_live_opt -> rename_dead_opt ->
          lift_declarations_opt ->
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt
          -> bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (positive -> char list option) ->
          (positive -> positive) -> (positive * (((Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
          Coq7_Compilers.ToString.OfPHOAS.var_data) Compilers.Coq_expr.expr))
          -> (((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * expr,
          char list list) sum

        val expr_of_PHOAS_cps :
          Coq7_Compilers.Options.relax_zrange_opt -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_expr.expr -> (positive -> char list option) ->
          (positive -> char list option) -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type,
          Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
          Compilers.Coq_type.for_each_lhs_of_arrow ->
          Coq6_Compilers.ZRange.Coq_type.Coq_option.interp ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
          Compilers.Coq_type.for_each_lhs_of_arrow ->
          Coq7_Compilers.ToString.OfPHOAS.var_typedef_data -> positive ->
          (positive -> positive) -> ((positive * (((Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
          Coq7_Compilers.ToString.OfPHOAS.var_data) Compilers.Coq_expr.expr))
          -> ('a1, char list list) sum) -> ('a1, char list list) sum

        val coq_ExprOfPHOAS_cont :
          coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
          consider_retargs_live_opt -> rename_dead_opt ->
          lift_declarations_opt ->
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt
          -> bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> char list list option ->
          (positive * (((Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
          Coq7_Compilers.ToString.OfPHOAS.var_data) Compilers.Coq_expr.expr))
          -> (((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * expr,
          char list list) sum

        val coq_ExprOfPHOAS_with_opt_outbounds_cps :
          Coq7_Compilers.Options.relax_zrange_opt ->
          Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options
          -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
          Compilers.Coq_expr.coq_Expr -> char list list option ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
          Compilers.Coq_type.for_each_lhs_of_arrow ->
          Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp option ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
          Compilers.Coq_type.for_each_lhs_of_arrow ->
          Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data ->
          ((positive * (((Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
          Coq7_Compilers.ToString.OfPHOAS.var_data) Compilers.Coq_expr.expr))
          -> ('a1, char list list) sum) -> ('a1, char list list) sum

        val coq_ExprOfPHOAS_cps :
          Coq7_Compilers.Options.relax_zrange_opt ->
          Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options
          -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
          Compilers.Coq_expr.coq_Expr -> char list list option ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
          Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
          Compilers.Coq_type.for_each_lhs_of_arrow ->
          Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data ->
          ((positive * (((Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
          Coq7_Compilers.ToString.OfPHOAS.var_data) Compilers.Coq_expr.expr))
          -> ('a1, char list list) sum) -> ('a1, char list list) sum

        val var_data_of_PHOAS_bounds :
          Coq7_Compilers.Options.relax_zrange_opt ->
          Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options
          -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
          Compilers.Coq_expr.coq_Expr -> char list list option ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
          Compilers.Coq_type.for_each_lhs_of_arrow ->
          Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
          Compilers.Coq_type.for_each_lhs_of_arrow ->
          Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data ->
          ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data,
          char list list) sum

        val coq_ExprOfPHOAS :
          coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
          consider_retargs_live_opt -> rename_dead_opt ->
          lift_declarations_opt ->
          Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
          Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options
          ->
          Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt
          -> bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
          Compilers.Coq_expr.coq_Expr -> char list list option ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
          Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
          Compilers.Coq_type.for_each_lhs_of_arrow ->
          Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data ->
          (((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * expr,
          char list list) sum
       end
     end
   end
 end

module Coq25_Compilers :
 sig
  module ToString :
   sig
    module C :
     sig
      val comment_block : char list list -> char list list

      val coq_FIAT_INLINE : char list -> char list

      module String :
       sig
        val stdint_bitwidths : z list

        module Coq_int :
         sig
          module Coq_type :
           sig
            val to_string_opt_typedef :
              Coq7_Compilers.Options.language_naming_conventions_opt ->
              Coq7_Compilers.Options.skip_typedefs_opt -> char list ->
              Coq7_Compilers.ToString.Coq_int.coq_type -> char list option ->
              char list

            val to_string :
              Coq7_Compilers.Options.language_naming_conventions_opt ->
              char list -> Coq7_Compilers.ToString.Coq_int.coq_type ->
              char list

            val to_literal_macro_string :
              Coq7_Compilers.ToString.Coq_int.coq_type -> char list option
           end
         end

        module Coq_type :
         sig
          module Coq_primitive :
           sig
            val to_string_opt_typedef :
              Coq7_Compilers.Options.language_naming_conventions_opt ->
              Coq7_Compilers.Options.skip_typedefs_opt -> char list ->
              Coq24_Compilers.ToString.IR.Coq_type.primitive ->
              Coq7_Compilers.ToString.Coq_int.coq_type option -> char list
              option -> char list

            val to_string :
              Coq7_Compilers.Options.language_naming_conventions_opt ->
              char list -> Coq24_Compilers.ToString.IR.Coq_type.primitive ->
              Coq7_Compilers.ToString.Coq_int.coq_type option -> char list
           end
         end

        val value_barrier_name :
          Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
          char list -> Coq7_Compilers.ToString.Coq_int.coq_type -> char list

        val value_barrier_func :
          Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
          char list -> Coq7_Compilers.ToString.Coq_int.coq_type -> char list
          list

        val make_typedef :
          Coq7_Compilers.Options.language_naming_conventions_opt ->
          Coq7_Compilers.Options.documentation_options_opt -> char list ->
          (((char list * (char list ->
          char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
          option) * (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type,
          Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) ->
          char list list

        val header :
          Coq7_Compilers.Options.language_naming_conventions_opt ->
          Coq7_Compilers.Options.documentation_options_opt ->
          Coq7_Compilers.Options.package_name_opt ->
          Coq7_Compilers.Options.class_name_opt ->
          Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool ->
          char list -> Coq7_Compilers.ToString.ident_infos ->
          (((char list * (char list ->
          char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
          option) * (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type,
          Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT)
          list -> char list list
       end

      module Coq_primitive :
       sig
        val to_string :
          char list -> Coq24_Compilers.ToString.IR.Coq_type.primitive -> z ->
          char list
       end

      val arith_to_string :
        Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
        char list -> Coq24_Compilers.ToString.IR.Coq_type.coq_type ->
        Coq24_Compilers.ToString.IR.arith_expr -> char list

      val stmt_to_string :
        Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
        char list -> Coq24_Compilers.ToString.IR.stmt -> char list

      val to_strings :
        Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
        char list -> Coq24_Compilers.ToString.IR.expr -> char list list

      val to_base_arg_list :
        Coq7_Compilers.Options.language_naming_conventions_opt ->
        Coq7_Compilers.Options.skip_typedefs_opt -> char list ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        Coq7_Compilers.ToString.OfPHOAS.base_var_data -> char list list

      val to_arg_list :
        Coq7_Compilers.Options.language_naming_conventions_opt ->
        Coq7_Compilers.Options.skip_typedefs_opt -> char list ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type ->
        Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list

      val to_arg_list_for_each_lhs_of_arrow :
        Coq7_Compilers.Options.language_naming_conventions_opt ->
        Coq7_Compilers.Options.skip_typedefs_opt -> char list ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type,
        Coq7_Compilers.ToString.OfPHOAS.var_data)
        Compilers.Coq_type.for_each_lhs_of_arrow -> char list list

      val to_base_retarg_list :
        Coq7_Compilers.Options.language_naming_conventions_opt ->
        Coq7_Compilers.Options.skip_typedefs_opt -> char list ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        Coq7_Compilers.ToString.OfPHOAS.base_var_data -> char list list

      val to_retarg_list :
        Coq7_Compilers.Options.language_naming_conventions_opt ->
        Coq7_Compilers.Options.skip_typedefs_opt -> char list ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type ->
        Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list

      val integer_promote_type :
        Coq7_Compilers.ToString.Coq_int.coq_type ->
        Coq7_Compilers.ToString.Coq_int.coq_type

      val rank : Coq7_Compilers.ToString.Coq_int.coq_type -> z

      val coq_C_common_type :
        Coq7_Compilers.ToString.Coq_int.coq_type ->
        Coq7_Compilers.ToString.Coq_int.coq_type ->
        Coq7_Compilers.ToString.Coq_int.coq_type

      val coq_C_bin_op_natural_output :
        Coq24_Compilers.ToString.IR.coq_Z_binop ->
        (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
        -> Coq7_Compilers.ToString.Coq_int.coq_type

      val coq_C_bin_op_casts :
        Coq24_Compilers.ToString.IR.coq_Z_binop ->
        Coq7_Compilers.ToString.Coq_int.coq_type option ->
        (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
        -> Coq7_Compilers.ToString.Coq_int.coq_type
        option * (Coq7_Compilers.ToString.Coq_int.coq_type
        option * Coq7_Compilers.ToString.Coq_int.coq_type option)

      val coq_C_un_op_casts :
        Coq24_Compilers.ToString.IR.coq_Z_unop ->
        Coq7_Compilers.ToString.Coq_int.coq_type option ->
        Coq7_Compilers.ToString.Coq_int.coq_type ->
        Coq7_Compilers.ToString.Coq_int.coq_type
        option * Coq7_Compilers.ToString.Coq_int.coq_type option

      val coq_CLanguageCasts :
        Coq24_Compilers.ToString.IR.OfPHOAS.coq_LanguageCasts

      val to_function_lines :
        Coq7_Compilers.Options.language_naming_conventions_opt ->
        Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> bool ->
        bool -> char list -> char list -> Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        (((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq7_Compilers.ToString.OfPHOAS.var_data)
        Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * Coq24_Compilers.ToString.IR.expr)
        -> char list list

      val consider_retargs_live_opt_instance_0 :
        Coq24_Compilers.ToString.IR.OfPHOAS.consider_retargs_live_opt

      val rename_dead_opt_instance_0 :
        Coq24_Compilers.ToString.IR.OfPHOAS.rename_dead_opt

      val lift_declarations_opt_instance_0 :
        Coq24_Compilers.ToString.IR.OfPHOAS.lift_declarations_opt

      val coq_ToFunctionLines :
        Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
        Coq7_Compilers.Options.relax_zrange_opt ->
        Coq7_Compilers.Options.language_naming_conventions_opt ->
        Coq7_Compilers.Options.documentation_options_opt ->
        Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool ->
        bool -> bool -> bool -> char list -> char list -> Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr ->
        ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq7_Compilers.ToString.OfPHOAS.var_data)
        Compilers.Coq_type.for_each_lhs_of_arrow ->
        Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list) ->
        char list list option -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type,
        Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
        Compilers.Coq_type.for_each_lhs_of_arrow ->
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
        Compilers.Coq_type.for_each_lhs_of_arrow ->
        Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data -> (char list
        list * Coq7_Compilers.ToString.ident_infos, char list) sum

      val coq_OutputCAPI : Coq7_Compilers.ToString.coq_OutputLanguageAPI
     end
   end
 end

module Rust :
 sig
  val comment_module_header_block : char list list -> char list list

  val comment_block : char list list -> char list list

  val stdint_bitwidths : z list

  val int_type_to_string_opt_typedef :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list ->
    Coq7_Compilers.ToString.Coq_int.coq_type -> char list option -> char list

  val int_type_to_string :
    Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
    char list -> Coq7_Compilers.ToString.Coq_int.coq_type -> char list

  val make_typedef :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.documentation_options_opt -> char list -> bool ->
    bool -> (((char list * (char list ->
    char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
    option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) ->
    char list list

  val header :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.documentation_options_opt ->
    Coq7_Compilers.Options.package_name_opt ->
    Coq7_Compilers.Options.class_name_opt ->
    Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool ->
    char list -> Coq7_Compilers.ToString.ident_infos ->
    (((char list * (char list ->
    char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
    option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) list ->
    char list list

  val cast_literal :
    char list -> Coq7_Compilers.ToString.Coq_int.coq_type -> char list option

  val primitive_type_to_string_opt_typedef :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list ->
    Coq24_Compilers.ToString.IR.Coq_type.primitive ->
    Coq7_Compilers.ToString.Coq_int.coq_type option -> char list option ->
    char list

  val primitive_type_to_string :
    Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
    char list -> Coq24_Compilers.ToString.IR.Coq_type.primitive ->
    Coq7_Compilers.ToString.Coq_int.coq_type option -> char list

  val primitive_array_type_to_string :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list ->
    Coq24_Compilers.ToString.IR.Coq_type.primitive ->
    Coq7_Compilers.ToString.Coq_int.coq_type option -> nat -> char list
    option -> char list

  val int_literal_to_string :
    char list -> Coq24_Compilers.ToString.IR.Coq_type.primitive -> z ->
    char list

  val arith_to_string :
    Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
    char list -> Coq24_Compilers.ToString.IR.Coq_type.coq_type ->
    Coq24_Compilers.ToString.IR.arith_expr -> char list

  val stmt_to_string :
    Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
    char list -> Coq24_Compilers.ToString.IR.stmt -> char list

  val to_strings :
    Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
    char list -> Coq24_Compilers.ToString.IR.expr -> char list list

  type coq_Mode =
  | In
  | Out

  val to_base_arg_list :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list ->
    coq_Mode -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
    Coq7_Compilers.ToString.OfPHOAS.base_var_data -> char list list

  val to_arg_list :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list ->
    coq_Mode -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> Coq7_Compilers.ToString.OfPHOAS.var_data
    -> char list list

  val to_arg_list_for_each_lhs_of_arrow :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list ->
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow -> char list list

  val coq_Rust_bin_op_natural_output :
    Coq24_Compilers.ToString.IR.coq_Z_binop ->
    (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
    -> Coq7_Compilers.ToString.Coq_int.coq_type

  val coq_Rust_bin_op_casts :
    Coq24_Compilers.ToString.IR.coq_Z_binop ->
    Coq7_Compilers.ToString.Coq_int.coq_type option ->
    (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
    -> Coq7_Compilers.ToString.Coq_int.coq_type
    option * (Coq7_Compilers.ToString.Coq_int.coq_type
    option * Coq7_Compilers.ToString.Coq_int.coq_type option)

  val coq_Rust_un_op_casts :
    Coq24_Compilers.ToString.IR.coq_Z_unop ->
    Coq7_Compilers.ToString.Coq_int.coq_type option ->
    Coq7_Compilers.ToString.Coq_int.coq_type ->
    Coq7_Compilers.ToString.Coq_int.coq_type
    option * Coq7_Compilers.ToString.Coq_int.coq_type option

  val coq_RustLanguageCasts :
    Coq24_Compilers.ToString.IR.OfPHOAS.coq_LanguageCasts

  val to_function_lines :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> bool -> bool
    -> char list -> char list -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * Coq24_Compilers.ToString.IR.expr)
    -> char list list

  val consider_retargs_live_opt_instance_0 :
    Coq24_Compilers.ToString.IR.OfPHOAS.consider_retargs_live_opt

  val rename_dead_opt_instance_0 :
    Coq24_Compilers.ToString.IR.OfPHOAS.rename_dead_opt

  val lift_declarations_opt_instance_0 :
    Coq24_Compilers.ToString.IR.OfPHOAS.lift_declarations_opt

  val coq_ToFunctionLines :
    Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
    Coq7_Compilers.Options.relax_zrange_opt ->
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.documentation_options_opt ->
    Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool -> bool ->
    bool -> bool -> char list -> char list -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr ->
    ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list) -> char list
    list option -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data -> (char list
    list * Coq7_Compilers.ToString.ident_infos, char list) sum

  val coq_OutputRustAPI : Coq7_Compilers.ToString.coq_OutputLanguageAPI
 end

module Go :
 sig
  val comment_block : char list list -> char list list

  val comment_block_extra_newlines : char list list -> char list list

  val stdint_bitwidths : z list

  val bits_std_bitwidths : z list

  val is_bits_standard_bitwidth : z -> bool

  val is_nonbits_special_bitwidth : z -> bool

  val int_type_to_string_opt_typedef :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list ->
    Coq7_Compilers.ToString.Coq_int.coq_type -> char list option -> char list

  val int_type_to_string :
    Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
    char list -> Coq7_Compilers.ToString.Coq_int.coq_type -> char list

  val make_typedef :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.documentation_options_opt -> char list -> bool ->
    bool -> (((char list * (char list ->
    char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
    option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) ->
    char list list

  val header :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.documentation_options_opt ->
    Coq7_Compilers.Options.package_name_opt ->
    Coq7_Compilers.Options.class_name_opt ->
    Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool ->
    char list -> Coq7_Compilers.ToString.ident_infos ->
    (((char list * (char list ->
    char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
    option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) list ->
    char list list

  val cast_literal :
    char list -> Coq7_Compilers.ToString.Coq_int.coq_type -> char list option

  val primitive_type_to_string_opt_typedef :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list ->
    Coq24_Compilers.ToString.IR.Coq_type.primitive ->
    Coq7_Compilers.ToString.Coq_int.coq_type option -> char list option ->
    char list

  val primitive_type_to_string :
    Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
    char list -> Coq24_Compilers.ToString.IR.Coq_type.primitive ->
    Coq7_Compilers.ToString.Coq_int.coq_type option -> char list

  val primitive_array_type_to_string :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list ->
    Coq24_Compilers.ToString.IR.Coq_type.primitive ->
    Coq7_Compilers.ToString.Coq_int.coq_type option -> nat -> char list
    option -> char list

  val int_literal_to_string :
    char list -> Coq24_Compilers.ToString.IR.Coq_type.primitive -> z ->
    char list

  val arith_to_string :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt -> bool
    -> char list -> Coq24_Compilers.ToString.IR.Coq_type.coq_type ->
    Coq24_Compilers.ToString.IR.arith_expr -> char list

  val consider_retargs_live_opt_instance_0 :
    Coq24_Compilers.ToString.IR.OfPHOAS.consider_retargs_live_opt

  val rename_dead_opt_instance_0 :
    Coq24_Compilers.ToString.IR.OfPHOAS.rename_dead_opt

  val lift_declarations_opt_instance_0 :
    Coq24_Compilers.ToString.IR.OfPHOAS.lift_declarations_opt

  val stmt_to_string :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt -> bool
    -> char list -> Coq24_Compilers.ToString.IR.stmt -> char list

  val to_strings :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt -> bool
    -> char list -> Coq24_Compilers.ToString.IR.expr -> char list list

  type coq_Mode =
  | In
  | Out

  val to_base_arg_list :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list ->
    coq_Mode -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
    Coq7_Compilers.ToString.OfPHOAS.base_var_data -> char list list

  val to_arg_list :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list ->
    coq_Mode -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> Coq7_Compilers.ToString.OfPHOAS.var_data
    -> char list list

  val to_arg_list_for_each_lhs_of_arrow :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list ->
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow -> char list list

  val coq_Go_bin_op_natural_output :
    Coq24_Compilers.ToString.IR.coq_Z_binop ->
    (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
    -> Coq7_Compilers.ToString.Coq_int.coq_type

  val bin_op_commutes_with_mod_pow2 :
    Coq24_Compilers.ToString.IR.coq_Z_binop -> bool

  val coq_Go_bin_op_casts :
    Coq24_Compilers.ToString.IR.coq_Z_binop ->
    Coq7_Compilers.ToString.Coq_int.coq_type option ->
    (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
    -> Coq7_Compilers.ToString.Coq_int.coq_type
    option * (Coq7_Compilers.ToString.Coq_int.coq_type
    option * Coq7_Compilers.ToString.Coq_int.coq_type option)

  val coq_Go_un_op_casts :
    Coq24_Compilers.ToString.IR.coq_Z_unop ->
    Coq7_Compilers.ToString.Coq_int.coq_type option ->
    Coq7_Compilers.ToString.Coq_int.coq_type ->
    Coq7_Compilers.ToString.Coq_int.coq_type
    option * Coq7_Compilers.ToString.Coq_int.coq_type option

  val coq_GoLanguageCasts :
    Coq24_Compilers.ToString.IR.OfPHOAS.coq_LanguageCasts

  val to_function_lines :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.output_options_opt -> bool -> bool -> bool -> bool
    -> char list -> char list -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * Coq24_Compilers.ToString.IR.expr)
    -> char list list

  val strip_special_infos :
    Coq7_Compilers.ToString.ident_infos -> Coq7_Compilers.ToString.ident_infos

  val coq_ToFunctionLines :
    Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
    Coq7_Compilers.Options.relax_zrange_opt ->
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.documentation_options_opt ->
    Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool -> bool ->
    bool -> bool -> char list -> char list -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr ->
    ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list) -> char list
    list option -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data -> (char list
    list * Coq7_Compilers.ToString.ident_infos, char list) sum

  val coq_OutputGoAPI : Coq7_Compilers.ToString.coq_OutputLanguageAPI
 end

module Java :
 sig
  val comment_block : char list list -> char list list

  val header :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.documentation_options_opt ->
    Coq7_Compilers.Options.package_name_opt ->
    Coq7_Compilers.Options.class_name_opt ->
    Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool ->
    char list -> Coq7_Compilers.ToString.ident_infos ->
    (((char list * (char list ->
    char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
    option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) list ->
    char list list

  val footer :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.documentation_options_opt ->
    Coq7_Compilers.Options.package_name_opt ->
    Coq7_Compilers.Options.class_name_opt -> z -> bool -> bool -> char list
    -> Coq7_Compilers.ToString.ident_infos -> char list list

  val int_type_to_string :
    bool -> char list -> Coq7_Compilers.ToString.Coq_int.coq_type -> char list

  val primitive_type_to_string :
    bool -> char list -> Coq24_Compilers.ToString.IR.Coq_type.primitive ->
    Coq7_Compilers.ToString.Coq_int.coq_type option -> char list

  val int_literal_to_string :
    char list -> Coq24_Compilers.ToString.IR.Coq_type.primitive -> z ->
    char list

  val arith_to_string :
    Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
    char list -> Coq24_Compilers.ToString.IR.Coq_type.coq_type ->
    Coq24_Compilers.ToString.IR.arith_expr -> char list

  val consider_retargs_live_opt_instance_0 :
    Coq24_Compilers.ToString.IR.OfPHOAS.consider_retargs_live_opt

  val rename_dead_opt_instance_0 :
    Coq24_Compilers.ToString.IR.OfPHOAS.rename_dead_opt

  val lift_declarations_opt_instance_0 :
    Coq24_Compilers.ToString.IR.OfPHOAS.lift_declarations_opt

  val stmt_to_string :
    Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
    char list -> Coq24_Compilers.ToString.IR.stmt -> char list

  val to_strings :
    Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
    char list -> Coq24_Compilers.ToString.IR.expr -> char list list

  type coq_Mode =
  | In
  | Out

  val to_base_arg_list :
    char list -> coq_Mode -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type ->
    Coq7_Compilers.ToString.OfPHOAS.base_var_data -> char list list

  val to_arg_list :
    char list -> coq_Mode -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list

  val to_arg_list_for_each_lhs_of_arrow :
    char list -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow -> char list list

  val coq_Java_bin_op_natural_output :
    Coq24_Compilers.ToString.IR.coq_Z_binop ->
    (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
    -> Coq7_Compilers.ToString.Coq_int.coq_type

  val bin_op_commutes_with_mod_pow2 :
    Coq24_Compilers.ToString.IR.coq_Z_binop -> bool

  val coq_Java_bin_op_casts :
    Coq24_Compilers.ToString.IR.coq_Z_binop ->
    Coq7_Compilers.ToString.Coq_int.coq_type option ->
    (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
    -> Coq7_Compilers.ToString.Coq_int.coq_type
    option * (Coq7_Compilers.ToString.Coq_int.coq_type
    option * Coq7_Compilers.ToString.Coq_int.coq_type option)

  val coq_Java_un_op_casts :
    Coq24_Compilers.ToString.IR.coq_Z_unop ->
    Coq7_Compilers.ToString.Coq_int.coq_type option ->
    Coq7_Compilers.ToString.Coq_int.coq_type ->
    Coq7_Compilers.ToString.Coq_int.coq_type
    option * Coq7_Compilers.ToString.Coq_int.coq_type option

  val coq_JavaLanguageCasts :
    Coq24_Compilers.ToString.IR.OfPHOAS.coq_LanguageCasts

  val to_function_lines :
    Coq7_Compilers.Options.language_naming_conventions_opt -> bool -> bool ->
    bool -> char list -> char list -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * Coq24_Compilers.ToString.IR.expr)
    -> char list list

  val javadoc_replace : char list -> char list

  val javadoc_format : char list list -> char list list

  val coq_ToFunctionLines :
    Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
    Coq7_Compilers.Options.relax_zrange_opt ->
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.documentation_options_opt ->
    Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool -> bool ->
    bool -> bool -> char list -> char list -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr ->
    ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list) -> char list
    list option -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data -> (char list
    list * Coq7_Compilers.ToString.ident_infos, char list) sum

  val coq_OutputJavaAPI : Coq7_Compilers.ToString.coq_OutputLanguageAPI
 end

module JSON :
 sig
  val indent : char list -> char list list -> char list list

  val int_bitwidth_to_string : bool -> z -> char list

  val int_type_to_string :
    Coq7_Compilers.ToString.Coq_int.coq_type -> char list

  val primitive_type_to_string :
    Coq24_Compilers.ToString.IR.Coq_type.primitive ->
    Coq7_Compilers.ToString.Coq_int.coq_type option -> char list

  val int_literal_to_string :
    Coq24_Compilers.ToString.IR.Coq_type.primitive -> z -> char list

  type op_data = { datatype : char list; name : char list list;
                   operation : char list;
                   parameters : (char list * char list) list;
                   arguments : char list list list }

  val datatype : op_data -> char list

  val name : op_data -> char list list

  val operation : op_data -> char list

  val parameters : op_data -> (char list * char list) list

  val arguments : op_data -> char list list list

  val comma_concat : char list list list -> char list list

  val op_data_to_JSON : op_data -> char list list

  val arith_to_string :
    char list list -> Coq24_Compilers.ToString.IR.Coq_type.coq_type ->
    Coq7_Compilers.ToString.Coq_int.coq_type option ->
    Coq24_Compilers.ToString.IR.arith_expr -> char list list list

  val stmt_to_string : Coq24_Compilers.ToString.IR.stmt -> char list list

  val to_strings : Coq24_Compilers.ToString.IR.expr -> char list list

  val to_base_arg_list :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
    Coq7_Compilers.ToString.OfPHOAS.base_var_data ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
    ((char list * char list) * (char list * char list)) list

  val to_arg_list :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> Coq7_Compilers.ToString.OfPHOAS.var_data
    -> Coq6_Compilers.ZRange.Coq_type.Coq_option.interp ->
    ((char list * char list) * (char list * char list)) list

  val to_arg_list_for_each_lhs_of_arrow :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    ((char list * char list) * (char list * char list)) list

  val coq_JSON_bin_op_natural_output :
    Coq24_Compilers.ToString.IR.coq_Z_binop ->
    (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
    -> Coq7_Compilers.ToString.Coq_int.coq_type

  val bin_op_commutes_with_mod_pow2 :
    Coq24_Compilers.ToString.IR.coq_Z_binop -> bool

  val coq_JSON_bin_op_casts :
    Coq24_Compilers.ToString.IR.coq_Z_binop ->
    Coq7_Compilers.ToString.Coq_int.coq_type option ->
    (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
    -> Coq7_Compilers.ToString.Coq_int.coq_type
    option * (Coq7_Compilers.ToString.Coq_int.coq_type
    option * Coq7_Compilers.ToString.Coq_int.coq_type option)

  val coq_JSON_un_op_casts :
    Coq24_Compilers.ToString.IR.coq_Z_unop ->
    Coq7_Compilers.ToString.Coq_int.coq_type option ->
    Coq7_Compilers.ToString.Coq_int.coq_type ->
    Coq7_Compilers.ToString.Coq_int.coq_type
    option * Coq7_Compilers.ToString.Coq_int.coq_type option

  val coq_JSONLanguageCasts :
    Coq24_Compilers.ToString.IR.OfPHOAS.coq_LanguageCasts

  val to_function_lines :
    bool -> bool -> char list -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
    (((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * Coq24_Compilers.ToString.IR.expr)
    -> char list list

  val consider_retargs_live_opt_instance_0 :
    Coq24_Compilers.ToString.IR.OfPHOAS.consider_retargs_live_opt

  val rename_dead_opt_instance_0 :
    Coq24_Compilers.ToString.IR.OfPHOAS.rename_dead_opt

  val lift_declarations_opt_instance_0 :
    Coq24_Compilers.ToString.IR.OfPHOAS.lift_declarations_opt

  val coq_ToFunctionLines :
    Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
    Coq7_Compilers.Options.relax_zrange_opt ->
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.documentation_options_opt ->
    Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool -> bool ->
    bool -> bool -> char list -> char list -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr ->
    ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list) -> char list
    list option -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data -> (char list
    list * Coq7_Compilers.ToString.ident_infos, char list) sum

  val coq_OutputJSONAPI : Coq7_Compilers.ToString.coq_OutputLanguageAPI
 end

module Zig :
 sig
  val comment_module_header_block : char list list -> char list list

  val comment_block : char list list -> char list list

  val int_type_to_string_opt_typedef :
    Coq7_Compilers.Options.skip_typedefs_opt ->
    Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
    char list -> Coq7_Compilers.ToString.Coq_int.coq_type -> char list option
    -> char list

  val int_type_to_string :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.ToString.Coq_int.coq_type -> char list

  val primitive_type_to_string_opt_typedef :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> char list ->
    Coq24_Compilers.ToString.IR.Coq_type.primitive ->
    Coq7_Compilers.ToString.Coq_int.coq_type option -> char list option ->
    char list

  val primitive_type_to_string :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq24_Compilers.ToString.IR.Coq_type.primitive ->
    Coq7_Compilers.ToString.Coq_int.coq_type option -> char list

  val primitive_array_type_to_string :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> char list ->
    Coq24_Compilers.ToString.IR.Coq_type.primitive ->
    Coq7_Compilers.ToString.Coq_int.coq_type option -> nat -> char list
    option -> char list

  val make_typedef :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.documentation_options_opt -> char list -> bool ->
    (((char list * (char list ->
    char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
    option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) ->
    char list list

  val header :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.documentation_options_opt ->
    Coq7_Compilers.Options.package_name_opt ->
    Coq7_Compilers.Options.class_name_opt ->
    Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool ->
    char list -> Coq7_Compilers.ToString.ident_infos ->
    (((char list * (char list ->
    char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
    option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) list ->
    char list list

  val int_literal_to_string :
    char list -> Coq24_Compilers.ToString.IR.Coq_type.primitive -> z ->
    char list

  val arith_to_string :
    Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
    char list -> Coq24_Compilers.ToString.IR.Coq_type.coq_type ->
    Coq24_Compilers.ToString.IR.arith_expr -> char list

  val stmt_to_string :
    Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
    char list -> Coq24_Compilers.ToString.IR.stmt -> char list

  val to_strings :
    Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
    char list -> Coq24_Compilers.ToString.IR.expr -> char list list

  type coq_Mode =
  | In
  | Out

  val to_base_arg_list :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list ->
    coq_Mode -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
    Coq7_Compilers.ToString.OfPHOAS.base_var_data -> char list list

  val to_arg_list :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list ->
    coq_Mode -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> Coq7_Compilers.ToString.OfPHOAS.var_data
    -> char list list

  val to_arg_list_for_each_lhs_of_arrow :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list ->
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow -> char list list

  val coq_Zig_bin_op_natural_output :
    Coq24_Compilers.ToString.IR.coq_Z_binop ->
    (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
    -> Coq7_Compilers.ToString.Coq_int.coq_type

  val coq_Zig_bin_op_casts :
    Coq24_Compilers.ToString.IR.coq_Z_binop ->
    Coq7_Compilers.ToString.Coq_int.coq_type option ->
    (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
    -> Coq7_Compilers.ToString.Coq_int.coq_type
    option * (Coq7_Compilers.ToString.Coq_int.coq_type
    option * Coq7_Compilers.ToString.Coq_int.coq_type option)

  val coq_Zig_un_op_casts :
    Coq24_Compilers.ToString.IR.coq_Z_unop ->
    Coq7_Compilers.ToString.Coq_int.coq_type option ->
    Coq7_Compilers.ToString.Coq_int.coq_type ->
    Coq7_Compilers.ToString.Coq_int.coq_type
    option * Coq7_Compilers.ToString.Coq_int.coq_type option

  val coq_ZigLanguageCasts :
    Coq24_Compilers.ToString.IR.OfPHOAS.coq_LanguageCasts

  val to_function_lines :
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> bool -> bool
    -> char list -> char list -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * Coq24_Compilers.ToString.IR.expr)
    -> char list list

  val consider_retargs_live_opt_instance_0 :
    Coq24_Compilers.ToString.IR.OfPHOAS.consider_retargs_live_opt

  val rename_dead_opt_instance_0 :
    Coq24_Compilers.ToString.IR.OfPHOAS.rename_dead_opt

  val lift_declarations_opt_instance_0 :
    Coq24_Compilers.ToString.IR.OfPHOAS.lift_declarations_opt

  val coq_ToFunctionLines :
    Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
    Coq7_Compilers.Options.relax_zrange_opt ->
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.documentation_options_opt ->
    Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool -> bool ->
    bool -> bool -> char list -> char list -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr ->
    ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list) -> char list
    list option -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data -> (char list
    list * Coq7_Compilers.ToString.ident_infos, char list) sum

  val coq_OutputZigAPI : Coq7_Compilers.ToString.coq_OutputLanguageAPI
 end

type base_system =
| Bin
| Hex
| Oct
| Dec0

type spec =
| Unit
| Bool
| String
| Int of base_system list
| Nat of base_system list
| Tuple of spec list
| Symbol of char list list
| CustomSymbol of (char list * __) list
| Custom of (char list -> __ option) * char list

type key0 =
| Long_key of char list
| Short_key of char list

type doc = char list list

type usage_msg = char list list

type spec_data = __

type spec_data_with_key = (char list * spec_data) list

type opt_spec_data = __

type keyed_spec_list_data = __

type spec_list_data = __

val update_type_of_list : __ list -> ('a1 -> 'a2) -> __ -> __

val update_type_of_list2 : __ list -> (__ -> __) -> __ -> __

val cons_type_of_list : __ list -> 'a1 -> __ -> __

val cons_type_of_list' : __ list -> 'a1 -> __ -> __

val uncons_type_of_list : __ list -> __ -> 'a1 * __

val split_type_of_list_' : __ list -> __ list -> __ -> __ * __

val split_type_of_list' : __ list -> __ list -> __ -> __ * __

val make_symlist :
  char list -> char list -> char list -> char list list -> char list

val doc_length : doc -> nat

val print_key : key0 -> char list

val print_key_list : key0 list -> char list

val print_spec_parts :
  (((key0 list, char list) sum * spec) * doc) -> char list * char list list

val print_spec_short : char list -> spec -> char list

val help_specs : ((key0 list * spec) * doc) list

val arg_matches_key : char list -> key0 -> bool

val arg_matches_key_list : char list -> key0 list -> bool

val parse_bool_opt : char list -> bool option

val print_base_system : base_system -> char list

val print_base_systems : base_system list -> char list

val parse_int_as_opt : base_system -> char list -> z option

val parse_int_opt : base_system list -> char list -> (base_system * z) option

val parse_nat_opt :
  base_system list -> char list -> (base_system * nat) option

type parse_error =
| Help of char list
| Missing of char list * char list
| Wrong of char list * char list * char list * char list
| No_keyed_arg of char list * char list list
| Missing_prog_name
| Too_many_args of char list * char list list
| Out_of_fuel of char list
| Internal_error of char list * char list

type 't parse_result = (parse_error, 't) errorT

val parse_args_via_spec :
  spec -> char list list -> parse_error -> (char list -> char list ->
  parse_error) -> (spec_data * char list list) parse_result

type arg_spec = { named_args : ((key0 list * spec) * doc) list;
                  anon_args : ((char list * spec) * doc) list;
                  anon_opt_args : ((char list * spec) * doc) list;
                  anon_opt_repeated_arg : ((char list * spec) * doc) option }

type shouldBlockIndent =
| NoIndent
| ArbitraryIndent
| IndentUpTo of nat

val spaces : nat -> char list

val maybe_block_indent :
  shouldBlockIndent -> nat -> char list -> char list list -> char list list

val usage_string :
  shouldBlockIndent -> arg_spec -> usage_msg -> char list list

type arg_spec_results =
  ((keyed_spec_list_data * spec_list_data) * spec_list_data) * __

val consume_one_named_arg :
  char list -> char list list -> ((key0 list * spec) * doc) -> parse_error ->
  (char list -> char list -> parse_error) -> ((spec_data_with_key ->
  spec_data_with_key) * char list list) option parse_result

val consume_named_arg :
  char list -> char list list -> ((key0 list * spec) * doc) list ->
  (char list -> parse_error) -> (char list -> char list -> char list ->
  parse_error) -> ((keyed_spec_list_data -> keyed_spec_list_data) * char list
  list) parse_result

val consume_help_or_named_arg :
  char list -> char list list -> ((key0 list * spec) * doc) list ->
  (char list -> parse_error) -> (char list -> char list -> char list ->
  parse_error) -> parse_error -> ((keyed_spec_list_data ->
  keyed_spec_list_data) * char list list) parse_result

val consume_one_anon_arg :
  bool -> char list list -> spec -> parse_error -> (char list -> char list ->
  parse_error) -> (opt_spec_data * char list list) parse_result

val build_type_of_list_map : 'a1 list -> 'a3 -> ('a1 -> 'a2) -> __

val cons_spec_list_data :
  bool -> char list -> spec -> doc -> ((char list * spec) * doc) list ->
  opt_spec_data -> spec_list_data -> spec_list_data

val empty_spec_list_data_opt :
  ((char list * spec) * doc) list -> spec_list_data

val empty_opt_repeated_arg : (('a1 * spec) * 'a2) option -> __

val consume_args :
  nat -> char list list -> arg_spec -> (char list -> parse_error) ->
  (char list -> char list -> char list -> parse_error) -> (char list list ->
  parse_error) -> (char list -> parse_error) -> (char list list ->
  parse_error) -> parse_error -> parse_error -> ((((keyed_spec_list_data ->
  keyed_spec_list_data) * spec_list_data) * spec_list_data) * __) parse_result

val default_named_result : spec -> spec_data_with_key

val default_named_results' : ((key0 list * spec) * doc) list -> 'a1 -> __

val default_named_results :
  ((key0 list * spec) * doc) list -> keyed_spec_list_data

type prog_name_countT = nat

val parse_argv :
  prog_name_countT -> char list list -> arg_spec -> arg_spec_results
  parse_result

val is_real_error : parse_error -> bool

val make_usage : char list -> arg_spec -> char list

val show_list_parse_error :
  shouldBlockIndent -> arg_spec -> parse_error -> char list list

val default_should_block_indent : shouldBlockIndent

module ForExtraction :
 sig
  type coq_SynthesisKind =
  | Coq_word_by_word_montgomery
  | Coq_unsaturated_solinas
  | Coq_saturated_solinas
  | Coq_dettman_multiplication
  | Coq_solinas_reduction
  | Coq_base_conversion

  val parse_SynthesisKind_list : (char list * coq_SynthesisKind) list

  val parse_string_and :
    (char list -> 'a1 option) -> char list -> (char list * 'a1) option

  val parse_Z : char list -> z option

  val parse_N : char list -> n option

  val parse_nat : char list -> nat option

  val parse_Q : char list -> q option

  val parse_list_Z : char list -> z list option

  val parse_list_REG : char list -> rEG list option

  val parse_list_rewrite_pass :
    char list -> RewritePass.rewrite_pass list option

  val parse_comma_list_Z : char list -> z list option

  val parse_callee_saved_registers :
    char list -> assembly_callee_saved_registers_opt option

  val parse_n : char list -> maybeLimbCount option

  val parse_sc : char list -> (z * (z * z) list) option

  val parse_machine_wordsize : char list -> z option

  val parse_m : char list -> z option

  val parse_case_convention : char list -> capitalization_data option

  val valid_case_conventions : char list

  val parse_src_n : char list -> nat option

  val parse_limbwidth : char list -> q option

  val parse_bounds_multiplier :
    char list option -> char list * q option option

  val parse_dirbounds_multiplier :
    char list -> (char list option, char list list) sum -> char list * (q
    option, char list list) sum

  val parse_bounds_list : char list option -> char list * z list option option

  val parse_dirbounds :
    char list -> (char list option, char list list) sum -> bool ->
    char list * (bounds0, char list list) sum

  val show_c : (z * z) list show

  val quote : char list -> char list

  val known_debug_options_with_spec : (char list * char list) list

  val known_debug_options : char list list

  val special_debug_options : (char list * flag_option_kind) list

  val default_debug : char list

  val known_asm_rewriting_pass_flags : char list list

  val known_asm_rewriting_pass_flags_with_spec : (char list * char list) list

  val special_asm_rewriting_pass_flags : (char list * flag_option_kind) list

  val default_asm_rewriting_passes : char list

  val coq_CollectErrors :
    machine_wordsize_opt -> Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    ((synthesis_output_kind * char list) * (char list,
    (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list ->
    ((char list, char list list list * char list list list) debugM,
    (char list, char list list) debugM list) sum

  type supported_languagesT =
    (char list * Coq7_Compilers.ToString.coq_OutputLanguageAPI) list

  val default_supported_languages : supported_languagesT

  val describe_flag_options :
    char list -> char list -> (char list * flag_option_kind) list ->
    (char list * char list) list -> char list list

  val synthesis_kind_spec : (char list * spec) * doc

  val curve_description_spec : (char list * spec) * doc

  val lang_default :
    supported_languagesT ->
    char list * Coq7_Compilers.ToString.coq_OutputLanguageAPI

  val lang_spec : supported_languagesT -> (key0 list * spec) * doc

  val no_prefix_fiat_spec : (key0 list * spec) * doc

  val package_name_spec : (key0 list * spec) * doc

  val class_name_spec : (key0 list * spec) * doc

  val private_function_case_spec : (key0 list * spec) * doc

  val public_function_case_spec : (key0 list * spec) * doc

  val private_type_case_spec : (key0 list * spec) * doc

  val public_type_case_spec : (key0 list * spec) * doc

  val class_case_spec : (key0 list * spec) * doc

  val package_case_spec : (key0 list * spec) * doc

  val static_spec : (key0 list * spec) * doc

  val internal_static_spec : (key0 list * spec) * doc

  val inline_spec : (key0 list * spec) * doc

  val inline_internal_spec : (key0 list * spec) * doc

  val only_signed_spec : (key0 list * spec) * doc

  val no_select_spec : (key0 list * spec) * doc

  val no_wide_int_spec : (key0 list * spec) * doc

  val widen_carry_spec : (key0 list * spec) * doc

  val widen_bytes_spec : (key0 list * spec) * doc

  val split_multiret_spec : (key0 list * spec) * doc

  val value_barrier_spec : (key0 list * spec) * doc

  val no_primitives_spec : (key0 list * spec) * doc

  val no_field_element_typedefs_spec : (key0 list * spec) * doc

  val emit_all_casts_spec : (key0 list * spec) * doc

  val relax_primitive_carry_to_bitwidth_spec : (key0 list * spec) * doc

  val cmovznz_by_mul_spec : (key0 list * spec) * doc

  val shiftr_avoid_uint1_spec : (key0 list * spec) * doc

  val tight_bounds_multiplier_default : q

  val tight_bounds_multiplier_spec : (key0 list * spec) * doc

  val n_spec : (char list * spec) * doc

  val n_nat_spec : (char list * spec) * doc

  val last_limb_width_spec : (char list * spec) * doc

  val last_reduction_spec : (char list * spec) * doc

  val sc_spec : (char list * spec) * doc

  val m_spec : (char list * spec) * doc

  val machine_wordsize_spec : (char list * spec) * doc

  val src_n_spec : (char list * spec) * doc

  val src_limbwidth_spec : (char list * spec) * doc

  val dst_limbwidth_spec : (char list * spec) * doc

  val use_bitwidth_in_spec : (key0 list * spec) * doc

  val use_bitwidth_out_spec : (key0 list * spec) * doc

  val default_inbounds_multiplier : z

  val inbounds_multiplier_spec : (key0 list * spec) * doc

  val default_outbounds_multiplier : z

  val outbounds_multiplier_spec : (key0 list * spec) * doc

  val inbounds_spec : (key0 list * spec) * doc

  val outbounds_spec : (key0 list * spec) * doc

  val function_to_synthesize_spec : char list -> (char list * spec) * doc

  val hint_file_spec : (key0 list * spec) * doc

  val output_file_spec : (key0 list * spec) * doc

  val asm_output_spec : (key0 list * spec) * doc

  val asm_reg_spec : (key0 list * spec) * doc

  val asm_callee_saved_registers_spec : (key0 list * spec) * doc

  val asm_stack_size_spec : (key0 list * spec) * doc

  val no_error_on_unused_asm_functions_spec : (key0 list * spec) * doc

  val asm_input_first_spec : (key0 list * spec) * doc

  val asm_reg_rtl_spec : (key0 list * spec) * doc

  val asm_error_on_unique_names_mismatch_spec : (key0 list * spec) * doc

  val asm_rewriting_pipeline_spec : (key0 list * spec) * doc

  val asm_rewriting_passes_spec : (key0 list * spec) * doc

  val doc_text_before_function_name_spec : (key0 list * spec) * doc

  val doc_text_before_type_name_spec : (key0 list * spec) * doc

  val doc_newline_before_package_declaration_spec : (key0 list * spec) * doc

  val doc_newline_in_typedef_bounds_spec : (key0 list * spec) * doc

  val doc_prepend_header_raw_spec : (key0 list * spec) * doc

  val doc_prepend_header_spec : (key0 list * spec) * doc

  val debug_spec : (key0 list * spec) * doc

  val collapse_list_default : 'a1 -> 'a1 list -> 'a1

  val join_errors :
    ('a1, char list list) sum -> ('a2, char list list) sum -> ('a1 * 'a2,
    char list list) sum

  type coq_ParsedSynthesizeOptions = { static : static_opt;
                                       internal_static : internal_static_opt;
                                       inline : inline_opt;
                                       inline_internal : inline_internal_opt;
                                       only_signed : only_signed_opt;
                                       no_select : no_select_opt;
                                       emit_primitives : emit_primitives_opt;
                                       output_options : Coq7_Compilers.Options.output_options_opt;
                                       use_mul_for_cmovznz : use_mul_for_cmovznz_opt;
                                       abstract_interpretation_options : 
                                       Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options;
                                       should_split_mul : should_split_mul_opt;
                                       should_split_multiret : should_split_multiret_opt;
                                       unfold_value_barrier : unfold_value_barrier_opt;
                                       widen_carry : widen_carry_opt;
                                       widen_bytes : widen_bytes_opt;
                                       ignore_unique_asm_names : ignore_unique_asm_names_opt;
                                       machine_wordsize : machine_wordsize_opt;
                                       internal_package_name : Coq7_Compilers.Options.package_name_opt;
                                       internal_class_name : Coq7_Compilers.Options.class_name_opt;
                                       language_naming_conventions : 
                                       Coq7_Compilers.Options.language_naming_conventions_opt;
                                       documentation_options : Coq7_Compilers.Options.documentation_options_opt;
                                       equivalence_checker_options : 
                                       Coq_Options.equivalence_checker_options_opt;
                                       error_on_unused_assembly_functions : 
                                       error_on_unused_assembly_functions_opt;
                                       no_prefix_fiat : bool;
                                       before_header_lines : char list list;
                                       extra_early_header_lines : char list
                                                                  list;
                                       debug_rewriting : debug_rewriting_opt;
                                       debug_on_success : bool }

  val static : coq_ParsedSynthesizeOptions -> static_opt

  val internal_static : coq_ParsedSynthesizeOptions -> internal_static_opt

  val inline : coq_ParsedSynthesizeOptions -> inline_opt

  val inline_internal : coq_ParsedSynthesizeOptions -> inline_internal_opt

  val only_signed : coq_ParsedSynthesizeOptions -> only_signed_opt

  val no_select : coq_ParsedSynthesizeOptions -> no_select_opt

  val emit_primitives : coq_ParsedSynthesizeOptions -> emit_primitives_opt

  val output_options :
    coq_ParsedSynthesizeOptions -> Coq7_Compilers.Options.output_options_opt

  val use_mul_for_cmovznz :
    coq_ParsedSynthesizeOptions -> use_mul_for_cmovznz_opt

  val abstract_interpretation_options :
    coq_ParsedSynthesizeOptions ->
    Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options

  val should_split_mul : coq_ParsedSynthesizeOptions -> should_split_mul_opt

  val should_split_multiret :
    coq_ParsedSynthesizeOptions -> should_split_multiret_opt

  val unfold_value_barrier :
    coq_ParsedSynthesizeOptions -> unfold_value_barrier_opt

  val widen_carry : coq_ParsedSynthesizeOptions -> widen_carry_opt

  val widen_bytes : coq_ParsedSynthesizeOptions -> widen_bytes_opt

  val ignore_unique_asm_names :
    coq_ParsedSynthesizeOptions -> ignore_unique_asm_names_opt

  val low_level_rewriter_method :
    coq_ParsedSynthesizeOptions -> low_level_rewriter_method_opt

  val machine_wordsize : coq_ParsedSynthesizeOptions -> machine_wordsize_opt

  val internal_package_name :
    coq_ParsedSynthesizeOptions -> Coq7_Compilers.Options.package_name_opt

  val internal_class_name :
    coq_ParsedSynthesizeOptions -> Coq7_Compilers.Options.class_name_opt

  val language_naming_conventions :
    coq_ParsedSynthesizeOptions ->
    Coq7_Compilers.Options.language_naming_conventions_opt

  val documentation_options :
    coq_ParsedSynthesizeOptions ->
    Coq7_Compilers.Options.documentation_options_opt

  val equivalence_checker_options :
    coq_ParsedSynthesizeOptions -> Coq_Options.equivalence_checker_options_opt

  val error_on_unused_assembly_functions :
    coq_ParsedSynthesizeOptions -> error_on_unused_assembly_functions_opt

  val no_prefix_fiat : coq_ParsedSynthesizeOptions -> bool

  val before_header_lines : coq_ParsedSynthesizeOptions -> char list list

  val extra_early_header_lines : coq_ParsedSynthesizeOptions -> char list list

  val debug_rewriting : coq_ParsedSynthesizeOptions -> debug_rewriting_opt

  val debug_on_success : coq_ParsedSynthesizeOptions -> bool

  type coq_SynthesizeOptions = { parsed_synthesize_options : coq_ParsedSynthesizeOptions;
                                 assembly_hints_lines : assembly_hints_lines_opt }

  val parsed_synthesize_options :
    coq_SynthesizeOptions -> coq_ParsedSynthesizeOptions

  val assembly_hints_lines : coq_SynthesizeOptions -> assembly_hints_lines_opt

  type coq_IODriverOptions = { hint_file_names : char list list;
                               output_file_name : char list;
                               asm_output_file_name : char list }

  val hint_file_names : coq_IODriverOptions -> char list list

  val output_file_name : coq_IODriverOptions -> char list

  val asm_output_file_name : coq_IODriverOptions -> char list

  val with_read_concat_asm_files_cps :
    (char list -> (char list list -> 'a1) -> 'a1) -> char list list ->
    (assembly_hints_lines_opt -> 'a1) -> 'a1

  val common_optional_options :
    supported_languagesT -> ((key0 list * spec) * doc) list

  val choose_one_of_many : 'a1 list -> 'a1 option

  val parse_common_optional_options :
    supported_languagesT -> machine_wordsize_opt -> keyed_spec_list_data ->
    ((coq_IODriverOptions * coq_ParsedSynthesizeOptions) * Coq7_Compilers.ToString.coq_OutputLanguageAPI,
    char list list) sum

  type coq_PipelineAPI = { spec : arg_spec;
                           parse_args : (coq_SynthesizeOptions ->
                                        arg_spec_results -> (__ * __,
                                        char list list) sum);
                           show_lines_args : ((__ * __) -> char list list);
                           coq_Synthesize : (Coq7_Compilers.ToString.coq_OutputLanguageAPI
                                            -> coq_SynthesizeOptions -> __ ->
                                            char list list -> char list ->
                                            ((synthesis_output_kind * char list) * (char list,
                                            (Pipeline.coq_ErrorMessage,
                                            char list list) errorT) debugM)
                                            list) }

  val spec : coq_PipelineAPI -> arg_spec

  type coq_ParsedArgsT = __

  type coq_StringArgsT = __

  type coq_ArgsT = coq_StringArgsT * coq_ParsedArgsT

  val parse_args :
    coq_PipelineAPI -> coq_SynthesizeOptions -> arg_spec_results ->
    (coq_ArgsT, char list list) sum

  val show_lines_args : coq_PipelineAPI -> coq_ArgsT -> char list list

  val coq_Synthesize :
    coq_PipelineAPI -> Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    coq_SynthesizeOptions -> coq_ParsedArgsT -> char list list -> char list
    -> ((synthesis_output_kind * char list) * (char list,
    (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list

  type 'a coq_IODriverAPI = { error : (char list list -> 'a);
                              ret : (unit -> 'a);
                              with_read_stdin : ((char list list -> 'a) -> 'a);
                              write_stdout_then : (char list list -> (unit ->
                                                  'a) -> 'a);
                              write_stderr_then : (char list list -> (unit ->
                                                  'a) -> 'a);
                              with_read_file : (char list -> (char list list
                                               -> 'a) -> 'a);
                              write_file_then : (char list -> char list list
                                                -> (unit -> 'a) -> 'a) }

  val error : 'a1 coq_IODriverAPI -> char list list -> 'a1

  val ret : 'a1 coq_IODriverAPI -> unit -> 'a1

  val with_read_stdin : 'a1 coq_IODriverAPI -> (char list list -> 'a1) -> 'a1

  val write_stdout_then :
    'a1 coq_IODriverAPI -> char list list -> (unit -> 'a1) -> 'a1

  val write_stderr_then :
    'a1 coq_IODriverAPI -> char list list -> (unit -> 'a1) -> 'a1

  val with_read_file :
    'a1 coq_IODriverAPI -> char list -> (char list list -> 'a1) -> 'a1

  val write_file_then :
    'a1 coq_IODriverAPI -> char list -> char list list -> (unit -> 'a1) -> 'a1

  module Parameterized :
   sig
    val coq_PipelineLines :
      coq_PipelineAPI -> Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
      coq_SynthesizeOptions -> char list -> char list -> char list ->
      coq_ArgsT -> ((synthesis_output_kind * char list) * (char list,
      (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list

    val coq_ProcessedLines :
      coq_PipelineAPI -> Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
      coq_SynthesizeOptions -> char list -> char list -> char list ->
      coq_ArgsT -> ((char list, char list list * char list list) debugM,
      char list list) sum

    val coq_Pipeline :
      coq_PipelineAPI -> Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
      coq_SynthesizeOptions -> char list -> char list -> char list ->
      coq_ArgsT -> (((char list list * char list list) * char list list) ->
      'a1) -> (char list list -> 'a1) -> 'a1

    val coq_PipelineMain :
      coq_PipelineAPI -> prog_name_countT -> supported_languagesT -> 'a1
      coq_IODriverAPI -> char list list -> 'a1
   end

  module UnsaturatedSolinas :
   sig
    val api : coq_PipelineAPI

    val coq_PipelineMain :
      prog_name_countT -> supported_languagesT -> 'a1 coq_IODriverAPI ->
      char list list -> 'a1
   end

  module WordByWordMontgomery :
   sig
    val api : coq_PipelineAPI

    val coq_PipelineMain :
      prog_name_countT -> supported_languagesT -> 'a1 coq_IODriverAPI ->
      char list list -> 'a1
   end

  module SaturatedSolinas :
   sig
    val api : coq_PipelineAPI

    val coq_PipelineMain :
      prog_name_countT -> supported_languagesT -> 'a1 coq_IODriverAPI ->
      char list list -> 'a1
   end

  module DettmanMultiplication :
   sig
    val api : coq_PipelineAPI

    val coq_PipelineMain :
      prog_name_countT -> supported_languagesT -> 'a1 coq_IODriverAPI ->
      char list list -> 'a1
   end

  module SolinasReduction :
   sig
    val api : coq_PipelineAPI

    val coq_PipelineMain :
      prog_name_countT -> supported_languagesT -> 'a1 coq_IODriverAPI ->
      char list list -> 'a1
   end

  module BaseConversion :
   sig
    val api : coq_PipelineAPI

    val coq_PipelineMain :
      prog_name_countT -> supported_languagesT -> 'a1 coq_IODriverAPI ->
      char list list -> 'a1
   end

  module FiatCrypto :
   sig
    val coq_PipelineMain :
      supported_languagesT -> 'a1 coq_IODriverAPI -> char list list -> 'a1
   end
 end

type trace =
| Finished
| Err of char list list
| Read_stdin of (char list list -> trace)
| Write_stdout of char list list * trace
| Write_stderr of char list list * trace
| Read_file of char list * (char list list -> trace)
| Write_file of char list * char list list * trace

val iODriverTrace : trace ForExtraction.coq_IODriverAPI

val split_stdout_stderr :
  (char list list, char list list) sum list -> char list list * char list list

val eval' :
  trace -> char list list list -> (char list * char list list) list ->
  ((char list list, char list list) sum list -> 'a1) -> (char list list,
  char list list) sum list -> (char list * char list list) list -> (char list
  list option * 'a1) * (char list * char list list) list

val eval_trace :
  trace -> char list list list -> (char list * char list list) list ->
  ((char list list, char list list) sum list -> 'a1) -> (char list list
  option * 'a1) * (char list * char list list) list

module type OCamlPrimitivesT =
 sig
  type coq_OCaml_string

  val string_length : coq_OCaml_string -> Int.t

  val string_get : coq_OCaml_string -> Int.t -> char

  val string_init : Int.t -> (Int.t -> char) -> coq_OCaml_string

  type 'x coq_OCaml_array

  val coq_Array_to_list : 'a1 coq_OCaml_array -> 'a1 list

  val coq_Array_of_list : 'a1 list -> 'a1 coq_OCaml_array
 end

module OCamlPrimitives :
 OCamlPrimitivesT

module type Js_of_ocamlPrimitivesT =
 sig
  type 'x coq_Js_t

  type js_string

  type 'x js_array

  val js_to_array :
    'a1 js_array coq_Js_t -> 'a1 OCamlPrimitives.coq_OCaml_array

  val js_to_string : js_string coq_Js_t -> OCamlPrimitives.coq_OCaml_string

  val js_of_array :
    'a1 OCamlPrimitives.coq_OCaml_array -> 'a1 js_array coq_Js_t

  val js_of_string : OCamlPrimitives.coq_OCaml_string -> js_string coq_Js_t

  val js_to_bool : bool coq_Js_t -> bool

  val js_of_bool : bool -> bool coq_Js_t

  type coq_Js_Unsafe_any

  val coq_Js_Unsafe_inject : 'a1 -> coq_Js_Unsafe_any

  val coq_Js_export : OCamlPrimitives.coq_OCaml_string -> 'a1 -> unit

  type 'x js_callback

  val js_wrap_callback : ('a1 -> 'a2) -> ('a1 -> 'a2) js_callback
 end

module Js_of_ocamlPrimitives :
 Js_of_ocamlPrimitivesT

val nat_of_int : Int.t -> nat

val int_of_nat : nat -> Int.t

val string_of_Coq_string : char list -> OCamlPrimitives.coq_OCaml_string

val string_to_Coq_string : OCamlPrimitives.coq_OCaml_string -> char list

val main_gen : (char list list -> trace) -> unit

module Coq_bopname :
 sig
  type bopname =
  | Coq_add
  | Coq_sub
  | Coq_mul
  | Coq_mulhuu
  | Coq_divu
  | Coq_remu
  | Coq_and
  | Coq_or
  | Coq_xor
  | Coq_sru
  | Coq_slu
  | Coq_srs
  | Coq_lts
  | Coq_ltu
  | Coq_eq
 end

module Coq_access_size :
 sig
  type access_size =
  | Coq_one
  | Coq_two
  | Coq_four
  | Coq_word
 end

module Coq_expr :
 sig
  type expr =
  | Coq_literal of z
  | Coq_var of char list
  | Coq_load of Coq_access_size.access_size * expr
  | Coq_inlinetable of Coq_access_size.access_size * char list * expr
  | Coq_op of Coq_bopname.bopname * expr * expr
  | Coq_ite of expr * expr * expr
 end

module Coq_cmd :
 sig
  type cmd =
  | Coq_skip
  | Coq_set of char list * Coq_expr.expr
  | Coq_unset of char list
  | Coq_store of Coq_access_size.access_size * Coq_expr.expr * Coq_expr.expr
  | Coq_stackalloc of char list * z * cmd
  | Coq_cond of Coq_expr.expr * cmd * cmd
  | Coq_seq of cmd * cmd
  | Coq_while of Coq_expr.expr * cmd
  | Coq_call of char list list * char list * Coq_expr.expr list
  | Coq_interact of char list list * char list * Coq_expr.expr list
 end

type func = (char list list * char list list) * Coq_cmd.cmd

module Coq0_expr :
 sig
  val vars : Coq_expr.expr -> char list list
 end

module Coq0_cmd :
 sig
  val vars : Coq_cmd.cmd -> char list list
 end

val prelude : char list

val lF0 : char list

val c_var : char list -> char list

val c_fun : char list -> char list

val c_lit : z -> char list

val c_byte_withoutcast : char -> char list

val c_bop : char list -> Coq_bopname.bopname -> char list -> char list

val c_size : Coq_access_size.access_size -> char list

val c_expr : Coq_expr.expr -> char list

val list_uniq : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list

val list_minus : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list -> 'a1 list

val c_call : char list list -> char list -> char list list -> char list

val c_act : char list list -> char list -> char list list -> char list

val c_cmd : char list -> Coq_cmd.cmd -> char list

val rename_away_from : char list -> char list list -> char list

val rename_outs :
  char list list -> char list list -> (char list * char list)
  list * char list list

val fmt_c_decl :
  char list -> char list list -> char list -> char list list -> char list

val c_func :
  (char list * ((char list list * char list list) * Coq_cmd.cmd)) -> char list

module Coq_word :
 sig
  type word = { unsigned : (__ -> z); signed : (__ -> z); of_Z : (z -> __);
                add : (__ -> __ -> __); sub : (__ -> __ -> __);
                opp : (__ -> __); coq_or : (__ -> __ -> __);
                coq_and : (__ -> __ -> __); xor : (__ -> __ -> __);
                not : (__ -> __); ndn : (__ -> __ -> __);
                mul : (__ -> __ -> __); mulhss : (__ -> __ -> __);
                mulhsu : (__ -> __ -> __); mulhuu : (__ -> __ -> __);
                divu : (__ -> __ -> __); divs : (__ -> __ -> __);
                modu : (__ -> __ -> __); mods : (__ -> __ -> __);
                slu : (__ -> __ -> __); sru : (__ -> __ -> __);
                srs : (__ -> __ -> __); eqb : (__ -> __ -> bool);
                ltu : (__ -> __ -> bool); lts : (__ -> __ -> bool);
                sextend : (z -> __ -> __) }

  type rep = __

  val ltu : z -> word -> rep -> rep -> bool
 end

type rep0 = z
  (* singleton inductive, whose constructor was mk *)

val unsigned0 : z -> rep0 -> z

val wrap : z -> z -> rep0

val signed0 : z -> rep0 -> z

type special_cases = { div_by_zero : (z -> z); mod_by_zero : (z -> z);
                       adjust_too_big_shift_amount : (z -> z) }

val gen_word : z -> special_cases -> Coq_word.word

val default_special_case_handlers : z -> special_cases

val word0 : z -> Coq_word.word

module Coq_map :
 sig
  type ('key, 'value) map = { get : (__ -> 'key -> 'value option);
                              empty : __; put : (__ -> 'key -> 'value -> __);
                              remove : (__ -> 'key -> __);
                              fold : (__ -> (__ -> 'key -> 'value -> __) ->
                                     __ -> __ -> __) }
 end

module Coq_parameters :
 sig
  type parameters =
    __ -> __ -> bool
    (* singleton inductive, whose constructor was Build_parameters *)

  type key = __

  type value = __

  val ltb : parameters -> key -> key -> bool
 end

val eqb1 :
  Coq_parameters.parameters -> Coq_parameters.key -> Coq_parameters.key ->
  bool

val put0 :
  Coq_parameters.parameters -> (Coq_parameters.key * Coq_parameters.value)
  list -> Coq_parameters.key -> Coq_parameters.value ->
  (Coq_parameters.key * Coq_parameters.value) list

val remove1 :
  Coq_parameters.parameters -> (Coq_parameters.key * Coq_parameters.value)
  list -> Coq_parameters.key -> (Coq_parameters.key * Coq_parameters.value)
  list

type rep1 =
  (Coq_parameters.key * Coq_parameters.value) list
  (* singleton inductive, whose constructor was Build_rep *)

val value0 :
  Coq_parameters.parameters -> rep1 ->
  (Coq_parameters.key * Coq_parameters.value) list

val lookup0 :
  Coq_parameters.parameters -> (Coq_parameters.key * Coq_parameters.value)
  list -> Coq_parameters.key -> Coq_parameters.value option

val map4 :
  Coq_parameters.parameters -> (Coq_parameters.key, Coq_parameters.value)
  Coq_map.map

val sortedList_parameters : z -> Coq_word.word -> Coq_parameters.parameters

val map5 : z -> Coq_word.word -> (Coq_word.rep, 'a1) Coq_map.map

module Coq_Ascii :
 sig
  val ltb : char -> char -> bool
 end

val ltb0 : char list -> char list -> bool

val build_parameters : Coq_parameters.parameters

val bytes_per_word : z -> z

val bytes_per : z -> Coq_access_size.access_size -> nat

type parameters0 = unit

module Coq_rep :
 sig
  type rep = { rtype_of_ltype : (__ -> __); dummy_ltype : __;
               make_error : __; dummy_size : __ }

  type ltype = __

  type rtype = __

  type size = __

  val rtype_of_ltype :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    -> rep -> ltype -> rtype

  val dummy_ltype :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    -> rep -> ltype

  val make_error :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    -> rep -> rtype

  val dummy_size :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    -> rep -> size

  val listZ_local :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> rep -> rep

  val coq_Z :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> rep
 end

type base_ltype = __

type ltype0 = __

type base_rtype = __

type rtype0 = __

val base_make_error :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq_rep.rep -> Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type -> base_rtype

val make_error0 :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq_rep.rep -> Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type -> rtype0

val dummy_base_ltype :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq_rep.rep -> Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type -> base_ltype

val dummy_ltype0 :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq_rep.rep -> Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type -> ltype0

val base_rtype_of_ltype :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq_rep.rep -> Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type -> base_ltype -> base_rtype

val rtype_of_ltype0 :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq_rep.rep -> Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type -> ltype0
  -> rtype0

type base_access_sizes = __

type access_sizes = __

type 'f baseonly = __

type 't base_listonly = __

type 'f base_listexcl = __

type 't listonly = 't base_listonly baseonly

type list_lengths = nat listonly

type listonly_base_ltype = base_ltype base_listonly

type listexcl_base_ltype = base_ltype base_listexcl

val flatten_base_ltype :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
  base_ltype -> char list list

val flatten_argnames :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, ltype0)
  Compilers.Coq_type.for_each_lhs_of_arrow -> char list list

val flatten_listonly_base_ltype :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
  listonly_base_ltype -> char list list

val flatten_listexcl_base_ltype :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
  listexcl_base_ltype -> char list list

val extract_listnames :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
  base_ltype -> listonly_base_ltype * listexcl_base_ltype

val load_list_item :
  z -> Coq_access_size.access_size -> Coq_expr.expr -> nat -> Coq_expr.expr

val load_list :
  z -> (nat -> char list) -> Coq_access_size.access_size -> Coq_expr.expr ->
  nat -> nat -> nat -> (nat * char list list) * Coq_cmd.cmd

val load_all_lists :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
  nat -> base_ltype -> nat base_listonly -> base_access_sizes ->
  (nat * base_ltype) * Coq_cmd.cmd

val load_arguments :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> nat -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, ltype0)
  Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, list_lengths)
  Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, access_sizes)
  Compilers.Coq_type.for_each_lhs_of_arrow -> (nat * (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, ltype0)
  Compilers.Coq_type.for_each_lhs_of_arrow) * Coq_cmd.cmd

val store_list_item :
  z -> Coq_access_size.access_size -> Coq_expr.expr -> Coq_expr.expr -> nat
  -> Coq_cmd.cmd

val store_list :
  z -> Coq_access_size.access_size -> Coq_expr.expr -> Coq_expr.expr list ->
  nat -> Coq_cmd.cmd

val store_return_values :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
  base_ltype -> base_ltype -> access_sizes -> list_lengths * Coq_cmd.cmd

val loosest_range : zrange option list -> zrange option

val access_size_to_zrange : z -> Coq_access_size.access_size -> zrange

val zrange_to_access_size' :
  z -> zrange -> Coq_access_size.access_size list ->
  Coq_access_size.access_size option

val zrange_to_access_size : z -> zrange -> Coq_access_size.access_size option

val make_access_size :
  z -> zrange option list -> Coq_access_size.access_size option

val make_base_access_sizes :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
  Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
  base_access_sizes option

val make_access_sizes_args :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type,
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
  Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, access_sizes)
  Compilers.Coq_type.for_each_lhs_of_arrow option

val list_lengths_from_bounds :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
  Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp -> nat
  base_listonly option

val list_lengths_from_argbounds :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type,
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
  Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, list_lengths)
  Compilers.Coq_type.for_each_lhs_of_arrow option

val make_names :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> (nat -> char list) -> nat -> Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type -> nat * base_ltype

val make_innames' :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> (nat -> char list) -> nat -> Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
  nat * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, ltype0)
  Compilers.Coq_type.for_each_lhs_of_arrow

val make_innames :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> (nat -> char list) -> Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, ltype0)
  Compilers.Coq_type.for_each_lhs_of_arrow

val make_outnames :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> (nat -> char list) -> Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type -> base_ltype

val prefix_name_gen : char list -> nat -> char list

val default_inname_gen : nat -> char list

val default_outname_gen : nat -> char list

val default_varname_gen : nat -> char list

val eRROR : char list

val error_free_expr : Coq_expr.expr -> bool

val error_free_cmd : Coq_cmd.cmd -> bool

val max_range : z -> zrange

val range_good : z -> zrange -> bool

val width_range : z -> zrange

val cast_exempt :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
  Compilers.Coq_expr.expr -> bool

val invert_literal0 : Coq_expr.expr -> z option

val literal_eqb : Coq_expr.expr -> z -> bool

val literal_ltwidth : z -> Coq_expr.expr -> bool

val rshiftr :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> rtype0

val rshiftl :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> rtype0

val rtruncating_shiftl :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> rtype0

val rlnot_modulo :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> rtype0

val rselect :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> rtype0

val rnth_default :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> rtype0

val rmul_high :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> rtype0

val is_cast_literal_ident :
  z -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> bool

val is_cast_literal :
  z -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
  Compilers.Coq_expr.expr -> bool

val is_pair_range :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> bool

val is_cast2_literal_App2 :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
  Compilers.Coq_expr.expr -> bool

val is_cast2_literal_App1 :
  z -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
  Compilers.Coq_expr.expr -> bool

val is_cast2_literal :
  z -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
  Compilers.Coq_expr.expr -> bool

val is_cast_ident :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> bool

val is_cast_ident_expr :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
  Compilers.Coq_expr.expr -> bool

val is_cast :
  z -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
  Compilers.Coq_expr.expr -> bool

val require_cast_for_arg :
  z -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
  Compilers.Coq_expr.expr -> bool

val translate_binop :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> rtype0 option

val translate_ident :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> rtype0

val translate_cast_exempt :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> bool -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, ltype0)
  Compilers.Coq_expr.expr -> rtype0

val translate_expr :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> bool -> Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq3_Compilers.ident, ltype0) Compilers.Coq_expr.expr -> rtype0

val assign_list :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> nat -> base_rtype -> (nat * base_ltype) * Coq_cmd.cmd

val assign_base :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
  nat -> base_rtype -> (nat * base_ltype) * Coq_cmd.cmd

val assign :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> nat -> rtype0 -> (nat * ltype0) * Coq_cmd.cmd

val translate_ident2_for_cmd :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> ltype0 -> ltype0 ->
  ltype0 option

val translate_cmd :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, ltype0)
  Compilers.Coq_expr.expr -> nat -> (nat * ltype0) * Coq_cmd.cmd

val translate_func' :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, ltype0)
  Compilers.Coq_expr.expr -> nat -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, ltype0)
  Compilers.Coq_type.for_each_lhs_of_arrow -> (nat * base_ltype) * Coq_cmd.cmd

val translate_func :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
  Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, ltype0)
  Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, list_lengths)
  Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, access_sizes)
  Compilers.Coq_type.for_each_lhs_of_arrow -> base_ltype -> base_access_sizes
  -> ((char list list * char list list) * Coq_cmd.cmd) * list_lengths

val print_name :
  (char list * Coq7_Compilers.ToString.Coq_int.coq_type option) -> char list

val print_type :
  (char list * Coq7_Compilers.ToString.Coq_int.coq_type option) -> char list

val print_cast :
  (char list * Coq7_Compilers.ToString.Coq_int.coq_type option) -> char list

val flatten_base_var_data :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
  Coq7_Compilers.ToString.OfPHOAS.base_var_data ->
  (char list * Coq7_Compilers.ToString.Coq_int.coq_type option) list

val flatten_argnames_of_var_data :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type,
  Coq7_Compilers.ToString.OfPHOAS.var_data)
  Compilers.Coq_type.for_each_lhs_of_arrow ->
  (char list * Coq7_Compilers.ToString.Coq_int.coq_type option) list

val flatten_listonly_base_var_data :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
  Coq7_Compilers.ToString.OfPHOAS.base_var_data base_listonly ->
  (char list * Coq7_Compilers.ToString.Coq_int.coq_type option) list

val flatten_listexcl_base_var_data :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
  Coq7_Compilers.ToString.OfPHOAS.base_var_data base_listexcl ->
  (char list * Coq7_Compilers.ToString.Coq_int.coq_type option) list

val extract_list_var_data :
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
  Coq7_Compilers.ToString.OfPHOAS.base_var_data ->
  Coq7_Compilers.ToString.OfPHOAS.base_var_data
  base_listonly * Coq7_Compilers.ToString.OfPHOAS.base_var_data base_listexcl

val make_base_var_data :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
  base_ltype -> list_lengths -> Coq7_Compilers.ToString.OfPHOAS.base_var_data
  option

val make_var_data :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> ltype0 -> list_lengths ->
  Coq7_Compilers.ToString.OfPHOAS.var_data option

val make_var_data_of_args :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, ltype0)
  Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, list_lengths)
  Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type,
  Coq7_Compilers.ToString.OfPHOAS.var_data)
  Compilers.Coq_type.for_each_lhs_of_arrow option

val make_header :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq7_Compilers.Options.skip_typedefs_opt ->
  Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, ltype0)
  Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type, list_lengths)
  Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type,
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
  Compilers.Coq_type.for_each_lhs_of_arrow -> ltype0 -> list_lengths ->
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp -> char list list option

val bedrock_func_to_lines : (char list * func) -> char list list

val wrap_call :
  z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
  Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
  parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
  Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type,
  Coq7_Compilers.ToString.OfPHOAS.var_data)
  Compilers.Coq_type.for_each_lhs_of_arrow ->
  Coq7_Compilers.ToString.OfPHOAS.base_var_data -> (char list * func) ->
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, access_sizes)
  Compilers.Coq_type.for_each_lhs_of_arrow -> base_access_sizes -> char list

val decidable_Bitwidth : z -> decidable0

val bedrock2_ToFunctionLines :
  Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
  Coq7_Compilers.Options.relax_zrange_opt ->
  Coq7_Compilers.Options.language_naming_conventions_opt ->
  Coq7_Compilers.Options.documentation_options_opt ->
  Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool -> bool ->
  bool -> bool -> char list -> char list -> Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> ((Coq3_Compilers.base
  Compilers.Coq_base.Coq_type.coq_type,
  Coq7_Compilers.ToString.OfPHOAS.var_data)
  Compilers.Coq_type.for_each_lhs_of_arrow ->
  Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list) -> char list
  list option -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
  Compilers.Coq_type.for_each_lhs_of_arrow ->
  Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
  (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
  Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
  Compilers.Coq_type.for_each_lhs_of_arrow ->
  Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data -> (char list
  list * Coq7_Compilers.ToString.ident_infos, char list) sum

val outputBedrock2API : Coq7_Compilers.ToString.coq_OutputLanguageAPI

module Bedrock2Later :
 sig
  val bedrock2_supported_languages : ForExtraction.supported_languagesT

  module FiatCrypto :
   sig
    val main : unit
   end
 end
